/*-----DynamicData_PopulationScript--------------------------------*/
/*-----------------------------------------------------------------*/
  /*-----Description-----*/
    --This script developed by STARLIMS for data extraction from the
    --v10.2 database ().  It is used to populate the DynamicData
    --table in the V10.8 database so that the data can be easily 
    --accessed, and so we can retire the v10.2 STARLIMS interface.
  /*----- -----*/
  
  /*-----History-----*/
    --2014.12.04: Luis has provided this latest script.
  /*----- -----*/

  /*----- -----*/
  /*----- -----*/
/*-----------------------------------------------------------------*/



/*1. In 10.2 database, run this statement each time  re-populate table is needed
------------------------------------------------------------------------------

- Using SQL Developer:
*/



drop table DynamicData
commit


create table DynamicData
as 
 SELECT DISTINCT 
 RESULTS.ANALYTE, RESULTS.FINAL, RESULTS.NRES, RESULTS.RN1, RESULTS.RN5, RESULTS.RN6, RESULTS.RN9, RESULTS.RUNNO, RESULTS.STD_VALUE, RESULTS.UNITS, RESULTS.DATEANALYZED, RESULTS.DATEPREP, RESULTS.RETESTED, 
 ORDTASK.ORDNO, ORDTASK.QCTYPE, ORDTASK.TESTCODE, ORDTASK.TESTNO, ORDTASK.TMNAME, ORDTASK.METHOD, 
 ORDERS.CLSAMPNO, ORDERS.ORDGROUP, ORDERS.SAMPDATE, ORDERS.SAMPTIME, ORDERS.LOGDATE, ORDERS.EVIDENCENUMBER, ORDERS.PATIENTID, ORDERS.PATIENTSEX, ORDERS.PATIENTAGE, ORDERS.PATIENETHNICITY, ORDERS.SAMPLENUMBER, ORDERS.PRIORITY, ORDERS.PWSCODE, ORDERS.BTLABID, 
 FOLDERS.DRAWDATE, FOLDERS.APPRDATE, FOLDERS.FOLDERNO, FOLDERS.RASCLIENTID, FOLDERS.PONUMBER, FOLDERS.TRACKINGNUMBER, FOLDERS.PCA, FOLDERS.CHAINOFCUSTODY, FOLDERS.REPORTDUEDATE, FOLDERS.REPORTTYPE, 
 FOLDERSCONTACTSEXT.SENDCOA, 
 ENVSAMPLEPOINTS.SAMPLEPOINTNAME, 
 RASCLIENTS.RASCLIENTID RASCLIENTID2, RASCLIENTCONTACTSEXT.ADRESS, RASCLIENTCONTACTSEXT.ADRESS_A, RASCLIENTCONTACTSEXT.CITY, RASCLIENTCONTACTSEXT.FULLNAME, RASCLIENTCONTACTSEXT.STATE, RASCLIENTCONTACTSEXT.ZIP, 
 SAMPLE_PROGRAMS.MATCODE, SAMPLE_PROGRAMS.SAMP_POINT_STEP, 
 ANALYTES.NRES NRES2, ANALYTES.SINONYM, ANALYTES.SORTER, ANALYTES.STORET, ANALYTES.CONTAMINENT, 
 SP_TESTS.SPTESTSORTER, SP_TESTS.SP_TESTNO, SP_TESTS.TESTCODE TESTCODE2, SP_TESTS.PROFILE, SP_TESTS.DEPT, 
 SPEC_ANALYTES.LOWA, SPEC_ANALYTES.LOWB, SPEC_ANALYTES.PRINTFLAG, SPEC_ANALYTES.SYNONIM, SPEC_ANALYTES.UNITS UNITS2, SPEC_ANALYTES.SPN01, SPEC_ANALYTES.SPN02, SPEC_ANALYTES.SPN03, SPEC_ANALYTES.SPN04, SPEC_ANALYTES.HIGHA, SPEC_ANALYTES.HIGHB, 
 SAMPLEQUALIFIERS.QUALIFIERCODE   QCODE, SAMPLEQUALIFIERS.QUALIFMESSAGE QMSG, 
 SAMPLEQUALIFIERS_1.QUALIFIERCODE QCODE1, SAMPLEQUALIFIERS_1.QUALIFMESSAGE QMSG1, 
 SAMPLEQUALIFIERS_2.QUALIFIERCODE QCODE2, SAMPLEQUALIFIERS_2.QUALIFMESSAGE QMSG2, 
 SAMPLEQUALIFIERS_3.QUALIFIERCODE QCODE3, SAMPLEQUALIFIERS_3.QUALIFMESSAGE QMSG3
 FROM   ((((((((((((((STARDATA.FOLDERS FOLDERS INNER JOIN STARDATA.ORDERS ORDERS ON FOLDERS.FOLDERNO=ORDERS.FOLDERNO) 
 LEFT OUTER JOIN STARDATA.RASCLIENTS RASCLIENTS ON FOLDERS.RASCLIENTID=RASCLIENTS.RASCLIENTID)
 LEFT OUTER JOIN STARDATA.FOLDERSCONTACTSEXT FOLDERSCONTACTSEXT ON FOLDERS.FOLDERNO=FOLDERSCONTACTSEXT.FOLDERNO) 
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS ON FOLDERS.FOLDERNO=SAMPLEQUALIFIERS.FOLDERNO AND SAMPLEQUALIFIERS.ORDNO is null AND SAMPLEQUALIFIERS.TESTCODE is null AND SAMPLEQUALIFIERS.ANALYTE is null) 
 LEFT OUTER JOIN STARDATA.RASCLIENTCONTACTSEXT RASCLIENTCONTACTSEXT ON (FOLDERSCONTACTSEXT.RASCLIENTID=RASCLIENTCONTACTSEXT.RASCLIENTID) AND (FOLDERSCONTACTSEXT.CONTACTID=RASCLIENTCONTACTSEXT.CONTACTID)) 
 INNER JOIN STARDATA.ORDTASK ORDTASK ON (ORDERS.FOLDERNO=ORDTASK.FOLDERNO) AND (ORDERS.ORDNO=ORDTASK.ORDNO)) 
 LEFT OUTER JOIN STARDATA.ENVSAMPLEPOINTS ENVSAMPLEPOINTS ON ORDERS.SITEID=ENVSAMPLEPOINTS.ENVSAMPOINTID) 
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS_1 ON (ORDERS.FOLDERNO=SAMPLEQUALIFIERS_1.FOLDERNO) AND (ORDERS.ORDNO=SAMPLEQUALIFIERS_1.ORDNO) AND (SAMPLEQUALIFIERS_1.TESTCODE is null) AND (SAMPLEQUALIFIERS_1.ANALYTE is null)) 
 INNER JOIN STARDATA.RESULTS RESULTS ON ((ORDTASK.FOLDERNO=RESULTS.FOLDERNO) AND (ORDTASK.ORDNO=RESULTS.ORDNO)) AND (ORDTASK.TESTCODE=RESULTS.TESTCODE)) 
 INNER JOIN STARDATA.SP_TESTS SP_TESTS ON (ORDTASK.SP_CODE=SP_TESTS.SP_CODE) AND (ORDTASK.TESTCODE=SP_TESTS.TESTCODE) AND (ORDTASK.PROFILE=SP_TESTS.PROFILE))
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS_2 ON ((ORDTASK.ORDNO=SAMPLEQUALIFIERS_2.ORDNO) AND (ORDTASK.TESTCODE=SAMPLEQUALIFIERS_2.TESTCODE) AND (SAMPLEQUALIFIERS_2.ANALYTE is null)) AND (ORDTASK.FOLDERNO=SAMPLEQUALIFIERS_2.FOLDERNO)) 
 INNER JOIN STARDATA.ANALYTES ANALYTES ON (RESULTS.TESTCODE=ANALYTES.TESTCODE) AND (RESULTS.ANALYTE=ANALYTES.ANALYTE)) 
 INNER JOIN STARDATA.SPEC_ANALYTES SPEC_ANALYTES ON ((RESULTS.SPECNO=SPEC_ANALYTES.SPECNO) AND (RESULTS.TESTCODE=SPEC_ANALYTES.TESTCODE)) AND (RESULTS.ANALYTE=SPEC_ANALYTES.ANALYTE)) 
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS_3 ON ((RESULTS.FOLDERNO=SAMPLEQUALIFIERS_3.FOLDERNO) AND (RESULTS.ORDNO=SAMPLEQUALIFIERS_3.ORDNO) AND (RESULTS.ANALYTE=SAMPLEQUALIFIERS_3.ANALYTE)) AND (RESULTS.TESTCODE=SAMPLEQUALIFIERS_3.TESTCODE)) 
 INNER JOIN STARDATA.SAMPLE_PROGRAMS SAMPLE_PROGRAMS ON SP_TESTS.SP_CODE=SAMPLE_PROGRAMS.SP_CODE
 union
  SELECT DISTINCT 
 RESULTS.ANALYTE, RESULTS.FINAL, RESULTS.NRES, RESULTS.RN1, RESULTS.RN5, RESULTS.RN6, RESULTS.RN9, RESULTS.RUNNO, RESULTS.STD_VALUE, RESULTS.UNITS, RESULTS.DATEANALYZED, RESULTS.DATEPREP, RESULTS.RETESTED, 
 ORDTASK.ORDNO, ORDTASK.QCTYPE, ORDTASK.TESTCODE, ORDTASK.TESTNO, ORDTASK.TMNAME, ORDTASK.METHOD, 
 ORDERS.CLSAMPNO, ORDERS.ORDGROUP, ORDERS.SAMPDATE, ORDERS.SAMPTIME, ORDERS.LOGDATE, ORDERS.EVIDENCENUMBER, ORDERS.PATIENTID, ORDERS.PATIENTSEX, ORDERS.PATIENTAGE, ORDERS.PATIENETHNICITY, ORDERS.SAMPLENUMBER, ORDERS.PRIORITY, ORDERS.PWSCODE, ORDERS.BTLABID, 
 FOLDERS.DRAWDATE, FOLDERS.APPRDATE, FOLDERS.FOLDERNO, FOLDERS.RASCLIENTID, FOLDERS.PONUMBER, FOLDERS.TRACKINGNUMBER, FOLDERS.PCA, FOLDERS.CHAINOFCUSTODY, FOLDERS.REPORTDUEDATE, FOLDERS.REPORTTYPE, 
 FOLDERSCONTACTSEXT.SENDCOA, 
 ENVSAMPLEPOINTS.SAMPLEPOINTNAME, 
 RASCLIENTS.RASCLIENTID RASCLIENTID2, RASCLIENTCONTACTSEXT.ADRESS, RASCLIENTCONTACTSEXT.ADRESS_A, RASCLIENTCONTACTSEXT.CITY, RASCLIENTCONTACTSEXT.FULLNAME, RASCLIENTCONTACTSEXT.STATE, RASCLIENTCONTACTSEXT.ZIP, 
 SAMPLE_PROGRAMS.MATCODE, SAMPLE_PROGRAMS.SAMP_POINT_STEP, 
 ANALYTES.NRES NRES2, ANALYTES.SINONYM, ANALYTES.SORTER, ANALYTES.STORET, ANALYTES.CONTAMINENT, 
 SP_TESTS.SPTESTSORTER, SP_TESTS.SP_TESTNO, SP_TESTS.TESTCODE TESTCODE2, SP_TESTS.PROFILE, SP_TESTS.DEPT, 
 SPEC_ANALYTES.LOWA, SPEC_ANALYTES.LOWB, SPEC_ANALYTES.PRINTFLAG, SPEC_ANALYTES.SYNONIM, SPEC_ANALYTES.UNITS UNITS2, SPEC_ANALYTES.SPN01, SPEC_ANALYTES.SPN02, SPEC_ANALYTES.SPN03, SPEC_ANALYTES.SPN04, SPEC_ANALYTES.HIGHA, SPEC_ANALYTES.HIGHB, 
 SAMPLEQUALIFIERS.QUALIFIERCODE   QCODE, SAMPLEQUALIFIERS.QUALIFMESSAGE QMSG, 
 SAMPLEQUALIFIERS_1.QUALIFIERCODE QCODE1, SAMPLEQUALIFIERS_1.QUALIFMESSAGE QMSG1, 
 SAMPLEQUALIFIERS_2.QUALIFIERCODE QCODE2, SAMPLEQUALIFIERS_2.QUALIFMESSAGE QMSG2, 
 SAMPLEQUALIFIERS_3.QUALIFIERCODE QCODE3, SAMPLEQUALIFIERS_3.QUALIFMESSAGE QMSG3
 FROM   ((((((((((((((STARDATA.FOLDERS FOLDERS INNER JOIN STARDATA.ORDERS ORDERS ON FOLDERS.FOLDERNO=ORDERS.FOLDERNO) 
 LEFT OUTER JOIN STARDATA.RASCLIENTS RASCLIENTS ON FOLDERS.RASCLIENTID=RASCLIENTS.RASCLIENTID)
 LEFT OUTER JOIN STARDATA.FOLDERSCONTACTSEXT FOLDERSCONTACTSEXT ON FOLDERS.FOLDERNO=FOLDERSCONTACTSEXT.FOLDERNO) 
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS ON FOLDERS.FOLDERNO=SAMPLEQUALIFIERS.FOLDERNO AND SAMPLEQUALIFIERS.ORDNO is null AND SAMPLEQUALIFIERS.TESTCODE is null AND SAMPLEQUALIFIERS.ANALYTE is null) 
 LEFT OUTER JOIN STARDATA.RASCLIENTCONTACTSEXT RASCLIENTCONTACTSEXT ON (FOLDERSCONTACTSEXT.RASCLIENTID=RASCLIENTCONTACTSEXT.RASCLIENTID) AND (FOLDERSCONTACTSEXT.CONTACTID=RASCLIENTCONTACTSEXT.CONTACTID)) 
 INNER JOIN STARDATA.ORDTASK ORDTASK ON (ORDERS.FOLDERNO=ORDTASK.FOLDERNO) AND (ORDERS.ORDNO=ORDTASK.ORDNO)) 
 LEFT OUTER JOIN STARDATA.ENVSAMPLEPOINTS ENVSAMPLEPOINTS ON ORDERS.SITEID=ENVSAMPLEPOINTS.ENVSAMPOINTID) 
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS_1 ON (ORDERS.FOLDERNO=SAMPLEQUALIFIERS_1.FOLDERNO) AND (ORDERS.ORDNO=SAMPLEQUALIFIERS_1.ORDNO) AND (SAMPLEQUALIFIERS_1.TESTCODE is null) AND (SAMPLEQUALIFIERS_1.ANALYTE is null)) 
 INNER JOIN STARDATA.RESULTS RESULTS ON ((ORDTASK.FOLDERNO=RESULTS.FOLDERNO) AND (ORDTASK.ORDNO=RESULTS.ORDNO)) AND (ORDTASK.TESTCODE=RESULTS.TESTCODE)) 
 INNER JOIN STARDATA.SP_TESTS SP_TESTS ON (ORDTASK.SP_CODE=SP_TESTS.SP_CODE) AND (ORDTASK.TESTCODE=SP_TESTS.TESTCODE) )
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS_2 ON ((ORDTASK.ORDNO=SAMPLEQUALIFIERS_2.ORDNO) AND (ORDTASK.TESTCODE=SAMPLEQUALIFIERS_2.TESTCODE) AND (SAMPLEQUALIFIERS_2.ANALYTE is null)) AND (ORDTASK.FOLDERNO=SAMPLEQUALIFIERS_2.FOLDERNO)) 
 INNER JOIN STARDATA.ANALYTES ANALYTES ON (RESULTS.TESTCODE=ANALYTES.TESTCODE) AND (RESULTS.ANALYTE=ANALYTES.ANALYTE)) 
 INNER JOIN STARDATA.SPEC_ANALYTES SPEC_ANALYTES ON ((RESULTS.SPECNO=SPEC_ANALYTES.SPECNO) AND (RESULTS.TESTCODE=SPEC_ANALYTES.TESTCODE)) AND (RESULTS.ANALYTE=SPEC_ANALYTES.ANALYTE)) 
 LEFT OUTER JOIN STARDATA.SAMPLEQUALIFIERS SAMPLEQUALIFIERS_3 ON ((RESULTS.FOLDERNO=SAMPLEQUALIFIERS_3.FOLDERNO) AND (RESULTS.ORDNO=SAMPLEQUALIFIERS_3.ORDNO) AND (RESULTS.ANALYTE=SAMPLEQUALIFIERS_3.ANALYTE)) AND (RESULTS.TESTCODE=SAMPLEQUALIFIERS_3.TESTCODE)) 
 INNER JOIN STARDATA.SAMPLE_PROGRAMS SAMPLE_PROGRAMS ON SP_TESTS.SP_CODE=SAMPLE_PROGRAMS.SP_CODE
 where ORDTASK.QCTYPE <> 'N/A'



2. In STARLIMS 10.8, create DYNAMICDATA using Designer with origrec and orgsts fields only


3. In 10.8 database, run this statement 


drop table DynamicData
commit


 CREATE TABLE "DYNAMICDATA" 
   (  "ANALYTE" VARCHAR2(50 BYTE) NOT NULL ENABLE, 
  "FINAL" VARCHAR2(50 BYTE), 
  "NRES" VARCHAR2(2 BYTE), 
  "RN1" VARCHAR2(10 BYTE), 
  "RN5" VARCHAR2(10 BYTE), 
  "RN6" VARCHAR2(10 BYTE), 
  "RN9" VARCHAR2(10 BYTE), 
  "RUNNO" NUMBER(22,0), 
  "STD_VALUE" VARCHAR2(10 BYTE), 
  "UNITS" VARCHAR2(15 BYTE), 
  "DATEANALYZED" DATE, 
  "DATEPREP" DATE, 
  "RETESTED" CHAR(1 BYTE), 
  "ORDNO" VARCHAR2(13 BYTE) NOT NULL ENABLE, 
  "QCTYPE" VARCHAR2(10 BYTE), 
  "TESTCODE" NUMBER(22,0) NOT NULL ENABLE, 
  "TESTNO" VARCHAR2(50 BYTE), 
  "TMNAME" VARCHAR2(15 BYTE), 
  "METHOD" VARCHAR2(25 BYTE), 
  "CLSAMPNO" VARCHAR2(254 BYTE), 
  "ORDGROUP" VARCHAR2(12 BYTE), 
  "SAMPDATE" DATE, 
  "SAMPTIME" VARCHAR2(8 BYTE), 
  "LOGDATE" DATE, 
  "EVIDENCENUMBER" VARCHAR2(20 BYTE), 
  "PATIENTID" VARCHAR2(15 BYTE), 
  "PATIENTSEX" VARCHAR2(7 BYTE), 
  "PATIENTAGE" VARCHAR2(5 BYTE), 
  "PATIENETHNICITY" VARCHAR2(30 BYTE), 
  "SAMPLENUMBER" NUMBER(22,0), 
  "PRIORITY" VARCHAR2(1 BYTE), 
  "PWSCODE" VARCHAR2(50 BYTE), 
  "BTLABID" VARCHAR2(10 BYTE), 
  "DRAWDATE" DATE, 
  "APPRDATE" DATE, 
  "FOLDERNO" VARCHAR2(10 BYTE) NOT NULL ENABLE, 
  "RASCLIENTID" VARCHAR2(15 BYTE), 
  "PONUMBER" VARCHAR2(20 BYTE), 
  "TRACKINGNUMBER" VARCHAR2(100 BYTE), 
  "PCA" VARCHAR2(100 BYTE), 
  "CHAINOFCUSTODY" CHAR(20 BYTE) NOT NULL ENABLE, 
  "REPORTDUEDATE" DATE, 
  "REPORTTYPE" VARCHAR2(25 BYTE), 
  "SENDCOA" VARCHAR2(2 BYTE), 
  "SAMPLEPOINTNAME" VARCHAR2(25 BYTE), 
  "RASCLIENTID2" VARCHAR2(15 BYTE), 
  "ADRESS" VARCHAR2(40 BYTE), 
  "ADRESS_A" VARCHAR2(40 BYTE), 
  "CITY" VARCHAR2(30 BYTE), 
  "FULLNAME" VARCHAR2(30 BYTE), 
  "STATE" VARCHAR2(2 BYTE), 
  "ZIP" VARCHAR2(10 BYTE), 
  "MATCODE" VARCHAR2(30 BYTE), 
  "SAMP_POINT_STEP" VARCHAR2(20 BYTE), 
  "NRES2" VARCHAR2(2 BYTE), 
  "SINONYM" VARCHAR2(60 BYTE), 
  "SORTER" NUMBER(22,0), 
  "STORET" VARCHAR2(100 BYTE), 
  "CONTAMINENT" VARCHAR2(100 BYTE), 
  "SPTESTSORTER" NUMBER(22,0), 
  "SP_TESTNO" VARCHAR2(50 BYTE), 
  "TESTCODE2" NUMBER(22,0) NOT NULL ENABLE, 
  "PROFILE" VARCHAR2(71 BYTE) NOT NULL ENABLE, 
  "DEPT" VARCHAR2(20 BYTE), 
  "LOWA" VARCHAR2(10 BYTE), 
  "LOWB" VARCHAR2(10 BYTE), 
  "PRINTFLAG" VARCHAR2(2 BYTE), 
  "SYNONIM" VARCHAR2(50 BYTE), 
  "UNITS2" VARCHAR2(15 BYTE), 
  "SPN01" VARCHAR2(10 BYTE), 
  "SPN02" VARCHAR2(10 BYTE), 
  "SPN03" VARCHAR2(10 BYTE), 
  "SPN04" VARCHAR2(10 BYTE), 
  "HIGHA" VARCHAR2(10 BYTE), 
  "HIGHB" VARCHAR2(10 BYTE), 
  "QCODE" VARCHAR2(3 BYTE), 
  "QMSG" VARCHAR2(1500 BYTE), 
  "QCODE1" VARCHAR2(3 BYTE), 
  "QMSG1" VARCHAR2(1500 BYTE), 
  "QCODE2" VARCHAR2(3 BYTE), 
  "QMSG2" VARCHAR2(1500 BYTE), 
  "QCODE3" VARCHAR2(3 BYTE), 
  "QMSG3" VARCHAR2(1500 BYTE)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT);
 


4. In STARLIMS 10.8, select DYNAMICDATA table and "Sync definition from database" in order to carry new fields created


3. Run Server Script:  DynamicData  to move 10.2 fields to the table
   In case the server script returned a timeout issue, run the BatchDynamicData server script


