
/*-----SL09_Scripts_SetDrawResult----------------------------------*/
  /*----------Description----------*/
    --Use this set of queries to identify and update
    --the [results].final field value so that the
    --report will print the value you want.
    --
    --The root problem here is that the report only will display
    --the result for the last Draw.  So if the anaysts enters
    --the sendout after the test, we will only see the sendout results
    --(Specimen forwarded to the CDC.).  We will update the
    --Final to the value we want the report to show.
  /*---------- ----------*/  

  /*----------History----------*/
    --2013.06.27 JTY: Created Script
  /*---------- ----------*/  

  /*---------- ----------*/
  /*---------- ----------*/  
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
  /*----------01. Review Results For Sample----------*/
/*  
    SELECT DISTINCT 
    F.FOLDERNO,
      r.analyte,
      ot.ordno,
      --f.folderno,
      f.apprdate,
      f.approvedby,
      f.apprsts,
      r.dateenter,
      r.numres,
      r.final,
      f.origrec AS f_origrec,
      r.origrec AS r_origrec,
      '~' AS eol
    FROM data_prod.folders f 
      INNER JOIN data_prod.ordtask ot ON (f.folderno = ot.folderno)      
      INNER JOIN data_prod.results r ON (ot.ordno =r.ordno)
    WHERE f.folderno IN (
      'PS12142005',
      'PS12152004',
      'PS12156011',
      'PS12180003',
      'PS12193009',
      'PS12215002')
    ORDER BY
      ot.ordno DESC,
      r.analyte ASC;
*/      
  /*---------- ----------*/  
  
  
  /*----------02. Set final value----------*/
    --We are going to overwrite whatever is the 
    --current final result with the one we want.  
    --we will leave the numres value that represents
    --the actual test result.
/*    
     UPDATE data_prod.results r SET r.final = '<64 no antibody detected' WHERE 1=1
       AND r.ordno IN ('PS12215002001A', 'PS12180003001A', 'PS12156011001A', 'PS12152004001A')    

     UPDATE data_prod.results r SET r.final = '128 Spotted Fever group reactive' WHERE 1=1
       AND r.ordno IN ('PS12193009001A')    
       
     UPDATE data_prod.results r SET r.final = 64 Spotted Fever group reactive' WHERE 1=1
       AND r.ordno IN ('PS12142005001A')    
       
*/       
  /*---------- ----------*/  
  
  

  /*----------Force Sample To Done----------*/
/*  
    UPDATE data_prod.folders f 
    SET 
      f.apprdate = to_date(sysdate,'DD-MON-YYYY'),
      f.approvedby = 'Auto',
      f.apprsts = 'Released'
    WHERE 1=1
      AND f.folderno IN ('')
*/    
  /*---------- ----------*/  

  /*---------- ----------*/
  /*---------- ----------*/  
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/



