
/*-----------------------------------------------------------------*/
/*-----V09_SendBackToApproval--------------------------------------*/
  --Scripts used to move sample to Sample/Concdition Approval screen.
  /*----------Descrtiption---------*/
    --This set of scripts can be used to review and update samples
    --so they appear back in the Approve Sample/Condition application.
  /*----------  ---------*/  

  /*----------History---------*/  
    --2013.04.11 JTY: Created Script
  /*----------  ---------*/    
/*-----------------------------------------------------------------*/


/*-----FolderCondition Update--------------------------------------*/
  /*----------Review Field Values---------*/
/*  
    SELECT DISTINCT
      fc.origrec,
      fc.testgroupname,
      fc.folderno,
      fc.approvalstatus,
      fc.dispapprovalstatus,
      fc.dispsts,
      fc.status,
      fc.batch_job_id,
      fc.batch_release_status --Done   
    FROM data_prod.foldercondition fc
    WHERE 1=1
      AND folderno IN (
          'PI12275004', 'PI12311016','PI12339016', 'PI11083011')
    ORDER BY 
      fc.folderno ASC
*/      
  /*----------  ---------*/

  /*----------Set batch_release_status to NULL  ---------*/    
/*  
    UPDATE data_prod.foldercondition
    SET 
      batch_release_status = NULL,
      approvalstatus = NULL,
      dispapprovalstatus = NULL
    WHERE 1=1
      AND folderno IN ('PI12311016','PI12339016')  
*/      
  /*----------  ---------*/  
/*-----------------------------------------------------------------*/
  

/*-----------------------------------------------------------------*/
  /*---------- Review Folder information ---------*/
/*  
    SELECT DISTINCT
      f.fldsts,
      f.dispsts,    
      f.folderno,
      f.apprdate,
      f.apprdisp, 
      f.approvedby,
      f.apprsts
    FROM data_prod.folders f
    WHERE 1=1
      AND f.folderno IN ('PI12275004', 'PI12311016','PI12339016', 'PI11083011')  
    ORDER BY 
      f.folderno ASC
*/      
  /*----------  ---------*/
  
  /*----------  ---------*/
/*  
    UPDATE folders
    SET
      apprdate = NULL,   --3/20/2013
      approvedby = NULL,  --Auto
      apprsts = 'N/A'    --Released
    WHERE 1=1
      AND folderno IN ('PI12311016','PI12339016')  
/*      
  /*----------  ---------*/    
  
/*-----------------------------------------------------------------*/  


