

/*-----Approved_SamplesAndTests-----------------------------------------------*/
  ---DESCRIPTION---
    --These queries were created to show what test and panels were approved on
    --the specified date.
  --- ---
  

  ---HISTORY---
    --2018.07.20 JTY: Created Query
  --- ---

/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
  SELECT DISTINCT
    f.dept,
    mr.field_varchar_80 AS sample_type,    
    cr.external_id,
    ot.ordno,
    ot.runno,
    ot.testno AS test_name,    
    (to_char(COALESCE(fel.eventdate, ot.apprdate), 'MM/DD/YYYY') || '  ' || 
        COALESCE(fel.eventtime, '--:--')) AS test_approved,
    f.testgroupname AS panel_name,
    (to_char(f.apprdate, 'MM/DD/YYYY') || '  ' || f.apprtime) AS panel_approved,
    '~' AS eol
  FROM centralreceiving cr
    INNER JOIN folders f ON (cr.external_id = f.external_id)
    INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
    INNER JOIN runs r ON (ot.runno = ot.runno)
    INNER JOIN metadata_repository mr ON (1=1
      AND mr.tablereference = 'CENTRALRECEIVING'
      AND mr.original_origrec = cr.origrec)
    LEFT OUTER JOIN floweventlog fel ON (1=1
      AND fel.folderno = ot.folderno
      AND fel.testcode = ot.testcode
      AND fel.ordno = ot.ordno
      AND fel.stepcode = 'Release Test')    
  WHERE 1=1
    AND mr.field_varchar_80 IN ('Diagnostic')
    AND f.dept IN (&DeptList)
--    AND ((ot.apprdate IS NOT NULL) OR (f.apprdate IS NOT NULL))
    AND (ot.apprdate IS NOT NULL)
    AND (to_date(to_char(ot.apprdate, 'DD-MON-YYYY'), 'DD-MON-YYYY')  = to_date('&CheckDate', 'DD-MON-YYYY')
         OR to_date(to_char(f.apprdate, 'DD-MON-YYYY'), 'DD-MON-YYYY')  = to_date('&CheckDate', 'DD-MON-YYYY')    
    )
    ---Round 1 Test Set---

    AND ot.testno IN (
      'Influenza PCR', 'Measles PCR', 'Mumps PCR', 
      'Hantavirus IgG EIA', 'WNV IgM MAC-ELISA', 'SLE IgM MAC-ELISA', 
      'Rubella IgM EIA', 'RMSF IgG IFA', 'Hantavirus IgM EIA', 
      'Dengue IgM EIA', 'Dengue PCR', 'Zika IgM Capture ELISA', 
      'Trioplex rRT-PCR', 'Plaque Reduction Neutralization Test (PRNT)', 'Chikungunya IgM ELISA', 
      'Zika IgM MAC-ELISA', 'Norovirus PCR', 'FilmArray Respiratory Panel 2', 'HIV EIA'
    )

    --- ---

  ORDER BY
    ot.ordno ASC,
    f.dept ASC,
    test_approved ASC,
    ot.testno ASC,
    cr.external_id ASC
    
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
  --Find samlpes that have been retested in the date range specified
  
/*  
  WITH
  ---TargetSamples---
    TargetSamples AS (
      SELECT DISTINCT
        f.external_id
      FROM folders f
        INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
        INNER JOIN ordtask ot2 ON (1=1
            AND ot.folderno = ot2.folderno 
            AND ot.ordno <> ot2.ordno)
      WHERE 1=1
        AND f.external_id IS NOT NULL
        AND ot.testno IN (
          'Influenza PCR', 'Measles PCR', 'Mumps PCR', 
          'Hantavirus IgG EIA', 'WNV IgM MAC-ELISA', 'SLE IgM MAC-ELISA', 
          'Rubella IgM EIA', 'RMSF IgG IFA', 'Hantavirus IgM EIA', 
          'Dengue IgM EIA', 'Dengue PCR', 'Zika IgM Capture ELISA', 
          'Trioplex rRT-PCR', 'Plaque Reduction Neutralization Test (PRNT)', 'Chikungunya IgM ELISA', 
          'Zika IgM MAC-ELISA', 'Norovirus PCR', 'FilmArray Respiratory Panel 2',
          'HIV EIA'
        )
        AND to_date(ot.apprdate, 'DD-MON-YY') BETWEEN 
            to_date('&FromDate', 'DD-MON-YYYY') AND to_date('&ToDate', 'DD-MON-YYYY')
      ORDER BY
        f.external_id
    )
  --- ---
  --- ---
    SELECT DISTINCT
      f.dept,
      mr.field_varchar_80 AS sample_type,    
      cr.external_id,
      ot.ordno,
      ot.testno AS test_name,    
      (to_char(COALESCE(fel.eventdate, ot.apprdate), 'MM/DD/YYYY') || '  ' || 
          COALESCE(fel.eventtime, '--:--')) AS test_approved,
      f.testgroupname AS panel_name,
      (to_char(f.apprdate, 'MM/DD/YYYY') || '  ' || f.apprtime) AS panel_approved,
      '~' AS eol
    FROM TargetSamples ts
      INNER JOIN centralreceiving cr ON (ts.external_id = cr.external_id)
      INNER JOIN folders f ON (ts.external_id = f.external_id)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN runs r ON (ot.runno = ot.runno)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      LEFT OUTER JOIN floweventlog fel ON (1=1
        AND fel.folderno = ot.folderno
        AND fel.testcode = ot.testcode
        AND fel.ordno = ot.ordno
        AND fel.stepcode = 'Release Test')    
    WHERE 1=1
      AND mr.field_varchar_80 IN ('Diagnostic')
      --- ---
    ORDER BY
      ot.ordno ASC,
      f.dept ASC,
      test_approved ASC,
      ot.testno ASC,
      cr.external_id ASC
  --- ---
*/
  
/*---------------------------------------------------------------------------*/

