/*-----02~myLIMS Users Accounts Scripts----------------------------*/  
  /*-----Description-----*/
    --Set of scripts developed for maintenance of the myLIMS users
    --the following scipts are included:
      --01. Email Distribution List for myLIMS users
      --02. myLIMS Users List: Identify myLIMS users
      --03. Expiring Users: Identify myLIMS users with expiring accounts
      --04. Assign PDF Password: Generate PDF encription key for client
      
    --NOTE: The [users].pwexpd is suposed to contain the account expire
    --date (I think) but it appears that this does not always seem to 
    --coorespond to the value in the User Interface in the Security tab
    --in the Exipry Date field.  I think this may be a bug in STARLiMS
    --and have noticed that if you re-select the field value, it will 
    --update the record once you move off the user.
  /*----- -----*/
  
  /*----- -----*/
  /*----- -----*/
  
/*-----------------------------------------------------------------*/  



/*-----01. Email Distribution List---------------------------------*/
  --Use this query to generate an email distribution list for all external
  -- myLIMS users.
  WITH
    ---email_list---
      email_list AS (
        SELECT DISTINCT
          u.email
        FROM rasclients rc
          INNER JOIN rasclientcontacts rcx ON (rc.rasclientid = rcx.rasclientid)
          INNER JOIN users u ON (rcx.usrnam = u.usrnam)
          INNER JOIN userroles ur ON (u.usrnam = ur.usrnam)
          INNER JOIN roles r ON (ur.treeauth = r.treeauth)
        WHERE 1=1
          AND u.status = 'Active'
          AND r.role IN ('MyLims', 'myCounty')
          AND u.email IS NOT NULL
      ),
    --- ---
    ---distribution_list---
      distribution_list AS (
        SELECT 
          ListAgg(el.email,';') WITHIN GROUP (ORDER BY el.email) AS mylims_list
        FROM email_list el
        WHERE 1=1 
      )
    --- ---
    ---final query---
      SELECT
        dl.mylims_list
      FROM distribution_list dl
    --- ---
/*---------------------------------------------------------------------------*/




/*-----02. myLIMS Users List---------------------------------------*/
  --General Query to identify myLIMS users
/*
  SELECT DISTINCT
    rc.compname,
    rc.rasclientid,
    u.usrnam,
    r.role,
    u.status,
    u.fullname,
    trunc(u.pwexpd) AS pwexpd,
    u.email,
    u.userphone,
    u.gracelog,
    u.authority,
    u.methoddeveloper,
    u.poweruser,
    u.designer,
    u.showerrordetails,
    u.securityaction,
    u.simultaneousloginsallowed AS multi_logins,
    '~' AS eol
  FROM sundata_prod.rasclientcontacts rcc 
    INNER JOIN sundata_prod.rasclients rc ON (rcc.rasclientid = rc.rasclientid)
    INNER JOIN sundata_prod.users u ON (rcc.usrnam = u.usrnam)
    INNER JOIN sundata_prod.userroles ur ON (u.usrnam = ur.usrnam)
    INNER JOIN sundata_prod.roles r ON (ur.treeauth = r.treeauth)
  WHERE 1=1
    AND rcc.rasclientid NOT IN ('ADHS')
    --AND u.usrnam NOT IN ('BRICENA', 'YODERJ', 'PETERSA')
    --AND rcc.rasclientid IN ('MCHD-TB', 'MCHD-P-EM')
    AND u.status IN ('Active')
  --  AND u.status = 'Hold'
  --  AND rcc.rasclientid IN ('PCPH','MCHD-TB')
  ORDER BY
    rc.rasclientid ASC,
    TRUNC(u.pwexpd) ASC,
    u.fullname ASC,
    u.status ASC,
    rc.compname ASC;
*/
/*-----------------------------------------------------------------*/ 


/*-----03. Expiring Users-----------------------------------------*/
  --Identify users whos accounts are due to expire within 30 days.
  --I have REMmed out other criteria you may be interested in utilizing.
/*

  WITH
  ---UserDetails ---
    UserDetails AS (
      SELECT DISTINCT
        (rc.compname || ' (' || rc.rasclientid || ')') AS organization,
        u.fullname,
        to_char(u.pwexpd, 'YYYY.MM.DD') AS exp_date,
        u.status,
        u.userphone,
        u.email,
        u.authority,
        rcc.usrnam,
        rcc.rasclientid,
        '~' AS eol
      FROM &Environment.rasclientcontacts rcc 
        INNER JOIN &Environment.rasclients rc ON (rcc.rasclientid = rc.rasclientid)
        INNER JOIN &Environment.users u ON (rcc.usrnam = u.usrnam)
      WHERE 1=1
        AND u.deptlist = 'External'
        AND u.status = 'Active'        
    ),    
  --- 
  ---LastLogin---
    LastLogin AS (
     SELECT DISTINCT
       ud.usrnam,
       TO_CHAR (max(sl.edate),'YYYY.MM.DD HH:MM AM') AS last_login,
       '~' AS eol
     FROM UserDetails ud
       LEFT OUTER JOIN &Environment.starlimslog sl ON ( 1=1
         AND ud.usrnam = sl.usrnam
         AND sl.descr = 'LOGIN')
     WHERE 1=1
     GROUP BY
       ud.usrnam
    )
  --- 
  ---Final Query---
    SELECT DISTINCT
      ud.organization,
      ud.fullname,    
      ud.usrnam,
      ud.exp_date,
      ll.last_login,
      ud.email,
      ud.status,
      ud.userphone,
      ud.authority,
      ud.rasclientid,
      '' AS eol
    FROM UserDetails ud
      INNER JOIN LastLogin ll ON (ud.usrnam = ll.usrnam)
    WHERE 1=1
      --30 day check--
        AND TO_DATE(ud.exp_date, 'YYYY.MM.DD') < TO_DATE(ADD_MONTHS(sysdate,1), 'DD-MON-YY')
      --Accounts that should be expired already--
        --AND ud.exp_date < ll.last_login
      --Accounts that were never logged into--
        --AND ll.last_login IS NULL
    ORDER BY
      ud.fullname ASC,    
      ud.exp_date ASC,
      ud.organization ASC;

  ---
  */
/*-----------------------------------------------------------------*/    
/*=================================================================*/





/*=================================================================*/


/*-----04. Assign PDF Password----------------------------------------------*/
  --Gnerate password to be stored in the URL field of the [Client List] 
  --application to be used for the password for encrypted PDF files.
/*
  UPDATE &Environment.rasclients rc
  SET
    rc.url = (
      rc.rasclientid || '_' ||
      DBMS_RANDOM.STRING('L',3)    
    )
  WHERE 1=1
    AND rc.rasclientid = '&RasClientID'
*/
/*---------------------------------------------------------------------------*/

