/*-----myLIMS Users Accounts Scripts-------------------------------*/  
  /*-----Description-----*/
    --Set of scripts developed for maintenance of the myLIMS users
    --the following scipts are included:
      --1. Expiring Users: Identify users who's login are due to expire.
      
    --NOTE: The [users].pwexpd is suposed to contain the account expire
    --date (I think) but it appears that this does not always seem to 
    --coorespond to the value in the User Interface in the Security tab
    --in the Exipry Date field.  I think this may be a bug in STARLiMS
    --and have noticed that if you re-select the field value, it will 
    --update the record once you move off the user.
  /*----- -----*/
  
  /*----- -----*/
  /*----- -----*/
  
/*-----------------------------------------------------------------*/  


/*-----1. Expiring Users------------------------------------------*/
  --Identify users whos accounts are due to expire within 30 days.
  --I have REMmed out other criteria you may be interested in utilizing.


  WITH
  ---UserDetails ---
    UserDetails AS (
      SELECT DISTINCT
        (rc.compname || ' (' || rc.rasclientid || ')') AS organization,
        u.fullname,
        to_char(u.pwexpd, 'YYYY.MM.DD') AS exp_date,
        u.status,
        u.userphone,
        u.email,
        u.authority,
        rcc.usrnam,
        rcc.rasclientid,
        '~' AS eol
      FROM &Environment.rasclientcontacts rcc 
        INNER JOIN &Environment.rasclients rc ON (rcc.rasclientid = rc.rasclientid)
        INNER JOIN &Environment.users u ON (rcc.usrnam = u.usrnam)
      WHERE 1=1
        AND u.deptlist = 'External'
        AND u.status = 'Active'        
    ),    
  --- 
  ---LastLogin---
    LastLogin AS (
     SELECT DISTINCT
       ud.usrnam,
       TO_CHAR (max(sl.edate),'YYYY.MM.DD HH:MM AM') AS last_login,
       '~' AS eol
     FROM UserDetails ud
       LEFT OUTER JOIN &Environment.starlimslog sl ON ( 1=1
         AND ud.usrnam = sl.usrnam
         AND sl.descr = 'LOGIN')
     WHERE 1=1
     GROUP BY
       ud.usrnam
    )
  --- 
  ---Final Query---
    SELECT DISTINCT
      ud.organization,
      ud.fullname,    
      ud.usrnam,
      ud.exp_date,
      ll.last_login,
      ud.email,
      ud.status,
      ud.userphone,
      ud.authority,
      ud.rasclientid,
      '' AS eol
    FROM UserDetails ud
      INNER JOIN LastLogin ll ON (ud.usrnam = ll.usrnam)
    WHERE 1=1
      --30 day check--
        AND TO_DATE(ud.exp_date, 'YYYY.MM.DD') < TO_DATE(ADD_MONTHS(sysdate,1), 'DD-MON-YY')
      --Accounts that should be expired already--
        --AND ud.exp_date < ll.last_login
      --Accounts that were never logged into--
        --AND ll.last_login IS NULL
    ORDER BY
      ud.fullname ASC,    
      ud.exp_date ASC,
      ud.organization ASC;

  ---
/*-----------------------------------------------------------------*/    
/*=================================================================*/





/*=================================================================*/
