
/*-----PanelsMaintenance-----------------------------------------------------*/
  ---DESCRIPTION---
    --Maintenance related to Panels including:
      --01. RemoveRetiredTests: Remove retired test from Active Panels
      --02. Clean Responsible List: Remove persons from Responsible list if 
            --they are no longer Active Users
  --- ---
  
  ---HISTORY---
    --2019.02.25 JTY: Add Clean Responsible List
    --2018.05.29 JTY: Created Script
  --- ---
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*---01. RemoveRetiredTests--------------------------------------------------*/
  --Remove retired test from Active Panels


  --Identify Panels/Test that will be updated:
      SELECT DISTINCT
        t.testno,
        ctt.testgroupname,
        ctt.origrec AS ctt_origrec,
        '~' AS eol    
      FROM  tests t
        INNER JOIN conditiontesttriggers ctt ON (t.testcode = ctt.testcode)
        INNER JOIN testgroupnames tgn ON (ctt.testgroupname = tgn.testgroupname)
      WHERE 1=1
        AND tgn.status = 'Active'
        AND t.testcatcode = 'Retired'
      ORDER BY
        t.testno ASC,
        ctt.testgroupname ASC;  


/* Perform Removal

      DELETE FROM conditiontesttriggers ctt
      WHERE 1=1
        AND ctt.origrec IN (
          SELECT DISTINCT
            ctt.origrec AS ctt_origrec
          FROM  tests t
            INNER JOIN conditiontesttriggers ctt ON (t.testcode = ctt.testcode)
            INNER JOIN testgroupnames tgn ON (ctt.testgroupname = tgn.testgroupname)
          WHERE 1=1
            AND tgn.status = 'Active'
            AND t.testcatcode = 'Retired'
        )
*/  
/*---------------------------------------------------------------------------*/


/*-----02. Clean Responsible List--------------------------------------------*/
   --Remove persons from Responsible list if they are no longer Active Users
/*   
      DELETE
      FROM testgroup_users tgu
      WHERE 1=1
        AND tgu.usrnam IN (
        SELECT DISTINCT 
          u.usrnam
        FROM users u
        WHERE 1=1
          AND u.status <> 'Active'  
        );
*/   
/*---------------------------------------------------------------------------*/
