/*-----RasClientContactsMaintenance------------------------------------------*/
/*---------------------------------------------------------------------------*/
  -----DESCRIPTION-----
    --Scripts associated with RasClientContacts including the following:
      --01. InternalContactEmailSync
  ----- -----
  
  -----HISTORY-----
    --2018.07.16 JTY: Created Script
  ----- -----
    
/*---------------------------------------------------------------------------*/





/*---------------------------------------------------------------------------*/
/*-----01. InternalContactEmailSync------------------------------------------*/
  --This script will update the RasClient Contacts emails with the corresponding
  --user email.  This can become out of sync when the user email is updated.
  --This will happen when adding a new external user to STARLiMS since we begin win
  --a wrong email to ensure the password does not get sent the them un-encripted.
  
  
  MERGE INTO rasclientcontacts t1
  USING (
    SELECT DISTINCT
      rcc.origrec AS rcc_origrec,
      rcc.rasclientid,
      u.usrnam,
      rcc.email AS rcc_email,
      u.email AS u_email,
      '~' AS eol
    FROM rasclientcontacts rcc
      LEFT OUTER JOIN users u ON (rcc.usrnam = u.usrnam)
    WHERE 1=1
      AND rcc.email <> u.email
    ORDER BY 
      rcc.rasclientid ASC,
      u.usrnam ASC
  ) t2
  ON (t1.origrec = t2.rcc_origrec)
  WHEN MATCHED THEN
    UPDATE
    SET t1.email = t2.u_email
/*---------------------------------------------------------------------------*/


