

/*-----Cross Environments Check: PossibleResuts--------------------*/
  /*----------DESCRIPTION----------*/
    --Use this script to compare PossibleResults across environements.
    --the query will identify what PR are in Environment1 but not
    --Environment2
  /*---------- ----------*/

  /*----------HISTORY----------*/
    --2013.06.28 JTY: Created Script
  /*---------- ----------*/


  /*---------- ----------*/
  /*---------- ----------*/

  /*----------ENVIRONMENTS----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod  
  /*---------- ----------*/
  
  /*----------Reference Tables----------*/
    --SELECT * FROM &Environment.PossibleResults
    --SELECT * FROM &Environment.tests
  /*---------- ----------*/
  
/*-----------------------------------------------------------------*/




/*-----------------------------------------------------------------*/
  /*---------- ----------*/
    WITH
    ---Environment1---
      MyEnv01 AS (
        SELECT DISTINCT
          CASE 
            WHEN ('&Environment_01' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment_01' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment_01' = 'sundata_prod') THEN 'PROD'                            
          END AS env,
          t.testno,  
          pr.analyte,          
          pr.result_status,
          pr.loincnumber,
          pr.sorter,
          pr.result,
          (
            COALESCE(t.testno, 'testno') || '~' || CHR(13) ||
            COALESCE(pr.analyte, 'analyte') || '~' || CHR(13) ||
            COALESCE(pr.result_status, 'status') || '~' || CHR(13) ||            
            COALESCE(pr.result, 'result')
          ) AS MyJoin,
          '~' AS eol
        FROM &Environment_01.PossibleResults pr        
          LEFT OUTER JOIN &Environment_01.tests t ON (pr.testcode = t.testcode)
        WHERE 1=1
        ORDER BY
          t.testno ASC,  
          pr.analyte ASC,
          pr.sorter ASC,
          pr.result ASC
      ),
    ---
    ---Environment2--
      MyEnv02 AS (
        SELECT DISTINCT
          CASE 
            WHEN ('&Environment_02' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment_02' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment_02' = 'sundata_prod') THEN 'PROD'                            
          END AS env,
          t.testno,  
          pr.analyte,          
          pr.result_status,
          pr.loincnumber,
          pr.sorter,
          pr.result,
          (
            COALESCE(t.testno, 'testno') || '~' || CHR(13) ||
            COALESCE(pr.analyte, 'analyte') || '~' || CHR(13) ||
            COALESCE(pr.result_status, 'status') || '~' || CHR(13) ||            
            COALESCE(pr.result, 'result')
          ) AS MyJoin,
          '~' AS eol
        FROM &Environment_02.PossibleResults pr        
          LEFT OUTER JOIN &Environment_02.tests t ON (pr.testcode = t.testcode)
        WHERE 1=1
        ORDER BY
          t.testno ASC,  
          pr.analyte ASC,
          pr.sorter ASC,
          pr.result ASC
        ),
    ---    
    ---Difference---
      MyDiff AS (
        SELECT DISTINCT
          E01.env AS env_01,
          CASE 
            WHEN ('&Environment_02' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment_02' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment_02' = 'sundata_prod') THEN 'PROD'                            
          END AS env_02,
          E01.testno,  
          E01.analyte,          
          E01.result_status,
          E01.loincnumber,
          E01.sorter,
          E01.result,
          '~' AS eol
        FROM MyEnv01 E01
          LEFT OUTER JOIN MyEnv02 E02 ON (
            E01.MyJoin = E02.MyJoin
          )
        WHERE 1=1
          AND E02.MyJoin IS NULL
        ORDER BY
          E01.testno ASC,  
          E01.analyte ASC,
          E01.sorter ASC,
          E01.result ASC
        )
    ---
    ---Final Query---
      --What's in Environment01 that is missing in Environment02
      SELECT DISTINCT 
          md.env_01,
          md.env_02,
          md.testno,  
          md.analyte,          
          md.result_status,
          md.loincnumber,
          md.sorter,
          md.result,
          '~' AS eol      
      FROM MyDiff md
      WHERE 1=1
      --Enter Tests of interest here--
        --AND md.analyte = 'Sendout Virology'
      --
      ORDER BY 
          md.testno ASC,  
          md.analyte ASC,
          md.sorter ASC,
          md.result ASC;
    ---    
  /*---------- ----------*/
/*-----------------------------------------------------------------*/
