

/*-----Cross Environments Check: Reagents-------------------------*/
  /*----------DESCRIPTION----------*/
    --Use this script to compare Reagents across environements.
    --the query will identify what Reagents in in Environment01
    --but NOT in Environment02 for test associated with the
    --identified lab.
    --NOTE: this is for NON-Micro Tests.
  /*---------- ----------*/

  /*----------HISTORY----------*/
  /*---------- ----------*/


  /*---------- ----------*/
  /*---------- ----------*/

  /*----------ENVIRONMENTS----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod  
  /*---------- ----------*/
  /*----------DEPARTMENTS----------*/
    --PHX-BT
    --PHX-BAC
    --PHX-TB
    --PHX-VIR
    --PHX-EM
    --PHX-SER
  /*---------- ----------*/    
  
  
  /*----------Reference Tables----------*/
/*  
    SELECT * FROM &Environment.tests;
    SELECT * FROM &Environment.testreagents;
    SELECT * FROM &Environment.Methodsrelatedtotests;    
*/    
  /*---------- ----------*/

/*-----------------------------------------------------------------*/




/*-----------------------------------------------------------------*/
  /*---------- ----------*/
    WITH
    ---Environment1---
      MyEnv01 AS (
        SELECT DISTINCT
          CASE 
            WHEN ('&Environment_01' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment_01' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment_01' = 'sundata_prod') THEN 'PROD'                            
          END AS env_01,
          mrt.dept,
          mrt.servgrp,
          t.testcatcode AS test_library,
          t.testno,
          tr.matcode,
          --Optional Info
          t.testflag,
          t.testcode,
          t.teststatus as t_status,
          mrt.methodstatus,
          '~' AS eol
        FROM &Environment_01.tests t
          LEFT OUTER JOIN &Environment_01.testreagents tr ON (t.testcode = tr.testcode)
          LEFT OUTER JOIN &Environment_01.Methodsrelatedtotests mrt ON (t.testcode = mrt.testcode)
        WHERE 1=1
--          AND mrt.dept IN ('&Department')
          AND NOT (t.testcatcode IN ('Retired', 'QC Inventory', 'Safety and Training'))
          AND tr.matcode IS NOT NULL          
--          AND mrt.methodstatus <> 'Delete'
--          AND t.teststatus <> 'Delete'
          --AND NOT (m.mattype IN ('Delete'))
        ORDER BY
          mrt.dept ASC,
          mrt.servgrp ASC,
          t.testcatcode ASC,
          t.testno ASC,
          tr.matcode ASC
      ),
    ---
    ---Environment2--
      MyEnv02 AS (
        SELECT DISTINCT
          CASE 
            WHEN ('&Environment_02' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment_02' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment_02' = 'sundata_prod') THEN 'PROD'                            
          END AS env_02,
          mrt.dept,
          mrt.servgrp,
          t.testcatcode AS test_library,
          t.testno,
          tr.matcode,
          --Optional Info
          t.testflag,
          t.testcode,
          t.teststatus as t_status,
          mrt.methodstatus,
          '~' AS eol
        FROM &Environment_02.tests t
          LEFT OUTER JOIN &Environment_02.testreagents tr ON (t.testcode = tr.testcode)
          LEFT OUTER JOIN &Environment_02.Methodsrelatedtotests mrt ON (t.testcode = mrt.testcode)
        WHERE 1=1        
--          AND mrt.dept IN ('&Department')
          AND NOT (t.testcatcode IN ('Retired', 'QC Inventory', 'Safety and Training'))
          AND tr.matcode IS NOT NULL
--          AND mrt.methodstatus <> 'Delete'
--          AND t.teststatus <> 'Delete'
          --AND NOT (m.mattype IN ('Delete'))
        ORDER BY
          mrt.dept ASC,
          mrt.servgrp ASC,
          t.testcatcode ASC,
          t.testno ASC,
          tr.matcode ASC
        ),
    ---    
    ---Difference---
      MyDiff AS (
        SELECT DISTINCT
          E01.env_01,
          CASE 
            WHEN ('&Environment_02' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment_02' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment_02' = 'sundata_prod') THEN 'PROD'                            
          END AS env_02,
          E01.dept,
          E01.servgrp,
          E01.test_library,
          E01.testno,
          E01.matcode,
          --Optional Info
          E01.testflag,
          E01.testcode,
          E01.t_status,
          E01.methodstatus
        FROM MyEnv01 E01
          LEFT OUTER JOIN MyEnv02 E02 ON (
              E01.testno = E02.testno
              AND E01.matcode = E02.matcode)
        WHERE 1=1        
          AND E02.matcode IS NULL
          --AND E01.matcode IS NOT NULL
        ORDER BY
          E01.dept ASC,
          E01.servgrp ASC,
          E01.test_library ASC,
          E01.testno ASC,
          E01.matcode ASC
        )
    ---
    ---Final Query---
      --What's in Environment01 that is missing in Environment02
      SELECT DISTINCT 
          md.dept,          
          md.env_01,
          md.env_02,
          md.dept,
          md.servgrp,
          md.test_library,
          md.testno,
          md.matcode,
          --Optional Info
          md.testflag,
          md.testcode,
          md.t_status,
          md.methodstatus,
          '~' AS eol      
      FROM MyDiff md
      ORDER BY 
          md.dept ASC,
          md.servgrp ASC,
          md.matcode ASC,
          md.test_library ASC,
          md.testno ASC,
          md.matcode ASC;
    ---    
  /*---------- ----------*/

/*-----------------------------------------------------------------*/
