

/*-----Compare_Suppliers-------------------------------------------*/  
  /*----------Description----------*/
    --Use script here to identify suppliers that don't match or 
    --are missing accross environments.  In this code we are
    --performing a match on suppcode and suppnam fields.
  /*----------  ----------*/

  /*----------SL10 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/
  
  /*----------History----------*/  
    --2013.06.05 JTY: Created framework.
  /*----------  ----------*/  

  /*----------Source Tables----------*/  
    --SELECT DISTINCT * FROM sunrise_data.suppliers s
  /*----------  ----------*/  
/*-----------------------------------------------------------------*/  



/*-----Perform Compare---------------------------------------------*/
  --Identify what Suppliers exists in Env01 but NOT in Env02.
  /*----------  ----------*/      
    WITH
      ---MyEnv01---
        --Supplier information for Environment01
      MyEnv01 AS (      
        SELECT DISTINCT
          CASE
            WHEN ('&Environment01' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment01' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment01' = 'sundata_prod') THEN 'PROD'
          END AS env01,
          (s.suppcode || '~' || s.suppnam) AS MyKey,
          s.suppcode,
          s.suppnam,
          '~' AS eol
        FROM  &Environment01.suppliers s
        WHERE 1=1
        ORDER BY
          UPPER(s.suppcode) ASC       
      ),
      ---
      ---MyEnv02---  
        --Supplier information for Environment02
      MyEnv02 AS (
        SELECT DISTINCT
          CASE
            WHEN ('&Environment02' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment02' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment02' = 'sundata_prod') THEN 'PROD'
          END AS env02,
          (s.suppcode || '~' || s.suppnam) AS MyKey,
          s.suppcode,
          s.suppnam,
          '~' AS eol
        FROM  &Environment02.suppliers s
        WHERE 1=1
        ORDER BY
          UPPER(s.suppcode) ASC       
      ),
      ---
      ---MyDiff---
        --Identify suppliers in Env01 that do not exists in Env02
      MyDiff AS (        
        SELECT DISTINCT
          e01.env01,
          CASE
            WHEN ('&Environment02' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment02' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment02' = 'sundata_prod') THEN 'PROD'
          END AS env02,
          e01.suppcode,
          e01.suppnam,
          '~' AS eol          
        FROM MyEnv01 e01
          LEFT OUTER JOIN MyEnv02 E02 ON (e01.MyKey = e02.MyKey)
        WHERE 1=1
          AND e02.MyKey IS NULL
        ORDER BY
          UPPER(e01.suppcode) ASC
      )       
      ---
      ---Summary---            
        SELECT * FROM MyDiff ORDER BY UPPER(suppcode) ASC
      ---
  /*----------  ----------*/  
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
  /*----------  ----------*/  
  /*----------  ----------*/  
/*-----------------------------------------------------------------*/
