/*-----------------------------------------------------------------*/
  --Utilize the provided script below for developing a cross-
  --environment compare script.  Ideally you want to get no
  --records back from the developed script when utilized.  This
  --would indicate environments are identical.
  
  /*----------Description----------*/
  /*----------  ----------*/  


  /*----------SL10.7 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/
  
  /*----------History----------*/
    --20xx.xx.xx ABC: Created file.
  /*----------  ----------*/   
/*-----------------------------------------------------------------*/





/*-----------------------------------------------------------------*/
  --Description of purpose of script
    WITH 
      ---TheSource---
        --Build list to compare
      TheSource AS (
        SELECT DISTINCT
          CASE 
             WHEN ('&SourceSchema' = 'sunrise_data') THEN 'DEV'
             WHEN ('&SourceSchema' = 'sundata_sat') THEN 'TEST'
             WHEN ('&SourceSchema' = 'sundata_prod') THEN 'PROD'                            
           END AS env,   
          --List columns of interest--     
          t.column1,
          t.column2,
          ...
          t.columnN,
          --
          --Build join key with relavant columns.  This will
          --join against the TheTarget key--
          (
              t.column1 || '|' ||
              t.column2 || '|' ||
              ...
              t.columnN           
          ) AS Key
          --
        FROM  &SourceSchema.table t
          --Any required joins--
        WHERE 1=1
          --Additional criteria here--
      ),
     ---
     ---TheTarget---
       --TheTarget needs to have exact same columns as TheSource.
     TheTarget AS (
       SELECT DISTINCT
         CASE 
            WHEN ('&TargetSchema' = 'sunrise_data') THEN 'DEV'
            WHEN ('&TargetSchema' = 'sundata_sat') THEN 'TEST'
            WHEN ('&TargetSchema' = 'sundata_prod') THEN 'PROD'                            
          END AS env,        
          --List columns of interest--     
          t.column1,
          t.column2,
          ...
          t.columnN,
          --
          --This join key needs to be built exactly the
          --sam as TheSource join key--
          (
              t.column1 || '|' ||
              t.column2 || '|' ||
              ...
              t.columnN           
          ) AS Key
          --
        FROM  &TargetSchema.table t
          --Any required joins--
        WHERE 1=1
          --Additional criteria here--
      )      
     ---
     ---TheDifference---
       --Identify rows in Source or Target that don't match.
       SELECT DISTINCT
         COALESCE(ts.env,tt.env) AS env,
         COALESCE(ts.column1,tt.column1) AS column1,
         COALESCE(ts.column2,tt.column2) AS column2,
         ...
         COALESCE(ts.columnN,tt.columnN) AS columnN,
         '~' AS eol
       FROM TheSource ts
         FULL OUTER JOIN TheTarget tt ON (ts.key = tt.key)
       WHERE 1=1
         AND (tt.key IS NULL OR ts.key IS NULL)
       ORDER BY 
         env ASC,
         columnX ASC,
         columnY ASC,
         ...
         columnZ ASC;
     ---
/*-----------------------------------------------------------------*/
     
