

/*-----HL7 Codes Extract-------------------------------------------*/
  -----DESCRIPTIION-----
    --SQL script created for extracting various codes related to ELR
    --this is based on scripts developed for CR381.  
  ----- -----

  
  
  -----HISTORY-----
    --2016.04.19 JTY: Created file based on extract file for CR381.
  ----- -----
  
/*-----------------------------------------------------------------*/



/*-----1.	List of all LOINC codes in use for tests-----------------*/
--  SELECT * FROM sundata_prod.testloinccodes tlc ORDER BY tlc.loincnumber ASC;
/*
WITH
  ---AllTests---
    AllTests AS (
      SELECT DISTINCT
        t.testcatcode,
        t.testno,
        t.testcode,
        tlc.analyte,
        sp.printflag,
        NULL AS w_samples,
        tlc.loincnumber,
        tlc.version,
        tlc.loinccomponenet,
        '~' AS eol    
      FROM sundata_prod.testloinccodes tlc
        INNER JOIN sundata_prod.tests t ON (tlc.testcode = t.testcode)
        INNER JOIN sundata_prod.spec_analytes sp ON (1=1
          AND tlc.testcode = sp.testcode
          AND tlc.analyte = sp.analyte)
      WHERE 1=1
        AND t.testcatcode NOT IN ('Retired','Clinical')
        --AND tlc.analyte <> 'TESTLOINC'        
      ORDER BY
        t.testcatcode ASC,
        t.testcode ASC,
        tlc.analyte ASC,
        tlc.version ASC,
        tlc.loincnumber ASC),  
  --- ---
  ---WithSamples---
    WithSamples AS (
      SELECT DISTINCT
        al.testcatcode,
        al.testno,
        al.testcode,
        al.analyte,
        al.printflag,
        'Y' AS w_samples,
        al.loincnumber,
        al.version,
        al.loinccomponenet,
        al.eol          
      FROM AllTests al
        INNER JOIN sundata_prod.results r ON (1=1
          AND al.testcode = r.testcode 
          AND al.analyte = r.analyte)
        INNER JOIN sundata_prod.folders f ON (r.folderno = f.folderno)
        INNER JOIN sundata_prod.centralreceiving cr ON (f.external_id = cr.external_id)
        INNER JOIN sundata_prod.metadata_repository mr ON (1=1
          AND mr.tablereference = 'CENTRALRECEIVING'
          AND mr.original_origrec = cr.origrec
          AND mr.field_varchar_80 = 'Diagnostic')      
      WHERE 1=1),
  --- ---
  ---Combined---
    Combined AS (
      SELECT DISTINCT
        al.testcatcode,      
        al.testno,
        al.testcode,
        al.analyte,
        al.printflag,
        COALESCE(ws.w_samples, 'N') AS w_samples,
        al.loincnumber,
        al.version,
        al.loinccomponenet,
        (al.testno || ' (' || al.testcode || ')') AS testname_code,
        al.eol
      FROM AllTests al
        LEFT OUTER JOIN WithSamples ws ON (1=1
          AND al.testcode = ws.testcode
          AND al.analyte= ws.analyte)
      WHERE 1=1
    )
  --- ---
  ---Final Query---
    SELECT DISTINCT
        cb.testcatcode,
        cb.testname_code,
        cb.analyte,
        cb.printflag,
        cb.w_samples,
        cb.loincnumber,
        cb.version,
        cb.loinccomponenet,
        cb.testno,
        cb.testcode,
        cb.eol
    FROM Combined cb
    WHERE 1=1
    ORDER BY
        cb.testcatcode ASC,
        cb.testcode ASC,
        cb.analyte ASC,
        cb.version ASC,
        cb.loincnumber ASC; 
  --- ---    
*/
/*-----------------------------------------------------------------*/





/*-----2.	List of all SNOMED codes in use for results--------------*/
  --This query takes a very long time to run... 30min +
/*
WITH
  ---AllTests---
    AllTests AS (
      SELECT DISTINCT
        t.testcatcode,
        t.testno,
        t.testcode,
        pr.analyte,
        sp.printflag,
        pr.conclusion_report,
        NULL AS w_samples,
        pr.snomedcode,
        sc.snomedelement,
        pr.localnumber,
        pr.cdc_reportable,
        pr.elr_reportable,
        pr.code_system_oid,
        '~' AS eol    
      FROM sundata_prod.possibleresults pr
        INNER JOIN sundata_prod.tests t ON (pr.testcode = t.testcode)
        LEFT OUTER JOIN sundata_prod.snomedcodes sc ON (1=1
          AND pr.snomedcode = sc.snomedcode
          AND pr.result = sc.snomedelement)
        LEFT OUTER JOIN sundata_prod.spec_analytes sp ON (1=1
          AND sp.specno = '3' --Sample Specs
          AND sp.origrec >0
          AND t.testcode = sp.testcode
          AND pr.analyte = sp.analyte)
      WHERE 1=1
        AND t.testcatcode NOT IN ('Retired','Clinical')
--        AND t.testcode = '1'
--        AND tlc.code_system_oid = 'SCT'
      ORDER BY
        t.testcatcode ASC,
        t.testcode ASC,
        pr.analyte ASC,
        sc.snomedelement ASC),  
  --- ---
  ---WithSamples---
    WithSamples AS (
      SELECT DISTINCT
        al.testcatcode,
        al.testno,
        al.testcode,
        al.analyte,
        'Y' AS w_samples,
        al.printflag,
        al.conclusion_report,
        al.snomedcode,
        al.snomedelement,
        al.localnumber,
        al.cdc_reportable,
        al.elr_reportable,
        al.code_system_oid,
        al.eol          
      FROM AllTests al
        INNER JOIN sundata_prod.results r ON (1=1
          AND al.testcode = r.testcode 
          AND al.analyte = r.analyte)
        INNER JOIN sundata_prod.folders f ON (r.folderno = f.folderno)
        INNER JOIN sundata_prod.centralreceiving cr ON (f.external_id = cr.external_id)
        INNER JOIN sundata_prod.metadata_repository mr ON (1=1
          AND mr.tablereference = 'CENTRALRECEIVING'
          AND mr.original_origrec = cr.origrec
          AND mr.field_varchar_80 = 'Diagnostic')
      WHERE 1=1),
  --- ---
  ---Combined---
    Combined AS (
      SELECT DISTINCT
        al.testcatcode,
        al.testno,
        al.testcode,
        al.analyte,
        al.printflag,
        al.conclusion_report,        
        COALESCE(ws.w_samples, 'N') AS w_samples,
        al.snomedcode,
        al.snomedelement,
        al.localnumber,
        al.cdc_reportable,
        al.elr_reportable,
        al.code_system_oid,
        (al.testno || ' (' || al.testcode || ')') AS testname_code,        
        al.eol          
      FROM AllTests al
        LEFT OUTER JOIN WithSamples ws ON (1=1
          AND al.testcode = ws.testcode
          AND al.analyte= ws.analyte)
      WHERE 1=1
    )
  --- ---
  ---Final Query---
    SELECT DISTINCT
        cb.testcatcode,
        cb.testname_code,
        cb.testno,
        cb.testcode,
        cb.analyte,
        cb.printflag,
        cb.conclusion_report,
        cb.w_samples,
        cb.snomedcode,
        cb.snomedelement,
        cb.localnumber,
        cb.cdc_reportable,
        cb.elr_reportable,
        cb.code_system_oid,
        cb.eol          
    FROM Combined cb
    WHERE 1=1
    ORDER BY
        cb.testcatcode ASC,
        cb.testcode ASC,
        cb.analyte ASC,
        cb.snomedcode ASC,
        cb.snomedelement ASC; 
  --- ---
*/  
/*-----------------------------------------------------------------*/



/*-----3. All human test and whats setup for ELR messaging--------*/
  --List all human test and what test are configured for ELR
  
/*  
  WITH
    ---AllTests---
      --All test with associated client, excluding PHLIP
    AllTests AS (
      SELECT DISTINCT
        t.testcatcode,
        t.testno,
        t.testcode,
        t.testflag,
        ha.analyte,
        rc.rasclientid AS client_id,
        '~' AS eol
      FROM sundata_prod.tests t 
        LEFT OUTER JOIN sundata_prod.hl7_analytes ha ON (1=1
          AND t.testcode = ha.testcode)
        LEFT OUTER JOIN sundata_prod.rasclients rc ON (ha.rasclientid = rc.rasclientid)
      WHERE 1=1
        --Exclude non-human test--
        AND t.testcatcode NOT IN (
            'Clinical', 'Environmental', 
            'Food/Miscellaneous', 'QC Inventory', 
            'Safety and Training', 'Retired')
        AND t.testno NOT IN ('Rabies FRA')
        --
        --Only reportable analytes--
        AND (ha.lrn_param = 'N' OR ha.lrn_param IS NULL)
      ),
    --- ---
    ---PHILP test---
      PhlipTest AS (
        SELECT DISTINCT
          t.testcatcode,
          t.testno,
          t.testcode,
          t.testflag,
          tlc.analyte,
          rc.rasclientid AS client_id,
          '~' AS eol
        FROM sundata_prod.hl7_dist_submitters hs
          INNER JOIN sundata_prod.testgroupnames tgn ON (hs.testgroupname = tgn.testgroupname)
          INNER JOIN sundata_prod.sample_programs sp ON (tgn.sp_code = sp.sp_code)
          INNER JOIN sundata_prod.hl7_dist_loincs hl ON (tgn.testgroupname = hl.testgroupname)
          INNER JOIN sundata_prod.tests t ON (hl.testcode = t.testcode)
          INNER JOIN sundata_prod.testloinccodes tlc ON (1=1
            AND t.testcode = tlc.testcode 
            AND hl.analyte = tlc.analyte)
          INNER JOIN sundata_prod.hl7_fieldmap_binder hb ON (hl.header_name = hb.header_name)
          INNER JOIN sundata_prod.rasclients rc ON (hs.rasclientid = rc.rasclientid)
        WHERE 1=1
          AND tgn.status = 'Active'
      ),
    --- ---
    ---Combined---
      Combined AS (
        SELECT DISTINCT
          al.testcatcode,
          al.testno,          
          al.testcode,
          al.testflag,
          al.analyte,
          al.client_id,
          '~' AS eol
        FROM AllTests al 
        
        UNION 
        
        SELECT DISTINCT
          pt.testcatcode,
          pt.testno,
          pt.testcode,
          pt.testflag,
          pt.analyte,
          pt.client_id,
          '~' AS eol
        FROM PhlipTest pt
      ),
      
    --- ---
    ---Aggrigate---
      Aggrigate AS (
        SELECT DISTINCT
          cb.testcatcode,
          cb.testno,          
          cb.testcode,
          cb.testflag,
          cb.analyte,
          ListAgg(cb.client_id, ',') WITHIN GROUP (ORDER BY cb.client_id) AS program_clients,
          cb.eol
        FROM Combined cb
        GROUP BY
          cb.testcatcode,
          cb.testno,
          cb.testcode,
          cb.testflag,
          cb.analyte,
          cb.eol

      )
    --- ---
    ---Final Query---    
        SELECT DISTINCT
          ag.program_clients,
          ag.testcatcode,
          ag.testno,          
          ag.testcode,
          ag.testflag,
          ag.analyte,
          ag.eol
        FROM Aggrigate ag 
        ORDER BY
          ag.testcatcode ASC,
          ag.testno ASC,
          ag.analyte ASC;
*/          
/*-----------------------------------------------------------------*/





/*-----4. List Specimen Source SNOMED List-------------------------*/
  --The Specimen Source SNOMED list is associated with the
  --specimen_sources table and is the "Specimen Type" field in the
  --accessioning screen.  This information for samples is stored in
  --the [CentralReceiving].spec_source field.
/*  
  WITH
  ---AllCodes---
    AllCodes AS (
      SELECT DISTINCT
        src.spectype,
        src.specimen_source,
        NULL AS w_samples,
        src.conceptname,
        src.snomedct,
        src.snomed_description,
        '~' AS eol
      FROM sundata_prod.specimen_sources src
      WHERE 1=1      
      ORDER BY
        src.spectype ASC,
        src.specimen_source ASC,
        src.snomedct ASC,
        src.conceptname ASC
    ),  
  --- ---
  ---WithSamples---
    WithSamples AS (
      SELECT DISTINCT
        ac.spectype,
        ac.specimen_source,
        ac.conceptname,
        ac.snomedct,
        ac.snomed_description,
        'Y' w_samples,
        ac.eol
      FROM  AllCodes ac
        INNER JOIN sundata_prod.centralreceiving cr ON (ac.specimen_source = cr.spec_source)
        INNER JOIN sundata_prod.metadata_repository mr ON (1=1
          AND mr.tablereference = 'CENTRALRECEIVING'
          AND mr.original_origrec = cr.origrec
          AND mr.field_varchar_80 = 'Diagnostic')              
      WHERE 1=1
    ),
  --- ---
  ---Combine---
    Combined AS (
      SELECT DISTINCT
          ac.spectype,
          ac.specimen_source,
          COALESCE(ws.w_samples,'N') AS w_samples,
          ac.conceptname,
          ac.snomedct,
          ac.snomed_description,
          ac.eol
      FROM AllCodes ac
        LEFT OUTER JOIN WithSamples ws ON (1=1
          AND ac.spectype = ws.spectype
          AND ac.specimen_source = ws.specimen_source
          AND ac.snomedct = ws.snomedct)
      WHERE 1=1
    )
  --- ---
  ---FinalQuery---
    SELECT DISTINCT
      cb.spectype,
      cb.specimen_source,
      cb.w_samples,
      cb.conceptname,
      cb.snomedct,
      cb.snomed_description,
      cb.eol
    FROM Combined cb
    WHERE 1=1
    ORDER BY
        cb.spectype ASC,
        cb.specimen_source ASC,
        cb.snomedct ASC,
        cb.conceptname ASC;
  --- ---
*/  
/*-----------------------------------------------------------------*/





/*-----5. List Specimen Site SNOMED List-------------------------*/
  --The Specimen Site information doesn't seem to have a direct
  --relationship to a SNOMED code.
  --The [base_static_data] table in combination with the 
  --[metadata_repository] table define the valus for the Specimen Site
  --This is then displayed on the Sample Description field of the
  --accessioning screen and stored in the [CentralReceiving].sampdesc
  --field.

/*  
  WITH
  ---AllCodes---
    AllCodes AS (
      SELECT DISTINCT
        bs.bs_name AS spec_site,
        mr.field_varchar_01 AS specimen_type,
        mr.field_varchar_10 AS snomed_Description,
        mr.field_varchar_11 AS snomet_ct,        
        NULL AS w_samples,
        bs.bs_id,
        '~' AS eol
      FROM sundata_prod.base_static_data bs
        INNER JOIN sundata_prod.metadata_repository mr ON (1=1
          AND mr.tablereference = 'BASE_STATIC_DATA'
          AND mr.original_origrec = bs.origrec)
      WHERE 1=1
        AND bs.bs_status = 'Active'
        AND bs.bs_type = 'Sample Descriptions'
      ORDER BY
        bs.bs_name ASC,
        bs.bs_id ASC
    ),  
  --- ---
  ---WithSamples---
    WithSamples AS (
      SELECT DISTINCT
        ac.spec_site,
        ac.specimen_type,
        ac.snomed_Description,
        ac.snomet_ct,
        'Y' AS w_samples,
        ac.bs_id,
        ac.eol
      FROM  AllCodes ac
        INNER JOIN sundata_prod.centralreceiving cr ON (ac.spec_site = cr.sampdesc)
      WHERE 1=1
    ),
  --- ---
  ---Combine---
    Combined AS (
      SELECT DISTINCT
        ac.spec_site,
        ac.specimen_type,
        ac.snomed_Description,
        ac.snomet_ct,
         COALESCE(ws.w_samples,'N') AS w_samples,
         ac.bs_id,
         ac.eol
      FROM AllCodes ac
        LEFT OUTER JOIN WithSamples ws ON (ac.spec_site = ws.spec_site)
      WHERE 1=1
    )
  --- ---
  ---FinalQuery---
    SELECT DISTINCT
      cb.spec_site,
      cb.specimen_type,
      cb.snomed_Description,
      cb.snomet_ct,
      cb.w_samples,
      cb.bs_id,
      cb.eol
    FROM Combined cb
    WHERE 1=1
    ORDER BY
        cb.spec_site ASC,
        cb.bs_id ASC;
  --- ---
  */
/*-----------------------------------------------------------------*/




/*-----6. Sex/Gender-----------------------------------------------*/
  --Display list of sex codes along with coordsonding values.
  --[base_static_data] table contains the various sex codes and
  --values.  The Sex field in the accessioning form is stored in
  --the [CentralReceiving]
/*

  WITH
  ---AllCodes---
    AllCodes AS (
      SELECT DISTINCT
        dbms_lob.substr(bs.bs_description) AS sex_desc,
        NULL AS w_samples,
        bs.bs_name AS sex_code,
        bs.bs_id,
        '~' AS eol
      FROM sundata_prod.base_static_data bs
        INNER JOIN sundata_prod.metadata_repository mr ON (1=1
          AND mr.tablereference = 'BASE_STATIC_DATA'
          AND mr.original_origrec = bs.origrec)
      WHERE 1=1
        AND bs.bs_status = 'Active'
        AND bs.bs_type = 'Sex Codes'
      ORDER BY
        sex_desc ASC,
        bs.bs_id ASC
    ),  
  --- ---
  ---WithSamples---
    WithSamples AS (
      SELECT DISTINCT
        ac.sex_desc,
        ac.sex_code,
        ac.bs_id,
        'Y' AS w_samples,
        ac.eol
      FROM  AllCodes ac
        INNER JOIN sundata_prod.centralreceiving cr ON (ac.sex_code = cr.sex)
      WHERE 1=1
    ),
  --- ---
  ---Combine---
    Combined AS (
      SELECT DISTINCT
        ac.sex_desc,
        COALESCE(ws.w_samples,'N') AS w_samples,
        ac.sex_code,
        ac.bs_id,
        ac.eol
      FROM AllCodes ac
        LEFT OUTER JOIN WithSamples ws ON (ac.sex_desc = ws.sex_desc)
      WHERE 1=1
    )
  --- ---
  ---FinalQuery---
    SELECT DISTINCT
      cb.sex_desc,
      cb.w_samples,
      cb.sex_code,
      cb.bs_id,
      cb.eol
    FROM Combined cb
    WHERE 1=1
    ORDER BY
        cb.sex_desc ASC,
        cb.bs_id ASC;
  --- ---
*/  
/*-----------------------------------------------------------------*/




/*-----7. Program Test---------------------------------------------*/
  --Identify the programs and associated test we have congfigured
  --for electronic reporting.
/*
  WITH
    ---LRN-B, ELR---
      clients1 AS (
        SELECT DISTINCT
          (rc.compname || ' (' || rc.rasclientid || ')') AS client,
          (t.testno || ' (' || t.testcode || ')' ) AS test_nacode,
          rc.rasclientid,
          t.testcode,
          '~' AS eol
        FROM sundata_prod.hl7_analytes ha
          INNER JOIN sundata_prod.tests t ON (ha.testcode = t.testcode)
          INNER JOIN sundata_prod.rasclients rc ON (ha.rasclientid = rc.rasclientid)
        WHERE 1=1
        ORDER BY
          client ASC,
          test_nacode ASC
      ),
    ---  ---
    ---PHLIP---
      clients2 AS (  
        SELECT DISTINCT
          (rc.compname || ' (' || rc.rasclientid || ')') AS client,
          (t.testno || ' (' || t.testcode || ')' ) AS test_nacode,
          rc.rasclientid,
          t.testcode,
          '~' AS eol  
        FROM sundata_prod.HL7_DIST_SUBMITTERS hs
          INNER JOIN sundata_prod.rasclients rc ON (hs.rasclientid = rc.rasclientid)
          INNER JOIN sundata_prod.hl7_dist_loincs hl ON (hs.rasclientid = hl.rasclientid)
          INNER JOIN sundata_prod.tests t ON (hl.testcode = t.testcode)
        WHERE 1=1
        ORDER BY
          client ASC,
          test_nacode ASC
      ),
    ---  ---
    ---Combined---
      Combined AS (
        SELECT DISTINCT * FROM clients1
        UNION
        SELECT DISTINCT * FROM clients2
      )
    ---  ---
    ---Final Query---
      SELECT DISTINCT
        CASE c.rasclientid
          WHEN 'CDC' THEN 'LRN-B'
          WHEN 'MEDSIS-TEST' THEN 'ELR'
          WHEN 'PHLIP-FLU' THEN 'PHLIP'
        END AS program,
        c.client,
        c.test_nacode,
        c.eol
      FROM Combined c
      WHERE 1=1
      ORDER BY
        c.client,
        program ASC,
        c.test_nacode ASC;
    ---  ---
*/  
/*-----------------------------------------------------------------*/
