

/*-----------------------------------------------------------------*/
/*-----Rabies Extract----------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Rabies extract development for EPI team.
  /*----- -----*/

  /*-----HISTORY-----*/
    --2015.03.12 JTY: Create script
    --2015.03.23 JTY: Finalized script with EPI folks:
      --Laura Adams
      --Christine Wampler
    --2015.05.05 JTY: Updated to pull Species from results.rn1 instead
      --of CentralReceivingQuestions.
  /*----- -----*/

/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/

--SELECT DISTINCT cq.questioncaption FROM sundata_prod.centralrecvquestions cq Order by cq.questioncaption ASC;

  /*----- -----*/
    SELECT DISTINCT
      cr.external_id AS sample_id,
      --fc.status,
      mr.field_varchar_05 AS animal_type,
--      cq4.response AS species,    ---->Work on where   Results.rn1
      r.rn1 AS species,
      r.final,
      cr.date_collected,
      cr.date_received,
      --Trunc(ot.apprdate) AS test_appr,
      --f.apprdate AS sample_appr,
      cr.pid AS patient_id,
      --rc.rasclientid AS submitter_code,
      rc.compname AS Client_name,
      rc.city AS client_city,
      rc.county AS client_county,
      rc.zip AS client_zip,
      --cq1.response AS different_submitter,
      --cq2.response AS animal_mortality,
      cq3.response AS animal_quarantined,
      cq5.response AS bite_exposure,
      cq6.response AS cross_street,
      cq7.response AS how_bitten,
      cq8.response AS domestic_exposed,
      cq9.response AS address_loc,
      cq10.response AS exposed_persons,
      cq11.response AS nonbite_exposure,
      cq14.response AS provoked,
      cq15.response AS bite_location,      
      cq12.response AS in_public,
      cq13.response AS vaccinated,
      '~' AS EOL
    FROM  sundata_prod.centralreceiving cr
      INNER JOIN sundata_prod.metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      INNER JOIN sundata_prod.rasclients rc ON (cr.rasclientid = rc.rasclientid)
--      
      INNER JOIN sundata_prod.centralrecvquestions cq ON (cr.external_id = cq.external_id)

      INNER JOIN sundata_prod.centralrecvquestions cq1 ON ( 1=1
        AND cr.external_id = cq1.external_id
        AND cq1.questioncaption = 'Agency that collected the animal (diff than submitter)')
      INNER JOIN sundata_prod.centralrecvquestions cq2 ON ( 1=1
        AND cr.external_id = cq2.external_id
        AND cq2.questioncaption = 'Animal mortality status')
      INNER JOIN sundata_prod.centralrecvquestions cq3 ON ( 1=1
        AND cr.external_id = cq3.external_id
        AND cq3.questioncaption = 'Animal quarantined?')
      INNER JOIN sundata_prod.centralrecvquestions cq4 ON ( 1=1
        AND cr.external_id = cq4.external_id
        AND cq4.questioncaption = 'Animal species')
      INNER JOIN sundata_prod.centralrecvquestions cq5 ON ( 1=1
        AND cr.external_id = cq5.external_id
        AND cq5.questioncaption = 'Bite/Exposure')
      INNER JOIN sundata_prod.centralrecvquestions cq6 ON ( 1=1
        AND cr.external_id = cq6.external_id
        AND cq6.questioncaption = 'Closest cross streets')
      INNER JOIN sundata_prod.centralrecvquestions cq7 ON ( 1=1
        AND cr.external_id = cq7.external_id
        AND cq7.questioncaption = 'Describe how and why the patient was bitten')
      INNER JOIN sundata_prod.centralrecvquestions cq8 ON ( 1=1
        AND cr.external_id = cq8.external_id
        AND cq8.questioncaption = 'If wild animal, any domestic animals exposed?')
      INNER JOIN sundata_prod.centralrecvquestions cq9 ON ( 1=1
        AND cr.external_id = cq9.external_id
        AND cq9.questioncaption = 'Location or address of exposure')
      INNER JOIN sundata_prod.centralrecvquestions cq10 ON ( 1=1
        AND cr.external_id = cq10.external_id
        AND cq10.questioncaption = 'Number of Individuals exposed')
      INNER JOIN sundata_prod.centralrecvquestions cq11 ON ( 1=1
        AND cr.external_id = cq11.external_id
        AND cq11.questioncaption = 'Other exposure to Human (non-bite)?')
      INNER JOIN sundata_prod.centralrecvquestions cq12 ON ( 1=1
        AND cr.external_id = cq12.external_id
        AND cq12.questioncaption = 'Was animal found in public space?')
      INNER JOIN sundata_prod.centralrecvquestions cq13 ON ( 1=1
        AND cr.external_id = cq13.external_id
        AND cq13.questioncaption = 'Was animal vaccinated?')
      INNER JOIN sundata_prod.centralrecvquestions cq14 ON ( 1=1
        AND cr.external_id = cq14.external_id
        AND cq14.questioncaption = 'Was bite provoked?')
      INNER JOIN sundata_prod.centralrecvquestions cq15 ON ( 1=1
        AND cr.external_id = cq15.external_id
        AND cq15.questioncaption = 'Where was the person bitten or exposed (body part)?')
--
      INNER JOIN sundata_prod.folders f ON (cr.external_id = f.external_id)
      INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN sundata_prod.ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN sundata_prod.results r ON (1=1
        AND ot.ordno = r.ordno
        AND ot.testcode = r.testcode)
    WHERE 1=1
      AND mr.field_varchar_80 IN ('Diagnostic')
      AND fc.status IN ('OOS', 'Done')
--      AND cr.date_received BETWEEN TO_DATE('01-JAN-2014','DD-MON-YYYY') AND TO_DATE('31-DEC-2014','DD-MON-YYYY')
    ORDER BY
      cr.date_collected DESC,
      cr.external_id ASC;
  /*----- -----*/


/*-----------------------------------------------------------------*/
