

WITH
  ExternalLogins AS (
    SELECT DISTINCT
      u.usrnam,
      MAX(sl.edate) AS last_login,
      '~' AS eol
    FROM starlimslog sl
      INNER JOIN users u ON (sl.usrnam = u.usrnam)
    WHERE 1=1
      AND u.status = 'Active'
      AND u.deptlist = 'External'
    GROUP BY
      u.usrnam
    ORDER BY
      u.usrnam ASC
  ),    
  TimeframeFilter AS (
    SELECT DISTINCT
      (rc.compname || ' (' || rc.rasclientid || ')') AS client_name,
      (u.fullname || ' (' || u.usrnam || ')') AS user_name,
      el.last_login,
      '~' AS eol
    FROM ExternalLogins el
      INNER JOIN users u ON (el.usrnam = u.usrnam)
      INNER JOIN rasclientcontacts rcc ON (u.usrnam = rcc.usrnam)
      INNER JOIN rasclients rc ON (rcc.rasclientid = rc.rasclientid)
    WHERE 1=1
      AND el.last_login BETWEEN
       to_date('2019-01-01','YYYY-MM-DD')
       AND
       to_date ('2019-03-21','YYYY-MM-DD')
    ORDER BY
      last_login DESC,
      client_name ASC,
      user_name ASC
  )
SELECT * FROM TimeframeFilter
