

/*-----------------------------------------------------------------*/
/*-----ApprovalDateMisMatch----------------------------------------*/
  /*-----DESCRIPTION-----*/
    --These script have been created to identify any samples that
    --have an approval date in the Folder table that doesn't match
    --the value in the FolderCondition table.  This type of situation
    --should be impossible.
    
    --we have noticed some cases where a date is in the FolderCondition
    --table, but a coresponding date is NOT in the Folders table.
  /*----- -----*/

  /*-----HISTORY-----*/
    --2016.02.22 JTY: Created Scripts
  /*----- -----*/

/*-----------------------------------------------------------------*/





/*-----------------------------------------------------------------*/
  /*-----01.Identify Suspect Samples-----*/
    SELECT DISTINCT
      f.external_id,
      f.apprdate AS f_apprdate,
      fc.approveddate AS fc_approveddate,
      f.approvedby AS f_approvedby,
      fc.approvedby AS fc_approvedby,
      f.apprsts AS f_apprsts,
      fc.approvalstatus AS fc_approvalstatus,
      '~' AS eol
    FROM sundata_prod.folders f
      INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
    WHERE 1=1
      AND (
        (COALESCE(fc.approveddate,to_date('01-JAN-1900','DD-MM-YYYY')) <> COALESCE(f.apprdate,to_date('01-JAN-1900','DD-MM-YYYY')))
      )
    ORDER BY
      f.external_id DESC;
  /*----- -----*/

  /*-----02. Folders Table Repair-----*/
    --Use this script to repair identified samples by taking information from the
    --FolderCondition table for the Folders table values.
/*
    MERGE INTO sundata_prod.folders t1
    USING (
      SELECT DISTINCT
        f.external_id,
        f.folderno,
        f.apprdate AS f_apprdate,
        fc.approveddate AS fc_approveddate,
        f.approvedby AS f_approvedby,
        fc.approvedby AS fc_approvedby,
        f.apprsts AS f_apprsts,
        fc.approvalstatus AS fc_approvalstatus,
        '~' AS eol
      FROM sundata_prod.folders f
        INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
      WHERE 1=1
        AND (COALESCE(fc.approveddate,to_date('01-JAN-1900','DD-MM-YYYY')) 
            <>  COALESCE(f.apprdate,to_date('01-JAN-1900','DD-MM-YYYY')))
        --Exculde List
--        AND (f.external_id NOT IN ('AZ00019926'))
      ORDER BY
        f.external_id DESC
    ) t2
    ON (t1.folderno=t2.folderno)    
    WHEN MATCHED THEN
      UPDATE SET
        t1.apprdate = t2.fc_approveddate,
        t1.approvedby = t2.fc_approvedby,
        t1.apprsts = t2.fc_approvalstatus,
        t1.apprdisp = t2.fc_approvalstatus
*/
  /*----- -----*/
  
    /*-----0. FolderCondition Table Repair-----*/
    --Use this script to repair identified samples by taking information from the
    --Foldes table for the FolderCondition table values.    
    
    --Note, we havn't needed this query at this point, just copy query
    --above for Folders repair, and make appropriate corrections.
  /*----- -----*/
  
  
  
/*-----------------------------------------------------------------*/
