


/*-----CIFOR MERGE FIX-------------------------------------------------------*/
  --Use these scripts to identify and fix any records that are causing the
  --batch merge file to fail.  The error that is reported is:
  
  
  --    ERROR at line 1:
  --    ORA-30926: unable to get a stable set of rows in the source tables
  --    ORA-06512: at "SUNDATA_PROD.CIFOR_PKG", line 403
  --    ORA-06512: at "SUNDATA_PROD.CIFOR_PKG", line 463
  --    ORA-06512: at "SUNDATA_PROD.CIFOR_PKG", line 90
  --    ORA-06512: at "SUNDATA_PROD.CIFOR_PKG", line 119
  --    ORA-06512: at line 11
/*---------------------------------------------------------------------------*/



/*-----01 Identify Duplicate Person -----------------------------------------*/
  --Identify same person with different address
  WITH
    --Identified_Records--
    Identified_Records AS (
      SELECT DISTINCT
        'Home' AS address_type,
        cr.owner_address,
        cr.owner_city,
        cr.owner_zip,
        cr.owner_county,
        cr.owner_state,
        cr.owner_country,
        cr.patient_id,
        SUBSTR('MEDSIS ' || (TO_CHAR(TRUNC(sysdate))),1,25) AS description,
        pa.origrec AS pa_origrec,
        cr.origrec AS cr_origrec,
        '~' AS EOL
      FROM centralreceiving cr
        INNER JOIN patient_addresses pa ON (cr.patient_id = pa.patient_id)
      WHERE 1=1
        AND cr.external_pid2 LIKE '%MEDSIS%'
        AND pa.address_type = 'Home'
        AND (
          COALESCE(cr.owner_address,'-') <> COALESCE(pa.address,'-')
          OR COALESCE(cr.owner_city,'-') <> COALESCE(pa.city,'-')
          OR COALESCE(cr.owner_zip,'-') <> COALESCE(pa.zip,'-')
          OR COALESCE(cr.owner_county,'-') <> COALESCE(pa.county,'-')
          OR COALESCE(cr.owner_state,'-') <> COALESCE(pa.state,'-')
          OR COALESCE(cr.owner_country,'-') <> COALESCE(pa.country,'-')
        )
      ORDER BY 
        pa_origrec ASC
    ),
    -- --
    --Duplicate_Patients--
    Duplicate_Patients AS (
      SELECT DISTINCT
        ir1.*
      FROM Identified_Records ir1
        INNER JOIN Identified_Records ir2 ON (1=1
          AND ir1.pa_origrec = ir2.pa_origrec
          AND ir1.owner_address <> ir2.owner_address)
      WHERE 1=1
    )
    -- --
    SELECT dp.owner_address, dp.* FROM Duplicate_Patients dp
/*---------------------------------------------------------------------------*/


/*-----02 Update address to match--------------------------------------------*/
/*
  UPDATE Centralreceiving cr
  SET cr.owner_address = '&PatientAddress'
  WHERE 1=1
    AND cr.patient_id  = '&PatientID'
*/    
/*---------------------------------------------------------------------------*/
