/*-----DataScrubScripts------------------------------------------------------*/
  /*-----Description-----*/
    --This set of scripts have been created to review and clean any data
    --between tables that don't seem to match as they should.
    --The following scripts are included:
      --1. Disposition Match - Make sure Folder.dispsts and FolderCondition.dispsts
      --                       fields match values.
  /*----- -----*/ 

  /*-----History-----*/
  /*----- -----*/
  
/*---------------------------------------------------------------------------*/




/*-----1. Disposition Match--------------------------------------------------*/
  --Folder.dispsts should match FolderCondition.dispsts.  But why so many
  --don't match with fc.dispsts = Draft  ???
MERGE INTO sundata_prod.foldercondition t1
USING (
  SELECT DISTINCT
    fc.folderno,
    f.apprsts,
    f.dispsts,
    f.fldsts,
    fc.status, 
    fc.dispsts AS fc_dispsts,
    fc.approveddate,
    f.apprdate,
    '~' AS eol
  FROM sundata_prod.foldercondition fc
    INNER JOIN sundata_prod.folders f ON (fc.folderno = f.folderno)
  WHERE 1=1
    AND fc.approveddate IS NOT NULL
    AND fc.approvedby IS NOT NULL
  AND fc.dispsts NOT IN('Draft','Cancel')
  AND fc.dispsts <> f.dispsts
  ORDER BY
    fc.folderno DESC
) t2
ON (t1.folderno = t2.folderno)
WHEN MATCHED THEN
  UPDATE SET t1.dispsts = t2.dispsts
/*---------------------------------------------------------------------------*/



--select distinct fc.dispsts from sundata_prod.foldercondition fc where fc.dispsts NOT IN ('Draft', 'Cancel')

/*
SELECT DISTINCT
  f.dept,
  f.folderno,
  rcx.fullname,
  f.apprsts,
  f.apprdisp,
  f.apprdate,
  f.approvedby,
  fc.approvalstatus,
  fc.dispsts,
  fc.approveddate,
  fc.approvedby,
  r.final,
  ot.apprdate,
  ot.apprvedby,
  '~' AS eol
FROM sundata_prod.centralreceiving cr
  INNER JOIN sundata_prod.folders f ON (cr.external_id = f.external_id)
  INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
  INNER JOIN sundata_prod.ordtask ot ON (f.folderno = ot.folderno)
  INNER JOIN sundata_prod.results r ON (1=1
    AND ot.ordno = r.ordno
    AND ot.testcode = r.testcode)
  INNER JOIN sundata_prod.folderscontactsext fcx ON (1=1
    AND cr.rasclientid = fcx.rasclientid
    AND f.folderno = fcx.folderno)
  INNER JOIN sundata_prod.rasclientcontactsext rcx ON (1=1
    AND fcx.rasclientid = rcx.rasclientid
    AND fcx.contactid = rcx.contactid)
WHERE 1=1
  AND f.dept = 'PHX-TB'
  AND f.apprsts = 'Released'
  AND cr.rasclientid = 'MCHD-TB'
--  AND f.external_id IN ('AZ00048350', )
--  AND f.apprsts = 'DONE'
ORDER BY
  f.dept ASC,
  f.folderno DESC
*/
