

/*-----InventoryDefaultFix-----------------------------------------*/
  /*----------DESCRIPTION----------*/
    --Use the provided script her to identify inventory associated
    --with the material of interest to determine if more than one
    --inventory id is set as the default inventory.  Then make
    --corrections to the identified inventory id to ensure only 
    --one inventory id is the default inventory.
  /*---------- ----------*/  

  /*----------HISTORY----------*/
    --2013.10.01 JTY: Created Script
  /*---------- ----------*/  

  /*----------Environments----------*/  
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  
  /*---------- ----------*/    
/*-----------------------------------------------------------------*/


/*-----Identify and Fix--------------------------------------------*/
  /*----------Identify conflicting inventory id's----------*/
    --Note, if only one record is returned, there should not be a problem.
    SELECT DISTINCT
      i.matcode,
      i.inventoryid,
      i.default_inv,
      i.status,
      i.expire_date,
      i.origrec,
      '~' AS eol
    FROM &Environment.Inventory i
    WHERE 1=1
      AND i.matcode = '&MatCode'
      AND i.default_inv = 'Y'
    ORDER BY
      i.matcode ASC,
      i.inventoryid ASC,
      i.expire_date ASC;
  /*---------- ----------*/  

  /*----------Update default_inv flag----------*/
    --Set the default_inv flag to 'N' for provided
    --inventory_id.
/*  
    UPDATE &Environment.Inventory i
    SET i.default_inv = 'N'
    WHERE 1=1
      AND i.inventoryid = '&InventoryID'
*/      
  /*---------- ----------*/  

/*-----------------------------------------------------------------*/

