
  
/*-----InventorySupplierFix----------------------------------------*/
  /*----------Description---------*/
    --Use this set of queries to identify and repair any inventory
    --that does not have a supplier associated with it.
    
  /*---------- ---------*/  

  /*----------Envrionments---------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod  
  /*---------- ---------*/  

  /*----------History---------*/
    --2013.08.22 JTY: Created Scripts
  /*---------- ---------*/  

/*-----------------------------------------------------------------*/





/*-----Identify Inventory with no suppliers------------------------*/
  --List of inventory that is missing a related supplier  
  SELECT DISTINCT
    l.dept,
    m.matcode,
    m.matname,
    m.mattype,
    i.suppcode,
    --m.mattype,
    --i.lotno,
    --l.location,
    --i.status,    
    --i.unit_code,
    --i.expire_date,
    --i.inventoryid,
    --i.receive_date,
    --ic.amountchange,
    --ic.balance,
    --ic.datechange,
    '~' AS eol  
  FROM &Environment.inventory i
    INNER JOIN &Environment.Inventorychange ic ON (i.inventoryid = ic.inventoryid)
    INNER JOIN &Environment.locations l ON (ic.locationcode = l.locationcode)
    INNER JOIN &Environment.materials m ON (i.matcode = m.matcode)
    --INNER JOIN sundata_prod.suppliers s ON (i.suppcode = s.suppcode)    
  WHERE 1=1
    --AND i.matcode = 'Proteinase K'
    AND i.suppcode IS NULL
  ORDER BY
    l.dept ASC,
    m.matcode ASC;    
/*-----------------------------------------------------------------*/




/*-----Suppliers Association---------------------------------------*/
  --This script will take all valid materials and update the supplier
  --code to the identified supplier from the adhs_tempsup table.
/*
  MERGE INTO &Envrionment.inventory i
  USING (
    SELECT DISTINCT  
     i.matcode,
     ts.suppcode
    FROM &Envrionment.inventory i
      INNER JOIN sunrise_data.adhs_tempsup ts ON (i.matcode = ts.matcode)
    WHERE 1=1
      AND i.suppcode IS NULL 
    ORDER BY
      i.matcode ASC  
    ) ns
  ON (i.matcode = ns.matcode)
  WHEN MATCHED THEN
    UPDATE SET
      i.suppcode = ns.suppcode
*/      

/*-----------------------------------------------------------------*/  
  




/*-----Catch any straglers-----------------------------------------*/  
  --Catch any materials that are not in the recognized list and
  --default them to "In-House"
/*  
  SELECT * FROM &Environment.inventory i 
  WHERE 1=1
    AND i.suppcode IS NULL
  ORDER BY 
    i.matcode ASC
*/
/*
  UPDATE &Environment.inventory i 
  SET i.suppcode = 'In-House'
  WHERE 1=1
    AND i.suppcode IS NULL
*/    
/*-----------------------------------------------------------------*/  
