/*=================================================================*/
/*=====PatientRecordsFix===========================================*/
  /*-----Description-----*/
    --Use scripts provided here to update information related to
    --patients record.  Patient related tables include CentralReceiving
    --and Patients.
    --The following Script Sets are included:
    --01. Patient Date of Birth
    --02. Patient Name
  /*----- -----*/  

  /*-----HISTORY-----*/
    --2014.04.29 JTY: Created Script
    --2015.07.16 JTY: Update script to include Patient Name scipts
  /*----- -----*/  

/*=================================================================*/




/*=====01. Patient Date of Birth==================================*/
  /*----------Usage Notes----------*/
    --Provided scripts here can be used to update Date Of Birth 
    --issues related to the [Patients] table, and the 
    --[CentralReceiving] table.
    --
  /*----------  ----------*/



/*-----Data Review-------------------------------------------------*/
/*
  --Review current values for specified records.  
      SELECT DISTINCT
        p.patient_id,
        '~' AS sp1,
        f.dept,
        cr2.origrec AS cr_origrec,
        cr2.rasclientid,
        cr2.external_id,
        (cr2.last_name || ', ' || cr2.first_name) AS cr_name,
        cr2.birth_date AS cr_dob,
        '~' AS sp2,
        p.origrec AS p_origrec,
        (p.last_name || ', ' || p.first_name) AS p_name,
        p.date_of_birth AS p_dob,
        '~' AS eol
      FROM &Environment.centralreceiving cr
        LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
        INNER JOIN &Environment.centralreceiving cr2 ON (p.patient_id = cr2.patient_id)
        INNER JOIN &Environment.folders f ON (cr.external_id = f.external_id)
      WHERE 1=1
        AND cr.external_id = '&SampleID'
--        AND cr.patient_id = '&PatientID'
      ORDER BY
        cr2.external_id ASC,
        (cr2.last_name || ', ' || cr2.first_name) ASC;
*/
/*-----------------------------------------------------------------*/


/*-----Brute Force Update for Patient Date of Birth----------------*/

  ---CentralReceiving Table---
    UPDATE centralreceiving cr SET cr.birth_date = to_date('&DateOfBirth', 'DD-MON-YYYY')
    WHERE 1=1
      AND cr.patient_id = '&PatientID';
  --- ---
  ---Patients table---
    UPDATE patients p SET p.date_of_birth = to_date('&DateOfBirth', 'DD-MON-YYYY')
    WHERE 1=1
      AND p.patient_id  = '&PatientID';

   select cr.first_name, cr.last_name, cr.birth_date from centralreceiving cr where cr.patient_id = '&PatientID';
   select p.first_name, p.last_name, p.date_of_birth from patients p WHERE p.patient_id  = '&PatientID'
/*-----------------------------------------------------------------*/



/*-----Merge Updates-----------------------------------------------*/
  --Updates provided here assume that there is a correct DOB in 
  --the referenced table.  It uses the referenced table to update
  --the table that has the incorrrect value.

  -----Update Patients Record-----
    --Will update the [Patients].date_of_birth value with the
    --value located in the [CentralReceiving].birth_date given 
    --the SampleID associated with this patient.
/*    
    MERGE INTO &Environment.patients T1
    USING (
      SELECT DISTINCT
        p.patient_id,
        cr.external_id,
        (cr.last_name || ', ' || cr.first_name) AS patient_name,
        cr.birth_date AS cr_dob,
        p.date_of_birth AS p_dob,
        '~' AS eol
      FROM &Environment.centralreceiving cr
        LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
      WHERE 1=1
        AND cr.external_id = '&SampleID'
      ORDER BY
        cr.external_id
      )  T2
    ON ( 1=1
         AND T1.patient_id = T2.patient_id
       )
    WHEN MATCHED THEN
      UPDATE SET T1.Date_Of_Birth = T2.cr_dob;


  SELECT DISTINCT
    p.patient_id,
    cr.external_id,
    (cr.last_name || ', ' || cr.first_name) AS patient_name,
    cr.birth_date AS cr_dob,
    p.date_of_birth AS p_dob,
    cr.origrec AS cr_origrec,
    p.origrec AS p_origrec,
    '~' AS eol
  FROM &Environment.centralreceiving cr
    LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
  WHERE 1=1
    --Comment out as needed--
    AND cr.external_id = '&SampleID'
    --AND cr.patient_id = '&PatientID'
    --
  ORDER BY
    cr.external_id;      
      
*/      
  -----

  -----Update CentralReceivng Record-----
    --Will update the [CentralReceiving].birth_date value with the
    --value located in the [Patients].date_of_birth. given 
    --the SampleID associated with this patient.
/*    
    MERGE INTO &Environment.centralreceiving T1
    USING (
      SELECT DISTINCT
        p.patient_id,
        cr.external_id,
        (cr.last_name || ', ' || cr.first_name) AS patient_name,
        cr.birth_date AS cr_dob,
        p.date_of_birth AS p_dob,
        '~' AS eol
      FROM &Environment.centralreceiving cr
        LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
      WHERE 1=1
        AND cr.external_id = '&SampleID'
--        AND cr.patient_id = '&PatientID'
AND cr.last_name = p.last_name
AND cr.first_name = p.first_name       
      ORDER BY
        cr.external_id
      )  T2
    ON ( 1=1
         AND T1.patient_id = T2.patient_id 
         --Comment this out if you want to update all CR records for this patient.
         --AND T1.external_id = '&SampleID'  
       )
    WHEN MATCHED THEN
      UPDATE SET T1.birth_date = T2.p_dob;
      
  SELECT DISTINCT
    p.patient_id,
    cr.external_id,
    (cr.last_name || ', ' || cr.first_name) AS patient_name,
    cr.birth_date AS cr_dob,
    p.date_of_birth AS p_dob,
    cr.origrec AS cr_origrec,
    p.origrec AS p_origrec,
    '~' AS eol
  FROM &Environment.centralreceiving cr
    LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
  WHERE 1=1
    --Comment out as needed--
    AND cr.external_id = '&SampleID'
    --AND cr.patient_id = '&PatientID'
    --
  ORDER BY
    cr.external_id;      
*/      
  -----  
  
/*-----------------------------------------------------------------*/

/*-----Brute Force Updates-----------------------------------------*/

  -----Patients Table Update-----
/*
    UPDATE &Environment.patients p
    SET p.date_of_birth = TO_DATE('&PatientDOB', 'DD-MON-YYYY')
    WHERE 1=1
      AND p.origrec = '&p_origrec';
*/      
  -----
  -----CentralReceiving Table Update-----
/*  
    UPDATE &Environment.centralreceiving cr
    SET cr.birth_date = TO_DATE('&CentralReceivingDOB', 'DD-MON-YYYY')
    WHERE 1=1
      AND cr.origrec = '&cr_origrec';
*/      
  -----
/*-----------------------------------------------------------------*/
/*=================================================================*/

---Update Sex
--UPDATE sundata_prod.patients p SET p.sex = 'M' WHERE p.patient_id = 'PID00036262'
--UPDATE sundata_prod.centralreceiving cr SET cr.sex = 'M' WHERE cr.external_id = 'AZ00041538'






/*=====02. Patient Name===========================================*/
  /*----------Usage Notes----------*/
    --Provided scripts here can be used to update Patient Name 
    --issues related to the [Patients] table, and the 
    --[CentralReceiving] table.
    --
  /*----------  ----------*/

/*-----Data Review-------------------------------------------------*/
--select cr2.* from sundata_prod.centralreceiving cr2
--select p.* from sundata_prod.patients p
/*
  --Review current values for specified records.  
      SELECT DISTINCT
        p.patient_id,
        '~' AS sp1,
        cr2.rasclientid,
        cr2.external_id,
        '~' AS sp2,
        cr2.last_name AS cr_last,
        cr2.first_name AS cr_first,
        cr2.middle_initial AS cr_mi,
        p.last_name AS p_last,
        p.first_name AS p_first,
        p.middle_name AS p_middle_name,
        cr2.birth_date AS cr_dob,
        p.date_of_birth AS p_dob,
        '~' AS sp3,
        cr.origrec as cr_origrec,
        cr2.origrec AS cr_origrec,
        p.origrec AS p_origrec,
        '~' AS eol
      FROM &Environment.centralreceiving cr
        LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
        INNER JOIN &Environment.centralreceiving cr2 ON (p.patient_id = cr2.patient_id)
      WHERE 1=1
--        AND cr.external_id = '&SampleID'
--        AND cr.patient_id = '&PatientID'
      AND cr.external_id IN ('AZ00031913','AZ00032032')
      ORDER BY
        cr2.external_id ASC,
        (cr2.last_name || ', ' || cr2.first_name) ASC;
        
*/        
/*-----------------------------------------------------------------*/

/*-----Merge Updates-----------------------------------------------*/
  --Updates provided here assume that there is a correct Name in 
  --the referenced table.  It uses the referenced table to update
  --the table that has the incorrrect value.

  -----Update Patients Record-----
    --Will update the [Patients] first, mi, last values with the
    --value located in the [CentralReceiving] table given 
    --the SampleID associated with this patient.
/*
    MERGE INTO &Environment.patients T1
    USING (
      SELECT DISTINCT
        p.patient_id,
        cr.external_id,
        '~' AS SP1,
        cr.last_name AS cr_last_name,
        cr.first_name AS cr_first_name,
        cr.middle_initial AS cr_middle_initial,
        '~' AS SP2,
        p.last_name AS p_last_name,
        p.first_name AS p_first_name,
        p.middle_name AS p_middle_name,
        '~' AS eol
      FROM &Environment.centralreceiving cr
        LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
      WHERE 1=1
        AND cr.external_id = '&SampleID'
      ORDER BY
        cr.external_id
      )  T2
    ON ( 1=1
         AND T1.patient_id = T2.patient_id
       )
    WHEN MATCHED THEN
      UPDATE SET
        T1.last_name = T2.cr_last_name,
        T1.first_name = T2.cr_first_name,
        T1.middle_name = T2.cr_middle_name;

  ---Review Results of Update---

  SELECT DISTINCT
    p.patient_id,
    cr.external_id,
    p.last_name AS p_last_name,

    p.first_name AS p_first_name,
    cr.first_name AS cr_first_name,
    p.middle_name AS p_middle_name,
    cr.middle_initial AS cr_middle_initial,
    cr.origrec AS cr_origrec,
    p.origrec AS p_origrec,
    '~' AS eol
  FROM &Environment.centralreceiving cr
    LEFT OUTER JOIN &Environment.patients p ON (cr.patient_id = p.patient_id)
  WHERE 1=1
    --Comment out as needed--
    AND cr.external_id = '&SampleID'
    --AND cr.patient_id = '&PatientID'
    --
  ORDER BY
    cr.external_id;      
*/      

  -----

  -----  
  
/*-----------------------------------------------------------------*/

/*-----Brute Force Updates-----------------------------------------*/



  -----Patients Table Update-----

    UPDATE &Environment.patients p
    SET 
      p.last_name = '&LastName',
      p.first_name = '&FirstName',
      p.middle_name = '&MiddleName'      
    WHERE 1=1
      AND p.patient_id = '&p_patient_id';
  -----
  -----CentralReceiving Table Update-----
  
    UPDATE &Environment.centralreceiving cr
    SET 
      cr.last_name = '&LastName',
      cr.first_name = '&FirstName',
      cr.middle_initial = '&MiddleName'      
    WHERE 1=1
      AND cr.patient_id = '&cr_patient_id';      
      
  -----
/*-----------------------------------------------------------------*/
/*=================================================================*/
