

/*-----------------------------------------------------------------*/
/*-----Patient_MakeNew---------------------------------------------*/
  /*-----Description-----*/
  --Scripts provided here are for creating a new patient.
  --NOTE: You need to make sure to update the PATIENT_ID counter 
  --located in the Counters tab of the Settings application so that
  --the Patient ID does not get overwritten by new samples.
  /*----- -----*/
  
  /*-----Environments-----*/
    --DEV:  SUNRISE_DATA
    --TEST: SUNDATA_SAT
    --PROD: SUNDATA_PROD   
  /*----- -----*/

  /*-----History-----*/
    --2014.09.11 JTY: Created script
  /*----- -----*/


/*-----------------------------------------------------------------*/

--DELETE FROM sundata_sat.Patients p WHERE P.PATIENT_ID = 'PID00007621'

--SELECT * FROM sundata_sat.Patients p order by p.origrec desc;

--SELECT MAX(p.patient_id) FROM sundata_sat.Patients p
/*-----------------------------------------------------------------*/


  /*-----Patient Review-----*/  
    SELECT DISTINCT
      (cr.last_name || ', ' || cr.first_name || ' ~' || cr.middle_initial) AS patient_name,
      cr.birth_date,
      cr.patient_id,
      cr.external_id,
      cr.pid,  
      '~' AS eol
    FROM &Environment.centralreceiving cr
    WHERE 1=1
      AND to_date('&DateOfBirth','DD-MON-YYYY') = cr.birth_date
    ORDER BY 
    cr.patient_id ASC,
    cr.external_id ASC;
  /*----- -----*/  

SELECT MAX(patient_id) FROM &Environment.Patients;
  /*-----Create a New Patient-----*/
/*  

--DON'T FORGET TO UPDATE THE PATIENT_ID counter in STARLIMS!!!
  
    INSERT 
    INTO &Environment.patients p(
      p.patient_id,
      p.origsts, p.first_name, p.last_name,
      p.middle_name, p.date_of_birth, p.age,
      p.sex, p.status    
    )
    VALUES (
      '&PatientID',
      'N', '&FirstName', '&LastName',
      '&MiddleInitial', 
      TO_DATE('&BirthDate','DD/MM/YYYY'), 
      FLOOR(MONTHS_BETWEEN(SYSDATE,TO_DATE('&BirthDate','DD/MM/YYYY'))/12),
      '&Sex', 'Active'
    )    
*/    
    
  /*----- -----*/  

  /*-----Link Sample Top Patient -----*/
/*  
    SELECT * FROM sundata_sat.centralreceiving;
    
    UPDATE
    &Environment.centralreceiving cr
    SET cr.patient_id = '&PatientID'
    WHERE 1=1
      AND cr.external_id IN (&Samples)
      
*/  
  /*----- -----*/
    
/*-----------------------------------------------------------------*/




/*-----Odds-N-Ends-------------------------------------------------*/
/*
    SELECT * FROM sundata_sat.centralreceiving cr
    WHERE 1=1
      AND cr.external_id IN ('AZ00000063', 'AZ00000040')   

select * from patients p where p.patient_id = 'PID00019336'
    UPDATE
    &Environment.patients p
    SET 
      p.first_name = 'Bertha Alicia',
      p.last_name = 'Mendivil Pacheco'
    WHERE 1=1
      AND p.patient_id = 'PID00019336'
      
DELETE FROM patients p where p.patient_id = 'PID00019336'       
*/      


----Central Receiving Update
/*
    UPDATE
    &Environment.CentralReceiving cr    
    SET 
      cr.first_name = 'Bertha Alicia',
      cr.last_name = 'Mendivil Pacheco'
    WHERE 1=1
      --AND cr.patient_id = 'PID00021006'
      AND cr.pid = '0101818581'
*/
/*-----------------------------------------------------------------*/
