

/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/
--SELECT * FROM sundata_prod.ordtask ot WHERE 1=1;
--SELECT * FROM sundata_prod.tests t WHERE 1=1




/*-----------------------------------------------------------------*/
  --Conditions and limitations:  This set of quieries assumes that there
  --are no more than two conflicting 


  ---
  WITH
    ---SuspectRuns---
      SuspectRuns AS (
        SELECT DISTINCT
          r.runno
        FROM ordtask ot
          INNER JOIN runs r ON (r.runno = ot.runno)
            WHERE 1=1
              AND (
                    (
                     COALESCE(ot.apprvedby ,'NULL') 
                     <> 
                     COALESCE(r.approvedby ,'NULL')
                    )
                  OR
                    (
                     COALESCE(TO_CHAR(ot.apprdate,'DD-MON-YYYY') ,'NULL')
                     <>
                     COALESCE(TO_CHAR(r.approvedate,'DD-MON-YYYY') ,'NULL')
                    )
                  )
         ORDER BY r.runno ASC
      ),
    ---
    ---RunDetails---
      --Identify runs that are suspect (samples have conflicting approv info)
      RunDetails AS (
        SELECT DISTINCT
          sr.runno,
          ot.ordno,
          t.testno,
          t.testcode,
          t.testflag,
          ot.stepcode,
          ot.folderno,
          --run approval--
          COALESCE(TO_CHAR(r.approvedate,'DD-MON-YYYY') ,'NULL')  AS run_approvedate,
          COALESCE(r.approvedby ,'NULL') AS run_approvedby,
          --OrdTask approval--
          COALESCE(ot.apprvedby ,'NULL') AS ot_apprvedby,
          COALESCE(TO_CHAR(ot.apprdate,'DD-MON-YYYY') ,'NULL') AS ot_apprdate,
          --
          '~' AS eol
        FROM SuspectRuns sr
          INNER JOIN sundata_prod.runs r ON (sr.runno = r.runno)
          INNER JOIN sundata_prod.ordtask ot ON (sr.runno = ot.runno)
          INNER JOIN sundata_prod.tests t ON (ot.testcode = t.testcode)
        WHERE 1=1
--          AND ot.stepcode = 'Run Resulted'
--AND ot1.folderno = 'AZ00010667-01'     
--AND ot1.folderno LIKE 'AZ00010667%'     
--and ot1.runno = '58'
        ORDER BY
          sr.runno ASC,
          ot.ordno ASC,
          t.testno ASC,
          t.testcode ASC,
          t.testflag ASC,
          ot.stepcode ASC,
          ot.folderno ASC
      ),
    ---
    ---Tabulated---
      --Tabulate the dates
      Tabulated AS (
        SELECT DISTINCT
          rd.runno,
          rd.ordno,          
          rd.testno,
          rd.testcode,
          rd.testflag,          
          rd.stepcode,
          Count(CASE
              WHEN (ot.apprvedby = rd.ot_apprvedby) THEN 1
              ELSE NULL
              END) AS cnt_apprvedby_1,
          rd.ot_apprvedby,
          rd.ot_apprdate,
          Count(CASE
              WHEN (ot.apprvedby = rd.run_approvedby) THEN 1
              ELSE NULL
              END) AS cnt_apprvedby_2,
          rd.run_approvedby,
          rd.run_approvedate,
          rd.eol
        FROM RunDetails rd
        INNER JOIN sundata_prod.ordtask ot ON (rd.runno = ot.runno)
        WHERE 1=1
        GROUP BY
          rd.runno,
          rd.ordno,                    
          rd.testno,
          rd.testcode,
          rd.testflag,                    
          rd.stepcode,
          rd.ot_apprvedby,
          rd.ot_apprdate,
          rd.run_approvedby,
          rd.run_approvedate,          
          rd.eol          
      ),      
    ---
    ---ToTable---
      --Create table with results for ease of handling
      ToTable AS (
         --Break this up into a table for ease of using      
        SELECT DISTINCT
          t.runno,
          t.ordno,                    
          t.testno,
          t.testcode,
          t.testflag,                    
          t.stepcode,
          t.cnt_apprvedby_1 AS rec_cnt,
          t.ot_apprdate AS apprdate,
          t.ot_apprvedby AS apprvedby,
          t.eol
        FROM Tabulated t
        WHERE 1=1
        UNION
        SELECT DISTINCT
          t.runno,
          t.ordno,                              
          t.testno,
          t.testcode,
          t.testflag,                              
          t.stepcode,
          t.cnt_apprvedby_2 AS rec_cnt,        
          t.run_approvedate AS apprdate,
          t.run_approvedby AS apprvedby,
          t.eol
        FROM Tabulated t
        WHERE 1=1)
    ---  
select * from ToTable

/*
    
      
    ---RemoveTies---
      --We need to remove runs where the counts are equal
      RemoveTies AS (
      SELECT DISTINCT 
          tt1.runno,
          tt1.ordno,                              
          tt1.testno,
          tt1.testcode,
          tt1.testflag,                              
          tt1.stepcode,
          tt1.rec_cnt,        
          tt1.apprdate,
          tt1.apprvedby,
          tt1.eol      
      FROM ToTable tt1
        INNER JOIN ToTable tt2 ON (tt1.runno = tt2.runno)
      WHERE 1=1
        AND tt1.rec_cnt <> tt2.rec_cnt
      ORDER BY
        tt1.runno ASC),
    ---            
    
--      SELECT DISTINCT runno FROM ToTable     --How many suspect runs are there?323
    ---ProposedUpdate---
      ProposedUpdate AS (
         --Get the proposed approval values    
        SELECT DISTINCT
          rt.runno,
          rt.ordno,                    
          rt.testno,
          rt.testcode,
          rt.testflag,                    
          rt.stepcode,
          rt.rec_cnt,
          rt.apprdate,
          rt.apprvedby,
          rt.eol
        FROM RemoveTies rt
        WHERE 1=1
          AND rt.rec_cnt = (SELECT DISTINCT MAX(rec_cnt)OVER() FROM RemoveTies WHERE rt.ordno = ordno)
        ORDER BY 
          rt.runno ASC),
    ---              
--select DISTINCT runno, apprdate, apprvedby from ProposedUpdate ORDER BY RUNNO ASC --269 runs    
   ---EventFlowLogCheck---
      --Make sure proposed change matches EventFlowLog values
      EventFlowLogCheck AS (
        SELECT DISTINCT
          pu.runno,
          pu.ordno,                              
          pu.testno,
          pu.testcode,
          pu.testflag,                              
          pu.stepcode,
--fel.usrnam,  
--fel.eventdate,        
          pu.rec_cnt,
          pu.apprdate,
          pu.apprvedby,
          pu.eol
        FROM ProposedUpdate pu
        INNER JOIN sundata_prod.floweventlog fel ON (1=1
          AND pu.ordno = fel.ordno
          AND pu.testcode = fel.testcode)
        WHERE 1=1
          AND fel.stepcode = 'Done Testing'
          AND pu.apprdate <> trunc(fel.eventdate)

--and fel.eventdate IS NULL               
      )
      
SELECT DISTINCT RUNNO, apprdate, apprvedby FROM  EventFlowLogCheck
*/    
--SELECT distinct eventtype, stepcode FROM sundata_prod.floweventlog where ordno = 'AZ00000003-01-001'
/*-----------------------------------------------------------------*/

/*
select
from sundata_prod.runs r
INNER JOIN sundata_prod.floweventlog fel ON (r.runno = fel.runno)
WHERE r.approvedate <> fel.eventdate
*/

