/*---------------------------------------------------------------------------*/
/*-----Specs_QC_Fix----------------------------------------------------------*/
  /*-----Description-----*/
    --This set of script can be used to identify and repair issues with duplicate
    --Specifications or QC Type when a new tests has been imported into an 
    --environment and dragged a specification that it should not have.
  /*----- -----*/

  /*----- -----*/
  /*----- -----*/

  /*-----History-----*/
    --2016.05.04 JTY: Created Script
  /*----- -----*/

/*---------------------------------------------------------------------------*/

  


  






/*-----SPEC_SET Cleanup------------------------------------------------------*/
/*-----01. Duplicate Specifications for QC Type------------------------------*/
  --Identify Duplicate [QC Type] in the [Test Plan Manager] in the Specs tab.
  --Re-direct to desirect [Spec Set] and remove wrongly imported [Spec Set].

  /*-----01: Identify Duplicate Spec Sets-----*/
    SELECT DISTINCT
      ss1.qctype,
      ss1.specno AS ss1_specno,
      ss2.specno AS ss2_specno,
      '~' AS eol
    FROM  &Environment.spec_sets ss1
      INNER JOIN &Environment.spec_sets ss2 ON (1=1
        AND ss1.matcode = ss2.matcode
        AND ss1.qctype = ss2.qctype
        AND ss1.specno <> ss2.specno)
    WHERE 1=1
      AND ss1.typeofspec = 'PRODQC'
    ORDER BY
      ss1.qctype ASC,
      ss1.specno ASC,
      ss1.specno ASC;
  /*----- -----*/

  /*-----02: Review Identified Sets-----*/
    --Need to determine what one to keep and what one to toss.  Likely the
    --highest SpecNo should be tossed.
    SELECT DISTINCT
      ss.specno,
      ss.qctype,
      t.testno,
      sa.analyte,
      sa.*,
      '~' AS eol
    FROM &Environment.spec_analytes sa
      INNER JOIN &Environment.spec_sets ss ON (sa.specno = ss.specno)
      INNER JOIN &Environment.tests t ON (sa.testcode = t.testcode)
    WHERE 1=1
      AND  sa.specno IN (&SpecNoList)
    ORDER BY
      sa.specno ASC,
      t.testno ASC,
      sa.analyte ASC
  /*----- -----*/

  /*-----03: Sample Redirect-----*/
    --Need to re-direct existing samples to utilize correc Spec Set
    SELECT DISTINCT
      o.folderno,
      o.ordno,
      o.qctype,
      o.specno,
      '~' AS eol
    FROM &Environment.orders o
    WHERE 1=1
      AND o.specno = '&BadSpecNo'
    ORDER BY
      o.specno ASC,
      o.ordno ASC;

/*       
    UPDATE &Environment.orders o
    SET o.specno = '&GoodSpecNo'
    WHERE 1=1
      AND o.specno = '&BadSpecNo'
*/    
    
  /*----- -----*/
  
  /*-----04: Clear out SPEC Analytes-----*/
    --We need to remove all analytes associated with bad Spec Set.
/*    
    DELETE 
    FROM &Environment.spec_analytes sa 
    WHERE 1=1
      AND sA.specno IN ('&BadSpecNo') 
*/      
  /*----- -----*/
  /*-----05: Delete Bad SPEC SET -----*/
    --You should perform this task in the user interface (Test Plan Manager)
    --in case their is code that may perform clean-up.  but here is the
    --scirpt anyway.
/*    
    DELETE
    FROM &Environment.spec_sets ss
    WHERE 1=1
      AND ss.specno = '&BadSpecNo'
*/      
  /*----- -----*/
 
  
/*---------------------------------------------------------------------------*/
