
/*-----SuspectSamples----------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --This set of scripts can be used to identify samples that seem
    --to have experienced some sort of issues.  This set of scripts
    --should help identify the samples and provide a path to repair
    --them.
  /*----- -----*/
  

  /*-----SCRIPTS-----*/
    --01. Samples Approved Results Not
    --02. Sample Run Fix
  /*----- -----*/

  /*-----HISTORY-----*/
    --2015.04.07 JTY: Created Script file
  /*----- -----*/
 
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
    SELECT DISTINCT
      ot.dept,
      r.runno,
      ot.testno,
      '--' AS sp1,
      r.origrec AS r_origrec,
      r.approvedate AS r_approvedate,
      r.approvedby AS r_approvedby,
      r.approvalstatus AS r_approvalstatus,
      r.dispapprovalstatus AS r_dispapprovalstatus,
      '--' AS sp1,
      ot.origrec AS ot_origrec,
      ot.apprdate AS ot_apprdate,
      ot.apprvedby AS ot_apprvedby,
      ot.dispsts AS ot_,
      ot.ts AS ot_ts,
      ot.tsa AS ot_tsa,
      ot.tsadisp AS ot_tsadisp,
      '--' AS sp1,
      
      '~' AS eol
    FROM runs r
      INNER JOIN ordtask ot ON (r.runno = ot.runno)
    WHERE 1=1
      AND r.runno = '10014'
      AND ot.testno = 'HIV-1/HIV-2 Multispot'
    ORDER BY
      ot.dept ASC,
      ot.testno ASC,
      r.runno DESC;
  
  
      UPDATE sundata_prod.runs r
    SET 
      r.approvedby = 'GUERRAA',
      r.approvedate = TO_DATE('26-APR-2016', 'DD-MON-YY'),
      r.approvalstatus = 'Released'
    WHERE 1=1
      AND r.runno = '10014';
/*-----------------------------------------------------------------*/  



/*-----------------------------------------------------------------*/

/*-----01. Samples Approved Results Not----------------------------*/
  /*-----DESCRIPTION-----*/
    --Identify samples where the Samples have been identified as 
    --completed, but the analysis has not yet been approved.
    --Currently these type of samples appear to be related to the
    --Suspect Runs issue.  See RunApprovedFix3.sql scripts for
    --scripts to idenify and fix run related information.
  /*----- -----*/

  /*-----Search Script-----*/
    SELECT DISTINCT
      f.external_id,
      f.dept,
      fc.approveddate AS fc_approveddate,
      ot.apprdate AS ot_apprdate,
      re.runno AS re_runno,
      --r.runtype AS r_runtype,
      re.analyte AS re_analyte,
      fc.status AS fc_status,
'~' AS sp1,
      r.approvalstatus AS r_approvalstatus,
      r.approvedby AS r_approvedby,
      r.runindicator AS r_runindicator,
      r.runstatus AS r_runstatus,
      r.runstsdisp AS r_runstsdisp,
      r.approvedate AS r_approvedate,
'~' AS sp2,
      fc.approvalstatus AS fc_approvalstatus,
      fc.approvedby AS fc_approvedby,
      f.apprdate AS f_apprdate,
      f.apprdisp AS f_apprdisp,
      f.approvedby AS f_approvedby,
      f.apprsts AS f_apprsts,
      ot.dispdept AS ot_dispdept,
      ot.dispsts AS ot_dispsts,
      ot.apprvedby AS ot_apprvedby,

      re.s AS re_s,
      re.sa AS re_sa,
      r.approvalstatus AS r_approvalstatus,
      r.approvedby AS r_approvedby,
      r.runindicator AS r_runindicator,
      r.runstatus AS r_runstatus,
      r.runstsdisp AS r_runstsdisp,
      r.approvedate AS r_approvedate,

      '~' AS eol
    FROM sundata_prod.folders f 
      INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN sundata_prod.ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN sundata_prod.results re ON (1=1
        AND ot.folderno = re.folderno
        AND ot.runno = re.runno)
      INNER JOIN sundata_prod.runs r ON (re.runno = r.runno)
    WHERE 1=1
      AND fc.approveddate IS NOT NULL  
      AND ot.apprdate IS NULL
    --  AND f.external_id IN ('AZ00028087','AZ000280878''AZ00028084') 
    ORDER BY
      f.dept ASC,
      re.runno ASC,
      f.external_id ASC,
      re.analyte ASC;
  /*----- -----*/

  /*-----Repair Scripts-----*/
  /*----- -----*/
/*-----------------------------------------------------------------*/






/*-----02. Sample Run Fix------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Identify samples along with all information related to the runs
    --they are associated with.
  /*----- -----*/

  /*-----Search Script-----*/
    SELECT DISTINCT
      f.external_id,
      f.dept,
      '~' AS sp1,
      ot.testno AS ot_testno,
      ot.dispsts AS ot_dispsts,
      ot.apprvedby AS ot_apprvedby,
      ot.apprdate AS ot_apprdate, 
      '~' AS sp2,
      r.runno AS r_runno,
      r.runstatus AS r_runstatus,
      r.stepcode AS r_stepcode,
      r.runstsdisp AS r_runstsdisp,
      r.approvalstatus AS r_approvalstatus,
      r.approvedby AS r_approvedby,
      r.approvedate AS r_approvedate,
      '~' AS sp3,
      re.analyte AS re_analyte,      
      re.s AS re_s,
      re.sa AS re_sa,
      '~' AS sp3,      
      fc.approveddate AS fc_approveddate,
      re.runno AS re_runno,
      fc.status AS fc_status,
      fc.approvalstatus AS fc_approvalstatus,
      fc.approvedby AS fc_approvedby,
      f.apprdate AS f_apprdate,
      f.apprdisp AS f_apprdisp,
      f.approvedby AS f_approvedby,
      f.apprsts AS f_apprsts,
      '~' AS eol
/*      
    FROM &Environment.runs r
      LEFT OUTER JOIN &Environment.results re ON (r.runno = re.runno)
      LEFT OUTER JOIN &Environment.ordtask ot ON (re.folderno = ot.folderno)
      LEFT OUTER JOIN &Environment.foldercondition fc ON (ot.folderno = fc.folderno)    
      LEFT OUTER JOIN &Environment.folders f ON (fc.folderno = f.folderno)
*/
    FROM &Environment.folders f 
      INNER JOIN &Environment.foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN &Environment.ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN &Environment.results re ON (1=1
        AND ot.folderno = re.folderno
        AND ot.runno = re.runno)
      INNER JOIN &Environment.runs r ON (re.runno = r.runno)
    WHERE 1=1
--      AND fc.approveddate IS NOT NULL  
--      AND ot.apprdate IS NULL
      AND f.external_id IN ('AZ00015311') 
--      AND r.runno = '103'

    ORDER BY
      f.dept ASC,
      re.runno ASC,
      f.external_id ASC,
      re.analyte ASC;

  /*----- -----*/

  /*-----Repair Scripts-----*/
/*  
    UPDATE sundata_prod.ordtask ot 
    SET 
      ot.apprvedby = 'PATTERJO',
      ot.apprdate = TO_DATE('3-JUN-2014', 'DD-MON-YY') 
    WHERE 1=1
      AND ot.folderno = 'AZ00015311-01';
     
    UPDATE sundata_prod.runs r
    SET 
      r.approvedby = 'PATTERJO',
      r.approvedate = TO_DATE('3-JUN-2014', 'DD-MON-YY'),
      r.approvalstatus = 'Released'
    WHERE 1=1
      AND r.runno = '3579';
*/      
  /*----- -----*/
/*-----------------------------------------------------------------*/






