


/*-----TestImportWorkFlowFix---------------------------------------*/
  /*----------Description----------*/
    --When a new method is imported into an different instance of
    --STARLIMS (ie DEV to TEST, TEST to PROD).  There are occasions
    --when the import process may import a duplicate Work Flow Method
    --This will cause issues in STARLIMS that can be exibited when
    --an analysts is attempting to setup a new run.  An exception
    --will be displayed, and there will be no Reagents associated
    --with the test.
    --Utilize these script to identify if there is more than one
    --workflow method with the same TMName.  If there is then we 
    --need to remove the latest one that represents the method
    --imported in with the new test.
  /*---------- ----------*/  

  /*----------SL10 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/

  /*----------History----------*/
    --2013.08.28 JTY: Created Script file
    --2016.08.02 JTY: Updated include script to identify muiltiple TMCodes
  /*---------- ----------*/  
  
/*-----------------------------------------------------------------*/




/*-----------------------------------------------------------------*/
SELECT DISTINCT
  twm.tmname,
  Count(*) AS MyCount
FROM &Environment.testwfmethods twm
GROUP BY
  twm.tmname
HAVING Count(*) >1;
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
  /*----------Review Records----------*/
  
  /*---------- ----------*/  
    --Show any WF methods with the specified name.  If more than 
    --one records has same name, last one(origrec) needs to go.
    SELECT
      twm.tmname,
      twm.tmcode,
      twm.origrec,
      '~' AS sp1,
      twm.*
    FROM &Environment.testwfmethods twm
    WHERE 1=1
--     AND twm.tmname = 'N/A'
      AND twm.tmname = '&TMName'
    ORDER BY
      twm.tmname ASC,
      twm.tmcode ASC;
  /*---------- ----------*/


  /*---------- ----------*/
    --Use this code to delete the extra WF method.
/*    
    DELETE
    FROM &Environment.testwfmethods twm
    WHERE 1=1
      AND twm.origrec = '&Origrec'
*/      
  /*---------- ----------*/    
  
/*-----------------------------------------------------------------*/


select * from testwfmethods where tmname = 'N/A'
delete from testwfmethods WHERE origrec = '2475'
