/*-----ActiveSamplesAssocatedWithTest----------------------------------------*/
/*---------------------------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --This query will identify all active samples assocated with the specified
    --test.  May need to use this query when attemping to retire a test and
    --starlims will not allow this due to active samples the test is associated
    --with.
  /*----- -----*/


  /*-----HISTORY-----*/
    --2015.02.23 JTY: Created Script
  /*----- -----*/
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
  /*----- -----*/
    SELECT DISTINCT
      t.testno,
      f.testgroupname AS panel,
      mr.field_varchar_80 AS activity_type,
      cr.external_id,
      f.apprdate,
      fc.approveddate AS fc_approveddate,
      fc.dispsts AS fc_dispsts,
      ot.apprdate,  
      r.final,
      '~' AS eol
    FROM sundata_prod.tests t 
      INNER JOIN sundata_prod.ordtask ot ON (ot.testcode = t.testcode)
      INNER JOIN sundata_prod.results r ON (1=1
        AND ot.testcode = r.testcode 
        AND ot.ordno = r.ordno)
      INNER JOIN sundata_prod.folders f ON (ot.folderno = f.folderno)
      INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN sundata_prod.centralreceiving CR ON (f.external_id = cr.external_id)
      INNER JOIN sundata_prod.metadata_repository MR ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
    WHERE 1=1
--Update Test Name Here
      AND t.testno IN ('Syphilis RPR', 'Syphilis TP-PA', 'Hepatitis C EIA')
--Set Department Here      
      AND ot.dept IN ('PHX-SER')
      AND fc.approveddate  IS NULL
      --AND mr.field_varchar_80 = ''
    ORDER BY 
      t.testno ASC,
      f.testgroupname ASC,
      mr.field_varchar_80 ASC,
      cr.external_id ASC;
  /*----- -----*/
  
/*---------------------------------------------------------------------------*/


  /*----- -----*/
    --Find Samples associated with Syphilis TP-PA test that don't have approval
    --date for the test.
    SELECT DISTINCT
      ot.folderno,
      ot.runno,
      ot.dept
    FROM sundata_prod.results r 
    INNER JOIN sundata_prod.ordtask ot ON (r.ordno = ot.ordno AND r.testcode = r.testcode)
    WHERE 1=1
      AND r.testno = 'Syphilis TP-PA'
      AND ot.apprdate IS NULL
  /*----- -----*/  
