/*-----BarCode_Queries-------------------------------------------------------*/
  -----DESCRIPTION-----
    --Queries related to data that is to present in the fillable PDF form for
    --sample submittals.
    --The Following Queries are included:
    --1. Client List - List of client to appear in the [Submitting Agency] 
                       --section.
  ----- -----
  
  -----HISTORY-----
  --2018.02.15 JTY: Created file.
  ----- -----

/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*-----1. Client List--------------------------------------------------------*/
  --List of clients to appear in the [Submitting Agency] section.  Currently
  --we want to restrict this to cients that submitt Human related samples (ie
  --Clinical samples).

    SELECT DISTINCT
      rc.county,
      (rc.compname || ' (' || rc.rasclientid || ')') AS client,
      rc.pob,
      rc.adress,
      rc.adress_a,
      rc.city,
      rc.zip,
      rc.primaryphone,
      rc.defaultcontact,
      '~' AS eol
    FROM centralreceiving cr 
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.origrec = cr.origrec)
    WHERE 1=1
      AND mr.field_varchar_80 IN ('Diagnostic')
      AND f.matcode IN ('Human')
    ORDER BY
      rc.county ASC,
      client ASC;
  
/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
