
/*-----------------------------------------------------------------*/
/*-----Calculations Queries----------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Utilize this set of queries for reviewing Calculations
    --assoicated with the item of interest.
    --The following objects have queries for this:
      --1. Canned Comments (CC)
      --2. TestTriggers (TRIG)
      --3. Spec Schema Actions (SPEC)
  /*----- -----*/

  /*-----HISTORY-----*/
    --2014.08.27 JTY: Created Script
  /*----- -----*/
  
  /*-----CalcName Prefixes-----*/
    --SELECT DISTINCT ca.* FROM sundata_prod.calcs_actions ca
    --CC
    --HL7M
    --MICR
    --SPEC
    --TRIG
    --WKSH
    --WTAC
    --WTACV10  
  /*----- -----*/

/*-----------------------------------------------------------------*/






/*------1. Canned Comments (CC)-------------------------------------*/
  --Show all Calculations related to Canned Comments
  
    SELECT DISTINCT
      ca.calcname,
      dbms_lob.substr(ca.calcul, 4000),
      cc.testgroupname,
      t.testno,
      cc.analyte,
      cc.canned_comment,
      cc.attachment_scope,
      cc.printonreport,
      cc.status,
      cc.start_date,
      cc.expiration_date,
      cc.stepcode,
      cc.compid,
      cc.analyte,
      '~' AS eol
    FROM &Environment.canned_comments cc
      INNER JOIN &Environment.tests t ON (cc.testcode = cc.testcode)
      INNER JOIN &Environment.calcs_actions ca ON (cc.calculation = ca.calcname)
    WHERE 1=1
    ORDER BY
      ca.calcname ASC;      
/*-----------------------------------------------------------------*/




/*------2. TestTriggers (TRIG)-------------------------------------*/
  --Show all Calculations related to Triggers defined in the 
  --Test Plan Manager
  
    SELECT DISTINCT
      ca.calcname,
      dbms_lob.substr(ca.calcul, 4000),
      t.testno,
      tf.notifype,
      tf.triggeraction,
      tf.executeonevent,
      tf.cond_type,
      tf.cond_load,
      tf.sorter,
      tf.specreport,
      '~' AS eol
    FROM &Environment.triggeriffail tf
      INNER JOIN &Environment.tests t ON (tf.testcode = t.testcode)
      INNER JOIN &Environment.calcs_actions ca ON (tf.condition = ca.calcname)
    WHERE 1=1
    ORDER BY
      ca.calcname DESC;      
/*-----------------------------------------------------------------*/




/*------3. Spec Schema Actions (SPEC)------------------------------*/
  --Show all Calculations related to Triggers defined in the 
  --Spec Schema application
  
    SELECT DISTINCT
      sc.TypeOfItem,
      ca.calcname,
      dbms_lob.substr(ca.calcul,4000),
      sc.SpecSchemaCode,
      sc.status,
      '~' AS eol
    FROM &Environment.SpecSchemaCalcs sc
      INNER JOIN &Environment.calcs_actions ca ON (sc.calculation = ca.calcname)
    WHERE 1=1
    ORDER BY
      sc.typeofitem ASC,
      ca.calcname DESC;
/*-----------------------------------------------------------------*/

