
/*-----CaseAndEvents-----------------------------------------------*/
  /*-----SUMMARY-----*/
    --This set of queries is to explore the relationships between
    --the various objects related to Cases and Events in STARLiMS
    --It is based on v10.7 in Oracle for Arizona Department of Health
    --Services (ADHS).
    
    --Queries were written in relationship to APHL Event Management
    --Working group.
  /*----- -----*/
  
  
  /*-----HISTORY-----*/
    --2016.01.07 JTY: Begin Script Creation
  /*----- -----*/
/*-----------------------------------------------------------------*/




/*-----Events Relationships----------------------------------------*/
  /*-----Events table-----*/
/*  
    SELECT DISTINCT
      e.event_type,
      e.event_id,
      e.name,
      e.short_name,
      e.status,
      e.activity,
      e.description,
      e.ext_event_id,
      e.parent_event_id,
      e.start_date,
      '~' AS eol
    FROM  sundata_prod.events e
    WHERE 1=1
    ORDER BY
      e.event_type ASC,
      e.event_id ASC;
*/      
  /*----- -----*/ 
  /*-----Event Types-----*/
/*
    SELECT DISTINCT
      et.event_type,
      et.description,
      '~' AS eol
    FROM sundata_prod.event_types et
    WHERE 1=1;
*/    
  /*----- -----*/
  /*-----folders-----*/
    --Link to Clinical and Environmental samples
/*
    SELECT DISTINCT
      f.external_id,
      f.folderno,
      f.event_id,
      '~' AS eol
    FROM sundata_prod.folders f
    WHERE 1=1
      AND f.event_id IS NOT NULL;
*/      
  /*----- -----*/
  /*-----event_reports-----*/
    --Link to Clinical and Environmental samples
/*
    SELECT DISTINCT
      er.event_id,
      er.description,
      er.reportid,
      er.event_reportid
      '~' AS eol
    FROM sundata_prod.event_reports er
    WHERE 1=1;
*/    
  /*----- -----*/
  /*-----Pulling it All Together-----*/
    SELECT DISTINCT
      et.event_type,
      et.description AS et_description,
      e.event_id,
      e.name,
      e.short_name,
      e.status,
      e.activity,
      e.description,
      e.ext_event_id,
      e.parent_event_id,
      e.start_date,
      f.external_id,
      f.folderno,
      er.description AS er_description,
      er.reportid,
      er.event_reportid,
      '~' AS eol
    FROM sundata_prod.events e
      LEFT OUTER JOIN sundata_prod.folders f ON (e.event_id = f.event_id)
      INNER JOIN sundata_prod.event_types et ON (e.event_type = et.event_type)
      LEFT OUTER JOIN sundata_prod.event_reports er ON (e.event_id = er.event_id)    
    WHERE 1=1
    ORDER BY
      et.event_type ASC,
      e.event_id ASC,
      f.external_id ASC,
      er.reportid ASC;
  /*----- -----*/
/*-----------------------------------------------------------------*/



/*-----Case Management--------------------------------------------*/
  /*----- -----*/
    SELECT DISTINCT
      c.activity,
      c.case_id,
      c.name,
      c.short_name,
      c.description,
      c.status,
      '~' AS EOL
    FROM  sundata_prod.cases c
    WHERE 1=1;
  /*----- -----*/
  /*----- -----*/
    SELECT DISTINCT
      cr.external_id,
      cr.case_id,
      cr.casenumber,
      '~' AS eol
    FROM sundata_prod.centralreceiving cr
    WHERE 1=1
      AND cr.case_id IS NOT NULL;
  /*----- -----*/
  /*-----Events table-----*/
    SELECT DISTINCT
      e.event_type,
      e.event_id,
      e.name,
      e.short_name,
      e.status,
      e.activity,
      e.description,
      e.ext_event_id,
      e.parent_event_id,
      e.start_date,
      '~' AS eol
    FROM  sundata_prod.events e
    WHERE 1=1
    ORDER BY
      e.event_type ASC,
      e.event_id ASC;
  /*----- -----*/ 

Select VALUE, TRANS_KEY 
from TRANSLATIONS
where 	TRANS_GROUP = 'LRN_Activity'
/*-----------------------------------------------------------------*/
