/*-----ExternalInterfaces----------------------------------------------------*/
/*---------------------------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Set of queries related to the External Interfaces application
      --01. Associated Tables
      --02. Interface Sorting Order
  /*----- -----*/

  /*----- -----*/
  /*----- -----*/

  /*-----HISTORY-----*/
  /*----- -----*/


/*---------------------------------------------------------------------------*/



/*------01 Assocaited Tables-------------------------------------------------*/
  --Tables associated with External Interfaces application
/*  
  SELECT * FROM sdwis_interfaces;
  SELECT * FROM sdwis_mappingfields;  
  SELECT * FROM sdwis_qbefields;  
  SELECT * FROM sdwis_batchjobs;
  SELECT * FROM sdwis_log;
  SELECT * FROM sdwis_out;
  SELECT * FROM sdwis_queries;
  SELECT * FROM sdwis_setting;
*/  
/*---------------------------------------------------------------------------*/




/*-----02. Interface Sorting Order-------------------------------------------*/
  --Show what column listing order is for exported file.
    SELECT DISTINCT
      (ei.interfacename || ' (' ||ei.interfaceid || ')') AS interface,
      emf.segment,
      emf.sorter,
      emf.fieldname,
      emf.starlims_table,
      emf.starlims_column,
      '~' AS eol
    FROM sdwis_interfaces ei
      INNER JOIN sdwis_mappingfields emf ON (ei.interfaceid = emf.interfaceid)
    WHERE 1=1
      AND ei.interfacename = '&InterfaceName'
    ORDER BY
      interface ASC,
      emf.segment ASC,
      emf.sorter ASC;
/*---------------------------------------------------------------------------*/  



/*-----11. Arrange CRE Export Order------------------------------------------*/
  --Dictate export order for CRE extract
  /*
    UPDATE sdwis_mappingfields mf SET mf.sorter = '3' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Reporting_month';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '6' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Patient_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '9' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Patient_age';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '12' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Patient_age_unit';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '15' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'PHL';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '18' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '21' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_name';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '24' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_state';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '27' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_zipcode';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '30' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Processing_Laboratory_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '33' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '36' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_name';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '39' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_state';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '42' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_zipcode';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '45' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Specimen_collection_date';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '48' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Specimen_received_date';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '51' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_Specimen_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '54' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'ARLN_Specimen_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '57' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Specimen_type';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '60' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Isolate_forwarded_to_RegLab';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '63' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Date_forwarded_to_RegLab';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '66' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Organism_tested';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '69' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Phenotypic_test_result';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '72' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Phenotypic_method_used';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '75' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Confirmed_carbapenem_resistant';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '78' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'AST_method_used';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '81' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'PCR_method_used';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '84' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'IMP_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '87' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'KPC_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '90' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'mcr_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '93' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'NDM_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '96' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'OXA_48_like_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '99' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'VIM_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '102' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Other_gene_name';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '105' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Other_gene_result';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '108' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Aztreonam_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '111' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Aztreonam_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '114' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Cefepime_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '117' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Cefepime_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '120' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ceftazidime_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '123' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ceftazidime_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '126' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ceftriaxone_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '129' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ceftriaxone_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '132' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Colistin_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '135' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Doripenem_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '138' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Doripenem_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '142' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ertapenem_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '145' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ertapenem_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '148' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Imipenem_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '151' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Imipenem_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '154' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Meropenem_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '157' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Meropenem_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '160' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Other_3rdGen_cephalosporin_name';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '163' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Other_3rdGen_cephalosporin_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '166' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Other_3rdGen_cephalosporin_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '169' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'RegLab_comment';
*/    
/*---------------------------------------------------------------------------*/  


/*-----11. Arrange CRPA Export Order------------------------------------------*/
  --Dictate export order for CRPA extract
/*
    UPDATE sdwis_mappingfields mf SET mf.sorter = '3' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Reporting_month';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '6' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Patient_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '9' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Patient_age';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '12' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Patient_age_unit';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '15' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'PHL';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '18' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '21' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_name';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '24' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_state';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '27' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Healthcare_facility_of_origin_zipcode';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '30' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Processing_Laboratory_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '33' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '36' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_name';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '39' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_state';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '42' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_facility_zipcode';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '45' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Specimen_collection_date';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '48' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Specimen_received_date';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '51' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Submitter_Specimen_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '54' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'ARLN_Specimen_ID';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '57' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Specimen_type';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '60' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Isolate_forwarded_to_RegLab';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '63' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Date_forwarded_to_RegLab';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '66' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Organism_tested';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '69' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Phenotypic_test_result';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '72' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Phenotypic_method_used';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '75' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Confirmed_carbapenem_resistant';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '78' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'AST_method_used';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '81' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'PCR_method_used';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '84' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'IMP_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '87' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'KPC_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '90' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'mcr_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '93' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'NDM_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '96' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'OXA_48_like_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '99' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'VIM_gene';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '102' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Other_gene_name';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '105' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Other_gene_result';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '108' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Aztreonam_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '111' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Aztreonam_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '114' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Cefepime_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '117' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Cefepime_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '120' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ceftazidime_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '123' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Ceftazidime_AST_zone_diameter';
    
    UPDATE sdwis_mappingfields mf SET mf.sorter = '126' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Colistin_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '135' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Doripenem_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '138' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Doripenem_AST_zone_diameter';
    
    UPDATE sdwis_mappingfields mf SET mf.sorter = '148' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Imipenem_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '151' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Imipenem_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '154' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Meropenem_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '157' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Meropenem_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '160' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Piperacillin_tazobactam_AST_MIC';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '163' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'Piperacillin_tazobactam_AST_zone_diameter';
    UPDATE sdwis_mappingfields mf SET mf.sorter = '169' WHERE mf.interfaceid = '&InterfaceID' AND mf.fieldname = 'RegLab_comment';
*/    
    
/*---------------------------------------------------------------------------*/  


