
/*=====QBE_Queries=================================================*/
  /*----------Description----------*/
    --This collection of queries are for investigation into 
    --QBE templates and associated reports.  The following sections
    --are included in this report:
       --1. QBE Template Reports - Queries displaying report related
       --   information
       --2. QBE Query Scripts - Used to veiw and update QBE Queries
  /*----------  ----------*/



  /*----------SL10 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/
  
  /*----------History----------*/
    --2014.07.08 JTY: Created file.
  /*----------  ----------*/  
  
/*=================================================================*/  





/*-----1. QBE Template Reports-------------------------------------*/  
  --This set of queries can be utilized to investigate reports 
  --associated with QBE Templates including parameters used by the
  --reports.


  -----Template Reports-----
    --Identify reports associated with QBE Templates
    SELECT DISTINCT
      qtp.name AS template_name,
      qtp.qbetemplateid,
      qtp.description AS template_desc,
      qrp.description AS report_desc,
      '' AS eol
    FROM &Environment.qbetemplates qtp
      INNER JOIN &Environment.qbereports qrp ON (qtp.qbetemplateid = qrp.qbetemplateid)
    WHERE 1=1
      --AND qtp.qbetemplateid = '&TemplateID'
    ORDER BY
      qtp.name ASC,
      qrp.description ASC;
  -----  
 
  
  -----Report Parameters-----
    --Identify report parameters for the indicated report.
    SELECT DISTINCT
    --  qrp.description AS report_desc,
    --  qtp.qbetemplateid,
      qtb.tablename,
      qtf.fieldname,
      qfc.parameter_name,
      qfc.defaultoperator,
    --  qfc.defaultvalue,
    --  qfc.readonly,
    --  qfc.required,
      '' AS eol
    FROM &Environment.qbetemplates qtp
      INNER JOIN &Environment.qbereports qrp ON (qtp.qbetemplateid = qrp.qbetemplateid)
      INNER JOIN &Environment.qbetables qtb ON (qtp.qbetemplateid = qtb.qbetemplateid)
      INNER JOIN &Environment.qbetablefields qtf ON (qtb.qbetableid = qtf.qbetableid)
      INNER JOIN &Environment.qbefieldcriteria qfc ON (1=1
        AND qtf.qbetableid = qfc.qbetableid
        AND qtf.fieldid = qfc.qbefieldid)
    WHERE 1=1
      --
      AND qrp.description = '&ReportDescription'
      AND qfc.report_parameter = 'Y'
    ORDER BY
    --  qrp.description ASC,
      qtb.tablename ASC,
      qtf.fieldname ASC;
  -----


  -----Baseline Query-----
    --General query used to develop other queries related to QBE Template Reports
/*      
    SELECT DISTINCT
      qtp.name AS template_name,
      qtp.qbetemplateid,
      qtp.description AS template_desc,
      qrp.description AS report_desc,
      qtb.tablename,
      qtf.fieldname,
      qfc.parameter_name,
      qfc.defaultoperator,
      qfc.defaultvalue,
      qfc.readonly,
      qfc.required,
      qfc.report_parameter,

      '' AS eol
    FROM &Environment.qbetemplates qtp
      INNER JOIN &Environment.qbereports qrp ON (qtp.qbetemplateid = qrp.qbetemplateid)
      INNER JOIN &Environment.qbetables qtb ON (qtp.qbetemplateid = qtb.qbetemplateid)
      INNER JOIN &Environment.qbetablefields qtf ON (qtb.qbetableid = qtf.qbetableid)
      INNER JOIN &Environment.qbefieldcriteria qfc ON (1=1
        AND qtf.qbetableid = qfc.qbetableid
        AND qtf.fieldid = qfc.qbefieldid)
    WHERE 1=1
      AND qtp.qbetemplateid = '&TemplateID'
      AND qrp.description = '&ReportDescription'
    ORDER BY
      qtp.name ASC,
      qrp.description ASC,
      qtb.tablename ASC,
      qtf.fieldname ASC
*/      
  -----
/*-----------------------------------------------------------------*/  


/*-----------------------------------------------------------------*/  

  /*----- -----*/
  /*----- -----*/  

  /*----- -----*/
  /*----- -----*/  
   
/*-----------------------------------------------------------------*/  




/*-----2. QBE Query Scripts----------------------------------------*/  

  /*-----Review QBE Querie Fields-----*/

    SELECT DISTINCT
      qbe.qbetemplateid,
      qbe.name AS template_name,
      daf.sorter,
      ('[' || daf.table_name || '].[' || daf.field_name || ']') AS table_field,
      daf.field_alias,
      '~' AS eol
    FROM qbetemplates qbe
      INNER JOIN qbedatafields daf ON (qbe.qbetemplateid = daf.qbetemplateid)
    WHERE 1=1
      AND qbe.qbetemplateid = '&TemplateID'
    ORDER BY
      qbe.qbetemplateid ASC,
      daf.sorter ASC;
  /*----- -----*/  

  /*-----Update Sorter Order-----*/
/*  
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '1'     
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Activity Type';
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '2' 
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Test Name';
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '3' 
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Sample ID';
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '4' 
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Test Status';
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '5' 
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Date Received';
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '6' 
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Approval Date';
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '7' 
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Approved by';
    UPDATE &Envrionment.qbedatafields daf SET daf.sorter = '8' 
      WHERE daf.qbetemplateid = '&TemplateID'  AND daf.field_alias = 'Test Code';

*/      
  /*----- -----*/  
   
/*-----------------------------------------------------------------*/  

