/*-----------------------------------------------------------------*/
/*-----Report Delivery Queue---------------------------------------*/
  /*-----DESCRIPTION-----*/
    --List of scripts related to the Report Delivery Queue and
    --and investigations.
  /*----- -----*/
  /*----- -----*/
    --01. Identify Samples of interest
    --02. No Reports For Completed Panels - with HL7 messaging
    --03. eTranmittal Batch Job Query Check
  /*----- -----*/
  
 
  
  /*-----HISTORY-----*/
    --2015.12.24 JTY: Created script
  /*----- -----*/

/*-----------------------------------------------------------------*/


/*-----01. Identify Samples of interest-----------------------------*/
  --Use this script to identify samples that you may want to re-print
  --the reports on.
  --Modify the script to get a list of the Batch ID's and samplesID's
  --and go to the Report Delivery Queue page and select the Queued
  --status, select the samples of interest, and print reports.
  --
  --NOTE: the "Print Archived Reports" option is currently broken, but
  --can be modified and used to generate PDF's locally that then can
  --be printed.  See CR392 for details on this procedure.
/*  
  SELECT DISTINCT
    rq.batch_id,
    cr.external_id,
    cr.rasclientid,
    mr.field_varchar_02 AS address,
    f.testgroupname AS panel,
    cr.sampdesc,
    rq.stardoc_id,
    rq.queue_item_no,
    
  --  cr.date_received,
  --  (t.testno || '(' || t.testcode || ')') AS test_no,
  -- f.fldsts,  
  --  ot.apprdate,
  --  ot.apprvedby,
  --  ot.dept,
  --  r.final,

    '~' AS eol
  FROM centralreceiving cr
    INNER JOIN folders f ON (cr.external_id = f.external_id)
    INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
    INNER JOIN tests t ON (ot.testcode = t.testcode)
    INNER JOIN results r ON (1=1
      AND ot.testcode = r.testcode
      AND ot.folderno = r.folderno)
    LEFT OUTER JOIN rr_report_delivery_queue rq ON (1=1
      AND f.folderno = rq.folderno
      AND f.testgroupname = rq.testgroupname
      AND rq.reporttype = 'Final')
    LEFT OUTER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
  WHERE 1=1
--    AND ot.dept IN ('PHX-EM')
--    AND cr.rasclientid = 'ADHS'
--    AND f.testgroupname IN (
--      'Food  Salmonella',
--      'Food - Staphylococcus aureus',
--      'Food - Bacillus cereus'
--    )
--    AND TO_DATE(cr.date_received, 'DD-MON-YY') BETWEEN 
--        TO_DATE('7-SEP-2015', 'DD-MON-YYYY') AND TO_DATE('11-SEP-2015', 'DD-MON-YYYY')
--    AND cr.external_id IN (
--      'AZ00039980','AZ00037357',
--     'AZ00039837', 'AZ00039730')
    AND cr.rasclientid = 'PIHH-WR'
   ORDER BY 
     rq.batch_id ASC,
     cr.external_id ASC,
     rq.stardoc_id ASC,
     cr.rasclientid ASC,
     rq.queue_item_no ASC,
     f.testgroupname ASC;
*/
/*-----------------------------------------------------------------*/




/*-----------------------------------------------------------------*/
/*
  --Use the query to investigate samples in the Report Deliver Queue
  SELECT DISTINCT
    rdq.batch_id,
    rdq.dept,
    rdq.folderno,
    rdq.testgroupname,
    rdq.reporttype,
    rdq.printed,
    rdq.schedstatus,
    rdq.queue_item_no,
    rdq.status,
    rdq.stardoc_id,
    rdq.reptemplate,
    rdq.usrnam,
    rdq.origrec AS rdq_origrec,
    '~' AS sp1,
    bs.totalitems,
    bs.processed,
    bs.noerrors,
    bs.progress,
    bs.process,
    bs.origrec AS bs_origrec,
    '~' AS eol
  FROM &Environment.rr_Report_Delivery_Queue rdq
    INNER JOIN &Environment.rr_Batchstatus bs ON (rdq.batch_id = bs.batchid)
  WHERE 1=1
--    AND rdq.folderno LIKE 'AZ00037357%'
  ORDER BY 
    rdq.origrec DESC;
*/    
/*-----------------------------------------------------------------*/




/*---02. No Reports For Completed Panels----------------------------*/
  /*-----Description-----*/
    --This query will identify samples that have been approved, but
    --have not had a report created for them.  This shouldn't happen.. 
    --Also want to check HL7 messaging information to see if we need
    --to re-submit these samples.
    
    --Also including HL7 information to see if we need to re-submit 
    --via HL7
    --
    --Note: You may need to utilize the 
  /*----- -----*/

  /*-----Identify Samples-----*/
/*  
    SELECT DISTINCT
      f.dept,
      fc.approveddate,
      f.testgroupname,
      f.external_id,
--      oq.rasclientid,
--      oq.status AS hl7_status,
      rdq.reporttype,
      fc.approvedby AS fc_approvedby,
      fc.approvedtime AS fc_approvedtime,
      fc.dispsts,
      rdq.batch_id,
      fc.origrec AS fc_origrec,
      f.apprdate AS f_apprdate,
      f.approvedby AS f_approvedby,
      f.apprsts AS f_apprsts,
      '~' AS eol
    FROM  sundata_prod.folders f
      INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
      LEFT OUTER JOIN sundata_prod.rr_Report_Delivery_Queue rdq ON ( 1=1
        AND f.folderno = rdq.folderno
        AND rdq.reporttype IN ('Final', 'Amended', 'Corrected')        
        )
      LEFT OUTER JOIN sundata_prod.orion_queue oq ON (f.folderno = oq.folderno)
    WHERE 1=1
--AND fc.folderno = 'AZ00040024-01'          
      AND fc.approveddate IS NOT NULL
      AND rdq.batch_id IS NULL
      AND f.testgroupname NOT LIKE 'PFGE%'
      AND fc.approveddate BETWEEN 
          TO_DATE('01-JAN-2016','DD-MON-YYYY') AND SYSDATE
--AND  oq.rasclientid = 'PHLIP-FLU'        
    ORDER BY
      f.dept ASC,
      fc.approveddate ASC,
      f.testgroupname ASC,
      f.external_id;
*/      
  /*----- -----*/

  /*-----Fix Folder Approval Info With FolderCondition-----*/
  
  
  /*----- -----*/



/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/


/*-----03. eTranmittal Query Check---------------------------------*/
  --This query mirrors the eTransmittal Delivery batch job and can
  --be used to troubleshoot issues with the job.
  
      SELECT DISTINCT
        rdh.sent_date,      
        rdq.rasclientid,
        rdq.dept,
        rdq.folderno,
        rdh.reporttype,
        rdq.status,
        rdh.delivery_method,
        rdh.delivery_address,
        rdq.testgroupname AS panel,
        rdq.queue_item_no,
        rdh.sent_by AS appr_by,
        to_char(rdh.sent_date, 'YYYY.MM.DD')  || '  ' || rdh.sent_time AS approved_dt,
        to_char(fq.senddate, 'YYYY.MM.DD  HH24:MM') AS faxed_dt,
        (TRUNC(sysdate) - TRUNC(rdh.sent_date)) AS elapsed_days,
        fq.receipt,
        rdh.message,
        rdh.stardoc_id,
        fq.crtmessage,
        rc.compname,
        rdq.stardoc_id,
        '~' AS eol
      FROM rr_report_delivery_queue rdq
        LEFT OUTER JOIN rr_rdq_history rdh ON (1=1
          AND rdq.queue_item_no = rdh.queue_item_no)
        INNER JOIN rasclients rc ON (rdq.rasclientid = rc.rasclientid)
        INNER JOIN folderscontactsext fcx ON (1=1
          AND rdq.rasclientid = fcx.rasclientid
          AND rdq.contactid = fcx.contactid)
        LEFT OUTER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
        INNER JOIN folders f ON (rdq.folderno = f.folderno)
        INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      WHERE 1=1
        AND TRUNC(rdh.sent_date) BETWEEN (TO_DATE('&CheckDate', 'DD-MON-YY')-1) and  TO_DATE('&CheckDate', 'DD-MON-YY')
        ORDER BY
        rdq.rasclientid ASC,
        rdq.dept ASC,
        elapsed_days ASC,
        rdq.folderno ASC;
/*-----------------------------------------------------------------*/


