

/*-----RougeReagents-----------------------------------------------*/

  /*----------Description----------*/
    --This set of scripts will identify materials that are utilized
    --in STARLIMS, but have NOT been identified by the supervisors
    --as valid materiasl (ie in the [sunrise_data].adhs_matsup table).
  /*---------- ----------*/

  /*----------History----------*/
    --2013.07.02 JTY: Created script.
  /*---------- ----------*/

  /*---------- ----------*/
  /*---------- ----------*/
    
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/

  /*---------- ----------*/
  /*---------- ----------*/

  /*---------- ----------*/
  /*---------- ----------*/

  /*---------- ----------*/
  /*---------- ----------*/
    
/*-----------------------------------------------------------------*/


        WITH
          ---MySteps---
            --Get the Steps related to the Micro Test
            MySteps AS (
              SELECT DISTINCT
                tc.dept,
                tc.testcatcode,
                t.testno,
                t.testcode,
                t.testflag,
                t.tmname,
                tws.Stepcode,
                '~' AS sp1,
                tws.Sorter AS step_order,
                twm.tmcode,
                '~' AS eol
              FROM &Environment.testcategory tc
                INNER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode)
                INNER JOIN &Environment.testwfmethods twm ON (t.tmname = twm.tmname)
                INNER JOIN &Environment.testwfsteps tws ON (twm.tmcode = tws.tmcode)
              WHERE 1=1
                AND t.testflag = 'Micro'  --Only interested in Micro Tests
              ORDER BY
                tc.dept ASC,
                t.testno ASC,
                tws.sorter ASC),
          ---
          ---StepComponents1---
            --Get the Components related to each step via ComponentType
            StepComponents1 AS (
              SELECT DISTINCT
                MS.dept,
                MS.testcatcode,
                MS.testno,
                MS.testcode,
                MS.testflag,
                MS.tmname,
                MS.Stepcode,
                mc.comptype,
                mc.compname,          
                mpcm.compid,
                '~' AS sp1,
                MS.step_order,
                '~' AS eol
              FROM MySteps MS
                INNER JOIN &Environment.microplates mp ON (
                    ms.stepcode = mp.stepcode AND ms.tmcode = mp.tmcode)
                INNER JOIN &Environment.micropanelconditions mpc ON (mp.fromcomptype = mpc.comptype)
                INNER JOIN &Environment.micropanelcomp mpcm ON (
                  mpc.comptype = mpcm.comptype AND mpc.panelid = mpcm.panelid)
                INNER JOIN &Environment.microcomponents mc ON (mpcm.compid = mc.compid)
              WHERE 1=1
              ORDER BY
                MS.dept ASC,
                MS.testno ASC,
                MS.step_order ASC,
                mc.comptype ASC,
                mc.compname ASC),
          ---            
          ---StepComponents2---
            --Get the Default Components related to each step
            StepComponents2 AS (
              SELECT DISTINCT
                MS.dept,
                MS.testcatcode,
                MS.testno,
                MS.testcode,
                MS.testflag,
                MS.tmname,
                MS.Stepcode,
                mc.comptype,
                mc.compname,
                mpdc.compid,
                '~' AS sp1,
                MS.step_order,
                --MS.tmcode,
                '~' AS eol
              FROM MySteps MS
                INNER JOIN &Environment.microplatedefcomp mpdc ON (
                    ms.stepcode = mpdc.stepcode AND ms.tmcode = mpdc.tmcode)
                INNER JOIN &Environment.microcomponents mc ON (mpdc.compid = mc.compid)              
              WHERE 1=1
              ORDER BY
                MS.dept ASC,
                MS.testno ASC,
                MS.step_order ASC,
                mc.comptype ASC,
                mc.compname ASC),
          ---          
          ---MyComponents---
            --Combine StepComponents1 & StepComponents2 to get all micro components
            --related to the Micro Test.
            MyComponents AS (
              (SELECT DISTINCT
                sc1.dept,
                sc1.testcatcode,
                sc1.testno,
                sc1.testcode,
                sc1.testflag,
                sc1.tmname,
                sc1.stepcode,
                sc1.comptype,
                sc1.compname,
                sc1.compid,
                '~' AS sp1,
                sc1.step_order,
                '~' AS eol
              FROM StepComponents1 sc1)
              UNION
              (SELECT DISTINCT
                sc2.dept,
                sc2.testcatcode,
                sc2.testno,
                sc2.testcode,
                sc2.testflag,
                sc2.tmname,
                sc2.stepcode,
                sc2.comptype,
                sc2.compname,          
                sc2.compid,
                '~' AS sp1,
                sc2.step_order,
                '~' AS eol
              FROM StepComponents2 sc2)
              ORDER BY
              dept ASC,
              testno ASC,
              step_order ASC,
              comptype ASC,
              compname ASC),
          ---     
          ---MyMicroTestMaterials---
            --Get materials for all identified components
            MyMicroTestMaterials AS (
              SELECT DISTINCT
                mc.dept,
                mc.testcatcode,
                mc.testno,
                mc.testcode,
                mc.testflag,
                m.matcode,
                m.mattype,
                m.unit_code,
                m.matname,
                mc.tmname,                
                '~' AS sp1,                
                mc.step_order,
                mc.stepcode,
                mc.comptype,
                mc.compname,
                mc.compid, 
                '~' AS eol
              FROM MyComponents mc
                INNER JOIN &Environment.microcompreagents mcr ON (
                    mc.Comptype = mcr.comptype AND mc.Compid = mcr.compid)
                INNER JOIN &Environment.materials m ON (mcr.matcode = m.matcode)
              WHERE 1=1
              ORDER BY
                mc.dept ASC,
                mc.testcatcode,
                mc.testno,              
                m.matcode,              
                mc.step_order ASC,
                mc.comptype ASC,
                mc.compname ASC),
          ---
          ---MyDefaultTestMaterials---
            MyDefaultTestMaterials AS (
            SELECT DISTINCT
              tc.dept,
              tc.testcatcode,
              t.testno,
              t.testcode,
              t.testflag,
              m.matcode,
              m.mattype,
              m.unit_code,                                 
              m.matname,
              t.tmname,  
              '~' AS sp1,
              NULL AS step_order,
              NULL AS stepcode,
              NULL AS comptype,
              NULL AS compname,
              NULL AS compid, 
              '~' AS eol
            FROM &Environment.testcategory tc
              INNER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode)
              INNER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)
              INNER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
            WHERE 1=1
            ORDER BY
              tc.dept ASC,
              tc.testcatcode ASC,
              t.testno ASC,
              m.matcode ASC),
          ---
          ---RecognizedMaterials---
            RecognizedMaterials AS (
              SELECT DISTINCT 
              ts.dept,
              NULL AS testcatcode,
              NULL AS testno,
              NULL AS testcode,
              NULL AS testflag,
              ts.matcode,
              ts.mattype,
              ts.unit_code,                                 
              ts.matname,
              NULL AS tmname,  
              '~' AS sp1,
              NULL AS step_order,
              NULL AS stepcode,
              NULL AS comptype,
              NULL AS compname,
              NULL AS compid, 
              '~' AS eol
              FROM  sunrise_data.adhs_tempsup ts
              WHERE 1=1
              ORDER BY 
              ts.dept ASC,
              ts.matcode ASC),
          ---
          ---AllUsedReagents---
            AllUsedReagents AS (
              SELECT DISTINCT * FROM MyMicroTestMaterials
              UNION
              SELECT DISTINCT * FROM MyDefaultTestMaterials),
          ---
          ---MatrialsNotIdentified---
            --Matrials used in SL, but not identified by Supervisors
            MatrialsNotIdentified AS (
              SELECT DISTINCT
                CASE
                  WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
                  WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
                  WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'
                END AS Env,
                aur.matcode,
                aur.dept,
                aur.testcatcode,
                aur.testno,
                aur.testcode,
                aur.testflag,
                aur.mattype,
                aur.unit_code,                                 
                aur.matname,
                aur.tmname,  
                aur.sp1,
                aur.step_order,
                aur.stepcode,
                aur.comptype,
                aur.compname,
                aur.compid, 
                aur.eol
              FROM AllUsedReagents aur
                LEFT OUTER JOIN RecognizedMaterials rm ON (
                    aur.matcode = rm.matcode)
              WHERE 1=1
                AND rm.matcode IS NULL
                --AND aur.testcatcode <> 'Retired'
              ORDER BY
                aur.matcode ASC,
                aur.dept ASC,
                aur.testcatcode ASC,
                aur.testno ASC,
                aur.step_order ASC,
                aur.comptype ASC,
                aur.compname ASC,
                aur.eol ASC)
                
          ---
          ---Final Query---
            --Give me Default and Micro test rouge materials
              --SELECT DISTINCT mni.* FROM MatrialsNotIdentified mni;            
            --Only Interested in 'Default' tests rouge materials
              SELECT DISTINCT mni.* FROM MatrialsNotIdentified mni WHERE mni.testflag = 'Default';
            --
          ---

