/*-----SampleVolumeInfo--------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --This set of scripts were createdt to help get an idea of the
    --volumme of reports and samples that are processed by the 
    --Clinical labs.  We also have stats related to myLIMS interface.
  /*----- -----*/


  /*-----SCRIPTS-----*/
    --01. Samples Received
    --02. Reports Generated Per Day
    --03. Active Submitters Count
    --04. myLIMS Submitters Count
    --05. myLIMS Reports
    --06. Client Volume
    --07. Chemistry Client Volume
  /*----- -----*/



  /*-----HISTORY-----*/
    --2015.12.31 JTY: Created Script
    --2016.01.05 JTY: Update to fix myLIMS reports script.
    --2016.02.26 JTY: Addition of Client Volume scripts.
  /*----- -----*/
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/

  /*-----01. Samples Received-----*/
    --251 Work Days in 2015
    --11,952 Samples/251 = 47.62 samples/day
    SELECT DISTINCT
      to_date('&StartDate','DD-MON-YY') AS begin_date,
      to_date('&EndDate','DD-MON-YY') AS end_date,
      COUNT (DISTINCT cr.external_id) AS sample_count,
      '~' AS eol
    FROM  sundata_prod.centralreceiving cr
      INNER JOIN sundata_prod.folders f ON (cr.external_id = f.external_id)
      INNER JOIN sundata_prod.metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        )    
    WHERE 1=1
      AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
      AND to_date(cr.date_received,'DD-MON-YY') BETWEEN to_date('&StartDate','DD-MON-YY') 
          AND to_date('&EndDate','DD-MON-YY');
  /*----- -----*/


  /*-----02. Reports Generated Per Day-----*/
    --251 Work Days in 2015
    --14,059 Reports/251 = 56.01 Reports/day
    SELECT DISTINCT
      to_date('&StartDate','DD-MON-YY') AS begin_date,
      to_date('&EndDate','DD-MON-YY') AS end_date,
      COUNT (DISTINCT f.folderno) AS reports_count,
      '~' AS eol
    FROM  sundata_prod.centralreceiving cr
      INNER JOIN sundata_prod.folders f ON (cr.external_id = f.external_id)
      INNER JOIN sundata_prod.metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        )    
    WHERE 1=1
      AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
      AND to_date(cr.date_received,'DD-MON-YY') BETWEEN to_date('&StartDate','DD-MON-YY') 
          AND to_date('&EndDate','DD-MON-YY');
  /*----- -----*/


  /*-----03. Active Submitters Count-----*/
    --242 Submitters
    SELECT DISTINCT
      to_date('&StartDate','DD-MON-YY') AS begin_date,
      to_date('&EndDate','DD-MON-YY') AS end_date,
      COUNT (DISTINCT cr.rasclientid) AS submitters_count,
      '~' AS eol
    FROM  sundata_prod.centralreceiving cr
      INNER JOIN sundata_prod.folders f ON (cr.external_id = f.external_id)
      INNER JOIN sundata_prod.metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        )    
    WHERE 1=1
      AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
      AND to_date(cr.date_received,'DD-MON-YY') BETWEEN to_date('&StartDate','DD-MON-YY') 
          AND to_date('&EndDate','DD-MON-YY');
  /*----- -----*/

  /*-----04. myLIMS Submitters Count-----*/
    -- 19 myLIMS Submitters
    SELECT DISTINCT
      COUNT (DISTINCT rc.rasclientid) AS myLIMS_count,
      '~' AS eol
    FROM  sundata_prod.rasclients rc
        INNER JOIN sundata_prod.rasclientcontacts rcc ON (rc.rasclientid = rcc.rasclientid)
        INNER JOIN sundata_prod.users u ON (rcc.usrnam = u.usrnam)
      WHERE 1=1
        AND u.deptlist = 'External'
        AND u.status = 'Active';
  /*----- -----*/


  /*-----05. myLIMS Reports-----*/
    --4,114 Reports associated with myLIMS clients
    SELECT DISTINCT
      to_date('&StartDate','DD-MON-YY') AS begin_date,
      to_date('&EndDate','DD-MON-YY') AS end_date,
      COUNT (DISTINCT f.folderno) AS mylims_reports_count,
      '~' AS eol
    FROM  sundata_prod.centralreceiving cr
      INNER JOIN sundata_prod.folders f ON (cr.external_id = f.external_id)
      INNER JOIN sundata_prod.metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        )
      INNER JOIN sundata_prod.rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN sundata_prod.rasclientcontacts rcc ON (rc.rasclientid = rcc.rasclientid)
      INNER JOIN sundata_prod.users u ON (rcc.usrnam = u.usrnam)
    WHERE 1=1
      AND u.deptlist = 'External'
      AND u.status = 'Active'   
      AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
      AND to_date(cr.date_received,'DD-MON-YY') BETWEEN to_date('&StartDate','DD-MON-YY') 
          AND to_date('&EndDate','DD-MON-YY');
  /*----- -----*/
/*-----------------------------------------------------------------*/





/*-----Client Volume---------------------------------------------------------*/
  /*-----Descriptioin-----*/
    --Get a list of Submitters along with the number of samples they submit
    --in the specified time period.  Also show the number of my_lims accounts
    --associated with the submitter.
  /*----- -----*/

  WITH 
    ---ClientInfo---
      ClientInfo AS (
        SELECT DISTINCT
          (rc.compname || '(' || rc.rasclientid ||')')AS client,
          rc.rasclientid,
          f.folderno,
          u.fullname,
          u.usrnam,
          u.status AS user_status,
          '~' AS eol
        FROM sundata_prod.folders f
          INNER JOIN sundata_prod.rasclients rc ON (f.rasclientid = rc.rasclientid)
          INNER JOIN sundata_prod.centralreceiving cr ON (f.external_id = cr.external_id)
          INNER JOIN sundata_prod.ordtask ot ON (f.folderno = ot.folderno)
          INNER JOIN sundata_prod.metadata_repository mr ON (1=1
            AND mr.tablereference = 'CENTRALRECEIVING'
            AND mr.original_origrec = cr.origrec)
          LEFT OUTER JOIN sundata_prod.rasclientcontacts rcc ON (rc.rasclientid = rcc.rasclientid)
          LEFT OUTER JOIN sundata_prod.users u ON (rcc.usrnam = u.usrnam)
        WHERE 1=1
          AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
          AND to_date(cr.date_received,'DD-MON-YY') BETWEEN to_date('&StartDate','DD-MON-YY') 
              AND to_date('&EndDate','DD-MON-YY')
          AND rc.compname NOT IN ('Arizona Department of Health Services')
--          AND u.status = 'Active'
      ),
    --- ---
    ---ClientSamples---
      ClientSamples AS (
        SELECT 
          ci.rasclientid,
          COUNT(DISTINCT ci.folderno) AS samples
        FROM ClientInfo ci
        GROUP BY 
          ci.rasclientid
        ORDER BY
          ci.rasclientid ASC
      ),
    --- ---
    ---MylimsCount---
      MylimsCount AS (
        SELECT 
          ci.rasclientid,
          COUNT(DISTINCT ci.fullname) AS users_count
        FROM ClientInfo ci
        WHERE 1=1
          --AND ci.user_status = 'Active'
        GROUP BY 
          ci.rasclientid
        ORDER BY
          ci.rasclientid ASC
      ),
    --- ---
    
    ---ClientStats---
      SubmittersStats AS (
        SELECT DISTINCT
          ci.client,
          cs.samples,
          ci.rasclientid,
          mc.users_count AS mylims_users,
          ci.eol
        FROM ClientSamples cs
          INNER JOIN ClientInfo ci ON (cs.rasclientid = ci.rasclientid)
          INNER JOIN MylimsCount mc ON (cs.rasclientid = mc.rasclientid)
      )
    --- ---
    ---Final Query---  
      SELECT DISTINCT
        ss.client,
        ss.samples,
        ss.rasclientid,
        ss.mylims_users,
        ss.eol
      FROM SubmittersStats ss
      WHERE 1=1
      ORDER BY
        ss.samples DESC,
        ss.client ASC,
        ss.mylims_users
    --- ---      
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*-----Chemistry Client Volume-----------------------------------------------*/
  /*-----Descriptioin-----*/
    --Get a list of Submitters along with the number of samples they submit
    --in the specified time period.  This Query for the Chemistry labs
  /*----- -----*/

  WITH 
    ---ClientInfo---
      ClientInfo AS (
        SELECT DISTINCT
          (rc.compname || '(' || rc.rasclientid ||')')AS client,
          rc.rasclientid,
          f.folderno,
          u.fullname,
          u.usrnam,
          u.status AS user_status,
          '~' AS eol
        FROM chemprod_data.folders f
          INNER JOIN chemprod_data.rasclients rc ON (f.rasclientid = rc.rasclientid)
          INNER JOIN chemprod_data.centralreceiving cr ON (f.external_id = cr.external_id)
          INNER JOIN chemprod_data.ordtask ot ON (f.folderno = ot.folderno)
--          INNER JOIN chemprod_data.metadata_repository mr ON (1=1
--            AND mr.tablereference = 'CENTRALRECEIVING'
--            AND mr.original_origrec = cr.origrec)
          LEFT OUTER JOIN chemprod_data.rasclientcontacts rcc ON (rc.rasclientid = rcc.rasclientid)
          LEFT OUTER JOIN chemprod_data.users u ON (rcc.usrnam = u.usrnam)
        WHERE 1=1
--          AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
          AND to_date(cr.date_received,'DD-MON-YY') BETWEEN to_date('&StartDate','DD-MON-YY') 
              AND to_date('&EndDate','DD-MON-YY')
--          AND rc.compname NOT IN ('Internal')
      ),
    --- ---
    ---ClientSamples---
      ClientSamples AS (
        SELECT 
          ci.rasclientid,
          COUNT(DISTINCT ci.folderno) AS samples
        FROM ClientInfo ci
        GROUP BY 
          ci.rasclientid
        ORDER BY
          ci.rasclientid ASC
      ),
    --- ---
    ---ClientStats---
      SubmittersStats AS (
        SELECT DISTINCT
          ci.client,
          cs.samples,
          ci.rasclientid,
          ci.eol
        FROM ClientSamples cs
          INNER JOIN ClientInfo ci ON (cs.rasclientid = ci.rasclientid)
      )
    --- ---
    ---Final Query---  
      SELECT DISTINCT
        ss.client,
        ss.samples,
        ss.rasclientid,
        ss.eol
      FROM SubmittersStats ss
      WHERE 1=1
      ORDER BY
        ss.samples DESC,
        ss.client ASC
    --- ---      
/*---------------------------------------------------------------------------*/

