/*-----------------------------------------------------------------*/
/*-----TestConfigurationDetails------------------------------------*/
  /*-----Description-----*/
    --This set of queries can be utilized to help complete the Default 
    --test configuration worksheet for test that have already been
    --defined.
    --
    --This is a work in progress, that we can update as we continue
    --to develop and fill this sheet out.
    --
    --The following Sections have been developed:
      --08. Specifications
      -- 09. Equipment Setup
    
  /*----- -----*/  

  /*----- -----*/
  /*----- -----*/  

  /*-----History-----*/
    --2014.10.08 JTY: Created Script
    --2015.12.23 JTY: Update with new sections
  /*----- -----*/  
/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/


  /*-----Test Info-----*/
/*
    SELECT DISTINCT
      t.testno,
      t.testcatcode AS "library",
      t.testflag AS testing_method,
      eq.eqtype AS equipment_type,
      t.testcode,      
      a.analyte,
      t.holdingtime,
      t.holdingtimeunits,
      t.testtype,
      '~' AS eol
    FROM &Environment.tests t
      INNER JOIN &Environment.analytes a ON (t.testcode = a.testcode)
      INNER JOIN &Environment.equip_tests et ON (t.testcode = et.testcode)
      INNER JOIN &Environment.equipment eq ON (et.eqid = eq.eqid)
    WHERE 1=1
      AND eq.eqtype <> 'Retired'
      AND t.testcode = &TestCode
      --AND t.testcatcode = '&CategoryCode'
    ORDER BY
      t.testcatcode ASC,
      t.testno ASC,
      t.testcode ASC;       
*/
  /*----- -----*/  

  /*-----Panels associated with test-----*/
/*  
  SELECT DISTINCT
    --Main DataGrid--
      tgn.testgroupname AS Panel,
      sp.progname AS usage,
      tgn.status,
      --tgn.questionformid,
    --
    --Synonyms tab--  
      --syn.synonim,
      --syn.namingconvention,
    --
    --PanelTest tab--
      t.testno,
      ctt.testcode,
      --ctt.testservgrp,
      ctt.dept,
      ctt.method,
      cta.analyte,
    --
    --Questions tab--
      --tgq.questioncaption,
    --
    --Responsible tab--
      --tgu.usrnam,
    --
    '~' AS eol
  FROM &Environment.testgroupnames tgn  
    INNER JOIN &Environment.Sample_Programs sp ON (tgn.sp_code = sp.sp_code)
    INNER JOIN &Environment.testgroupsynonims syn ON (tgn.testgroupname = syn.testgroupname)
    INNER JOIN &Environment.conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
    INNER JOIN &Environment.tests t ON (ctt.testcode = t.testcode)
    INNER JOIN &Environment.Conditiontestanalytes cta ON (
      ctt.dept = cta.dept
      AND ctt.testcode = cta.testcode
      AND ctt.testgroupname = cta.testgroupname
      AND ctt.method = cta.method)
    LEFT OUTER JOIN &Environment.Testgroupquestions tgq ON (tgn.testgroupname = tgq.testgroupname)
    INNER JOIN &Environment.Testgroup_Users tgu ON (tgn.testgroupname = tgu.testgroupname) 
  WHERE 1=1
    --AND ctt.dept = '&Dept'
    --AND t.testno = '&TestName'
    AND t.testcode = '&TestCode'
  ORDER BY 
      tgn.testgroupname ASC,
      sp.progname ASC,
      t.testno ASC,
      ctt.dept ASC,
      cta.analyte ASC;
*/
  /*----- -----*/

  /*-----Test Reagents-----*/
/*  
    SELECT DISTINCT
      tr.matcode,
      m.mattype,
      tr.units,
      m.matname,
      s.suppnam,
      ps.suppcode,
      '~' AS eol
    FROM &Environment.testreagents tr
      INNER JOIN &Environment.tests t ON (tr.testcode = t.testcode)
      INNER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
      INNER JOIN &Environment.prod_suppliers ps ON (m.matcode = ps.matcode)
      INNER JOIN &Environment.suppliers s ON (ps.suppcode = s.suppcode)
    WHERE 1=1
      AND t.testcode = '&TestCode'
*/      
  /*----- -----*/

  /*-----Possible Results-----*/
/*  
    SELECT DISTINCT
      (t.testno || '(' || t.testcode || ')') AS test_name_code,
      pr.analyte,
      pr.snomedcode AS result_code,
      pr.result,
      pr.conclusion_report AS report_as,
      pr.result_status,
      pr.sorter,
      t.testno,
      '~' AS eol
    FROM  &Environment.possibleresults pr
      INNER JOIN &Environment.tests t ON (pr.testcode = t.testcode)
    WHERE 1=1
      AND pr.testcode = '&TestCode'
    ORDER BY 
      (t.testno || '(' || t.testcode || ')')ASC,
      pr.sorter ASC,
      pr.result ASC;
*/      
  /*----- -----*/
  
  /*-----Canned Comments-----*/
/*  
    WITH  
      ---MyRef---
        --All panels in environment and associated test, 
        --and analytes.
        MyRef AS (
          SELECT DISTINCT
            ctt.dept,
            tc.testcatcode,
            ctt.servgrp,
            ctt.testgroupname AS panel,
            ctt.testcode,
            t.testno,
            a.analtype,
            a.analyte,
            '~' AS eol
          FROM &Environment.conditiontesttriggers ctt
            INNER JOIN &Environment.tests t ON (ctt.testcode = t.testcode)
            INNER JOIN &Environment.testcategory tc ON (t.testcatcode = tc.testcatcode)
            INNER JOIN &Environment.analytes a ON (t.testcode = a.testcode)
          WHERE 1=1
          ORDER BY 
            ctt.dept ASC,
            tc.testcatcode ASC,
            ctt.servgrp ASC,
            ctt.testgroupname  ASC,
            ctt.testcode ASC,
            t.testno ASC,
            a.analtype ASC,
            a.analyte ASC),
      ---
      ---MyCannedComments---              
        MyCannedComments AS (
          SELECT DISTINCT 
            CASE
              WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
              WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
              WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'                          
            END AS env, 
            (Coalesce(mr1.dept, mr2.dept, mr3.dept, 'All')) AS MyDept,
            CASE
              WHEN (mr3.analyte IS NOT NULL) THEN '04_Result'
              WHEN (mr2.testno IS NOT NULL) THEN '03_Test'
              WHEN (mr1.panel IS NOT NULL) THEN '02_Panel'
              ELSE '01_Folder'
            END AS CC_Level,     
            mr1.panel,    
            mr2.testno AS test_name,
            mr2.testcode,
            mr3.analyte,
            (cc.conditionfield || ' ' || cc.qualifier || ' '  || cc.conditionvalue ) AS cc_trigger,
            cc.canned_comment,
            '~' AS eol    
          FROM &Environment.canned_comments cc
            LEFT OUTER JOIN MyRef mr1 ON (cc.testgroupname = mr1.panel)
            LEFT OUTER JOIN MyRef mr2 ON (cc.testcode = mr2.testcode)
            LEFT OUTER JOIN MyRef mr3 ON (cc.analyte = mr3.analyte)
          WHERE 1=1
            --AND Coalesce(mr1.dept, mr2.dept, mr3.dept) IN ('PHX-TB')
          ORDER BY 
            cc_level ASC,
            --Coalesce(mr1.dept, mr2.dept, mr3.dept) DESC,
            mr1.panel ASC,
            mr2.testno ASC,
            mr3.analyte ASC,
            cc.canned_comment ASC),
      ---
      ---MySummary---
        MySummary AS (
          SELECT DISTINCT
            mcc.env,
            mcc.MyDept AS dept,
            mcc.cc_level,
            mcc.panel,
            mcc.test_name,
            mcc.testcode,
            mcc.analyte,
            mcc.cc_trigger,
            mcc.canned_comment,
            mcc.eol
          FROM MyCannedComments mcc
          WHERE 1=1
          ORDER BY 
            mcc.MyDept ASC,
            mcc.cc_level ASC,
            mcc.panel ASC,
            mcc.test_name ASC,
            mcc.analyte ASC,
            mcc.canned_comment ASC)
      ---
      ---Final Query---                      
        SELECT DISTINCT
            ms.env,
            ms.dept,
            ms.cc_level,
            ms.panel,
            ms.test_name,
            ms.testcode,
            ms.analyte,
            ms.cc_trigger,
            ms.canned_comment,
            ms.eol
        FROM MySummary ms
        WHERE 1=1
          AND (
              ms.testcode = '&TestCode'
              OR ms.panel = '&PaneName'
          )
  ---Filter parameters---      
  --        AND (ms.dept IS NULL or ms.dept IN ('All' ,'PHX-BAC'))  --PHX-BAC, PHX-BT, PHX-EM, PHX-SER, PHX-TB, PHX-VIR
  ---        
        ORDER BY
          ms.Dept ASC,
          ms.cc_level ASC,
          ms.panel ASC,
          ms.test_name ASC,
          ms.analyte ASC,
          ms.canned_comment ASC;
      ---
*/
  /*----- -----*/

  /*-----08. Specifications-----*/
/*  
    SELECT DISTINCT
      es.qctype,
      sa.specno,
      sa.analyte,
      sa.printflag,
      sa.qc_expected_result,
      sa.pass_text,
      sa.schemaname,
      '~' AS eol
    FROM sundata_prod.equip_standards es
      INNER JOIN sundata_prod.spec_sets ss ON (es.qctype = ss.qctype)
      INNER JOIN sundata_prod.spec_analytes sa ON (1=1
        AND es.testcode = sa.testcode
        AND ss.specno = sa.specno)
    WHERE 1=1
      AND es.testcode = &TestCode
    ORDER BY
      sa.analyte ASC,
      es.qctype ASC,
      sa.pass_text ASC;
*/
  /*----- -----*/  


  /*-----09. Equipment Setup-----*/
/*
    SELECT DISTINCT
      es.eqid,
      e.mfg,
      sl.cupno AS position,
      sl.postype,
      es.qctype,
      '~' AS eol
    FROM sundata_prod.equip_standards es
      INNER JOIN sundata_prod.qcsampslayout sl ON ( 1=1
        AND es.testcode = sl.testcode 
        AND es.eqid = sl.eqid
        AND es.qctype = sl.qctype)
      INNER JOIN sundata_prod.equipment e ON (es.eqid = e.eqid)
    WHERE 1=1
      AND es.testcode = '&TestCode'
      --AND es.eqid IN '&EquipmentID' --'ABI 7500 Fast DX "D"'
    ORDER BY 
    es.eqid ASC,
    sl.cupno ASC;
*/
  /*----- -----*/  



  /*----- -----*/
  /*----- -----*/  
/*-----------------------------------------------------------------*/



  
