
/*---------------------------------------------------------------------------*/
/*-----User_Queries----------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Set of qeries used to retrieve information on users.
      --1. Users Review - General Query to review all users.
      --2. myLIMS Users List - Review myLIMS users
  /*----- -----*/
  
  
  /*----- -----*/
  /*----- -----*/

  /*----- -----*/
  /*----- -----*/

/*---------------------------------------------------------------------------*/



/*-----1. Users Review------------------------------------------------------*/
  --General Query used to review STARLiMS users
  SELECT DISTINCT
    u.usrnam,
    r.role,
    u.fullname,
    u.status,
    u.deptlist,
    u.ldap_server,
    '~' AS eol
  FROM SUNDATA_PROD.users u
    INNER JOIN SUNDATA_PROD.Userroles ur ON (u.usrnam = ur.usrnam)
    INNER JOIN SUNDATA_PROD.Roles r ON (ur.treeauth = r.treeauth)
  WHERE 1=1
    AND u.status <> 'Retired'
  ORDER BY
    u.ldap_server ASC,
    u.status ASC,
    r.role ASC,
    u.fullname ASC
/*---------------------------------------------------------------------------*/


/*-----myLIMS Users List----------------------------------------------------*/
  ---Identify myLIMS users
  SELECT DISTINCT
    rc.compname,
    rc.rasclientid,
    u.usrnam,
    u.status,
    u.fullname,
    trunc(u.pwexpd) AS pwexpd,
    u.email,
    u.userphone,
    u.gracelog,
    u.authority,
    u.methoddeveloper,
    u.poweruser,
    u.designer,
    u.showerrordetails,
    u.securityaction,
    u.simultaneousloginsallowed AS multi_logins,
    '~' AS eol
  FROM sundata_prod.rasclientcontacts rcc 
    INNER JOIN sundata_prod.rasclients rc ON (rcc.rasclientid = rc.rasclientid)
    INNER JOIN sundata_prod.users u ON (rcc.usrnam = u.usrnam)
  WHERE 1=1
    AND rcc.rasclientid NOT IN ('ADHS')
    AND u.status IN ('Active')
  --  AND u.status = 'Hold'
  --  AND rcc.rasclientid IN ('APHL','MCHD-TB')
  ORDER BY
    rc.rasclientid ASC,
    TRUNC(u.pwexpd) ASC,
    u.fullname ASC,
    u.status ASC,
    rc.compname ASC;      
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
  
