
/*-----ReportDeliveryQueue_Fix-----------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Use this set of SQL statements to identify issues in the Report Delivery
    --Queue (RDQ) and address the identified issues.
    --
    --1. Clean Table Enteries - Clean out table enteries by ORIGRIC number.
    --2. 
  /*----- -----*/
  
  
  /*----- -----*/
  /*----- -----*/

  /*-----HISTORY-----*/
    --2016.12.08 JTY: Created Script File
  /*----- -----*/

/*---------------------------------------------------------------------------*/





/*-----1. Clean Table Enteries-----------------------------------------------*/
  --Use this set of SQL statements to clean out the table enteries for identified
  --samples/reports
  
  --DELETE FROM faxqueue fq WHERE 1=1 AND fq.origrec = '&fq_Origrec';
  --DELETE FROM rr_rdq_history rdh WHERE 1=1 AND rdh.origrec = '&rdh_origrec';
  --DELETE FROM rr_report_delivery_queue rdq WHERE 1=1 AND rdq.origrec = '&rdq_origrec';  
/*---------------------------------------------------------------------------*/




/*-----2. Identify Reports With Issues In The RDQ----------------------------*/
  SELECT DISTINCT
    rdq.status,
    rbs.progress,
    '~' AS SP_1,
    f.dept,
    rdq.batch_id,
    rdq.itemid,
    f.folderno,  
    f.testgroupname,
    to_char(rdh.sent_date, 'YYYY.MM.DD')  || '  ' || rdh.sent_time AS approved_dt,
    rdq.delivery_method,
    rdq.delivery_address, 
    u.fullname,
    f.rasclientid,
    rdq.extra_info,
    fq.crtmessage AS fax_message,
    rdq.reporttype,  
    '~' AS SP_2,
    rdq.origrec AS rdq_origrec,
    rdh.origrec AS rdh_origrec,
    fq.origrec AS fq_origrec,
    rb.origrec AS rb_origrec,
    rbs.origrec AS rbs_origrec,
    '~' AS eol
  FROM sundata_prod.rr_report_delivery_queue rdq
    INNER JOIN sundata_prod.folders f on (rdq.folderno = f.folderno)
    INNER JOIN sundata_prod.users u ON (rdq.usrnam = u.usrnam)
    INNER JOIN sundata_prod.rr_rdq_history rdh ON (1=1
      AND rdh.stardoc_id= rdq.stardoc_id
      AND rdh.queue_item_no = rdq.queue_item_no
      )
    LEFT OUTER JOIN sundata_prod.faxqueue fq ON (rdq.receipt_number = fq.receipt)
    LEFT OUTER JOIN sundata_prod.rr_batches rb ON (rdq.batch_id = rb.batchid)
    INNER JOIN sundata_prod.rr_batchstatus rbs ON (rdq.batch_id = rbs.batchid)
    
  WHERE 1=1
    --Identified Possible Problems--  
      AND (
        rdq.status IN ('RUNNING', 'ERROR')
        OR rdq.extra_info IS NOT NULL
        OR rbs.progress <> '100'
        OR upper(fq.crtmessage) LIKE '%ERROR%'
        OR (fq.origrec IS NOT NULL AND fq.senddate IS NULL)
      )
    --
    --AND rdq.batch_id = '&BatchID'
    --AND rdq.queue_item_no = '&QueueItemNumber'
    --AND rdq.folderno = '&FolderNo'
  ORDER BY 
    rdq.status ASC,
    f.dept ASC,
    rdq.batch_id ASC,
    f.folderno ASC,
    approved_dt ASC
/*---------------------------------------------------------------------------*/

