/*---------------------------------------------------------------------------*/
/*-----MissingFinalReports---------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --This set of queries can be used to identify samples that have been
    --completed, but don't have a final report associated with them.
  /*----- -----*/


  /*-----HISTORY-----*/
    --2016.02.22 JTY: Created Query
  /*----- -----*/

/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*-----01. Identify Suspect Samples------------------------------------------*/
  /*----- -----*/
    SELECT DISTINCT
      f.dept,
      fc.approveddate,
      f.testgroupname,
      f.external_id,
--      oq.rasclientid,
--      oq.status AS hl7_status,
      rdq.reporttype,
      fc.approvedby,
      fc.approvedtime,
      fc.dispsts,
      rdq.batch_id,
      fc.origrec AS fc_origrec,
      '~' AS eol
    FROM  sundata_prod.folders f
      INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
      LEFT OUTER JOIN sundata_prod.rr_Report_Delivery_Queue rdq ON ( 1=1
        AND f.folderno = rdq.folderno
AND rdq.reporttype IN ('Final', 'Amended', 'Corrected')        
        )
      LEFT OUTER JOIN sundata_prod.orion_queue oq ON (f.folderno = oq.folderno)
    WHERE 1=1
--AND fc.folderno = 'AZ00039233-01'          
      AND fc.approveddate IS NOT NULL
      AND rdq.batch_id IS NULL
      AND f.testgroupname NOT LIKE 'PFGE%'
      AND fc.approveddate BETWEEN 
          TO_DATE('01-JAN-2016','DD-MON-YYYY') AND SYSDATE
--AND  oq.rasclientid = 'PHLIP-FLU'        
    ORDER BY
      f.dept ASC,
      fc.approveddate ASC,
      f.testgroupname ASC,
      f.external_id;
  /*----- -----*/
/*---------------------------------------------------------------------------*/
