/*-----RDQ_ReportDeliveryIssues------------------------------------*/



    --10. Released Samples Not In RDQ

/*-----------------------------------------------------------------*/


/*-----------------------------------------------------------------*/



/*--01. RightFax Check---------------------------------------------*/
  --Need to determine what the status for faxes in a give date
  --range is.
/*  
  SELECT 
    rdq.dept,
    rdq.rasclientid,
    rdq.folderno,
    rdq.reporttype,
    rdq.delivery_method,
    fq.postdate,
    fq.senddate,
    fq.tocompany,
    fq.status,
    fq.statusname,
    fq.errorname,
    fq.faxhandler,
    fq.receipt,
    '~' AS eol
  FROM rr_report_delivery_queue rdq
        INNER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
  WHERE 1=1
--    AND fq.postdate BETWEEN '&StartDate' AND '&EndDate'
--    AND rdq.dept = '&Dept'
--    AND rdq.rasclientid = '&RasClientID'
    AND rdq.folderno LIKE '&FolderNo'
--    AND fq.senddate IS NOT NULL
  ORDER BY
    rdq.dept ASC,
    rdq.rasclientid ASC,
    fq.senddate DESC,
    rdq.folderno ASC,
    fq.postdate DESC
*/    
/*-----------------------------------------------------------------*/




/*--02. Email Check---------------------------------------------*/
  --Need to determine what the status for Email in a give date
  --range is.
/*  
  SELECT 
    rdq.dept,
    rdq.rasclientid,
    rdq.folderno,
    rdq.reporttype,
    rdq.delivery_method,
    rdh.sent_date,
    '~' AS eol
  FROM rr_report_delivery_queue rdq
    LEFT OUTER JOIN rr_rdq_history rdh ON (1=1
        AND rdq.queue_item_no = rdh.queue_item_no)
  WHERE 1=1
    AND rdq.delivery_method = 'E-mail'  
    AND rdh.sent_date BETWEEN '&StartDate' AND '&EndDate'
--    AND rdq.dept = '&Dept'
--    AND rdq.rasclientid = '&RasClientID'
--    AND rdq.folderno LIKE '&FolderNo'
--    AND fq.senddate IS NOT NULL
  ORDER BY
    rdq.dept ASC,
    rdq.rasclientid ASC,
    rdq.folderno ASC;
*/    
/*-----------------------------------------------------------------*/



/*--03. Hard Copy------------------------------------------------*/
  --Need to determine what the status for Hard Copy in a give date
  --range is.
  SELECT DISTINCT 
    f.external_id,
    f.dept,
    f.apprdate,
    rdq.batch_id,
    rdq.queue_item_no,
    rdq.status,
    rdq.delivery_method,
    rdq.stardoc_id,
    bs.progress,
    bs.noerrors,
    bs.totalitems,
    bs.processed,
    bs.origrec,
    bs.*,
    '~'
  FROM folders f 
    LEFT OUTER JOIN rr_report_delivery_queue rdq ON (f.folderno = rdq.folderno)
    LEFT OUTER JOIN rr_batchstatus bs ON rdq.batch_id = bs.batchid
  WHERE 1=1 
    AND f.external_id IS NOT NULL
    AND rdq.delivery_method = 'Hard Copy'
    AND f.apprdate BETWEEN '&StartDate' AND '&EndDate'
    AND bs.noerrors > 0
    AND bs.processed = 0
  ORDER BY
    f.dept ASC,
    f.apprdate ASC,
    rdq.batch_id ASC,
    f.external_id ASC;   
    
    
    
/*
    -----Inspect Batch-----
      SELECT * FROM  rr_batchstatus bs WHERE bs.batchid = '&BatchID';
      SELECT * FROM rr_report_delivery_queue rdq WHERE 1=1 AND rdq.batch_id = '&BatchID';
    ----- -----

    -----Re-Queue batch-----
      --Use these script to restart the Batch job when there have been failures.
      UPDATE rr_batchstatus bs
      SET 
        bs.progress = 0,
        bs.noerrors = 0
      WHERE 1=1
        AND bs.batchid = '&BatchID';
        
      UPDATE rr_report_delivery_queue rdq 
      SET rdq.status = 'QUEUED' 
      WHERE rdq.batch_id = '&BatchID'
    ----- -----    
*/    
/*-----------------------------------------------------------------*/




/*-----10. Released Samples Not In RDQ-----------------------------*/
  --This set of queries has been developed in response to the issue
  --that sometimes when a samples is released in the Release By Panel
  --application it does not appear in the RDQ.
  
  --2018.07.19 JTY: Created Scripts


  -----10.1 Identify Inconsistancies-----
    --Sometimes the FolderCondition table is updated bu the Folders
    --table is not updated.  First identify records that have this
    --issue.
    SELECT DISTINCT
      f.external_id,
      f.dept,
      f.testgroupname,
      f.apprdate AS f_apprdate,
      f.approvedby AS f_approvedby,
      f.apprdisp AS f_apprdisp,
      f.apprsts AS f_apprsts,
      f.fldsts AS f_fldsts,      
      fc.folderno,
      fc.approveddate AS fc_approveddate,
      fc.approvedtime AS fc_approvedtime,
      fc.approvedby AS fc_approvedby,
      '~' AS eol
    FROM folders f
      INNER JOIN foldercondition fc ON (f.folderno = fc.folderno)
    WHERE 1=1
      AND (COALESCE(f.apprdate, sysdate) <> COALESCE(fc.approveddate, sysdate))
      AND fc.folderno IN (&FolderList)
  ----- -----
  
  -----10.2 Repair Folders table-----
    --When samples have been identified in the previous query that have inconsistant
    --values between the Folders and the FolderCondition tables, use this query to 
    --upate the Folders table with values in the FolderCondition table.
    
/*
    MERGE INTO folders t1
    USING (
      SELECT DISTINCT
        f.external_id,
        f.dept,
        f.testgroupname,
        f.apprdate AS f_apprdate,
        f.approvedby AS f_approvedby,
        f.apprdisp AS f_apprdisp,
        f.apprsts AS f_apprsts,
        f.fldsts AS f_fldsts,      
        fc.folderno,
        fc.approveddate,
        fc.approvedtime,
        fc.approvedby,
        '~' AS eol
      FROM folders f
        INNER JOIN foldercondition fc ON (f.folderno = fc.folderno)
      WHERE 1=1
        AND (COALESCE(f.apprdate, sysdate) <> COALESCE(fc.approveddate, sysdate))
        AND fc.folderno IN (&FolderList)
            ) t2
    ON (t1.folderno = t2.folderno)
    WHEN MATCHED THEN
      UPDATE SET
      t1.apprdate = t2.approveddate,
      t1.apprtime = t2.approvedtime,
      t1.approvedby = t2.approvedby,
      t1.apprdisp = 'Released',
      t1.apprsts = 'Released'
*/
  ----- -----
  
  -----10.3 Next Create Reports-----
    --If reports need to be generated, you can now us the ADHS_Utilities tool
    --to generate the reports.
  ----- -----
  
  

  
/*-----------------------------------------------------------------*/
