/*----Review Suspect Samples----------------------------------------*/
  --Show samples that are associated with released runs but the
  --samles have not been approved.
  
  SELECT DISTINCT 
    r.dept,
    r.runno,
    f.external_id,
    f.folderno,
    ot.testgroupname AS panel,
    (ot.testno || ': ' || ot.testcode) AS test_name,
    re.analyte,
    r.approvalstatus AS r_approvalstatus,
    r.approvedate AS r_approvedate,
    ot.apprdate AS ot_apprdate,
    r.approvedby AS r_approvedby,
    ot.apprvedby AS ot_apprvedby,
    r.origrec AS run_origrec,
    ot.origrec AS ot_origrec,
    f.origrec AS f_origrec,
    fc.origrec AS fc_origrec,
    '~' AS eol
  FROM &Environment.runs r
    INNER JOIN &Environment.results re ON (r.runno = re.runno)
    INNER JOIN &Environment.ordtask ot ON (ot.runno = r.runno)
    INNER JOIN &Environment.folders f ON (ot.folderno = f.folderno)
    INNER JOIN &Environment.foldercondition fc ON (f.folderno = fc.folderno)
  WHERE 1=1
    AND r.approvalstatus = 'Released'
    AND (r.approvedby IS NOT NULL)
    AND (r.approvedate IS NOT NULL)
    AND (ot.apprvedby IS NULL
        OR ot.apprdate IS NULL)
--    AND r.dept IN ('PHX-VIR','PHX-SER')
    ORDER BY
      r.dept ASC,
      r.runno ASC,
      f.external_id ASC,
      ot.testgroupname ASC,
      test_name ASC,
      re.analyte ASC;
/*-----------------------------------------------------------------*/





  ---Update Run to force to Run Approval---
/*
    UPDATE runs r
    SET 
      r.approvedate = '',
      r.approvedby = '',
      r.approvalstatus = ''
      --r.runstatus = 'Done', 
      --r.runstsdisp = 'Done' 
    WHERE 1=1
      AND r.runno = '&RunNumber';
      
        
    UPDATE ordtask ot
    SET 
      ot.apprdate = '', 
      ot.apprvedby = '',
      --ot.ts = 'Done', --Done or OOS
      ot.tsa = 'RTR',
      ot.tsadisp = 'RTR'
    WHERE 1=1
      AND ot.runno = '&RunNumber';
*/
  --- ---
