/*=====SL10: InventoryHistory======================================*/


/*-----SL10: InventoryHistory--------------------------------*/
  /*----------Summary----------*/
    --This query will display the inventory history for the
    --parameters provided.
  /*---------- ----------*/  

  /*----------History----------*/
    --2013.07.25 JTY: Created Query
  /*---------- ----------*/  
  
  /*----------SL10 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/
/*-----------------------------------------------------------*/




/*-----------------------------------------------------------*/
/*-----Primary Query-----------------------------------------*/
  /*---------- ----------*/  
    SELECT DISTINCT    

      --Material Details--
      '~Mat:' AS Sep1,
      i.matcode,
      l.dept,      

      i.unit_code,
      i.suppcode,
      --
      --Inventory Info--
      'Inv:' AS Sep2,   
      i.lotno,
      i.status,
      i.item_counter,
      Trunc(i.receive_date) AS receive_date,
      Trunc(i.expire_date) AS expire_date,
      --
      --History--
      'His:' AS Sep3,
      (l.locationcode || ': ' || l.location) AS location,
      u.fullname AS h_changedby,
      ic.balance AS h_balance,
      Trunc(ic.datechange) AS h_datechange,
      ic.amountchange AS h_amountchange,
      --ic.itemsremoved AS h_itemsremoved,
      --
      --Misc--
      'Mis:' AS Sep4,      
      m.matname,      
      --
      '~' AS eol
    FROM &Environment.inventory i
      INNER JOIN &Environment.materials m ON (i.matcode = m.matcode)
      INNER JOIN &Environment.inventorychange ic ON (ic.inventoryid = i.inventoryiD)
      INNER JOIN &Environment.locations l ON (ic.locationcode = l.locationcode)
      INNER JOIN &Environment.users u ON (ic.changedby = u.usrnam)
    WHERE 1=1
---Selection Criteria---
      --AND i.lotno = ''
      AND i.matcode = '0.5% Acid Alcohol'
      --AND l.dept = 'PHX-VIR'
      --AND m.matname = ''
      --AND ic.locationcode = ''
      --AND i.item_counter <> '0'
---    
    ORDER BY
      i.matcode ASC,
      l.dept ASC,
      i.lotno ASC,
      --i.inventoryid ASC,
      Trunc(ic.datechange) ASC  
  /*---------- ----------*/    

  /*---------- ----------*/  
  /*---------- ----------*/    
  
/*-----------------------------------------------------------*/




/*-----WorkSpace---------------------------------------------*/
  /*---------- ----------*/  
  /*---------- ----------*/ 
/*-----------------------------------------------------------*/

/*=================================================================*/

