


/*-----Barcode Submittals----------------------------------------------------*/
  --Identify clients submitting samples via Barcode form
/*
  SELECT DISTINCT
    trunc(cr.date_received,'MON') AS month_date,
    cr.date_received,
    cr.external_id,
    CASE COALESCE(length(bl.scanned_by), 0)
      WHEN 0 THEN ''
      ELSE 'X'
    END AS barcode,
    (rc.compname || '(' || cr.rasclientid || ')') AS client,
    f.dept,
    f.testgroupname AS panel,
    bl.scanned_by,
--    COALESCE(bl.scanned_by AS barcode_scanned),
    '~' AS eol
  FROM centralreceiving cr
    INNER JOIN folders f ON (cr.external_id = f.external_id)
    LEFT OUTER JOIN barcode_log bl ON (cr.external_id = bl.external_id)
    INNER JOIN rasclients rc ON (f.rasclientid = rc.rasclientid)
    INNER JOIN metadata_repository mr ON (1=1
      AND mr.tablereference = 'CENTRALRECEIVING'
      AND mr.original_origrec = cr.origrec)
  WHERE 1=1
    AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
    AND f.prodgroup IN ('Human')
    AND f.dept IN ('PHX-SER', 'PHX-VIR', 'PHX-TB', 'PHX-BAC')
    AND to_date(cr.date_received, 'DD-MON-YY') BETWEEN to_date('&BeginDate', 'DD-MON-YY') AND to_date('&EndDate', 'DD-MON-YY')
  ORDER BY
    month_date ASC,
    barcode ASC,
    client ASC,
    date_received DESC,
    cr.external_id DESC
*/
/*---------------------------------------------------------------------------*/


/*-----First Barcode Submittal-----------------------------------------------*/
  --Determine when the first barcode sample was accessioned for each client
  --that has used the barcode submittal form.
  /*
WITH
  ---FirstOrigrec---
    FirstOrigrec AS (
      SELECT DISTINCT
        cr.rasclientid,
        MIN(cr.origrec) AS cr_origrec,
        '~' AS eol
      FROM barcode_log bl
        INNER JOIN centralreceiving cr ON (bl.external_id = cr.external_id)
        INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
        INNER JOIN folders f ON (cr.external_id = f.external_id)
        INNER JOIN metadata_repository mr ON (1=1
          AND mr.tablereference = 'CENTRALRECEIVING'
          AND mr.original_origrec = cr.origrec)
      WHERE 1=1
        AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
        AND f.prodgroup IN ('Human')
        AND f.dept IN ('PHX-SER', 'PHX-VIR', 'PHX-TB', 'PHX-BAC')
        AND to_date(cr.date_received, 'DD-MON-YY') BETWEEN to_date('&BeginDate', 'DD-MON-YY') AND to_date('&EndDate', 'DD-MON-YY')
      GROUP BY 
        cr.rasclientid
      ORDER BY
        cr.rasclientid ASC

    )
  --- ---
  ---FirstSubmittal---
      SELECT DISTINCT
        (rc.compname || ' (' || cr.rasclientid || ')') AS client_name,
        cr.date_received AS first_submittal,
        cr.external_id,
        cr.origrec AS cr_origrec,
        trunc(cr.date_received,'MON') AS month_date,
        EXTRACT(YEAR FROM cr.date_received) AS start_year,
        EXTRACT(MONTH FROM cr.date_received) AS start_month,
        fo.eol
      FROM FirstOrigrec fo
        INNER JOIN centralreceiving cr ON (fo.cr_origrec = cr.origrec)
        INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      WHERE 1=1
        ORDER BY 
          month_date ASC,
          client_name ASC
  --- ---
*/  

/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*-----ReceivedSamples-------------------------------------------------------*/
  --Bring information together and get list of samples submitted in the 
  --specified timeframe along with information on first barcode submittal.

  WITH
    ---FirstOrigrec---
      FirstOrigrec AS (
        SELECT DISTINCT
          cr.rasclientid,
          MIN(cr.origrec) AS cr_origrec,
          '~' AS eol
        FROM barcode_log bl
          INNER JOIN centralreceiving cr ON (bl.external_id = cr.external_id)
        WHERE 1=1
        GROUP BY 
          cr.rasclientid
        ORDER BY
          cr.rasclientid ASC
      ),
    --- ---
    ---FirstSubmittal---
      FirstSubmittal AS (
        SELECT DISTINCT
          cr.rasclientid,
          cr.external_id AS first_bc_id,
          cr.date_received AS first_bc_received,
          trunc(cr.date_received,'MON') AS first_bc_month,
          fo.eol
        FROM FirstOrigrec fo
          INNER JOIN centralreceiving cr ON (fo.cr_origrec = cr.origrec)
        WHERE 1=1
          ORDER BY 
            cr.rasclientid ASC
      )
    --- ---
    --- ---
      SELECT DISTINCT
      cr.date_received,
      cr.external_id,
      CASE COALESCE(length(bl.scanned_by), 0)
        WHEN 0 THEN ''
        ELSE 'X'
      END AS barcode,
      (rc.compname || '(' || cr.rasclientid || ')') AS client,
      f.dept,
      f.testgroupname AS panel,
      fs.first_bc_id,
      fs.first_bc_received,
      fs.first_bc_month,    
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      LEFT OUTER JOIN barcode_log bl ON (cr.external_id = bl.external_id)
      LEFT OUTER JOIN FirstSubmittal fs ON (fs.rasclientid = cr.rasclientid)
    WHERE 1=1
      AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
      AND f.prodgroup IN ('Human')
      AND f.dept IN ('PHX-SER', 'PHX-VIR', 'PHX-TB', 'PHX-BAC')
      AND to_date(cr.date_received, 'DD-MON-YY') BETWEEN to_date('&BeginDate', 'DD-MON-YY') AND to_date('&EndDate', 'DD-MON-YY')
    ORDER BY
      cr.date_received ASC,
      client ASC,
      cr.external_id ASC  
    --- ---
/*---------------------------------------------------------------------------*/

