--SELECT DISTINCT mr.field_varchar_80 FROM sundata_prod.metadata_repository mr WHERE mr.tablereference = 'CENTRALRECEIVING'


----Identify Clients submitting the most samples to ADHS-----
  SELECT DISTINCT
    (rc.compname || ' (' || rc.rasclientid || ')') AS client,
    COUNT(DISTINCT f.folderno) AS cnt,
    '' AS contact_name,
    rc.primaryphone AS phone,
    rc.email,
    rc.primaryfax as fax,
    '~' AS eol
  FROM  sundata_prod.centralreceiving cr
    INNER JOIN sundata_prod.rasclients rc ON (cr.rasclientid = rc.rasclientid)
    INNER JOIN sundata_prod.folders f ON (cr.external_id = f.external_id)
    INNER JOIN sundata_prod.metadata_repository mr ON ( 1=1
      AND mr.tablereference = 'CENTRALRECEIVING'
      AND mr.original_origrec = cr.origrec)
  WHERE 1=1
    AND mr.field_varchar_80 IN ('LRN-B','Diagnostic')
    AND to_date(cr.date_received, 'DD-MON-YYYY') BETWEEN to_date((sysdate-366), 'DD-MON-YYYY') AND to_date(sysdate, 'DD-MON-YYYY')
  GROUP BY
    (rc.compname || ' (' || rc.rasclientid || ')'),
    rc.primaryphone,
    rc.email,
    rc.primaryfax
  ORDER BY
    COUNT(DISTINCT f.folderno) DESC
