/*---------------------------------------------------------------------------*/
/*-----RecevingDeptQueries---------------------------------------------------*/
  /*-----Description-----*/
    --These are queries the receiving department periodically requests
  /*----- -----*/
  
  
  /*----- -----*/
    --2019.01.14 JTY: Created Scripts
  /*----- -----*/
  
/*---------------------------------------------------------------------------*/


/*--01. Barcode Accessiioning Stats------------------------------------------*/
/*---------------------------------------------------------------------------*/
  SELECT DISTINCT
    to_date(cr.date_received, 'DD-MON-YY') AS date_received,
    cr.external_id,
    CASE COALESCE(length(bl.scanned_by), 0)
      WHEN 0 THEN ''
      ELSE 'X'
    END AS barcode,
    (rc.compname || '(' || cr.rasclientid || ')') AS client,
    f.dept,
    f.testgroupname AS panel,
    bl.scanned_by,
--    COALESCE(bl.scanned_by AS barcode_scanned),
    '~' AS eol
  FROM centralreceiving cr
    INNER JOIN folders f ON (cr.external_id = f.external_id)
    LEFT OUTER JOIN barcode_log bl ON (cr.external_id = bl.external_id)
    INNER JOIN rasclients rc ON (f.rasclientid = rc.rasclientid)
  WHERE 1=1
    AND f.prodgroup IN ('Human')
    AND f.dept IN ('PHX-SER', 'PHX-VIR', 'PHX-TB', 'PHX-BAC')
    AND to_date(cr.date_received, 'DD-MON-YY') BETWEEN to_date('&BeginDate', 'DD-MON-YY') AND to_date('&EndDate', 'DD-MON-YY')
  ORDER BY
    date_received DESC,
    cr.external_id DESC
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
