

/*---------------------------------------------------------------------------*/
/*-----SubmitedSammplesReview------------------------------------------------*/
  --Query what samples have been submitted in the indicated timeframe, and
  --how they were submitted (Barcode).
  SELECT DISTINCT
    to_date(cr.date_received, 'DD-MON-YY') AS date_received,
    cr.external_id,
    CASE COALESCE(length(bl.scanned_by), 0)
      WHEN 0 THEN ''
      ELSE 'X'
    END AS barcode,
    (rc.compname || '(' || cr.rasclientid || ')') AS client,
    f.dept,
    f.testgroupname AS panel,
    bl.scanned_by,
--    COALESCE(bl.scanned_by AS barcode_scanned),
    '~' AS eol
  FROM centralreceiving cr
    INNER JOIN folders f ON (cr.external_id = f.external_id)
    LEFT OUTER JOIN barcode_log bl ON (cr.external_id = bl.external_id)
    INNER JOIN rasclients rc ON (f.rasclientid = rc.rasclientid)
    INNER JOIN metadata_repository mr ON (1=1
      AND mr.tablereference = 'CENTRALRECEIVING'
      AND mr.original_origrec = cr.origrec
      AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B')
      )
  WHERE 1=1
    AND f.prodgroup IN ('Human')
    AND f.dept IN ('PHX-SER', 'PHX-VIR', 'PHX-TB', 'PHX-BAC')
    AND to_date(cr.date_received, 'DD-MON-YY') BETWEEN to_date('&StartDate', 'DD-MON-YY') AND to_date('&EndDate', 'DD-MON-YY')
  ORDER BY
    date_received DESC,
    cr.external_id DESC;
    /*---------------------------------------------------------------------------*/
