

WITH
  --year_months--
    year_months AS (
      SELECT DISTINCT
        '&TheYear' AS the_year,
        (TO_CHAR(cr.date_received, 'MM') || ' - ' || TO_CHAR(cr.date_received, 'MON')) AS year_months,
        TO_CHAR(cr.date_received, 'MM') AS month_no
      FROM centralreceiving cr
      WHERE 1=1
        AND cr.date_received IS NOT NULL
      ORDER BY month_no ASC
    ),
  -- --
  --samples_received--
    samples_received AS (
      SELECT DISTINCT
        cr.rasclientid,
        TO_CHAR(cr.date_received, 'MM') AS month_no,
        COUNT(DISTINCT f.folderno) AS samples_count
      FROM  centralreceiving cr
        INNER JOIN folders f ON (cr.external_id = f.external_id)
        INNER JOIN metadata_repository mr ON (1=1
          AND mr.tablereference = 'CENTRALRECEIVING'
          AND mr.original_origrec = cr.origrec)
      WHERE 1=1
        AND mr.field_varchar_80 IN ('LRN-B', 'Diagnostic')
        AND EXTRACT(YEAR FROM cr.date_received) = '&TheYear'
      GROUP BY
        cr.rasclientid,
        TO_CHAR(cr.date_received, 'MM')
      ORDER BY
        cr.rasclientid ASC,
        month_no ASC
    ),
  -- --
  --communications_logged--
    communications_logged AS (
      SELECT DISTINCT
        cl.rasclientid,
        TO_CHAR(cl.logged_date, 'MM') AS month_no,
        COUNT(DISTINCT cl.origrec) AS communications_count,
        '~' AS eol
      FROM centralreceiving cr
        INNER JOIN folders f ON (cr.external_id = f.external_id)
        INNER JOIN metadata_repository mr ON (1=1
          AND mr.tablereference = 'CENTRALRECEIVING'
          AND mr.original_origrec = cr.origrec)
        INNER JOIN communication_log cl ON (f.folderno = cl.folder_number)
      WHERE 1=1
        AND mr.field_varchar_80 IN ('LRN-B', 'Diagnostic')
        AND EXTRACT(YEAR FROM cl.logged_date) = '&TheYear'
      GROUP BY
        cl.rasclientid,
        TO_CHAR(cl.logged_date, 'MM')
      ORDER BY
        cl.rasclientid ASC,
        month_no ASC
    ),
  -- --
  --client_sums--
    client_sums AS (
      SELECT DISTINCT
        COALESCE(sr.rasclientid, cl.rasclientid) AS rasclientid,
        ym.year_months,
        COALESCE(sr.samples_count,0) AS samples_count,
        COALESCE(cl.communications_count,0) AS communications_count,
        '~' AS eol
      FROM year_months ym
        LEFT OUTER JOIN samples_received sr ON (ym.month_no = sr.month_no)
        LEFT OUTER JOIN communications_logged cl ON (ym.month_no = cl.month_no)
      WHERE 1=1
          AND sr.rasclientid = cl.rasclientid
      ORDER BY
        rasclientid ASC,
        ym.year_months ASC
    )
  -- --
--  SELECT * FROM samples_received where rasclientid = 'ACC'
  SELECT * FROM communications_logged where rasclientid = 'ACC'  
/*  
  --Final Query--
    SELECT 
      cs.*
    FROM client_sums cs
    WHERE 1=1
      AND cs.rasclientid = 'ACC'
  -- --



--SELECT cl.logged_date FROM communication_log cl where cl.rasclientid = 'MCHD-TB'


/*  
  --merged_records--
    merged_records AS (
      SELECT DISTINCT
        sr.rasclientid,
        ym.year_months,
--        sr.month_received,
--        sr.samples_count,
--        cl.month_communication,
--        cl.communications_count,
       '~' AS eol
      FROM year_months ym
        LEFT OUTER JOIN samples_received sr ON (ym.year_months = sr.month_received)
        LEFT OUTER JOIN communications_logged cl ON (ym.year_months = cl.month_communication)
      WHERE 1=1
AND sr.rasclientid = 'ACC'
      ORDER BY 
        sr.rasclientid,
        ym.year_months
        
    )
SELECT * FROM merged_records

*/
