
/*=====Migrate_MicroComponents=====================================*/

  /*----------DESCRIPTION----------*/  
    --We present here a series of scripts developed to migrate
    --various aspects of Micro Components between environments(Schemas)
    --This is a work in progress, and we plan on adding scripts
    --to this document as need is identified.
  /*----------  ----------*/  

  /*----------SL10 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/  
  
  /*----------SCRIPT SETS----------*/  
    --01. Migrate MicroComponent: Migrate micro compnent beteween environments [microcomponents]
    --02. Migrate_PossibleResults: Migrate Possible Results
        --between schema's for already existing Micro Components.
    --03. Migrate_MicroPanels
  /*----------  ----------*/  

  /*----------HISTORY----------*/  
    --2014.06.30 JTY: Created framework and first script set.
    --2015.02.02 JTY: Addition of MicroComponent Migration.
    --2016.05.11 JTY: yoder
  /*----------  ----------*/  

/*=================================================================*/





/*-----01. Migrate_MicroComponent--------------------------------------------*/

  -----01. Grant Read Access to Source Schema-----
    --Need to grant user account access to read source tables.
--    GRANT SELECT ON microcomponents TO &TargetSchema;
  -----
  
  -----02. Review target Schema MicroComponents-----  
/*  
    SELECT DISTINCT
      mc.comptype,
      mc.compid,
      mc.acronym,
      mc.compname,
      mc.origsts,
      mc.hidefromreport,
      mc.eqid,
      mc.eqtype,
      mc.reportinterpretation,      
      '~' AS eol  
    FROM &TargetSchema.microcomponents mc
    WHERE 1=1
      AND mc.comptype = '&ComponentType' --'HPLC'
      --AND mc.compid = '&ComponentID'     --'MALDI-TOF'
    ORDER BY
      mc.compid ASC;
*/      
  -----
  
  -----03. Clean Out Target Schema(if desired)-----
    --Optionally, wipe Micro Compnent in target Schema.
/*    
    DELETE 
    FROM &TargetSchema.microcomponents mc
    WHERE 1=1
      AND mc.comptype = '&ComponentType' --'HPLC'
      AND mc.compid = '&ComponentID'     --'MALDI-TOF' 
*/            
  -----
  
  -----04. Update Target schema with values from source schema-----
    --We can now update the target schema with the source schema
    --information
/*    
    MERGE INTO &TargetSchema.microcomponents T1
    USING (
      SELECT DISTINCT
        mc.comptype,
        mc.compid,
        mc.acronym,
        mc.compname,
        mc.origsts,
        mc.hidefromreport,
        mc.eqid,
        mc.eqtype,
        mc.reportinterpretation, 
        '~' AS eol  
      FROM &SourceSchema.microcomponents mc
      WHERE 1=1
        AND mc.comptype = '&ComponentType' --'HPLC'
        AND mc.compid = '&ComponentID'     --'MALDI-TOF'
      ORDER BY
        mc.compid ASC    
    ) T2
    ON ( 1=1
      AND T1.comptype = T2.comptype
      AND T1.compid = T2.compid
       )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.comptype,
        t1.compid,
        t1.acronym,
        t1.compname,
        t1.origsts,
        t1.hidefromreport,
        t1.eqid,
        t1.eqtype,
        t1.reportinterpretation  
      )
      VALUES (
        t2.comptype,
        t2.compid,
        t2.acronym,
        t2.compname,
        t2.origsts,
        t2.hidefromreport,
        t2.eqid,
        t2.eqtype,
        t2.reportinterpretation  
      )  
*/      
  -----
/*---------------------------------------------------------------------------*/




/*-----02. Migrate_PossibleResults-------------------------------------------*/
  --This Script will migrate Existing Micro Componet Possible 
  --Results to the identified environment.  Here, We are assumeing
  --the Micro Component already exists in the target environment.
  --This migrates Possible Results tab enteries in the Micro Components
  --application.

  -----01. Grant Read Access to Source Schema-----
    --Need to grant user account access to read source tables.
--    GRANT SELECT ON microcompresponse TO &TargetSchema;
  -----
  
  -----02. Review target Schema Possible Results-----
/*  
    SELECT DISTINCT
      mcr.comptype,
      mcr.compid,
      mcr.ressorter,  
      mcr.response,
      mcr.status,
      mcr.interpretation,
      mcr.is_negative,
      mcr.origsts,
      mcr.snomedcode,
      mcr.code_system_oid,
      mcr.loincnumber,
      mcr.hidefromreport,
      mcr.localnumber,
      mcr.cdc_reportable,
      mcr.elr_reportable,
      '~' AS eol  
    FROM &TargetSchema.microcompresponse mcr
    WHERE 1=1
      AND mcr.comptype = '&ComponentType' --'Drug'
      AND mcr.compid = '&ComponentID'     --'Imipenem E test'    
    ORDER BY
      mcr.compid ASC,
      mcr.ressorter ASC;
*/      
  -----
  
  -----03. Clean Out Target Schema(if desired)-----
    --Optionally wipe out any existing P.R. in the target Schema
    --for this MicroComponent.
/*    
    DELETE 
    FROM &TargetSchema.microcompresponse mcr
    WHERE 1=1
      AND mcr.comptype = '&ComponentType' --'Drug'
      AND mcr.compid = '&ComponentID'     --'Imipenem E test' 
*/            
  -----
  
  -----04. Update Target schema with values from source schema-----
    --We can now update the target schema with the source schema
    --information
/*    
    MERGE INTO &TargetSchema.microcompresponse T1
    USING (
      SELECT DISTINCT
        mcr.comptype,
        mcr.compid,
        mcr.ressorter,  
        mcr.response,
        mcr.status,
        mcr.interpretation,
        mcr.is_negative,
        mcr.origsts,
        mcr.snomedcode,
        mcr.code_system_oid,
        mcr.loincnumber,
        mcr.hidefromreport,
        mcr.localnumber,
        mcr.cdc_reportable,
        mcr.elr_reportable,
        '~' AS eol  
      FROM &SourceSchema.microcompresponse mcr
      WHERE 1=1
        AND mcr.comptype = '&ComponentType' --'Drug'
        AND mcr.compid = '&ComponentID'     --'Imipenem E test'    
      ORDER BY
        mcr.compid ASC,
        mcr.ressorter ASC    
    ) T2
    ON ( 1=1
      AND T1.comptype = T2.comptype
      AND T1.compid = T2.compid
      AND T1.response = T2.response
       )
    WHEN NOT MATCHED THEN
      INSERT (
        T1.comptype,
        T1.compid,
        T1.ressorter,  
        T1.response,
        T1.status,
        T1.interpretation,
        T1.is_negative,
        T1.origsts,
        T1.snomedcode,
        T1.code_system_oid,
        T1.loincnumber,
        T1.hidefromreport,
        T1.localnumber,
        T1.cdc_reportable,
        T1.elr_reportable    
      )
      VALUES (
        T2.comptype,
        T2.compid,
        T2.ressorter,  
        T2.response,
        T2.status,
        T2.interpretation,
        T2.is_negative,
        T2.origsts,
        T2.snomedcode,
        T2.code_system_oid,
        T2.loincnumber,
        T2.hidefromreport,
        T2.localnumber,
        T2.cdc_reportable,
        T2.elr_reportable    
      )  
*/      
  -----
/*---------------------------------------------------------------------------*/




/*-----03. Migrate_MicroPanels-----------------------------------------------*/

  -----01. Grant Read Access to Source Schema-----
    --Need to grant user account access to read source tables.
/*
    GRANT SELECT ON MicroPanels TO &TargetSchema;
    GRANT SELECT ON MicroPanelComp TO &TargetSchema;    
    GRANT SELECT ON MicroPanelConditions TO &TargetSchema;    
*/    
  -----
  
  -----02. Review target Schema MicroPanels-----  
/*  
    SELECT DISTINCT
      mp.comptype,
      mp.panelid,
      mp.panelname,
      mp.origsts,      
      '~' AS eol  
    FROM &TargetSchema.MicroPanels mp
    WHERE 1=1
      AND mp.comptype = '&ComponentType' --'HPLC'
      --AND mp.panelid = '&PanelID'     --'MALDI-TOF'
    ORDER BY
      mp.panelid ASC;
*/      
  -----
  
  -----03. Clean Out Target Schema(if desired)-----
    --Optionally, wipe Micro Compnent in target Schema.
/*    
    DELETE 
    FROM &TargetSchema.MicroPanels mp
    WHERE 1=1
      AND mp.comptype = '&ComponentType' --'HPLC'
      AND mp.panelid = '&PanelID'     --'MALDI-TOF' 
*/            
  -----
  
  -----04. Create MicroPanel-----
    --We can now update the target schema with the source schema
    --information
/*    
    MERGE INTO &TargetSchema.MicroPanels T1
    USING (
      SELECT DISTINCT
        mp.comptype,
        mp.panelid,
        mp.panelname,
        mp.origsts,      
        '~' AS eol  
      FROM &SourceSchema.MicroPanels mp
      WHERE 1=1
        AND mp.comptype = '&ComponentType' --'HPLC'
        AND mp.panelid = '&PanelID'        --'MALDI-TOF'
      ORDER BY
        mp.panelid ASC    
    ) T2
    ON ( 1=1
      AND T1.comptype = T2.comptype
      AND T1.panelid = T2.panelid
       )
    WHEN NOT MATCHED THEN
      INSERT (
        T1.comptype,
        T1.panelid,
        T1.panelname,
        T1.origsts
      )
      VALUES (
        T2.comptype,
        T2.panelid,
        T2.panelname,
        T2.origsts
      )  
*/      
  -----
  -----05. Populate MicroPanel with MicroComponents-----
    --We can now update the target schema with the source schema
    --information
/*    
    MERGE INTO &TargetSchema.MicroPanelComp T1
    USING (
      SELECT DISTINCT
        mpc.comptype,
        mpc.panelid,
        mpc.compid,
        mpc.sorter,
        mpc.origsts,      
        '~' AS eol  
      FROM &SourceSchema.MicroPanelComp mpc
      WHERE 1=1
        AND mpc.comptype = '&ComponentType' --'HPLC'
        AND mpc.panelid = '&PanelID'        --'MALDI-TOF'
      ORDER BY
        mpc.panelid ASC    
    ) T2
    ON ( 1=1
      AND T1.comptype = T2.comptype
      AND T1.panelid = T2.panelid
      AND T1.compid = T2.compid
       )
    WHEN NOT MATCHED THEN
      INSERT (
        T1.comptype,
        T1.panelid,
        T1.compid,
        T1.sorter,
        T1.origsts
      )
      VALUES (
        T2.comptype,
        T2.panelid,
        T2.compid,
        T2.sorter,
        T2.origsts
      )  
*/      
  -----  
  -----06. Associate MicroPanel with MicroPanelConditions-----
    --We can now update the target schema with the source schema
    --information
/*    
    MERGE INTO &TargetSchema.MicroPanelConditions T1
    USING (
      SELECT DISTINCT
        mpd.comptype,
        mpd.panelid,
        mpd.condition,
        mpd.origsts,      
        '~' AS eol  
      FROM &SourceSchema.MicroPanelConditions mpd
      WHERE 1=1
        AND mpd.comptype = '&ComponentType' --'HPLC'
        AND mpd.panelid = '&PanelID'        --'MALDI-TOF'
      ORDER BY
        mpd.condition ASC,
        mpd.panelid ASC    
    ) T2
    ON ( 1=1
      AND T1.comptype = T2.comptype
      AND T1.panelid = T2.panelid
      AND T1.condition = T2.condition
       )
    WHEN NOT MATCHED THEN
      INSERT (
        T1.comptype,
        T1.panelid,
        T1.condition,
        T1.origsts
      )
      VALUES (
        T2.comptype,
        T2.panelid,
        T2.condition,
        T2.origsts
      )  
*/      
  -----    
/*---------------------------------------------------------------------------*/







/*=====Bone Yard=============================================================*/


  /*----------Identify Test with the indicated Micro Step----------*/
/*  
    SELECT DISTINCT
      t.testno,
      wfs.stepcode,
      wfs.description,
      wfs.stepname,
      wfs.steptype,
      wfs.tmcode,
      '~' AS EOL
    FROM &Environment.testwfsteps wfs
      INNER JOIN &Environment.testwfmethods wfm ON (wfs.tmcode = wfm.tmcode)
      INNER JOIN &Environment.tests t ON (wfm.tmname = t.tmname)
    WHERE 1=1
      AND wfs.stepcode = 'HPLC'
    ORDER BY wfs.stepcode ASC
*/
  /*---------- ----------*/
  
/*===========================================================================*/




/*-----New MicroComponent Migration------------------------------------------*/
  /*---Description---*/
    --Scripts here will migrate a NEW micro component to the targeted databse.  
  /*--- ---*/

  /*---Grants---*/
    --Eanble target Schema to read from Source Schema
/*    
    GRANT SELECT ON microcomponents TO &TargetSchema;
*/    
  /*--- ---*/


/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
