

/*-----Migrate_Materials-----------------------------------------------------*/
  /*-----Description-----*/
    --Utilize scripts here to migrate Possible Results.  This can be done
    --to copy PR:
      --within a test, between analytes.
      --from one test to another test analyte
      --between environments.

      --Assumptions
        --Target Database must have READ access to Source database
        --Targeted Anlyte has been associated with the target test.
  /*----- -----*/
  
  /*-----History-----*/
    --2017.06.06 Created Script file
  /*----- -----*/
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*-----01. Analyte Possible Result Migration---------------------------------*/
  /*-----00.1: Grant READ access to Target Schema-----*/
    --Note, you must be logged onto the Source Database to run these scripts.
    --GRANT SELECT ON possibleresults TO &TargetSchema;
    --GRANT SELECT ON tests TO &TargetSchema;
  /*----- -----*/

  /*-----01.1 Single Analyte Migration: Review Source and Target-----*/
    MERGE INTO &TargetSchema.possibleresults t1
    USING (  
      SELECT DISTINCT
        s_t.testno AS src_testno,
        s_t.testcode AS src_testcode,
        s_pr.analyte AS src_analyte,
        t_t.testno AS tar_testno,        
        t_t.testcode as tar_testcode,
        t_a.analyte AS tar_analyte,
        s_pr.sorter,
        s_pr.result,
        s_pr.conclusion_report,
        s_pr.result_status,
        s_pr.localnumber,
        s_pr.loincnumber,
        s_pr.snomedcode,
        s_pr.snomedconceptid,
        s_pr.code_system_oid,
        s_pr.cdc_reportable,
        s_pr.elr_reportable,
        s_pr.origsts,
        '~' AS eol
      FROM &SourceSchema.possibleresults s_pr
        INNER JOIN &SourceSchema.tests s_t ON (s_pr.testcode = s_t.testcode)
        INNER JOIN &TargetSchema.tests t_t ON (t_t.testno = '&TargetTestName')
        INNER JOIN &TargetSchema.analytes t_a ON (1=1
          AND t_a.testcode = t_t.testcode
          AND t_a.analyte = '&TargetAnalyte')
      WHERE 1=1
        AND s_t.testno = '&SourceTestName'
        AND s_pr.analyte = '&SourceAnalyte'
      ORDER BY
        s_t.testno ASC,
        t_a.analyte ASC,
        s_pr.sorter ASC,
        s_pr.result ASC
    ) t2
    ON ( 1=1
      AND (t1.testcode = t2.tar_testcode)
      AND (t1.analyte = t2.tar_analyte)
      AND (t1.result = t2.result)
    )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.testcode,
        t1.analyte,
        t1.sorter,
        t1.result,
        t1.conclusion_report,
        t1.result_status,
        t1.localnumber,
        t1.loincnumber,
        t1.snomedcode,
        t1.snomedconceptid,
        t1.code_system_oid,
        t1.cdc_reportable,
        t1.elr_reportable,
        t1.origsts
      )
      VALUES (
        t2.tar_testcode,
        t2.tar_analyte,
        t2.sorter,
        t2.result,
        t2.conclusion_report,
        t2.result_status,
        t2.localnumber,
        t2.loincnumber,
        t2.snomedcode,
        t2.snomedconceptid,
        t2.code_system_oid,
        t2.cdc_reportable,
        t2.elr_reportable,
        t2.origsts
      );
        
  /*----- -----*/
  
/*---------------------------------------------------------------------------*/

