/*---------------------------------------------------------------------------*/
/*-----Migrate_Test_Reagents-------------------------------------------------*/
  /*-----Description-----*/
    --Utilize scripts here to migrate Reagents between envrionments (One test at time).
    --the following Tables are updated:
      --TestReagents

      --Assumptions
        --Target Database must have READ access to Source database
        --Materials are already in target environment
      
      
      --Scripts:
        --01. Single Material Migration
        --02. Materials by TestName
  /*----- -----*/
  
  /*-----History-----*/
    --2017.06.17 Created Script file
  /*----- -----*/
/*---------------------------------------------------------------------------*/







  
  
  
  /*-----01. Reagents Migration-----------------------------------------*/
  /*-----00.1: Grant READ access to Target Schema-----*/
    --Note, you must be logged onto the Source Database to run these scripts.
/*    
    GRANT SELECT ON testreagents TO &TargetSchema;
    GRANT SELECT ON tests TO &TargetSchema;
*/    
  /*----- -----*/

  /*-----00.2 Single Material Migration: Review Source and Target-----*/
/*  
    SELECT DISTINCT
      tr.matcode,
      t1.testcode AS src_testcode,
      t2.testcode AS tar_testcode,     
      tr.origsts,
      tr.qty,      
      tr.type,
      tr.units,
      tr.verifypositiveamount,
      '~' AS eol
    FROM &SourceEnvironment.testreagents tr
      INNER JOIN &SourceEnvironment.tests t1 ON (tr.testcode = t1.testcode)
      INNER JOIN &TargetEnvironment.tests t2 ON (1=1
        AND t1.testno = t2.testno)
      INNER JOIN &TargetEnvironment.Materials m ON (tr.matcode = m.matcode)
    WHERE 1=1
      AND t1.testno = '&TestName'
    ORDER BY
      tr.matcode ASC;      
*/       
  /*----- -----*/
  
  -----01.01 Reagents Migration-----
    MERGE INTO &TargetSchema.testreagents t1
    USING (
    SELECT DISTINCT
      tr.matcode,
      t1.testcode AS src_testcode,
      t2.testcode AS tar_testcode,     
      tr.origsts,
      tr.qty,      
      tr.type,
      tr.units,
      tr.verifypositiveamount,
      '~' AS eol
    FROM &SourceSchema.testreagents tr
      INNER JOIN &SourceSchema.tests t1 ON (tr.testcode = t1.testcode)
      INNER JOIN &TargetSchema.tests t2 ON (1=1
        AND t1.testno = t2.testno)
      INNER JOIN &TargetSchema.Materials m ON (tr.matcode = m.matcode)
    WHERE 1=1
      AND t1.testno = '&TestName'
    ORDER BY
      tr.matcode ASC
    ) t2
    ON ( 1=1
      AND (t1.testcode = t2.tar_testcode)
      AND (t1.matcode = t2.matcode)
    )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.matcode,
        t1.origsts,
        t1.qty,
        t1.testcode,
        t1.type,
        t1.units,
        t1.verifypositiveamount
      )
      VALUES (
        t2.matcode,
        t2.origsts,
        t2.qty,
        t2.tar_testcode,
        t2.type,
        t2.units,
        t2.verifypositiveamount
      );
    ----- -----
  
 
  
  
/*---------------------------------------------------------------------------*/

