


/*-----Delete_MicroComponent-----------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Scripts here are for removing the indicated Micro Component from STARLiMS
  /*----- -----*/
  
  /*-----Limitations/Assumptions-----*/
    --
  /*----- -----*/


--NOTE: If you have an existing MicroComponent that just needs to be updated
--      from one environment to another, you can Delete the target environment
--      microcomponent using this script and migrate the MicroComponent from 
--      the source as a new MicroComponent using Migrate_NewMicroComponet script.


  /*-----Scripts-----*/

    --01. Preliminary Tasks
      --01. Target Schema Permissions
      --02. Identify Required Items
      --03. New MicroComponent Verification
    --02. Create Component:
    --03. Possible Results Tab
    --04. Micro Panels tab
    --05. Quality Control tab
    --06. Reagents tab
    --07. LOINC tab
  /*----- -----*/

  /*-----HISTORY-----*/
    --2016.05.13 JTY: Created Srcipt
  /*----- -----*/

/*---------------------------------------------------------------------------*/





/*-----01. Preliminary Tasks-------------------------------------------------*/

    --Verify that MicroCopmonent is in the specified Environment.
/*    
    SELECT DISTINCT
      mc.comptype,
      mc.compid,
      mc.acronym,
      mc.compname,
      mc.origsts,
      mc.hidefromreport,
      mc.eqid,
      mc.eqtype,
      mc.reportinterpretation,      
      '~' AS eol  
    FROM &TargetSchema.microcomponents mc
    WHERE 1=1
      AND mc.comptype = '&ComponentType' --'HPLC'
      AND mc.compid IN (&MC_List)
    ORDER BY
      mc.compid ASC;
*/
  /*----- -----*/  

/*---------------------------------------------------------------------------*/


-------02. Equipment tab--------------------------------------------------------
  --Remove any associations of equipment with MicroComponent
    DELETE 
    FROM  &TargetSchema.microcompequipments T1
    WHERE 1=1
      AND UPPER(T1.comptype) = UPPER('&ComponentType')
      AND UPPER(T1.compid) = UPPER('&ComponentID');
-------------------------------------------------------------------------------



-------03. LOINC tab-----------------------------------------------------------
  --Remove any associations of LOINC values with MicroComponent
    DELETE 
    FROM  &TargetSchema.microcomploinc T1
    WHERE 1=1
      AND UPPER(T1.comptype) = UPPER('&ComponentType')
      AND UPPER(T1.compid) = UPPER('&ComponentID');
-------------------------------------------------------------------------------



-------04. Reagents tab--------------------------------------------------------
   --Remove any associations of Reagents with MicroComponent
    DELETE 
    FROM  &TargetSchema.microcompreagents T1
    WHERE 1=1
      AND UPPER(T1.comptype) = UPPER('&ComponentType')
      AND UPPER(T1.compid) = UPPER('&ComponentID');
-------------------------------------------------------------------------------



------05. Quality Control tab--------------------------------------------------
   --Delete any Quality Control associated with MicroComponent  
    DELETE 
    FROM  &TargetSchema.microqccontrols T1
    WHERE 1=1
      AND UPPER(T1.comptype) = UPPER('&ComponentType')
      AND UPPER(T1.compid) = UPPER('&ComponentID');
-------------------------------------------------------------------------------



-------04. Micro Panels tab----------------------------------------------------

   -------01. Remove MicroComponent from MicroPanels-------
    DELETE
    FROM  &TargetSchema.micropanelcomp T1
    WHERE 1=1
      AND UPPER(T1.comptype) = UPPER('&ComponentType')
      AND UPPER(T1.compid) = UPPER('&ComponentID');
  ------- -------
  -------02. Break Micro Panel Conditions links-------
    --Remove any MicroPanels from Conditions if the MicroPanel has no MicroComponents
    DELETE 
    FROM  &TargetSchema.micropanelconditions T1
    WHERE 1=1
      AND T1.panelid IN (
        SELECT DISTINCT 
          mpd.panelid
        FROM &TargetSchema.micropanelconditions mpd        
          INNER JOIN &TargetSchema.micropanels mp ON (mpd.panelid = mp.panelid)
          LEFT OUTER JOIN &TargetSchema.micropanelcomp mpc ON (mp.panelid = mpc.panelid)
        WHERE 1=1
          AND mpc.compid IS NULL
          AND UPPER(mpd.comptype) = UPPER('&ComponentType')
      );
  ------- -------
  -------03. Delete Orphan Conditions-------
    --Delete any Conditions that no longer have any Panels associated with them.
    DELETE 
    FROM  &TargetSchema.microconditions T1
    WHERE 1=1
      AND T1.condition IN (
        SELECT DISTINCT 
          mc.condition          
        FROM &TargetSchema.microconditions mc
          LEFT OUTER JOIN sunrise_data.micropanelconditions mpd ON (mc.condition = mpd.condition)
        WHERE 1=1
          AND mpd.condition IS NULL
          AND mc.condition <> 'Condition'
      );
  ------- ------- 
  -------04. Delete MicroPanels that no longer have any MicroComponents-------
    DELETE
    FROM  &TargetSchema.micropanels T1
    WHERE 1=1
      AND T1.panelid IN (
        SELECT DISTINCT
          mp.panelid
        FROM &TargetSchema.micropanels mp
        LEFT OUTER JOIN &TargetSchema.micropanelcomp mcc ON (1=1
          AND mcc.comptype = mp.comptype
          AND mcc.panelid = mp.panelid)    
        WHERE 1=1
          AND UPPER(mp.comptype) = UPPER('&ComponentType')
          AND mcc.panelid IS NULL     
      )
      AND UPPER(T1.comptype) = UPPER('&ComponentType');
  ------- -------
-------------------------------------------------------------------------------


-------05. Possible Results Tab------------------------------------------------
  --Delete Possible Results from Micro Component
    DELETE 
    FROM  &TargetSchema.microcompresponse T1
    WHERE 1=1
      AND UPPER(T1.comptype) = UPPER('&ComponentType')
      AND UPPER(T1.compid) = UPPER('&ComponentID');
-------------------------------------------------------------------------------


-------06. Delete Component----------------------------------------------------
  --Final Removal of MicroComponent
    DELETE 
    FROM  &TargetSchema.microcomponents T1
    WHERE 1=1
      AND UPPER(T1.comptype) = UPPER('&ComponentType')
      AND UPPER(T1.compid) = UPPER('&ComponentID');
-------------------------------------------------------------------------------
















-------xx. Next Item tab-------------------------------------------------------
  ------- -------
  ------- -------
-------------------------------------------------------------------------------

