
----- Reiview Material Types-----

SELECT DISTINCT
  mt.mattype
FROM mattypes mt
ORDER BY mt.mattype ASC;
----- -----

-----Identify Material Types with no Matarials-----
  SELECT DISTINCT
    mt.mattype,
    '~' AS eol
  FROM mattypes mt
    LEFT OUTER JOIN materials m ON (mt.mattype = m.mattype)
  WHERE 1=1
    AND m.mattype IS NULL
  ORDER BY 
    mt.mattype ASC;
----- -----


  SELECT DISTINCT
    m.matcode,
    m.matname,
    m.mattype,
    '~' AS eol
  FROM materials m
  WHERE 1=1
    AND m.mattype IN (
      'BT Materials',
      'Chemical',
      'Buffer',
      'Standard',
      'PCR',
      'Sugar',
      'Environmental',
      'Tested Here',
      'Dehyd.Media',
      'Slide',
      'Cell Culture',
      'Water',
      'PCR Test',
      'Test Plan',
      'Control'
)




-----QC Sample Check-----
  SELECT DISTINCT
    m.matcode,
    m.matname,
    m.mattype,
    '~' AS eol
  FROM materials m
  WHERE 1=1
    AND m.mattype IN ('QC Sample', 'Kit')
----- -----


-----01. Kit Component-----
  UPDATE materials m
  SET m.mattype = 'Kit Component'
  WHERE 1=1
    AND m.matcode IN (
      'CRE 16S primers/probe mix',
      'IMP primers/probe mix',
      'KPC/NDM-1 primers/probe mix',
      'OXA-48 primers/probe mix',
      'VIM primers/probe mix',
      'mcr-1/mcr2 primers/probe mix',
      'BordetellaPrimer/Probe-IS481',
      'BordetellaPrimer/Probe-RP',
      'BordetellaPrimer/Probe-hIS1001',
      'BordetellaPrimer/Probe-pIS1001',
      'BordetellaPrimer/Probe-ptxS1',
      'H. influenzae PCR Primer HIA',
      'H. influenzae PCR Primer HIB',
      'H. influenzae PCR Primer HIC',
      'H. influenzae PCR Primer HID',
      'H. influenzae PCR Primer HIE',
      'H. influenzae PCR Primer HIF',
      'H. influenzae PCR Primer bexA',
      'Human Genomic DNA',
      'LRN 16S',
      'LRN BA Primer/Probes',
      'LRN BRU Primers/Probe',
      'LRN COX Primers/Probe',
      'LRN FT Primers/Probe',
      'LRN MERS-CoV Primer/Probes',
      'LRN MP Primers/Probe',
      'LRN OPX Primers/Probe',
      'LRN RG Primers/Probe',
      'LRN RP Primers/Probe',
      'LRN VAC Primers/Probe',
      'LRN VHSV Primers/Probe',
      'LRN VZV Primers/Probe',
      'LRN YPMT Primers/Probe',
      'MERS-CoV VTC',
      'Norovirus GI Primer/Probe',
      'Norovirus GII Primer/Probe',
      'SLE Primer/Probe',
      'TaqmanGeneExpMasterMix',
      'WNV Primer/Probe',
      'FERN-MIC Shigella qPCR (IC)',
      'FERN-MIC Shigella qPCR (ipaH)',
      'MLG 5B.03 (O103)',
      'MLG 5B.03 (O111)',
      'MLG 5B.03 (O121)',
      'MLG 5B.03 (O145)',
      'MLG 5B.03 (O26)',
      'MLG 5B.03 (O45)',
      'MLG 5B.03 (eae)',
      'MLG 5B.03 (stx)',
      'Shiga Toxin PCR primer (eaeA)',
      'Shiga Toxin PCR primer (hlyA)',
      'Shiga Toxin PCR primer (stx1)',
      'Shiga Toxin PCR primer (stx2)',
      'Trioplex rRT-PCR Pri/Pro Kit',
      'Zika primer/probe set 1',
      'Zika primer/probe set 2',
      'RT PCR Melt Curve Primer Pool',
      'Chikungunya PCR primer/probe 1',
      'Chikungunya PCR primer/probe 2',
      'N1-223 Primers',
      'N1-275 Primers',
      'N2-119-292-294 Primers',
      'RNaseP Primer/Probe',
      'Measles Primers/Probes',
      'Mumps PCR primer/probe'
  );
----- -----

--*******************************

-----02. QC-----
  UPDATE materials m
  SET m.mattype = 'QC Sample'
  WHERE 1=1
    AND m.matcode IN (
      'BTSure',
      '16S Pos E. coli ATCC 35150',
      'IMP positive control',
      'KPC/NDM-1 positive controls',
      'Norovirus GI Positive Control',
      'OXA-48 positive control',
      'RNaseP Control',
      'VIM positive control',
      'mcr-1/mcr2 positive control',
      '16S Pos E. coli ATCC 25922',
      'BordetellaPosCtrl(PBPC)',
      'DNA-A PCR Positive Control',
      'DNA-B PCR Positive Control',
      'Zika Negative Control  NHS',
      'Zika Positive Control  RNA',
      'Chikungunya PCR Negative Ctrl',
      'Chikungunya PCR Positive Ctrl',
      'Influenza A(H1N1)pdm09 PosCtrl',
      'Influenza A(H3N2) PosCtrl',
      'Measles PCR Positive Control',
      'Mumps PCR Positive Control',
      'Norovirus GII Positive Control',
      'Norovirus Negative Control',
      'SLE PCR Positive Control',
      'WNV PCR Positive Control',
      'DNA Ladder, 100bp',
      'ImmunoCard Crypro/Giardia Ctl',
      'SSA LQC Set 1',
      'SSA LQC Set 2',
      'SSA LQC Set 3',
      'SSA LQC Set 4',
      'SSA LQC Set 5',
      'SSA LQC Set 6',
      'CHIKV IgM Positive Control',
      'Calibrator Control',
      'Geenius HIV Controls',
      'Hanta IgG Pos',
      'Hanta IgM Pos',
      'Negative Control',
      'Negative Human Serum',
      'Non Kit Negative Control',
      'PRNT CHIK POS Ab.',
      'PRNT DEN 1 POS Ab.',
      'PRNT ZIKA POS Ab.',
      'SLE IgM Positive Control',
      'Trioplex rRT-PCR Control Set',
      'WNV IgM Positive Control',
      'Zika IgM Positive Control',
      'GeneXpert MTB/RIF Controls',
      'Processing Neg Ctrl',
      'Processing Pos Ctrl',
      'CMV IFA Pos',
      'Flu A Subtyping IFA POS',
      'Flu A/B IFA POS',
      'HSV DFA Positive',
      'HuMPV DFA POS',
      'PRNT DEN 2 POS Ab.',
      'PRNT DEN 3 POS Ab.',
      'PRNT DEN 4 POS Ab.',
      'PRNT SLE POS Ab.',
      'PRNT WNV POS Ab.',
      'Para 1-3 DFA POS',
      'RSV DFA Pos.',
      'Rabies Neg.',
      'Rabies Pos.',
      'Respiratory Panel 2 POS',
      'VZ DFA Pos.',
      'Adenovirus IFA Positive',
      'Enterovirus IFA Positive',
      'McFarland 0.5',
      'McFarland 1.0',
      'McFarland 2.0',
      'Measles IFA Positive',
      'Mumps IFA Positive',
      'Para-4 POS',
      'Std_408',
      'Bruker BTS-TB',
      'MGIT 960 Calibration Tube',
      'MIDI Calibration Standard',
      'MIDI Internal Standard',
      'McFarland Standard',
      'API 20 E'
 );
----- ----- 


-----03. Reagent-----
  UPDATE materials m
  SET m.mattype = 'Reagent'
  WHERE 1=1
    AND m.matcode IN (
      'Acetate Agar',
      'Andrades Adonitol',
      'Andrades Arabinose',
      'Andrades Base Control',
      'Andrades Cellobiose',
      'Andrades Dulcitol',
      'Andrades Glucose',
      'Andrades Inositol',
      'Andrades Lactose',
      'Andrades Maltose',
      'Andrades Mannitol',
      'Andrades Melibiose',
      'Andrades Raffinose',
      'Andrades Rhamnose',
      'Andrades Salicin',
      'Andrades Sorbitol',
      'Andrades Sucrose',
      'Andrades Trehalose',
      'Andrades Xylose',
      'Bile Esculin Agar',
      'Catalase',
      'Coagulase',
      'Ehrlichs Indole',
      'Esculin Agar',
      'HNID Panel',
      'Hippurate Broth',
--    'Indole-Kovak's',
      'Lead Acetate Strip',
      'Litmus Milk',
      'MIO',
      'MR-VP broth',
      'Malonate',
      'MoellerArginineDecarboxylase',
      'MoellerDecarboxylaseBase',
      'MoellerDecarboxylaseLysine',
      'MoellerOrnithineDecarboxylase',
      'Motility Test Medium',
      'Mucate',
      'Mug Disks',
      'NaCl 6.5% Broth',
      'NaCl Nutrient Broth, 0%',
      'NaCl Nutrient Broth, 1%',
      'NaCl Nutrient Broth, 10%',
      'NaCl Nutrient Broth, 6%',
      'NaCl Nutrient Broth, 8%',
      'Naladixic Acid',
      'Nitrate Broth',
      'Novobiocin',
      'Nutrient Gelatin',
      'OF Glucose',
      'OF Lactose',
      'OF Maltose',
      'OF Mannitol',
      'OF Sucrose',
      'OF Xylose',
      'ONPG',
      'Oxidase',
      'Sucrose Polysaccharide agar',
      'TSI',
      'Urea',
      'V Factor',
      'Vitek GP Cards',
      'X and V Factor',
      'Vitek GN cards',
      'API Saline',
      'James Reagent (IND)',
      'Lactose gelatin',
      'NIT1 (Sulfanilic Acid)',
      'NIT2',
      'OF Base',
      'TDA (Ferric Chloride 10%)',
      'Tecra C.perf enterotoxin',
      'VP1 (Potassium Hydroxide 40%)',
      'VP2 (Alpha-naphthol 6%)',
      'Zinc',
      '6.5% NaCl Broth with Indicator',
      'Andrades Dextrose',
      'Andrades Mannose',
      'Bacitracin',
      'Bile Esculin',
      'Catalase Test',
      'Citrate Agar (Simmons)',
      'D-Galacturonate',
      'D-Galacturonate Base',
      'DMACA Indole (spot Indole)',
      'Gram Sure',
      'Indoxyl Acetate Disk',
      'Lysine Decarboxylase',
      'Methyl Red',
      'OXIDASE',
      'Optochin',
      'Ornithine Decarboxylase',
      'Tartrate',
      'Tryptone Broth',
      'V Factors',
      'X Factor',
      'Cell Lysis Buffer',
      'Cell Suspension Buffer',
      'Tris EDTA Buffer',
      'Buffer 4',
      'CutSmart',
      'BBuffBlank150',
      'BPW',
      'BPWBlank150',
      'ButterfieldsBuffer',
      'PBS',
      'Hep C Wash Buffer',
      'M-15 Phosphate Buffer',
      'M-15 Phosphate Buffer 2 - 3 mL',
      'Tris-HCL',
      'Sterile Saline (TB)',
      'Human Foreskin',
      'MDCK',
      'RhMK',
      'Vero',
      'HF',
      'Hep2',
      'MRC-5',
      'SV-MRC',
      'Hi-Di Formamide',
      '3% Acid Alcohol',
      '4% Sterile NaOH',
      'AcetonitrileLC-MS Chromasolv',
      'Ethanol 200 Proof',
      'Formic Acid-MS',
      'Sodium Hydroxide, 1N',
      'Sodium Hypochlorite',
      'Standard Solvent MS',
      'Trifluoroacetic Acid',
      'Tween 20',
      'Water ChromasolvMS',
      'HPLC Isopropyl Alcohol',
      'HPLC Methanol',
      'Sodium Sulfite',
      'Sterile DI H2O',
      '16S Bacteriology',
      'Agarose',
      'Loading Dye',
      'Tris-Acetate EDTA (TAE) Buffer',
      'Ethidium Bromide',
      'Molecular Bio Grade (PCR) H2O',
      'Mosquito Grinding Diluent',
      'MG Ethanol',
      'Rnase Inhibitor',
      'Sterile DI H2O- 4.5 mL'
 );
----- ----- 


-----04. Stains-----
  UPDATE materials m
  SET m.mattype = 'Stains'
  WHERE 1=1
    AND m.matcode IN (
      'Gram stain slide'        
  );
----- ----- 


-----05. Testing Kit-----
  UPDATE materials m
  SET m.mattype = 'Testing Kit'
  WHERE 1=1
    AND m.matcode IN (
      'PYR',
      'DNA Extraction',
      'MagNAPureLCReagentKit',
      'Bio-Plex Calibration Kit',
      'Bio-Plex Validation Kit',
      'Salmonella Serotyping Kit',
      'GeneXpert MTB/RIF Kit',
      'INTROL TB Panel M114',
      'Respiratory Panel 2',
      'CDC Influenza A Subt Diag Kit',
      'CDC Influenza A/B typ Diag Kit',
      'CDC Influenza H5 Sub Type Kit',
      'CDC Influenza H7 Sub Type Kit',
      'QuantiTect Probe RT-PCR Kit',
      'CDC DENV 1-4 PCR Kit',
      'CDC A/H5 subtyping kit',
      'CDC A/H7 subtyping kit',
      'CDC Flu B Lineage Kit'
  );
----- ----- 


-----06. QC-----
  UPDATE materials m
  SET m.mattype = 'QC'
  WHERE 1=1
    AND m.mattype = 'QC Sample';
----- ----- 

--'QC Sample' to be replaced with 'QC'
--'Kit' to go away
