/*-----------------------------------------------------------------*/
/*-----Activity Type Related Change Queries------------------------*/
  -----DESCRIPTION-----
    --Created query set to update Activity Type associated with a sample.
  -----

  
  -----HISTORY-----
    --2015.06.29 JTY: Created Script
  -----

/*-----------------------------------------------------------------*/


/*-----Reference Tables--------------------------------------------*/
/*
  SELECT DISTINCT cr.* FROM sundata_prod.centralreceiving cr;  
  SELECT DISTINCT pvs.* FROM sundata_prod.phvs_value_sets pvs;
  SELECT DISTINCT pvsd.* FROM sundata_prod.phvs_value_sets_details pvsd;
  SELECT DISTINCT pvsd.* FROM sundata_prod.phvs_value_sets_details pvsd WHERE pvsd.value_set_code = 'PHVS_FoodActivityType';
  SELECT DISTINCT pvsd.* FROM sundata_prod.phvs_value_sets_details pvsd WHERE pvsd.value_set_code = 'PHVS_ActivityType';  
*/
/*-----------------------------------------------------------------*/


/*-----01. Activity Type Review------------------------------------*/
  --Review Acivity Type Associated with sample(s).
  SELECT DISTINCT
    cr.external_id,
    mr.field_varchar_80,
    cr.origrec AS cr_origrec,
    mr.origrec AS mr_origrec,
    pvsd.concept_name,
    '~' AS eol
  FROM  sundata_prod.centralreceiving cr
    INNER JOIN sundata_prod.metadata_repository mr ON (1=1
      AND mr.tablereference = 'CENTRALRECEIVING'
      AND mr.original_origrec = cr.origrec)
    INNER JOIN sundata_prod.phvs_value_sets_details pvsd ON (1=1
      AND pvsd.value_set_code = 'PHVS_FoodActivityType'  --PHVS_ActivityType, PHVS_FoodActivityType
      AND pvsd.concept_code = mr.field_varchar_80)
  WHERE 1=1
    AND cr.external_id IN (
          'AZ00032175', 'AZ00032176', 'AZ00032177',
          'AZ00032178', 'AZ00032179', 'AZ00032180',
          'AZ00032181', 'AZ00032182', 'AZ00032183',
          'AZ00032184', 'AZ00032185', 'AZ00032186',
          'AZ00032187', 'AZ00032188', 'AZ00032189',
          'AZ00032190', 'AZ00032191', 'AZ00032192',
          'AZ00032193', 'AZ00032194', 'AZ00032195',
          'AZ00032196', 'AZ00032197', 'AZ00032198',
          'AZ00032199', 'AZ00032200', 'AZ00032201',
          'AZ00032202', 'AZ00032203', 'AZ00032204'
    );
/*-----------------------------------------------------------------*/




/*-----02. Update Script-------------------------------------------*/
  --Update Activity Type to indicated value
/*
  MERGE INTO sundata_prod.metadata_repository t1
  USING (
      SELECT DISTINCT
        cr.external_id,
        mr.field_varchar_80,
        cr.origrec AS cr_origrec,
        mr.origrec AS mr_origrec,
        pvsd.concept_name,
        '~' AS eol
      FROM  sundata_prod.centralreceiving cr
        INNER JOIN sundata_prod.metadata_repository mr ON (1=1
          AND mr.tablereference = 'CENTRALRECEIVING'
          AND mr.original_origrec = cr.origrec)
        INNER JOIN sundata_prod.phvs_value_sets_details pvsd ON (1=1
          AND pvsd.value_set_code = 'PHVS_FoodActivityType'  --PHVS_ActivityType, PHVS_FoodActivityType
          AND pvsd.concept_code = mr.field_varchar_80)
      WHERE 1=1
        AND cr.external_id IN (
          'AZ00032175', 'AZ00032176', 'AZ00032177',
          'AZ00032178', 'AZ00032179', 'AZ00032180',
          'AZ00032181', 'AZ00032182', 'AZ00032183',
          'AZ00032184', 'AZ00032185', 'AZ00032186',
          'AZ00032187', 'AZ00032188', 'AZ00032189',
          'AZ00032190', 'AZ00032191', 'AZ00032192',
          'AZ00032193', 'AZ00032194', 'AZ00032195',
          'AZ00032196', 'AZ00032197', 'AZ00032198',
          'AZ00032199', 'AZ00032200', 'AZ00032201',
          'AZ00032202', 'AZ00032203', 'AZ00032204'
        )
        ) t2
  ON (t1.origrec = t2.mr_origrec)
  WHEN MATCHED THEN
    UPDATE SET t1.field_varchar_80 = 'NPT'
*/  
/*-----------------------------------------------------------------*/
