
/*-----------------------------------------------------------------*/
/*-----AddLabToSendout---------------------------------------------*/
  /*-----Description-----*/
    ---Use the script provided below to add a new Sendout lab to the
    ---list of labs identified in the Possible Results for each of the
    --Active Sendout test in STARLIMS.
  /*----- -----*/  

  
  
  /*-----History-----*/
    --2014.09.09 JTY: Created Script
  /*----- -----*/  
  
  
/*-----------------------------------------------------------------*/

      




/*-----------------------------------------------------------------*/

  /*-----1. List all Sendout tests -----*/  
    SELECT DISTINCT
      ctt.dept,
      t.testcode,
      t.testno, 
      tgn.status,
      '~' AS eol
    FROM &Environment.testgroupnames tgn  
      INNER JOIN &Environment.conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
      INNER JOIN &Environment.tests t ON (ctt.testcode = t.testcode)
    WHERE 1=1
      AND UPPER(t.testno) LIKE '%SEND%'
      AND tgn.status = 'Active'
    ORDER BY 
      ctt.dept ASC,
      t.testno ASC;  
  /*----- -----*/ 

  /*-----2. Review Sendout Results for lab of interest -----*/  
    SELECT DISTINCT
      ctt.dept,
      t.testcode,
      t.testno, 
      a.analyte, 
      pr.result,    
      tgn.status,
      '~' AS eol
    FROM &Environment.testgroupnames tgn  
      INNER JOIN &Environment.conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
      INNER JOIN &Environment.tests t ON (ctt.testcode = t.testcode)
      INNER JOIN &Environment.analytes a ON (t.testcode = a.testcode)
      INNER JOIN &Environment.possibleresults pr ON (1=1
        AND t.testcode = pr.testcode
        AND a.analyte = pr.analyte)
    WHERE 1=1
      AND UPPER(t.testno) LIKE '%SEND%'
      AND UPPER(pr.result) LIKE UPPER('Testing performed at %&LabName%.  See attached report.')
      AND tgn.status = 'Active'
    ORDER BY 
      ctt.dept ASC,
      t.testno ASC,
      a.analyte ASC,
      pr.result ASC;        
  /*----- -----*/  



  /*-----3. Perform Update to all Sendout test-----*/  
/*  
    MERGE INTO &Environment.possibleresults t1
    USING (
        SELECT DISTINCT
          ctt.dept,
          t.testno,  
          t.testcode,
          a.analyte,
          ('Testing performed at &LabName.  See attached report.') AS result,          
          tgn.status,
          '~' AS eol
        FROM &Environment.testgroupnames tgn  
          INNER JOIN &Environment.conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
          INNER JOIN &Environment.tests t ON (ctt.testcode = t.testcode)
          INNER JOIN &Environment.analytes a ON (t.testcode = a.testcode)
          INNER JOIN &Environment.possibleresults pr ON ( 1=1
            AND t.testcode = pr.testcode
            AND a.analyte = pr.analyte)
        WHERE 1=1
          AND UPPER(t.testno) LIKE '%SEND%'
          AND tgn.status = 'Active'
        ORDER BY 
          ctt.dept ASC,
          t.testno ASC,
          a.analyte ASC
        ) t2
    ON (1=1
        AND t1.testcode = t2.testcode
        AND UPPER(t1.result) = UPPER(t2.result)
       )
    WHEN NOT MATCHED THEN
      INSERT (
          testcode,
          analyte,
          result,
          result_status,
          origsts
      )
      VALUES (
          t2.testcode,
          t2.analyte,
          t2.result,
          t2.status,
          'N'
      )  
*/      
  /*----- -----*/  
/*-----------------------------------------------------------------*/









/*-----Miscellanous Scripts----------------------------------------*/

  /*-----1. Review Unique Sendout Results-----*/  
    SELECT DISTINCT
      pr.result,    
      '~' AS eol
    FROM &Environment.testgroupnames tgn  
      INNER JOIN &Environment.conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
      INNER JOIN &Environment.tests t ON (ctt.testcode = t.testcode)
      INNER JOIN &Environment.analytes a ON (t.testcode = a.testcode)
      INNER JOIN &Environment.possibleresults pr ON (1=1
        AND t.testcode = pr.testcode
        AND a.analyte = pr.analyte)
    WHERE 1=1
      AND UPPER(t.testno) LIKE '%SEND%'
      AND tgn.status = 'Active'
    ORDER BY 
      pr.result ASC;  
  /*----- -----*/  

  /*-----2. Updates-----*/  
/*  
    --Modify this to to make any modifications if changes need corrections.
    UPDATE &Environment.possibleresults pr
    SET 
      pr.result = 'Testing performed at California Department of Public Health.  See attached report.'
    WHERE 1=1
      AND pr.result = 'Testing performed at California Department of Public Health See attached report.'
*/      
  /*----- -----*/  
  

  /*-----3. Deletes-----*/  
/*  
    --Modify this to to delete any unwanted results.
    DELETE
    FROM &Environment.possibleresults pr
    WHERE 1=1
      AND pr.result = 'Testing performed at CDC. See attached report'

*/      
  /*----- -----*/  

  

  
/*-----------------------------------------------------------------*/

--See Attached Report
--Specimen was forwarded to CDC for further testing.  No additional reports will be generated.
--Specimen was forwarded to CDPH.  No additional reports will be generated.
--Specimen was tested at the CADPH. See attached results.
--Testing performed at CDC. See attached report
--Testing performed at CDPH.  See attached report.
--Testing performed at CDPH. See attached report.
--
--
--
/*
    DELETE
    FROM &Environment.possibleresults pr
    WHERE 1=1
      AND pr.result IN (
        'See Attached Report',
        'Specimen was forwarded to CDC for further testing.  No additional reports will be generated.',
        'Specimen was forwarded to CDPH.  No additional reports will be generated.',
        'Specimen was tested at the CADPH. See attached results.',
        'Testing performed at CDC. See attached report',
        'Testing performed at CDPH.  See attached report.',
        'Testing performed at CDPH. See attached report.'
      )
*/      
