
/*-----CannedComment_Updates---------------------------------------*/
/*-----------------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Utilize this set of SQL statements to modify/add CannedComments
    --The following scripts have been developed:
    --01. Panel_Manual_Add - Creates Panel level CC that is added
    --    manually by analysts
  /*----- -----*/


  /*-----KEY TABLES-----*/
    --SELECT DISTINCT cc.* FROM sundata_prod.canned_comments cc;
  /*----- -----*/

  /*-----HISTORY-----*/
    --2015.07.23 JTY: Created Script
  /*----- -----*/


/*-----------------------------------------------------------------*/


/*-----01. Panel_Manual_Add----------------------------------------*/
  /*-----Description-----*/
    --Here we present an SQL that will create a CC for identified 
    --panels.  The CC will be a manual added CC by the analysts.
  /*----- -----*/

  /*-----Review Active Panels-----*/
/*  
    SELECT DISTINCT 
      tgn.testgroupname,
      '~' AS eol
    FROM &Environment.testgroupnames tgn
    WHERE 1=1
      AND tgn.status = 'Active'
    ORDER BY tgn.testgroupname ASC;
*/    
  /*----- -----*/




  
  /*----- -----*/
/*
    MERGE INTO &Environment.canned_comments T1
    USING (
      SELECT DISTINCT
        '&Panel' AS testgroupname,
        '&NewCC' AS canned_comment,
        'Released' AS status,
        '~' AS eol
      FROM DUAL
    ) T2
    ON (1=1
        AND T1.testgroupname = T2.testgroupname
        AND T1.canned_comment = T2.canned_comment
        )
    WHEN NOT MATCHED THEN
      INSERT (
          testgroupname,
          status,
          attachment_scope,
          printonreport,
          start_date,
          expiration_date,
          canned_comment,
          origsts,
          sorter,
          runflag
          )
      VALUES (
        '&Panel',
        'Released',
        'External',
        'Y',
        TRUNC(sysdate),
        TRUNC(ADD_MONTHS(sysdate,1200)),
        TRIM('&NewCC'),
        'N',
        '0',
        '0'
      );
*/
  /*----- -----*/
--METADATA_EVENT_LOG
  /*-----Review CC-----*/
  

    SELECT DISTINCT
      CASE
        WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
        WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
        WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'                          
      END AS env,
      CASE
        WHEN (cc.analyte IS NOT NULL) THEN '04_Result'
        WHEN (cc.testcode IS NOT NULL) THEN '03_Test'
        WHEN (cc.testgroupname IS NOT NULL) THEN '02_Panel'
        ELSE '01_Folder'
      END AS CC_Level,
      cc.testgroupname,
      cc.status,
      cc.attachment_scope,
      cc.printonreport,
      cc.start_date,
      cc.expiration_date,
      cc.canned_comment,
      cc.origrec,
      '~' AS eol
    FROM &Environment.canned_comments cc
    WHERE 1=1
      AND UPPER(cc.canned_comment) LIKE UPPER('%&NewCC%')
    ORDER BY
      cc.testgroupname ASC,
      cc.canned_comment ASC;
      

  /*----- -----*/



/*-----------------------------------------------------------------*/
--delete from sundata_prod.canned_comments cc where cc.origrec IN ('1831146','1831147')
