


/*-----EquipmentAddition-----------------------------------------------------*/
  -----DESCRIPTION-----
    --This set of SQL statements can be used to help add new equipment that
    --we want to match existing equipment.
  ----- -----
  

  -----HISTORY-----
    --2018.07.24 JTY: Created Script
  ----- -----


/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/




  -----Step 01: Create new eqipment-----
    --In Equipment Manager, Create new equpiment with the appropriate equipment type
  ----- -----




  
  -----Setp 02: Add test to new equipment based on Source Equipment-----
    --Review Test assoicated with equipment--
      SELECT DISTINCT
        et.eqid,
        t.testno,
        et.*
      FROM equip_tests et
        INNER JOIN tests t ON (et.testcode = t.testcode)
      WHERE 1=1
        AND et.eqid IN ('&SourceEquipmentID', '&NewEquipmentID')
      ORDER BY
        t.testno ASC,
        et.eqid ASC
    -- --
    
    --Add test to new equipment based on Source Equipment--
      MERGE INTO equip_tests t1
      USING (
        SELECT DISTINCT
          '&NewEquipmentID' AS eqid,
          t.testno,
          et.calexpdate,
          et.calfrequency,
          et.folderno,
          et.matcode,
          et.origsts,
          et.override_flag,
          et.plategrpcode,
          et.testcode,
          et.empw_use_signoff,
          et.method,
          et.testinstrname,
          '~' AS eol
        FROM equip_tests et
          INNER JOIN tests t ON (et.testcode = t.testcode)
        WHERE 1=1
          AND et.eqid IN ('&SourceEquipmentID', '&NewEquipmentID')
        ORDER BY
          t.testno ASC
      ) t2
      ON (t1.eqid = t2.eqid AND t1.testcode = t2.testcode)
      WHEN NOT MATCHED THEN
        INSERT(
          t1.eqid,
          t1.calexpdate,
          t1.calfrequency,
          t1.folderno,
          t1.matcode,
          t1.origsts,
          t1.override_flag,
          t1.plategrpcode,
          t1.testcode,
          t1.empw_use_signoff,
          t1.method,
          t1.testinstrname
        )
        VALUES(
          t2.eqid,
          t2.calexpdate,
          t2.calfrequency,
          t2.folderno,
          t2.matcode,
          t2.origsts,
          t2.override_flag,
          t2.plategrpcode,
          t2.testcode,
          t2.empw_use_signoff,
          t2.method,
          t2.testinstrname
        )
    -- --
  ----- -----




  -----Setp 03: Add QC & Standards based on existing Equipment-----
    --Review Test assoicated with equipment--
      SELECT DISTINCT
        es.eqid,
        t.testno,
        es.*
      FROM equip_standards es
        INNER JOIN tests t ON (es.testcode = t.testcode)
      WHERE 1=1
        AND es.eqid IN ('&SourceEquipmentID', '&NewEquipmentID')
      ORDER BY
        t.testno ASC,
        es.eqid ASC
    -- --
    
    --Add test to new equipment based on Source Equipment--
      MERGE INTO equip_standards t1
      USING (
        SELECT DISTINCT
          '&NewEquipmentID' AS eqid,
          t.testno,
          es.testcode,
          es.cupno,
          es.instspecificqctype,
          es.inventoryid,
          es.multiplier,
          es.origsts,
          es.postype,
          es.qctype,
          es.status,
          es.stdamnt,
          es.method,
          es.forceinvid,
          es.batchid,
          es.qcinstrname,
          es.instrspecificdata,
          '~' AS eol
        FROM equip_standards es
          INNER JOIN tests t ON (es.testcode = t.testcode)
        WHERE 1=1
          AND es.eqid IN ('&SourceEquipmentID', '&NewEquipmentID')
        ORDER BY
          t.testno ASC
      ) t2
      ON (t1.eqid = t2.eqid AND t1.testcode = t2.testcode)
      WHEN NOT MATCHED THEN
        INSERT(
          t1.eqid,
          t1.testcode,
          t1.cupno,
          t1.instspecificqctype,
          t1.inventoryid,
          t1.multiplier,
          t1.origsts,
          t1.postype,
          t1.qctype,
          t1.status,
          t1.stdamnt,
          t1.method,
          t1.forceinvid,
          t1.batchid,
          t1.qcinstrname,
          t1.instrspecificdata
        )
        VALUES(
          t2.eqid,
          t2.testcode,
          t2.cupno,
          t2.instspecificqctype,
          t2.inventoryid,
          t2.multiplier,
          t2.origsts,
          t2.postype,
          t2.qctype,
          t2.status,
          t2.stdamnt,
          t2.method,
          t2.forceinvid,
          t2.batchid,
          t2.qcinstrname,
          t2.instrspecificdata
        )
    -- --
  ----- -----






  -----Setp 04: Update QC Sample Layout-----
    --Review Test assoicated with equipment--
      SELECT DISTINCT
        qc.eqid,
        t.testno,
        qc.cupno,
        qc.origsts,
        qc.postype,
        qc.qctype,
        qc.testcode,
        qc.method,
        qc.batchid,
        qc.qcgroup,
        qc.autoadd,        
        '~' AS eol        
      FROM qcsampslayout qc
        INNER JOIN tests t ON (qc.testcode = t.testcode)
        INNER JOIN equip_tests et ON (qc.testcode = et.testcode AND qc.method = et.method)
      WHERE 1=1
        AND qc.eqid IN ('&SourceEquipmentID', '&NewEquipmentID')
      ORDER BY
        t.testno ASC,
        qc.eqid ASC,
        qc.cupno ASC
    -- --
    
    --Add test to new equipment based on Source Equipment--
      MERGE INTO qcsampslayout t1
      USING (
        SELECT DISTINCT
          '&NewEquipmentID' AS eqid,
          t.testno,
          qc.cupno,
          qc.origsts,
          qc.postype,
          qc.qctype,
          qc.testcode,
          qc.method,
          qc.batchid,
          qc.qcgroup,
          qc.autoadd,
          '~' AS eol        
        FROM qcsampslayout qc
          INNER JOIN tests t ON (qc.testcode = t.testcode)
        WHERE 1=1
          AND qc.eqid IN ('&SourceEquipmentID', '&NewEquipmentID')
        ORDER BY
          t.testno ASC,
          eqid ASC,
          qc.cupno ASC
      ) t2
      ON (  1=1
            AND t1.eqid = t2.eqid
            AND t1.method = t2.method
            AND t1.testcode = t2.testcode
            AND t1.qctype = t2.qctype
            AND t1.cupno = t2.cupno
         )
      WHEN NOT MATCHED THEN
        INSERT(
          t1.eqid,
          t1.cupno,
          t1.origsts,
          t1.postype,
          t1.qctype,
          t1.testcode,
          t1.method,
          t1.batchid,
          t1.qcgroup,
          t1.autoadd
        )
        VALUES(
          t2.eqid,
          t2.cupno,
          t2.origsts,
          t2.postype,
          t2.qctype,
          t2.testcode,
          t2.method,
          t2.batchid,
          t2.qcgroup,
          t2.autoadd
        )
    -- --
  ----- -----

/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/





