


/*-----EquipmentRename---------------------------------------------*/
  /*-----Desctription-----*/
    --Develop scripts to rename equipment in STARLIMS.
      --The Following tables have been identified as needing to be
      --updated:
        --[EQUIPMENT].EQID
        --[EQUIPSCHEDULEEVENTS].EQID
        --[MAINTENANCE].EQID
        --[RUNS].EQUID
        --[EQUIP_TESTS].EQUID
        --[QCSampsLayout]
        --[equip_standards]
        --
        --Identified but not used:
          --[batch_qc_analytes]
          --[qcchart]
          --[empw_equip_users]
          
    --NOTE:  We have devloped this script on a piece of equipment
    --that does not have any QC, or runs associated with it, so
    --it is likely there are further constraints to be identified
    --as equipment with assoicated QC is identified for name change.          
  /*----- -----*/  
  
  /*----- -----*/
  /*----- -----*/  


  /*-----History-----*/
    --2014.09.02 JTY: Begin Script Deveopment
  /*----- -----*/  
  
/*-----------------------------------------------------------------*/





/*-----Review Tables to be updated---------------------------------*/  
  ---[EQUIPMENT]---
  SELECT DISTINCT
    '&Environment' AS environment,
    e.origrec,
    e.eqid,
    e.eqtype,
    e.dept,
    e.servgrp,
    e.serialno,
    '~' AS eol
    FROM &Environment.Equipment e 
    WHERE 1=1 
      AND e.eqid IN ('&OldEquipName', '&NewEquipName')
    ORDER BY
      e.eqid ASC,
      e.origrec DESC;
  ---

  ---[EQUIPSCHEDULEEVENTS]---      
  SELECT DISTINCT
    '&Environment' AS environment,
    ese.origrec,
    ese.eqid,
    ese.maintenanceevent,
    ese.description,
    ese.mainfrequency,
    ese.reminderwindow,
    ese.mainexpdate,
    '~' AS eol
    FROM &Environment.EquipScheduleEvents ese 
    WHERE 1=1 
      AND ese.eqid IN ('&OldEquipName', '&NewEquipName')
    ORDER BY
      ese.eqid ASC,        
      ese.origrec DESC;      
  ---

  ---[MAINTENANCE]---
  SELECT DISTINCT
    '&Environment' AS environment,
    m.origrec,
    m.eqid,
    m.maintenanceevent,
    m.openreason,    
    m.remarks,
    m.status,
    m.maintby,
    m.maintdate,
    m.maintime,
    m.openedby,
    m.opendate,
    m.opentime,
    '~' AS eol
    FROM &Environment.Maintenance m
    WHERE 1=1 
      AND m.eqid IN ('&OldEquipName', '&NewEquipName')    
    ORDER BY
      m.eqid ASC,    
      m.origrec DESC;
  ---  

  ---[RUNS]---
  SELECT DISTINCT
    '&Environment' AS environment,
    r.origrec,
    r.runno,
    r.eqid,
    r.dept,
    r.eqtype,
    r.opendate,
    r.runstatus,
    r.servgrp,
    r.method,
    r.approvedby,
    r.approvalstatus,
    r.approvedate,
    '~' AS eol
    FROM &Environment.runs r
    WHERE 1=1 
      AND r.eqid IN ('&OldEquipName', '&NewEquipName')    
    ORDER BY
      r.eqid ASC,
      r.origrec DESC;      
  ---   

  ---[EQUIP_TESTS]---
  SELECT DISTINCT
    '&Environment' AS environment,
    eq.origrec,
    eq.eqid,
    eq.testcode,
    eq.method,
    '~' AS eol
    FROM &Environment.equip_tests eq
    WHERE 1=1 
      AND eq.eqid IN ('&OldEquipName', '&NewEquipName')    
    ORDER BY
      eq.eqid ASC,
      eq.testcode ASC,
      eq.origrec DESC;      
  ---   

  ---[QCSampsLayout]---
  SELECT DISTINCT
    '&Environment' AS environment,
    qcl.origrec,
    qcl.eqid,
    qcl.testcode,
    qcl.method,
    qcl.qctype,
    qcl.postype,
    qcl.autoadd,
    '~' AS eol
    FROM &Environment.qcsampslayout qcl
    WHERE 1=1 
      AND qcl.eqid IN ('&OldEquipName', '&NewEquipName')    
    ORDER BY
      qcl.eqid ASC,
      qcl.testcode ASC,
      qcl.qctype ASC,
      qcl.origrec DESC;      
  ---   

  ---[equip_standards]---
  SELECT DISTINCT
    '&Environment' AS environment,
    es.origrec,
    es.eqid,
    es.testcode,
    es.method,
    es.cupno,
    es.qctype,
    '~' AS eol
    FROM &Environment.equip_standards es
    WHERE 1=1 
      AND es.eqid IN ('&OldEquipName', '&NewEquipName')    
    ORDER BY
      es.eqid ASC,
      es.testcode ASC,
      es.cupno ASC,
      es.qctype ASC,
      es.origrec DESC;      
  ---   

/*-----------------------------------------------------------------*/  



/*-----Change Equipment ID-----------------------------------------*/  
  --Run these scripts one at a time to update database.  This way
  --we can roll-back changes if we have a problem.
  
  ---Update [equip_standards] table, [eqid] value
/*  
    UPDATE &Environment.equip_standards es  
    SET
      es.eqid = '&NewEquipName'
    WHERE 1=1
      AND (es.eqid IN ('&OldEquipName', '&NewEquipName') );
*/      
  --- 
        
  ---Update [QCSampsLayout] table, [eqid] value
/*  
    UPDATE &Environment.equip_standards qcl  
    SET
      qcl.eqid = '&NewEquipName'
    WHERE 1=1
      AND (qcl.eqid IN ('&OldEquipName', '&NewEquipName') );
*/      
  --- 

  ---Update [EQUIP_TESTS] table, [eqid] value
/*  
    UPDATE &Environment.equip_tests eq  
    SET
      eq.eqid = '&NewEquipName'
    WHERE 1=1
      AND (eq.eqid IN ('&OldEquipName', '&NewEquipName') );
*/      
  ---        

  ---Update [RUNS] table, [eqid] value
/*  
    UPDATE &Environment.runs r  
    SET
      r.eqid = '&NewEquipName'
    WHERE 1=1
      AND (r.eqid IN ('&OldEquipName', '&NewEquipName') );
*/      
  --- 

  ---Update [MAINTENANCE] table, [eqid] value       
   --Constraint: Maintenance_FK1
/*   
    ALTER TABLE &Environment.Maintenance DISABLE CONSTRAINT Maintenance_FK1;            
    UPDATE &Environment.Maintenance m  
    SET
      m.eqid = '&NewEquipName'
    WHERE 1=1
      AND (m.eqid IN ('&OldEquipName', '&NewEquipName') );
*/      
  --- 

  ---Update [EQUIPSCHEDULEEVENTS] table, [eqid] value       
/*
   --Constraint: FK_EQUIPSCHEDULEEV_EQUIPMENT01
    ALTER TABLE &Environment.EquipScheduleEvents DISABLE CONSTRAINT FK_EQUIPSCHEDULEEV_EQUIPMENT01;
    UPDATE &Environment.EquipScheduleEvents ese 
    SET
      ese.eqid = '&NewEquipName'
    WHERE 1=1
      AND (ese.eqid IN ('&OldEquipName', '&NewEquipName') );
*/
  --- 

  ---Update [EQUIPMENT] table, [eqid] value       
/*  
    UPDATE &Environment.Equipment e  
    SET
      e.eqid = '&NewEquipName'
    WHERE 1=1
      AND (e.eqid IN ('&OldEquipName', '&NewEquipName') );
*/      
  --- 

  ---Enable Constraints---
/*  
    ALTER TABLE &Environment.Maintenance DISABLE CONSTRAINT Maintenance_FK1;
    ALTER TABLE &Environment.EquipScheduleEvents DISABLE CONSTRAINT FK_EQUIPSCHEDULEEV_EQUIPMENT01;    
*/
  ---


/*-----------------------------------------------------------------*/  
/*=================================================================*/
