/*-----------------------------------------------------------------*/

  ---SL10---
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  ---
  
  
/*-----------------------------------------------------------------*/


/*-----Research & Prep Work----------------------------------------*/

  /*---Reference Tables ---*/
    --SELECT * FROM sundata_prod.users
  /*--- ---*/
  
  /*---Identify cannidates for LDAP upgrade---*/
/*  
    SELECT DISTINCT
      u.usrnam,
      u.fullname,
      UPPER(u.email),
      --UPPER((RegExp_Replace(TRIM(u.fullname),' ','.') || '@azdhs.gov')) AS MyMail,
      u.pwexpd,
      --(TO_DATE(ADD_MONTHS(SysDate,60),'DD-MON-YY')) AS MyExpiryDate,
      u.gracelog,
      u.status,
      u.securityaction,
      u.ldap_server,
      u.ldap_port,
      u.ldap_alias,
      --('hs\' || LOWER(TRIM(u.usrnam))) AS MyAlias,  
      '~' AS eol
    FROM &Environment.users u
    WHERE 1=1
      AND u.status <> 'Retired'
      AND (u.securityaction <> 'GLOBALSECURITYACTION'
          OR u.securityaction IS NULL)
      --Only want users who's name matches their Emal address--
        AND (UPPER(TRIM(u.email)) =
            UPPER((RegExp_Replace(TRIM(u.fullname),' ','.') || '@azdhs.gov')))
      --
    --  AND (RegExp_Like())
    ORDER BY
      u.usrnam ASC;
*/      
  /*--- ---*/
    
  /*---Generte Email Notification List ---*/
/*  
    SELECT DISTINCT
      ListAgg(u.email, ';') WITHIN GROUP (ORDER BY u.email) AS MyEmailList
    FROM &Environment.users u
    WHERE 1=1
      AND u.status = 'Active'
      AND (u.securityaction <> 'GLOBALSECURITYACTION'
          OR u.securityaction IS NULL)
      --Only want users who's name matches their Emal address--
        AND (UPPER(TRIM(u.email)) =
            UPPER((RegExp_Replace(TRIM(u.fullname),' ','.') || '@azdhs.gov')));
      --
*/      
  /*--- ---*/
  
  /*--- ---*/
  /*--- ---*/  
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
/*
  UPDATE users u
  SET
    u.gracelog = '6',
    u.pwexpd = (TO_DATE(ADD_MONTHS(SysDate,60),'DD-MON-YY')),
    u.securityaction = 'GLOBALSECURITYACTION',
    u.ldap_server = 'HSPHXMDC03', --PROD: HSPHXMDC03
    u.ldap_port = '636', --PROD,DEV: 636  TEST: 389
    u.ldap_alias = ('hs\' || LOWER(TRIM(u.usrnam)))
  WHERE 1=1
    AND u.status <> 'Retired'
      AND (u.securityaction <> 'GLOBALSECURITYACTION'
          OR u.securityaction IS NULL)    
    --Only want users who's name matches their Emal address--
      AND (UPPER(TRIM(u.email)) =
          UPPER((RegExp_Replace(TRIM(u.fullname),' ','.') || '@azdhs.gov')))
 */

/*-----------------------------------------------------------------*/



/*-----Identify active users not LDAP------------------------------*/


  SELECT DISTINCT
  u.securityaction,
    u.fullname,
    u.usrnam,
    u.email,
    u.status,
    u.deptlist,
    u.last_login_attempt_date,
    u.ldap_server,
    '~' AS eol
  FROM &Envrionment.users u
  WHERE 1=1
    AND u.status <> 'Retired'
    AND (u.securityaction <> 'GLOBALSECURITYACTION'
        OR u.securityaction IS NULL)    
    AND u.ldap_server is null --24/53= 'HSPHXMDC03'
--    AND (UPPER(TRIM(u.email)) =
--        UPPER((RegExp_Replace(TRIM(u.fullname),' ','.') || '@azdhs.gov')))    
  ORDER BY
    UPPER(u.fullname) ASC,
    u.usrnam ASC;


/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
 --Review authentification information.
/*
  SELECT DISTINCT
  u.ldap_server,
  u.ldap_port,
  u.ldap_alias,
  u.securityaction,
    u.fullname,
    u.usrnam,
    u.email,
    u.status,
    u.deptlist,
    u.last_login_attempt_date,
    u.ldap_server,
    '~' AS eol
--  FROM &Envrionment.users u
FROM &Environment.users u
  WHERE 1=1
    AND u.status <> 'Retired'
    AND u.ldap_server IS NOT NULL
--    AND (u.securityaction <> 'GLOBALSECURITYACTION'
--        OR u.securityaction IS NULL)    
--    AND u.ldap_server is null --24/53= 'HSPHXMDC03'
--    AND (UPPER(TRIM(u.email)) =
--        UPPER((RegExp_Replace(TRIM(u.fullname),' ','.') || '@azdhs.gov')))    
  ORDER BY
    UPPER(u.fullname) ASC,
    u.usrnam ASC;
*/
/*-----------------------------------------------------------------*/
