PL/SQL Developer Test script 3.0
294


/*-----MarkUnusedMaterialsAsDelete---------------------------------*/

  /*----------Description----------*/
    --This script will review the materials used for
      --Reagents Related to test
      --Reagents Related to Micro Components associated with a test
      --Materils listed in the [sunrise_date].adhs_matsup table
    --Any material that is not associated with the listed items
    --above will have the MatType updated to type of 'Delete'    
  /*---------- ----------*/

  /*----------History----------*/
    --2013.07.02 JTY: Created script
  /*---------- ----------*/

  /*---------- ----------*/
  /*---------- ----------*/
/*-----------------------------------------------------------------*/





/*-----------------------------------------------------------------*/

  /*----------VARIABLES SECTION----------*/
    DECLARE 
    ---Primatives--
      iCounter pls_integer;    
    --
    ---Cursors---
      --This highly complex cursor will identify materials that
      --are NOT related to:
        --Reagents Related to test
        --Reagents Related to Micro Components associated with a test
        --Materils listed in the [sunrise_date].adhs_matsup table
      Cursor cur_MarkAsDelete IS
        WITH
          ---MySteps---
            --Get the Steps related to the Micro Test
            MySteps AS (
              SELECT DISTINCT
                tc.dept,
                tc.testcatcode,
                t.testno,
                t.testcode,
                t.testflag,
                t.tmname,
                tws.Stepcode,
                '~' AS sp1,
                tws.Sorter AS step_order,
                twm.tmcode,
                '~' AS eol
              FROM testcategory tc
                INNER JOIN tests t ON (tc.testcatcode = t.testcatcode)
                INNER JOIN testwfmethods twm ON (t.tmname = twm.tmname)
                INNER JOIN testwfsteps tws ON (twm.tmcode = tws.tmcode)
              WHERE 1=1
                AND t.testflag = 'Micro'  --Only interested in Micro Tests
              ORDER BY
                tc.dept ASC,
                t.testno ASC,
                tws.sorter ASC),
          ---
          ---StepComponents1---
            --Get the Components related to each step via ComponentType
            StepComponents1 AS (
              SELECT DISTINCT
                MS.dept,
                MS.testcatcode,
                MS.testno,
                MS.testcode,
                MS.testflag,
                MS.tmname,
                MS.Stepcode,
                mc.comptype,
                mc.compname,          
                mpcm.compid,
                '~' AS sp1,
                MS.step_order,
                '~' AS eol
              FROM MySteps MS
                INNER JOIN microplates mp ON (
                    ms.stepcode = mp.stepcode AND ms.tmcode = mp.tmcode)
                INNER JOIN micropanelconditions mpc ON (mp.fromcomptype = mpc.comptype)
                INNER JOIN micropanelcomp mpcm ON (
                  mpc.comptype = mpcm.comptype AND mpc.panelid = mpcm.panelid)
                INNER JOIN microcomponents mc ON (mpcm.compid = mc.compid)
              WHERE 1=1
              ORDER BY
                MS.dept ASC,
                MS.testno ASC,
                MS.step_order ASC,
                mc.comptype ASC,
                mc.compname ASC),
          ---            
          ---StepComponents2---
            --Get the Default Components related to each step
            StepComponents2 AS (
              SELECT DISTINCT
                MS.dept,
                MS.testcatcode,
                MS.testno,
                MS.testcode,
                MS.testflag,
                MS.tmname,
                MS.Stepcode,
                mc.comptype,
                mc.compname,
                mpdc.compid,
                '~' AS sp1,
                MS.step_order,
                --MS.tmcode,
                '~' AS eol
              FROM MySteps MS
                INNER JOIN microplatedefcomp mpdc ON (
                    ms.stepcode = mpdc.stepcode AND ms.tmcode = mpdc.tmcode)
                INNER JOIN microcomponents mc ON (mpdc.compid = mc.compid)              
              WHERE 1=1
              ORDER BY
                MS.dept ASC,
                MS.testno ASC,
                MS.step_order ASC,
                mc.comptype ASC,
                mc.compname ASC),
          ---          
          ---MyComponents---
            --Combine StepComponents1 & StepComponents2 to get all micro components
            --related to the Micro Test.
            MyComponents AS (
              (SELECT DISTINCT
                sc1.dept,
                sc1.testcatcode,
                sc1.testno,
                sc1.testcode,
                sc1.testflag,
                sc1.tmname,
                sc1.stepcode,
                sc1.comptype,
                sc1.compname,
                sc1.compid,
                '~' AS sp1,
                sc1.step_order,
                '~' AS eol
              FROM StepComponents1 sc1)
              UNION
              (SELECT DISTINCT
                sc2.dept,
                sc2.testcatcode,
                sc2.testno,
                sc2.testcode,
                sc2.testflag,
                sc2.tmname,
                sc2.stepcode,
                sc2.comptype,
                sc2.compname,          
                sc2.compid,
                '~' AS sp1,
                sc2.step_order,
                '~' AS eol
              FROM StepComponents2 sc2)
              ORDER BY
              dept ASC,
              testno ASC,
              step_order ASC,
              comptype ASC,
              compname ASC),
          ---     
          ---MyMaterials---
            --Get materials for all identified components
            MyMicroTestMaterials AS (
              SELECT DISTINCT
                MC.dept,
                MC.testcatcode,
                MC.testno,
                MC.testcode,
                MC.testflag,
                MC.tmname,
                MC.stepcode,
                MC.comptype,
                MC.compname,
                MC.compid, 
                m.mattype,
                m.matname,
                m.matcode,
                m.unit_code,                                 
                '~' AS sp1,
                MC.step_order,
                '~' AS eol
              FROM MyComponents MC
                INNER JOIN microcompreagents mcr ON (
                    MC.Comptype = mcr.comptype AND MC.Compid = mcr.compid)
                INNER JOIN materials m ON (mcr.matcode = m.matcode)
              WHERE 1=1
              ORDER BY
              dept ASC,
              testno ASC,
              step_order ASC,
              comptype ASC,
              compname ASC,
              m.mattype,
              m.matcode ASC),
          ---  
          ---ComponentMaterialsList---
            ComponentMaterialsList AS (
              SELECT DISTINCT
                mtm.matcode
              FROM MyMicroTestMaterials mtm
              WHERE 1=1
              ORDER BY 
                mtm.matcode ASC),
          ---
          ---TestMaterialsList---
            TestMaterialsList AS (
              SELECT DISTINCT
                tr.matcode
              FROM testreagents tr
              WHERE 1=1
              ORDER BY
                tr.matcode),
          ---
          ---RecognizedMaterials---
            RecognizedMaterials AS (
              SELECT DISTINCT 
                ts.matcode
              FROM  sunrise_data.adhs_tempsup ts
              WHERE 1=1
              ORDER BY 
                ts.matcode ASC),
          ---
          ---AllUsedReagents---
            AllUsedReagents AS (
              SELECT DISTINCT matcode FROM ComponentMaterialsList
              UNION
              SELECT DISTINCT matcode FROM TestMaterialsList
              UNION
              SELECT DISTINCT matcode FROM RecognizedMaterials),
          ---
          ---MaterialsNotUsed---
            MaterialsNotUsed AS (
              SELECT DISTINCT 
                m.matcode,
                m.mattype,
                '~' AS eol
              FROM materials m          
                LEFT OUTER JOIN AllUsedReagents aur ON (m.matcode = aur.matcode)       
              WHERE 1=1
                AND aur.matcode IS NULL
              ORDER BY 
                m.matcode ASC)
          --
          ---Final Query---
            --Here is the list of materials that need to have
            --mattype set to 'Delete'
            SELECT DISTINCT
              mnu.matcode,
              mnu.mattype
            FROM MaterialsNotUsed mnu
            WHERE 1=1
              AND mnu.mattype <> 'Delete'
            ORDER BY 
              mnu.matcode ASC;    
          ---
    ---
  /*---------- ----------*/
  




  /*----------CODE SECTION----------*/  
  BEGIN
    ---Set Variable Defaults---
      iCounter := 0;
    ---
    ---Set MatType = Delete---
      FOR rec_MarkAsDelete IN cur_MarkAsDelete LOOP
        iCounter := iCounter +1;
        dbms_output.put_line(
            iCounter || ': ' || rec_MarkAsDelete.matcode);
        UPDATE materials
        SET mattype = 'Delete'
        WHERE 1=1
          AND matcode = rec_MarkAsDelete.matcode;  
      END LOOP;
    ---
    ---
      dbms_output.put_line(iCounter || ' Materials Updated');    
    ---
  END;
  /*---------- ----------*/
/*-----------------------------------------------------------------*/
0
0
