/*-----CR198 MicroTest Reagents Fix--------------------------------*/
  --The thrust of this ticket is to review and update the reagents
  --associated with each of the micro test setup in LRNB
  
  /*---------- History ----------*/
    --2013.03.01 JTY: Created script file
  /*----------  ----------*/    
/*-----------------------------------------------------------------*/



/*-----Resources---------------------------------------------------*/

  /*----------SL10 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/

  /*---------- Basline Tables ----------*/
    --SELECT * FROM sundata_sat.microtaskreagents WHERE 1=1  
  /*----------  ----------*/  




/*-----------------------------------------------------------------*/





/*-----Research And Identify the data------------------------------*/

  /*---------- Reagents for Tests  ----------*/
/*  
    SELECT DISTINCT 
      CASE
        WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
        WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
        WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'
      END  AS Env,         
      tc.dept,
      tc.testcatcode,
      t.testno,
--      t.testcode,
      tr.matcode,      
      '~' AS eol
    FROM &Environment.testcategory tc
      LEFT OUTER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
      LEFT OUTER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)    
    WHERE 1=1
      AND tc.dept = 'PHX-BT'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, BT 
      AND tc.testcatcode = 'BioTerrorism'
AND regexp_like(t.testno, 'PCR ')      
    ORDER BY
      tc.dept ASC,
      tc.testcatcode ASC,
      t.testno ASC,
      tr.matcode ASC;    
*/      
  /*----------  ----------*/   

  /*---------- Reagents for MicroTests ----------*/
    --Identify each of the reagents assigned to 
    --components that are associated with a panel
/*
     SELECT DISTINCT
      CASE
        WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
        WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
        WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'
      END  AS Env,              
        mpc.panelid,
        mpc.comptype,
        mpc.compid,
        mcr.matcode,
        mcr.origsts,
        '~' AS eol
      FROM &Environment.Micropanelcomp mpc
        LEFT OUTER JOIN &Environment.microcompreagents mcr ON (1=1
          AND mpc.comptype = mcr.comptype
          AND mpc.compid = mcr.compid)      
      WHERE 1=1 
AND regexp_like(mpc.comptype, 'PCR ')      
AND regexp_like(mpc.compid, 'PCR')
      ORDER BY
        mpc.panelid ASC,
        mpc.comptype ASC,
        mpc.compid ASC,
        mcr.matcode ASC;
*/        
  /*----------  ----------*/
  
 
/*-----------------------------------------------------------------*/




/*-----UpdateMicroComponentReagents--------------------------------*/
  --We are going to take the identified ComponentType, ComponentID,
  -- and Clinical TestName to update the materials associated with
  --the ComponentID to match the materials for the identified
  --test.  

  --We have four main scripts here:
    --1. Display materials for the identified component before
      -- changes have been made.
    --2. Delete any extra component materials that are not found
      -- in the identified test materials.
    --3. Add any missing materials to the component that are
      --in the identified test but no the component.
    --4. Display materials for the identified component after
      --updates have been performed.
      
---DONT FORGET: YOU NEED TO COMMIT EACH TIME THIS SCRIPT IS EXECUTED AFTER INSPECTION OF RESULTS      

  /*----------1. Before Changes ----------*/ 
    SELECT DISTINCT
      CASE
        WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
        WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
        WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'
      END  AS Env,      
      mcr.comptype,
      mcr.compid,
      mcr.matcode,
      mcr.origsts,
      mcr.origrec,      
        '~' AS eol
      FROM &Environment.microcompreagents mcr
      WHERE 1=1 
        AND mcr.comptype = '&ComponentType'
        AND mcr.compid = '&CoponentID'
      ORDER BY
      mcr.comptype ASC,
      mcr.compid ASC,
      mcr.matcode ASC,
      mcr.origsts ASC,
      mcr.origrec;         
  /*----------  ----------*/
  
  /*----------2. Delete Extra Component Materials ----------*/
    MERGE INTO &Environment.microcompreagents mc1
    USING (
      SELECT DISTINCT 
        CASE
          WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
          WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
          WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'
        END  AS Env,         
        '&TestName' AS TestNo,
        mcr.comptype,
        mcr.compid,
        mcr.matcode,
        mcr.origrec AS origrec_to_toss
      FROM &Environment.microcompreagents mcr
        LEFT OUTER JOIN &Environment.testreagents tr ON (mcr.matcode = tr.matcode)
        LEFT OUTER JOIN &Environment.tests t ON (t.testcode = tr.testcode) 
      WHERE 1=1
        AND tr.matcode IS NULL
        AND mcr.comptype = '&ComponentType'
        AND mcr.compid = '&CoponentID'
      ORDER BY 
        mcr.matcode ASC) mc2
    ON (1=1
        AND mc1.comptype = mc2.comptype
        AND mc1.compid = mc2.compid
        AND mc1.matcode = mc2.matcode)       
    WHEN MATCHED THEN 
      UPDATE SET mc1.origsts = 'A'
      DELETE WHERE mc1.origrec = origrec_to_toss;
  /*----------  ----------*/      
  
  
    
  /*----------3. Insert Missing Component Materials ----------*/
    MERGE INTO &Environment.microcompreagents mc1
    USING (
      SELECT DISTINCT 
        ---Imputs---
          CASE
            WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
            WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
            WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'
          END  AS Env,         
          '&TestName' AS TestNo,
          '&ComponentType' AS CompType,
          '&CoponentID' AS CompID,
        ---
        tr.matcode
      FROM &Environment.testcategory tc
        INNER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
        INNER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)    
      WHERE 1=1
        AND t.testno = '&TestName'
      ORDER BY
        tr.matcode ASC) mc2
    ON (1=1
        AND mc1.comptype = mc2.comptype
        AND mc1.compid = mc2.compid
        AND mc1.matcode = mc2.matcode)
    WHEN NOT MATCHED THEN
      INSERT (
        mc1.comptype,
        mc1.compid,
        mc1.matcode,
        mc1.origsts)
      VALUES (
        mc2.comptype,
        mc2.compid,
        mc2.matcode,
        'A');
  /*----------  ----------*/      



  /*----------4. After Changes ----------*/
    SELECT DISTINCT
      CASE
        WHEN ('&Environment' = 'sunrise_data') THEN 'DEV'
        WHEN ('&Environment' = 'sundata_sat') THEN 'TEST'
        WHEN ('&Environment' = 'sundata_prod') THEN 'PROD'
      END  AS Env,      
      mcr.comptype,
      mcr.compid,
      mcr.matcode,
      mcr.origsts,
      mcr.origrec,      
        '~' AS eol
      FROM &Environment.microcompreagents mcr
      WHERE 1=1 
        AND mcr.comptype = '&ComponentType'
        AND mcr.compid = '&CoponentID'
      ORDER BY
      mcr.comptype ASC,
      mcr.compid ASC,
      mcr.matcode ASC,
      mcr.origsts ASC,
      mcr.origrec;         
  /*----------  ----------*/  
/*-----------------------------------------------------------------*/

  
  
