

/*-----------------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Set of queries written to add a new MicroComponent based on
    --an Existing MicroComponent.  To use these queries, you will
    --need to create a a new microComponent in the Micro Components
    --application under the Component Type you with the new MC to
    --reside. 
  /*----- -----*/

  /*-----HISTORY-----*/
    --2015.12.24 JTY: Created Scripts
  /*----- -----*/
/*-----------------------------------------------------------------*/





/*-----Possible Updates Merge--------------------------------------*/
  --Remember, you will need to create the new MicroComponent before
  --you will be able to update it with values from the Source.

  --This query will also update existinge Response values if the
  --Target MC alreadys has a response that's in the Source MC

  /*-----Review-----*/
/*  
    SELECT DISTINCT
      mc.*
    FROM &Environment.MICROCOMPONENTS mc
    WHERE 1=1
      AND mc.comptype IN ('&SourceCompType', '&TargetCompType')
      AND mc.compid IN ('&SourceCompID', '&TargetCompID')
    ORDER BY
      mc.comptype ASC,
      mc.compid ASC;


    SELECT DISTINCT
     mcr.*
    FROM &Environment.MICROCOMPRESPONSE mcr
    WHERE 1=1
      AND mcr.comptype IN ('&SourceCompType', '&TargetCompType')
      AND mcr.compid IN ('&SourceCompID', '&TargetCompID')
    ORDER BY
      mcr.comptype ASC,
      mcr.compid ASC,
      mcr.response ASC;
*/      
  /*----- -----*/


  /*-----Merge-----*/
/*  
    MERGE INTO &Environment.microcompresponse t1
    USING (
      SELECT DISTINCT
        mcr.comptype,
        mcr.compid,
        mcr.response,
        mcr.status,
        mcr.is_negative,
        mcr.origsts,
        mcr.interpretation,
        mcr.snomedcode,
        mcr.code_system_oid,
        mcr.ressorter,
        mcr.loincnumber,
        mcr.hidefromreport,
        mcr.localnumber,
        mcr.cdc_reportable
      FROM &Environment.microcompresponse mcr
      WHERE 1=1
        AND mcr.comptype = '&SourceCompType'
        AND mcr.compid = '&SourceCompID'   
    ) t2
    ON (1=1
        AND t1.comptype = '&TargetCompType'
        AND t1.compid = '&TargetCompID'
        AND t1.response = t2.response
    )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.comptype,
        t1.compid,
        t1.response,
        t1.status,
        t1.is_negative,
        t1.origsts,
        t1.interpretation,
        t1.snomedcode,
        t1.code_system_oid,
        t1.ressorter,
        t1.loincnumber,
        t1.hidefromreport,
        t1.localnumber,
        t1.cdc_reportable
      )
      VALUES (
        '&TargetCompType',
        '&TargetCompID',
        t2.response,
        t2.status,
        t2.is_negative,
        t2.origsts,
        t2.interpretation,
        t2.snomedcode,
        t2.code_system_oid,
        t2.ressorter,
        t2.loincnumber,
        t2.hidefromreport,
        t2.localnumber,
        t2.cdc_reportable 
      )
    WHEN MATCHED THEN
        UPDATE SET
          --t1.comptype,
          --t1.compid,
          --t1.response,
          t1.status = t2.status,
          t1.is_negative = t2.is_negative,
          t1.origsts = t2.origsts,
          t1.interpretation = t2.interpretation,
          t1.snomedcode = t2.snomedcode,
          t1.code_system_oid = t2.code_system_oid,
          t1.ressorter = t2.ressorter,
          t1.loincnumber = t2.loincnumber,
          t1.hidefromreport = t2.hidefromreport,
          t1.localnumber = t2.localnumber,
          t1.cdc_reportable = t2.cdc_reportable
*/          
  /*----- -----*/
/*-----------------------------------------------------------------*/





/*----MicroPanels Match--------------------------------------------*/
  --We will make sure the Target MicroComponent is in all the
  --MicroPanels the Source MicroComponent is in.
  
  /*-----Review-----*/
/*  
    SELECT DISTINCT
      mpc.comptype,
      mpc.panelid,
      mpc.compid,
      mpc.sorter,
      mpc.origsts
    FROM &Environment.micropanelcomp mpc
    WHERE 1=1
      AND mpc.comptype IN ('&SourceCompType', '&TargetCompType')
      AND mpc.compid IN ('&SourceCompID', '&TargetCompID')     
    ORDER BY
      mpc.comptype ASC,
      mpc.panelid ASC,
      mpc.compid ASC;
*/      
  /*----- -----*/

  /*-----Merge-----*/
/*  
    MERGE INTO &Environment.micropanelcomp t1
    USING (
      SELECT DISTINCT
        mpc.comptype,
        mpc.compid,
        mpc.panelid,
        mpc.sorter,
        mpc.origsts
      FROM &Environment.micropanelcomp mpc
      WHERE 1=1
        AND mpc.comptype = '&SourceCompType'
        AND mpc.compid = '&SourceCompID'   
    ) t2
    ON (1=1
        AND t1.comptype = '&TargetCompType'
        AND t1.compid = '&TargetCompID'
        AND t1.panelid = t2.panelid
    )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.comptype,
        t1.compid,
        t1.panelid,
        t1.sorter,
        t1.origsts
      )
      VALUES (
        '&TargetCompType',
        '&TargetCompID',
        t2.panelid,
        t2.sorter,
        t2.origsts
      )
    WHEN MATCHED THEN
        UPDATE SET
          --t1.comptype,
          --t1.compid,
          --t1.panelid = t2.panelid,
          t1.sorter = t2.sorter,
          t1.origsts = t2.origsts
*/          
  /*----- -----*/
/*-----------------------------------------------------------------*/




