
/*-----------------------------------------------------------------*/
/*-----PushSampleAround--------------------------------------------*/
  /*----------Discription---------*/
    --Scripts to review where a sample is located at, and "Push" it
    --to the locateion you want to push it to.
    --
    --Currently developed scripts include:
      --01. PushTo: Sample Pre Login
      --02. PushTo: Receive Prelogged
      --03. PushTo: Run Approval
      --04. PushTo: Sendout to Preliminary Release By panel
  /*---------- ---------*/

  /*----------Database Instances---------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod  
  /*---------- ---------*/
    
  /*----------History---------*/
    --2014.05.30 JTY: Created Scripts
    --2014.06.13 JTY: Added Run Approval push.
    --2014.08.04 JTY: Add Sendout to Prelmin push.
  /*---------- ---------*/
/*-----------------------------------------------------------------*/



/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/

  /*----------Sample Locations and Associated values----------*/
  --Here we provide a summary of the various locations a sample
  --can be parked, and the assoicated status values associated
  --with that location.
  
    /*---Location: Release by Panel, My Teams Pending Test, etc.---*/
      --This status appears to be the values when the sample is in
      --the flow and login has been completed.  Now where it appears
      --seems to depend upon other status values (OrdTask, Task, Ect?)
      --cr.dataentrystatus     = ReleaseDone
      --cr.dispdataentrystatus = ReleaseDone
      --cr.status              = Logged, Cancel
    /*--- ---*/
    
    /*--- ---*/
    /*--- ---*/       
  /*---------- ----------*/
/*-----------------------------------------------------------------*/




/*-----01. PushTo: Sample Pre Login-------------------------------*/
  --Want to move sample to the Sample Pre Login application.

    /*---Location: Sample Pre Login---*/
      --cr.dataentrystatus     = Pending
      --cr.dispdataentrystatus = Pending
      --cr.status              = Draft    
    /*--- ---*/
  
  
  /*----------Show Sample Status Values----------*/
    SELECT DISTINCT
      cr.external_id,
      cr.dataentrystatus,
      cr.dispdataentrystatus,
      cr.status,
      '~' AS eol
    FROM &Environment.CentralReceiving cr
    WHERE 1=1
--      AND cr.external_id = '&SampleID';
      AND cr.external_id IN (&SampleList);      
  /*---------- ----------*/

  /*----------Move Sample to Receive Prelogged----------*/
/*  
    UPDATE &Environment.CentralReceiving cr
    SET
      cr.dataentrystatus = 'Pending',
      cr.dispdataentrystatus = 'Pending',
      cr.status = 'Draft'
    WHERE 1=1
      AND cr.external_id = '&SampleID'   
*/    
  /*---------- ----------*/

/*-----------------------------------------------------------------*/





/*-----02. PushTo: Receive Prelogged-------------------------------*/
  --Want to move the sample to the Prelogged application

    /*---Location: Receive Prelogged---*/
      --cr.dataentrystatus     = ReleaseDone
      --cr.dispdataentrystatus = ReleaseDone
      --cr.status              = Prelogged    
    /*--- ---*/
  
  
  /*----------Show Sample Status Values----------*/
    SELECT DISTINCT
      cr.external_id,
      cr.dataentrystatus,
      cr.dispdataentrystatus,
      cr.status,
      '~' AS eol
    FROM &Environment.CentralReceiving cr
    WHERE 1=1
--      AND cr.external_id = '&SampleID';
      AND cr.external_id IN (&SampleList);      
  /*---------- ----------*/

  /*----------Move Sample to Receive Prelogged----------*/
/*  
    UPDATE &Environment.CentralReceiving cr
    SET
      cr.dataentrystatus = 'ReleaseDone',
      cr.dispdataentrystatus = 'ReleaseDone',
      cr.status = 'Prelogged'
    WHERE 1=1
      AND cr.external_id = '&SampleID' 
*/    
  /*---------- ----------*/

/*-----------------------------------------------------------------*/





/*-----03. PushTo: Run Approval------------------------------------*/
  --Have had problems with samples not going to Run Approval
  --application.  Use this script to review the status flags, and
  --push identified samples back.

    /*---Location: Release Run---*/
      --OT.tsa     = RTR
      --ot.tsadisp = RTR
    /*--- ---*/
  
  
  /*----------Review Run/Samples----------*/  
    SELECT DISTINCT
      ot.dept,
      ot.dispdept,
      ot.runno,
      f.external_id,
      ot.tsadisp,
      ot.tsa,
      ot.origrec,
      '~' AS eol
    FROM &Schema.ordtask ot
      INNER JOIN &Schema.runs r ON (ot.runno = r.runno)
      INNER JOIN &Schema.folders f ON (ot.folderno = f.folderno)
    WHERE 1=1
      AND ot.runno = '&RunNumber'
      --AND ot.runno IN ('4762','4763','4517')      
    ORDER BY
      r.runno ASC,
      f.external_id ASC;
  /*---------- ----------*/

  /*----------Move Sample to Run Approval----------*/
/*  
    UPDATE sundata_prod.ordtask ot
    SET 
      ot.tsa = 'RTR',
      ot.tsadisp = 'RTR' 
    WHERE ot.origrec IN ('74961','74963')
*/    
  /*---------- ----------*/

/*-----------------------------------------------------------------*/





/*-----04. PushTo: Sendout to Preliminary Release By panel--------*/
  --Have had problems with sample with send-out and other test not
  --appearing in Preliminary Release by Panel when a prliminary
  --report was requested.  Somehow the values related to this test
  --were updated to OOS instead of 'Active'

  
  /*----------Review Run/Samples----------*/  
    SELECT DISTINCT
      cr.external_id,
      f.origrec AS f_origrec,
      f.matcode,
      f.dispsts,
      f.fldsts,
      fc.origrec AS fc_origrec,
      fc.status,
      r.testcode,
      r.runno,
      r.testno,
      r.analyte,
      r.final,

      '~' AS eol
    FROM &Schema.CentralReceiving cr
      INNER JOIN &Schema.Folders f ON (cr.external_id = f.external_id)
      INNER JOIN &Schema.FolderCondition fc ON (f.folderno = fc.folderno)
      LEFT OUTER JOIN &Schema.Results r ON (r.folderno = f.folderno)            
    WHERE 1=1
--      AND r.testno = 'Sendout Salmonella Culture'
      AND cr.external_id IN ('AZ00027796')
--      AND r.testno = '&SendoutTestName'
--      AND cr.external_id = 'SampleID'
  ORDER BY
      r.testno ASC,
      cr.external_id ASC;
  /*---------- ----------*/

  /*----------Move Sample to Preliminary Release(Hopefully)----------*/
/*  
    UPDATE &Schema.folders f
    SET 
      --f.matcode = 'Human'
      f.dispsts = 'Active',
      f.fldsts = 'Active' 
    WHERE f.origrec IN ('&FoldersOrigrec');
*/
/*  
    UPDATE &Schema.folderCondition fc
    SET 
      fc.status = 'Active'
    WHERE fc.origrec IN ('&FolderConditionOrigrec');
*/   
  /*---------- ----------*/

/*-----------------------------------------------------------------*/





/*-----Move Back to Outsource Samples Results Entry-----------------*/
--select * from sundata_prod.ordtask ot ot.outsourceordno;
--select * from sundata_prod.outsourceorders oo
  /*----------Show Sample Status Values----------*/
    SELECT DISTINCT
      f.external_id,
      ot.dept,
      f.dispsts AS f_dispsts,
      fc.status AS fc_status,
      ot.dispdept,
      ot.outsourceordno,
      ot.ts,
      ot.apprdate,
      ot.apprvedby,
      oo.status AS oo_status,
      oo.dispsts AS oo_dispsts,
      ot.tsadisp,
      ot.tsa,
      r.s AS r_s,
      f.origrec AS f_origrec,
      fc.origrec AS fc_origrec,
      ot.origrec AS ot_origrec,
      oo.origrec AS oo_origrec,
      r.origrec AS r_origrec,
      '--' AS SP1,
--      ot.*,
      '~' AS eol
    FROM &Schema.folders f
      INNER JOIN &Schema.foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN &Schema.ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN &Schema.Results r ON (1=1
          AND ot.ordno = r.ordno
          AND ot.testcode = r.testcode)
      INNER JOIN &Schema.outsourceorders oo ON (ot.outsourceordno = oo.outsourceordno)      
    WHERE 1=1
      AND f.external_id IN (&SampleList)
    ORDER BY
      f.external_id ASC;   
  /*---------- ----------*/


  /*----------Check Current Values----------*/
/*  
    UPDATE &Schema.outsourceorders oo SET oo.status = 'Shipped', oo.dispsts = 'Shipped' WHERE oo.origrec = '20004';
    UPDATE &Schema.ordtask ot SET 
        ot.tsadisp = '', ot.tsa = '', ot.apprdate = '', ot.apprvedby = '', ot.ts = 'Logged'
      WHERE ot.origrec IN ('86629','86630','86631','86632');
    UPDATE &Schema.results r SET r.s = 'Logged' WHERE r.origrec IN ('342517','342518','342519','342520');
    UPDATE &Schema.folders f SET f.dispsts = 'Logged'WHERE f.origrec IN ('71676','71677','71678','71679');
    UPDATE &Schema.foldercondition fc SET fc.status ='Prelogged' WHERE fc.origrec IN ('74598','74599','74600','74601')
*/
  /*---------- ----------*/  

/*-----------------------------------------------------------------*/




/*-----Move from Preliminary/Release by Panel to Released---------*/

  /*----------Check Field Values----------*/
    SELECT DISTINCT
      f.origrec AS f_origrec,
      f.external_id,
      f.apprdate AS f_apprdate,
      f.approvedby AS f_approvedby,
      f.apprsts AS f_apprsts,
      f.dispsts AS f_dispsts,
      fc.origrec AS fc_origrec,
      fc.dispsts AS fc_dispsts,
      fc.approvalstatus AS fc_approvalstatus,
      fc.approvedby AS fc_approvedby,
      fc.approveddate AS fc_apporveddate,
      fc.approvedtime AS fc_approvedtime,
      '~~' AS sp1,
      f.*,
      fc.*,
      '~' AS eol
    FROM  sundata_prod.folders f
      INNER JOIN sundata_prod.foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN sundata_prod.ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN sundata_prod.results r ON (ot.folderno = r.folderno AND ot.testcode = r.testcode)
    WHERE 1=1
      AND f.external_id IN ('AZ00022659','AZ00027420', 'AZ00026141')
    ORDER BY
      f.external_id ASC
      
  /*---------- ----------*/  
  
  /*----------Push Sample to Completed----------*/  
/*
    UPDATE sundata_prod.folders f
    SET 
      f.apprsts = 'Released',
      f.apprdisp = 'Released',
      f.approvedby = 'WHITESD',
      f.apprdate = to_date('05-FEB-2015', 'DD-MON-YYYY')
    WHERE 1=1
      AND f.origrec = '78592';

    
  
    UPDATE sundata_prod.foldercondition fc 
    SET 
      fc.dispsts = 'Draft',
      fc.approvalstatus = 'Released',
      fc.approvedby = 'WHITESD',
      fc.approveddate = to_date('05-FEB-2015', 'DD-MON-YYYY'),
      fc.approvedtime = '16:40:00'
    WHERE 1=1
      AND fc.origrec = '81510'
*/      
  /*---------- ----------*/      


/*-----------------------------------------------------------------*/
