
/*=====RenameTest===============================================*/
  -----Description-----
    --Utilize these scripts to change an test name when we
    --want to change an existing test.  
    --These changes need to be made in addition to updating the
    --test name in the Test Manager application.
    --The following tables will need to be updated:
      --ConditionTestTriggers
      --SP_Tests
      --AnalyteProperties
      
    --For test with samples that have been processed, if you 
    --want to retro-activly change them, you may need to update
    --the following tables:
      --Results
      --OrdTask


    --Also a Utility that may prove usefull, will identify search value:
      --\\HSPHXVSTRLMS03\Starlims Online Help\SQL Repository\Version10\Utilities\FindColumnValue.tst 
    
    --NOTE:  I have only utilized this script on new Tests, so
    --there may be more tables that need to be updated and documented
    --here.
    --Also, these scripts were developed in segments and are just now
    --being put together, so there may be some errors or issues that
    --have not been flushed out.
    --Finally, it appears that we may need to syncocize the analyte in the 
    --Panels For Clinical Login application.
    
    --Script Location: \\HSPHXVSTRLMS03\Starlims Online Help\SQL Repository\Version10\UpdateScripts\RenameTest.sql
  -----
  
  -----Environment-----
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod  
  -----
  
  -----History-----
    --2013.11.21 JTY: Created script
  -----
/*=================================================================*/

--select * from sunrise_data.METHODSRELATEDTOTESTS rs WHERE rs.folderno LIKE '%1078%'
--select * from sunrise_data.METHODCERT where testcode = 245
--select * from sunrise_data.ordtask where testno like ('%Salmonella Serotyping%')



/*=====Scripts to update Analyte===================================*/

/*-----Review Tables to be updated---------------------------------*/    
   ---Tests---
     SELECT DISTINCT
       '&Environment' AS environment,
       t.testno,      
       t.*,
       '~' AS eol
       FROM &Environment.tests t
       WHERE 1=1 
         AND t.testcode = '&TestCode'
         AND t.testno = '&OldTestName'
       ORDER BY
         t.origrec DESC;
    ---    
   ---ConditionTestTriggers---
     SELECT DISTINCT
       '&Environment' AS environment,
       ctt.origrec,
       ctt.servgrp,
       ctt.testcode,
       ctt.testservgrp,
       '~' AS eol
       FROM &Environment.conditiontesttriggers ctt 
       WHERE 1=1 
         AND ctt.testcode = '&TestCode'
         AND ctt.testservgrp = '&OldTestName'
       ORDER BY
         ctt.origrec DESC;
    ---
    ---sp_tests---
      SELECT DISTINCT
        '&Environment' AS environment,
        spt.origrec,
        spt.testcode,
        spt.sp_testno,
        '~' AS eol
        FROM &Environment.sp_tests spt 
        WHERE 1=1 
          AND spt.testcode = '&TestCode'
          AND spt.sp_testno = '&OldTestName'
        ORDER BY
          spt.origrec DESC;
   ---
        
  --These will identify existing samples---
    ---OrdTask---
        SELECT DISTINCT
        '&Environment' AS environment,
        f.external_id,
        f.folderno,
        ot.testcode,
        ot.testno,
        ot.tsadisp,
        ot.tsa,
        ot.origrec AS ot_origrec,
        '~' AS eol
        FROM &Environment.folders f
          INNER JOIN &Environment.ordtask ot ON (f.folderno = ot.folderno)
        WHERE 1=1 
          AND ot.testcode = '&TestCode'
          AND ot.testno = '&OldTestName'
        ORDER BY
          ot.testno DESC;
    ---
    ---Results---
        SELECT DISTINCT
        '&Environment' AS environment,
        f.external_id,
        f.folderno,
        r.testcode,
        r.testno,
        r.numres,
        r.origrec AS r_origrec,
        '~' AS eol
        FROM &Environment.folders f
          INNER JOIN &Environment.results r ON (f.folderno = r.folderno)
        WHERE 1=1 
          AND r.testcode = '&TestCode'
          AND r.testno = '&OldTestName'          
        ORDER BY
          r.testno DESC,
          f.external_id ASC;
    ---
/*-----------------------------------------------------------------*/  


/*-----Change Test Name-----------------------------*/  
  --Run these scripts one at a time to update database.  This way
  --we can roll-back changes if we have a problem.
  ---Update [ConditionTestTriggers] table [testservgrp] column value---
/*
  -----[Tests]-----
    UPDATE &Environment.Tests t
      SET t.testno = '&NewTestName'
    WHERE 1=1
      AND t.testcode = '&TestCode'
      AND t.testno = '&OldTestName';     
  ----- -----

  -----[conditiontesttriggers]-----
    UPDATE &Environment.conditiontesttriggers ctt 
    SET
      ctt.testservgrp = '&NewTestName'
    WHERE 1=1
      AND ctt.testcode = '&TestCode'
      AND ctt.testservgrp = '&OldTestName';
  ----- -----

  -----[sp_tests]-----
    UPDATE &Environment.sp_tests spt 
    SET
      spt.sp_testno = '&NewTestName'      
    WHERE 1=1
      AND spt.testcode = '&TestCode'
      AND spt.sp_testno = '&OldTestName';
  ----- -----

  -----[ordtask]-----
    UPDATE &Environment.ordtask ot 
      SET ot.testno = '&NewTestName'
    WHERE 1=1
      AND ot.testcode = '&TestCode'
      AND ot.testno = '&OldTestName';
  ----- -----
  -----[Results]-----
    UPDATE &Environment.results r
      SET r.testno = '&NewTestName'
    WHERE 1=1
      AND r.testcode = '&TestCode'
      AND r.testno = '&OldTestName';
  ----- -----
*/
/*-----------------------------------------------------------------*/  
/*=================================================================*/

