
/*-----CR193 LRNB - Test Reagents Update---------------------------*/
  /*----------Description----------*/  
    --Utilize these set of queriest to identify, and update
    --LRNB tests with declared reagents from CR111.
  /*---------- ----------*/

  
  /*----------Histrory ----------*/
    --2013.02.20 JTY: Created Scripts
  /*---------- ----------*/  
  
/*-----------------------------------------------------------------*/




/*-----Resources---------------------------------------------------*/
  /*----------Databases ----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*---------- ----------*/  

  /*----------Referenced Tables ----------*/
    /*
    SELECT * FROM sunrise_data.Materials;
    SELECT * FROM sunrise_data.tests;
    SELECT * FROM sunrise_data.testreagents;
    SELECT * FROM sunrise_data.testcategory;    
    */
  /*---------- ----------*/    
/*-----------------------------------------------------------------*/




/*----Materials List-----------------------------------------------*/
  --Identify Matrials in database (not-deleted materials)
  
  /*---------- ----------*/
/*  
    SELECT DISTINCT
      m.matname,
      m.matcode,
      m.unit_code,
      m.mattype,
      m.dept,
      '~' AS eol
    FROM &Environment.materials m
    WHERE 1=1
      AND m.mattype <> 'Delete'
    ORDER BY
      m.matname ASC,
      m.matcode ASC,
      m.dept ASC,
      m.unit_code ASC,
      m.mattype ASC;
*/      
  /*---------- ----------*/  
  
/*-----------------------------------------------------------------*/



/*----Test Reagents------------------------------------------------*/
  --Showing here the Materials, Reagents and Test associated with
  --the reagents.

  /*----------Test Materials by test----------*/
/*  
    --List of materials associated with department tests.
    SELECT DISTINCT 
      --TestCategory Table--
        tc.dept,
        t.testno,
        --tc.testcatcode,
      --
      --TestReagents Table--
        tr.matcode,      
        tr.units,
      --
      --Materials Table--
        m.mattype,
        m.matname,
        m.synonim,
      --
      '~' AS eol
    FROM &Environment.testcategory tc
      LEFT OUTER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
      LEFT OUTER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)
      LEFT OUTER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
    WHERE 1=1
      AND tc.dept = 'PHX-BT'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, PHX-BT 
      --AND t.testcode = '288'
    ORDER BY
      tc.dept ASC,
      t.testno ASC,
      tr.matcode ASC,
      m.mattype ASC,
      m.matname ASC;  
*/      
  /*---------- ----------*/
  
  /*----------Unique Dept Test Materials----------*/
/*  
    --List of materials associated with department tests.
    SELECT DISTINCT 
      tc.dept,
      m.mattype,
      tr.matcode,      
      tr.units,
      t.testno,        
      m.matname,
      '~' AS eol
    FROM &Environment.testcategory tc
      LEFT OUTER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
      LEFT OUTER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)
      LEFT OUTER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
    WHERE 1=1
      AND tc.dept = 'PHX-BT'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, PHX-BT 
      --AND t.testcode = '288'
    ORDER BY
      tc.dept ASC,
      tr.matcode ASC,
      t.testno ASC,
      m.matname ASC,      
      m.mattype ASC,
      tr.units ASC;        
*/      
  /*---------- ----------*/   
/*-----------------------------------------------------------------*/





/*-----Replace Material--------------------------------------------*/
  --VOTED MOST USEFULL QUERY IN THIS SCRIPT FILE
  --Use this query to update the [testreagents] table to replace
  --old materials code with the new one.
  --We have broke this down two three queries:
    --Before Update - shows Test & material to be updated(old).
    --Perform Replace - Will preform the update
    --After Update - Shows Test & Material after updated (new).
    
  --You will need to commit each update.    
  
  /*----------Before Update----------*/
  
    SELECT DISTINCT 
      --TestCategory Table--
        tc.dept,
        t.testno,
        --tc.testcatcode,
      --
      --TestReagents Table--
        tr.matcode,      
        tr.units,
      --
      --Materials Table--
        m.mattype,
        m.matname,
        m.synonim,
      --
      '~' AS eol
    FROM &Environment.testcategory tc
      LEFT OUTER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
      LEFT OUTER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)
      LEFT OUTER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
    WHERE 1=1
      AND tc.dept = 'PHX-BT'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, PHX-BT 
      AND m.matcode = '&OldMatCode'
    ORDER BY
      tc.dept ASC,
      tr.matcode ASC,
      t.testno ASC,
      m.mattype ASC,
      m.matname ASC;        
  /*---------- ----------*/     
  
  /*----------Perform Replace ----------*/   
  MERGE INTO sunrise_data.testreagents tr
  USING (
    SELECT DISTINCT 
      tr.origrec AS tr_origrec,
      tr.matcode AS old_matcode,
      --NewMatCode--
      (SELECT DISTINCT 
        matcode
      FROM sunrise_data.materials 
      WHERE 1=1
        AND matcode = '&NewMatCode'
        AND rownum=1) AS new_matcode,
      --
      --NewUnits--
      (SELECT DISTINCT 
        unit_code
      FROM sunrise_data.materials 
      WHERE 1=1
        AND matcode = '&NewMatCode') AS new_units,
      --
      '~' AS eol
    FROM sunrise_data.testcategory tc
      LEFT OUTER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
      LEFT OUTER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)
      LEFT OUTER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
    WHERE 1=1
      AND tc.dept = 'PHX-BT'
      AND tr.matcode = '&OldMatCode' 
    ) a1
  ON (tr.origrec = a1.tr_origrec)
    WHEN MATCHED THEN
      UPDATE SET
        matcode = A1.new_matcode,
        units = A1.new_units;       
  /*---------- ----------*/
  
  /*----------After Update ----------*/  
    SELECT DISTINCT 
      --TestCategory Table--
        tc.dept,
        t.testno,
        --tc.testcatcode,
      --
      --TestReagents Table--
        tr.matcode,      
        tr.units,
      --
      --Materials Table--
        m.mattype,
        m.matname,
        m.synonim,
      --
      '~' AS eol
    FROM &Environment.testcategory tc
      LEFT OUTER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
      LEFT OUTER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)
      LEFT OUTER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
    WHERE 1=1
      AND tc.dept = 'PHX-BT'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, PHX-BT 
      AND m.matcode = '&NewMatCode'
    ORDER BY
      tc.dept ASC,
      tr.matcode ASC,
      t.testno ASC,
      m.mattype ASC,
      m.matname ASC;         
  /*---------- ----------*/            
/*-----------------------------------------------------------------*/





/*------Materials Suppliers List-----------------------------------*/
  /*----------List of suppliers for used materials----------*/
/*
    SELECT DISTINCT 
      tc.dept,
      t.testno,
      m.mattype,
      m.needqcprep AS qc,
      tr.matcode,      
      tr.units,
      ps.suppcode,
      m.matname,
      '~' AS eol
    FROM &Environment.testcategory tc
      LEFT OUTER JOIN &Environment.tests t ON (tc.testcatcode = t.testcatcode) 
      LEFT OUTER JOIN &Environment.testreagents tr ON (t.testcode = tr.testcode)
      LEFT OUTER JOIN &Environment.materials m ON (tr.matcode = m.matcode)
      LEFT OUTER JOIN &Environment.prod_suppliers ps ON (m.matcode = ps.matcode)
    WHERE 1=1
      AND tc.dept = 'PHX-BT'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, PHX-BT 
      --AND t.testcode = '288'
    ORDER BY
      tc.dept ASC,
      t.testno ASC,
      m.mattype ASC,
      tr.matcode ASC,
      m.matname ASC,      
      tr.units ASC;        
*/      
  /*---------- ----------*/   
/*-----------------------------------------------------------------*/



/*-----Compare across environments---------------------------------*/
  --This script will compare the reagents associated with each
  --test in DEV and TEST and identify any mis-matches

/*  
  WITH
    ---Env1--
      Env1 AS (
        SELECT DISTINCT 
          tc.dept,
          t.testno,
          m.mattype,
          m.needqcprep AS qc,
          tr.matcode,      
          tr.units,
          ps.suppcode,
          m.matname,
          '~' AS eol
        FROM &Environment1.testcategory tc
          LEFT OUTER JOIN &Environment1.tests t ON (tc.testcatcode = t.testcatcode) 
          LEFT OUTER JOIN &Environment1.testreagents tr ON (t.testcode = tr.testcode)
          LEFT OUTER JOIN &Environment1.materials m ON (tr.matcode = m.matcode)
          LEFT OUTER JOIN &Environment1.prod_suppliers ps ON (m.matcode = ps.matcode)
        WHERE 1=1
          AND tc.dept = '&Dept'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, PHX-BT 
        ORDER BY
          tc.dept ASC,
          t.testno ASC,
          m.mattype ASC,
          tr.matcode ASC,
          m.matname ASC,      
          tr.units ASC),
    ---
    ---Env2--
      Env2 AS (
        SELECT DISTINCT 
          tc.dept,
          t.testno,
          m.mattype,
          m.needqcprep AS qc,
          tr.matcode,      
          tr.units,
          ps.suppcode,
          m.matname,
          '~' AS eol
        FROM &Environment2.testcategory tc
          LEFT OUTER JOIN &Environment2.tests t ON (tc.testcatcode = t.testcatcode) 
          LEFT OUTER JOIN &Environment2.testreagents tr ON (t.testcode = tr.testcode)
          LEFT OUTER JOIN &Environment2.materials m ON (tr.matcode = m.matcode)
          LEFT OUTER JOIN &Environment2.prod_suppliers ps ON (m.matcode = ps.matcode)
        WHERE 1=1
          AND tc.dept = '&Dept'--PHX-BAC, PHX-ID, PHX-TB, PHX-SER, PHX-VIR, PHX-BT 
        ORDER BY
          tc.dept ASC,
          t.testno ASC,
          m.mattype ASC,
          tr.matcode ASC,
          m.matname ASC,      
          tr.units ASC),
    ---
    ---Identify Misses---
      MyMisses AS (
        SELECT DISTINCT 
          --Join fields--
            Env1.dept,
            Env1.testno,          
          --
          --Validation fields--
            Env1.mattype,
            Env1.matcode,      
            Env1.matname,
            Env1.qc,           
            Env1.units,          
            Env1.suppcode,
            Env2.suppcode AS suppcode2,            
          --
          '~' AS eol
        FROM Env1
          INNER JOIN Env2 ON ( 1=1
            AND Env1.dept = Env2.dept
            AND Env1.testno = Env2.testno
            AND Env1.mattype = Env2.mattype
            AND Env1.matcode = Env2.matcode            
            AND Env1.units = Env2.units
            )           
        WHERE 1=1
            AND Env1.suppcode <> Env2.suppcode          
        ORDER BY
          Env1.dept ASC,
          Env1.testno ASC,
          Env1.mattype ASC,
          Env1.matcode ASC,
          Env1.matname ASC,      
          Env1.units ASC)
    ---
SELECT * FROM MyMisses

    
    --DEV:  sunrise_data
    --TEST: sundata_sat

*/
/*-----------------------------------------------------------------*/
