
/*-----DeleteTestFromPanel---------------------------------------------------*/
  -----DESCRIPTION-----
    --This set of queries can be used to inspect and remove associations of 
    --tests with panels
  ----- -----


  -----HISTORY-----
    --20180430 JTY: Created Scripts
  ----- -----

/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
  --- See if there are any active samples associated with the test of interest---
    SELECT DISTINCT
      f.external_id,
      t.testno,
      '~' AS eol
    FROM folders f
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN tests t ON (ot.testcode = t.testcode)
    WHERE 1=1
      AND  f.apprdate IS NULL
      AND t.testno = '&TestName';
  --- ---


  ---Identify panels associated with test of interest---
    SELECT DISTINCT
      ctt.testgroupname,
      ctt.origrec AS ctt_origrec,
      (t.testno || '(' || t.testcode || ')') AS test_name_n_code,
      '~' AS eol
    FROM conditiontesttriggers ctt
      INNER JOIN tests t ON (ctt.testcode = t.testcode)
    WHERE 1=1
      AND t.testno = '&TestName'
    ORDER BY
      test_name_n_code ASC,
      ctt.testgroupname ASC;
  --- ---

  ---Delete Test associateion with Panel---  
    DELETE
    FROM conditiontesttriggers ctt
    WHERE 1=1
      AND ctt.origrec = '&ctt_origrec'
  --- ---
/*---------------------------------------------------------------------------*/
