

/*---------------------------------------------------------------------------*/
/*-----MicroComponents_Cleanup-----------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Scripts here are for Cleanup and removal of identified micro components.
  /*----- -----*/
  
  /*-----Limitations/Assumptions-----*/
    --TBD
  /*----- -----*/


  /*-----Scripts-----*/
    --01. Delete MicroComponents Responses associated with MicroComponent
    --02. Delete MicroComponents QC associated with MicroComponent
    --03. Delete MicroComponents Reagents associated with MicroComponent
    --04. Delete MicroComponents Reagents associated with MicroComponent

    --01. Disassociate MC with Micro Panel(s)
    --02. Disassociate Empty Panels from Conditions
    --03. Identify and delete any PanelConditions with no Panels
    --04. Identify and delete any empty panels

    
    

  /*----- -----*/

  /*-----HISTORY-----*/
    --2017.07.17 JTY: Created Srcipt
  /*----- -----*/

/*---------------------------------------------------------------------------*/



/*
-------01. Delete MicroComponents Responses associated with MicroComponent-----
  DELETE
    FROM &Environment.microcompresponse mcr
    WHERE 1=1
        AND mcr.comptype = '&ComponentType'
        AND mcr.compid = '&ComponentID';
-------------------------------------------------------------------------------


-------02. Delete MicroComponents QC associated with MicroComponent------------
  DELETE
    FROM &Environment.microqccontrols mqc
    WHERE 1=1
        AND mqc.comptype = '&ComponentType'
        AND mqc.compid = '&ComponentID';
-------------------------------------------------------------------------------

-------03. Delete MicroComponents Reagents associated with MicroComponent-----
  --SELECT DISTINCT * FROM sundata_prod.microcompreagents mcr
  DELETE
    FROM &Environment.microcompreagents mcr
    WHERE 1=1
        AND mcr.comptype = '&ComponentType'
        AND mcr.compid = '&ComponentID';
-------------------------------------------------------------------------------

-------04. Delete MicroComponents Reagents associated with MicroComponent-----
  --SELECT DISTINCT * FROM sundata_prod.microcomploinc mcl
  DELETE
    FROM &Environment.microcomploinc mcl
    WHERE 1=1
        AND mcl.comptype = '&ComponentType'
        AND mcl.compid = '&ComponentID';
-------------------------------------------------------------------------------
*/




/*-----01. Disassociate MC with Micro Panel(s)-------------------------------*/

  ---Identify potential changes---
    SELECT DISTINCT
      mpc.comptype,
      mpc.compid,
      mpc.panelid,
      '~' AS eol
    FROM &Environment.micropanelcomp mpc
    WHERE 1=1
      AND mpc.comptype = '&ComponentType'
  --    AND mpc.compid = '&ComponentID'
      AND mpc.compid IN (
        'VZ IFA',
        'RSV FA'
      )    
    ORDER BY
      mpc.comptype ASC,
      mpc.compid ASC;
   --- ---
   
   
  ---Remove association of MC with MicroPanels---
/*  
    DELETE
    FROM &Environment.micropanelcomp mpc
    WHERE 1=1
      AND mpc.comptype = '&ComponentType'
  --    AND mpc.compid = '&ComponentID'
      AND mpc.compid IN (
        'VZ IFA',
        'RSV FA'
      );
*/    
   --- ---
   
/*---------------------------------------------------------------------------*/





/*-----02. Disassociate Empty Panels from Conditions--------------------------*/

  ---Identify potential changes---
    SELECT DISTINCT
      pcd.condition,
      p.comptype,
      p.panelid,
      '~' AS eol
    FROM &Environment.micropanelconditions pcd
      INNER JOIN &Environment.micropanels p ON (pcd.panelid = p.panelid)
      LEFT OUTER JOIN sundata_prod.micropanelcomp pcp ON (1=1
        AND p.panelid = pcp.panelid
        AND p.comptype = pcp.comptype)
    WHERE 1=1
      AND pcp.comptype = '&ComponentType'
      AND pcp.compid IS NULL
    ORDER BY
      pcd.condition ASC,
      p.comptype ASC,
      p.panelid ASC;
   --- ---
   
   
  ---Remove association of MC with MicroPanels---
/*  
    DELETE
    FROM &Environment.micropanels mp
    WHERE 1=1
      AND mp.panelid IN (
        SELECT DISTINCT
          mp.panelid
        FROM &Environment.micropanels mp
          LEFT OUTER JOIN &Environment.micropanelcomp mpc ON (mp.panelid = mpc.panelid)
        WHERE 1=1
          AND mpc.comptype = '&ComponentType'
          AND mpc.compid IS NULL      
      )
*/    
   --- ---
   
/*---------------------------------------------------------------------------*/





/*-----03. Identify and delete any PanelConditions with no Panels------------*/
  ---Identify potential changes---
    SELECT DISTINCT
      mpc.condition,
      mpc.comptype,
      mpc.panelid,
      '~' AS eol
    FROM &Environment.microconditions mc
      LEFT OUTER JOIN &Environment.micropanelconditions mpc ON (mc.condition = mpc.condition)
    WHERE 1=1
      AND mpc.comptype = '&ComponentType'
      AND mpc.panelid IS NULL
    ORDER BY
      mpc.condition ASC,
      mpc.comptype ASC,
      mpc.panelid ASC;
   --- ---
 

  ---Remove association of MC with MicroPanels---
/*  
    DELETE
    FROM &Environment.microconditions mc
    WHERE 1=1
      AND mc.condition IN (
        SELECT DISTINCT
          mpc.condition
        FROM &Environment.microconditions mc
          LEFT OUTER JOIN &Environment.micropanelconditions mpc ON (mc.condition = mpc.condition)
        WHERE 1=1
          AND mpc.comptype = '&ComponentType'
          AND mpc.panelid IS NULL
      )
*/    
   --- ---
/*---------------------------------------------------------------------------*/







/*-----04. Identify and delete any empty panels------------------------------*/
  ---Identify potential changes---
    SELECT DISTINCT
      mp.comptype,
      mp.panelid,
      mpc.compid,
      '~' AS eol
    FROM &Environment.micropanels mp
      LEFT OUTER JOIN &Environment.micropanelcomp mpc ON (mp.panelid = mpc.panelid)
    WHERE 1=1
      AND mpc.comptype = '&ComponentType'
      AND mpc.compid IS NULL
    ORDER BY
      mp.comptype ASC,
      mp.panelid ASC,
      mpc.compid ASC;
   --- ---
   
   
  ---Remove association of MC with MicroPanels---
/*  
    DELETE
    FROM &Environment.micropanels mp
    WHERE 1=1
      AND mp.panelid IN (
        SELECT DISTINCT
          mp.panelid
        FROM &Environment.micropanels mp
          LEFT OUTER JOIN &Environment.micropanelcomp mpc ON (mp.panelid = mpc.panelid)
        WHERE 1=1
          AND mpc.comptype = '&ComponentType'
          AND mpc.compid IS NULL      
      )
*/    
   --- ---
/*---------------------------------------------------------------------------*/
















