

/*-----TestRetirementScripts-------------------------------------------------*/
  ---DESCRIPTION---
    --This Set of scripts can be executed to retire a given test in addition
    --removing it from any Active panels the test is assocaited with so it
    --will no longer be avaliable for selections for samples going forward.
  --- ---
  
  ---HISTORY---
    --2018.05.29 jty: Begin Scripts Creationg
  --- ---

/*---------------------------------------------------------------------------*/

/*-----01. Review----------------*/

  ---01a. Identify Active Samples in System Impacted by This---

    --This is just for your review, and so you can notify the section supervisors
    --of these samples so they can clean them up if they were lost in STARLiMS
    --some point in the past.
    SELECT DISTINCT
      f.dept,
      mr.field_varchar_80 AS activity_type,
      cr.rasclientid,
      cr.external_id,
      cr.date_received,
      f.testgroupname AS panel,
      (t.testno || '(' || t.testcode || ')') AS test_name,
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN metadata_repository mr ON ( 1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
      )
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN tests t ON (ot.testcode = t.testcode)
    WHERE 1=1
      AND f.apprdate IS NULL
      AND t.testno IN (&TestNameList)
    ORDER BY
      f.dept ASC,
      activity_type ASC,
      cr.rasclientid ASC,
      cr.external_id ASC;
  --- ---
  ---01b. Identify Active Panels Associated with tests---
    SELECT DISTINCT
      --Main DataGrid--
        (t.testno || '(' ||       ctt.testcode || ')') AS the_test,
        t.testcatcode AS test_library,
        ctt.method,
        sp.progname AS usage,
        ctt.dept,
        tgn.testgroupname AS panel,
        tgn.status AS panel_status,
      '~' AS eol
    FROM testgroupnames tgn  
      INNER JOIN sample_programs sp ON (tgn.sp_code = sp.sp_code)
      INNER JOIN testgroupsynonims syn ON (tgn.testgroupname = syn.testgroupname)
      INNER JOIN conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
      INNER JOIN tests t ON (ctt.testcode = t.testcode)
      INNER JOIN conditiontestanalytes cta ON (
        ctt.dept = cta.dept
        AND ctt.testcode = cta.testcode
        AND ctt.testgroupname = cta.testgroupname
        AND ctt.method = cta.method)
      LEFT OUTER JOIN Testgroupquestions tgq ON (tgn.testgroupname = tgq.testgroupname)
      INNER JOIN Testgroup_Users tgu ON (tgn.testgroupname = tgu.testgroupname) 
    WHERE 1=1
      AND (t.testcatcode <> 'Retired' OR tgn.status <> 'Retired')
      AND t.testno IN (&TestNameList)
    ORDER BY 
        the_test ASC,
        sp.progname ASC,
        ctt.dept ASC,
        tgn.testgroupname ASC;
  --- ---
/*---------------------------------------------------------------------------*/






/*-----02. Retire Test-------------------------------------------------------*/
  --Set the identified Test (by name) to the Retired category
/*  
    UPDATE tests t
    SET t.testcatcode = 'Retired'
    WHERE 1=1
      AND t.testno IN (&TestNameList)
*/
/*---------------------------------------------------------------------------*/
   




/*---------------------------------------------------------------------------*/
/*---03. Forceably Remove retired test from Active panels--------------------*/
/*
  DELETE FROM conditiontesttriggers ctt
  WHERE 1=1
    AND ctt.origrec IN (
      SELECT DISTINCT
        ctt.origrec AS ctt_origrec
      FROM  tests t
        INNER JOIN conditiontesttriggers ctt ON (t.testcode = ctt.testcode)
        INNER JOIN testgroupnames tgn ON (ctt.testgroupname = tgn.testgroupname)
      WHERE 1=1
        AND tgn.status = 'Active'
        AND t.testcatcode = 'Retired'
    )
*/  
/*---------------------------------------------------------------------------*/
