/*-----User Delete------------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Utilize this set of queries to determine if you can delete a user and
    --then delete the user from the database.
  /*----- -----*/
  
  /*----- -----*/
    --You  may want to execute the Test file 'FindColumnValue.tst' with values of:
      --FieldDataType = VARCHAR2
      --FieldDataLength = 15
      --FieldSearchValue = {USERNAM}
    --to verify all tables have been identified, and then after script run that
    --all tables have been purged.
  /*----- -----*/
  
  /*-----HISTORY-----*/
    --2016.05.20 JTY: Created Script
  /*----- -----*/
/*---------------------------------------------------------------------------*/



/*-----01. Make sure user has no critical records associated with them-------*/
  --We need to make sure this is basically a read-only user where there is
  --no Audit trail, Data Entry associated with them.
  --Run this query to verify that.  If any records are returned, it is
  --recomended that you DO NOT delete this user from the database.

  /*-----Check if user is cannidate for removal-----*/
    --Check UserStatus
    SELECT DISTINCT a.usrnam , 'DO NOT DELETE USER' as message 
      FROM  &Environment.Users a 
      WHERE 1=1
        AND a.status = 'Active'
        AND UPPER(a.usrnam) = UPPER('&UserNam');

    --Check Folders
    SELECT DISTINCT UPPER('&UserNam'), 'DO NOT DELETE USER' as message 
      FROM  &Environment.Folders a 
      WHERE 1=1
        AND (
          UPPER(a.approvedby) = UPPER('&UserNam')
          OR
          UPPER(a.createdby) = UPPER('&UserNam')
          OR
          UPPER(a.receivedby) = UPPER('&UserNam')
        );
    --Check FlowEventLog
    SELECT DISTINCT UPPER('&UserNam') , 'DO NOT DELETE USER' as message 
      FROM  &Environment.floweventlog a 
      WHERE UPPER(a.usrnam) = UPPER('&UserNam');
    --Check ChainOfCustody
    SELECT DISTINCT UPPER('&UserNam') , 'DO NOT DELETE USER' as message 
      FROM  &Environment.ChainOfCustody a 
      WHERE UPPER(a.custodian) = UPPER('&UserNam');
    --Check res_attachments
    SELECT DISTINCT UPPER('&UserNam') , 'DO NOT DELETE USER' as message 
      FROM  &Environment.res_attachments a 
      WHERE UPPER(a.attby) = UPPER('&UserNam');
    --Check rr_report_delivery_queue
    SELECT DISTINCT UPPER('&UserNam') , 'DO NOT DELETE USER' as message 
      FROM  &Environment.rr_report_delivery_queue a 
      WHERE UPPER(a.usrnam) = UPPER('&UserNam');
    --Check CentralReceiving
    SELECT DISTINCT a.usrnam , 'DO NOT DELETE USER' as message 
      FROM  &Environment.centralreceiving a 
      WHERE UPPER(a.usrnam) = UPPER('&UserNam');
    --Check Runs
    SELECT DISTINCT a.usrnam , 'DO NOT DELETE USER' as message 
      FROM  &Environment.runs a 
      WHERE (UPPER(a.usrnam) = UPPER('&UserNam'));
    --Check OrdTask
    SELECT DISTINCT a.usrnam , 'DO NOT DELETE USER' as message 
      FROM  &Environment.ordtask a 
      WHERE UPPER(a.usrnam) = UPPER('&UserNam');
    --Check Communications Log
    SELECT DISTINCT a.logged_by , 'DO NOT DELETE USER' as message 
      FROM  &Environment.communication_log a 
      WHERE UPPER(a.logged_by) = UPPER('&UserNam');
    --Check Method Certifications
    SELECT DISTINCT a.usrnam , 'DO NOT DELETE USER' as message 
      FROM  &Environment.methodcert a 
      WHERE UPPER(a.usrnam) = UPPER('&UserNam');
    --Check Equipment Maintenence
    SELECT DISTINCT a.openedby , 'DO NOT DELETE USER' as message 
      FROM  &Environment.maintenance a 
      WHERE UPPER(a.openedby) = UPPER('&UserNam');
  /*----- -----*/  
  
/*---------------------------------------------------------------------------*/




/*-----02. Perform Removal---------------------------------------------------*/
  --Run these script to remove the user from the database
/*
  -----UserPassword History-----
    --SELECT DISTINCT a.* FROM &Environment.hist_pw a WHERE UPPER(a.usrnam) = UPPER('&UserNam')
    DELETE 
    FROM &Environment.hist_pw a
    WHERE 1=1
      AND UPPER(a.usrnam) = UPPER('&UserNam');
  ----- -----
  -----RASClientContacts-----
    --SELECT DISTINCT a.* FROM &Environment.rasclientcontacts a WHERE UPPER(a.usrnam) = UPPER('&UserNam')
    DELETE 
    FROM &Environment.rasclientcontacts a
    WHERE 1=1
      AND UPPER(a.usrnam) = UPPER('&UserNam');
  ----- -----
  -----UserRoles-----
    --SELECT DISTINCT a.* FROM &Environment.UserRoles a WHERE UPPER(a.usrnam) = UPPER('&UserNam')
    DELETE 
    FROM &Environment.UserRoles a
    WHERE 1=1
      AND UPPER(a.usrnam) = UPPER('&UserNam');
  ----- -----  
  -----UserQuestions_Answers-----
    --SELECT DISTINCT a.* FROM &Environment.user_questions_answers a WHERE UPPER(a.usrnam) = UPPER('&UserNam')
    DELETE 
    FROM &Environment.user_questions_answers a
    WHERE 1=1
      AND UPPER(a.usrnam) = UPPER('&UserNam');
  ----- ----- 
  -----UserQuestions_Answers-----
    --SELECT DISTINCT a.* FROM &Environment.users a WHERE UPPER(a.usrnam) = UPPER('&UserNam')
    DELETE 
    FROM &Environment.users a
    WHERE 1=1
      AND UPPER(a.usrnam) = UPPER('&UserNam')
  ----- -----
*/
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
  /*----- -----*/
  /*----- -----*/
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
  /*----- -----*/
  /*----- -----*/
/*---------------------------------------------------------------------------*/
