

----------ReportDeliveryQueue Review----------
  SELECT
    rdq.dept,
    rdq.external_id,
    (rc.compname || ' (' || rc.rasclientid || ')') AS client_name,
    rdq.folderno,
    rdq.status,
    rdq.apprsts,
    rdq.reporttype,
    rdq.delivery_method,
    rdq.delivery_method,
    rdq.batch_id,
    rdq.queue_item_no,
    rdq.apprdate,
    rdq.stardoc_id,
    rdq.notes,
    rdq.receipt_number,
    '~' AS sp1,
    fq.*,
    '~' AS eol
  FROM rr_report_delivery_queue rdq
    INNER JOIN centralreceiving cr ON (rdq.external_id = cr.external_id)
    INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
    LEFT OUTER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
  WHERE 1=1
    AND rdq.external_id IN (&ExternalIDList)
  ORDER BY
    rdq.dept ASC,
    rdq.external_id ASC,
    rdq.folderno ASC;
---------- ----------


----------Clean RDQ for identified Date Range----------
/*
  UPDATE faxqueue fq
  SET
    fq.crtmessage = 'Manual Cancel by SQL Script',
    fq.statusname = 'fsDoneOK',
    fq.senddate = to_date('&RepairDate', 'DD-MON-YY')
  WHERE 1=1
    AND fq.origrec IN (
    
    
            SELECT DISTINCT
              fq.origrec
            FROM rr_report_delivery_queue rdq
              LEFT OUTER JOIN rr_rdq_history rdh ON (1=1
                AND rdq.receipt_number = rdh.receipt_number
                AND rdq.queue_item_no = rdh.queue_item_no)
              INNER JOIN rasclients rc ON (rdq.rasclientid = rc.rasclientid)
              INNER JOIN folderscontactsext fcx ON (1=1
                AND rdq.rasclientid = fcx.rasclientid
                AND rdq.contactid = fcx.contactid)
              LEFT OUTER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
              INNER JOIN folders f ON (rdq.folderno = f.folderno)
              INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
            WHERE 1=1
              AND rdq.rasclientid IN (&ClientList)
              AND (
                  TRUNC(rdh.sent_date) BETWEEN 
                    TO_DATE('&StartDate', 'DD-MON-YY') 
                    AND TO_DATE('&EndDate', 'DD-MON-YY')
                   )
              AND fq.tofax IS NOT NULL
              AND rdq.status = 'PROCESSED'
              AND (
                  upper(fq.crtmessage) LIKE '%ERROR%' OR
                  fq.senddate IS NULL
                  )
    
    )
*/    
---------- ----------

----------UPDATE RDQ status flag----------
/*
  UPDATE rr_report_delivery_queue rdq
  SET rdq.status = 'PROCESSED'
  WHERE 1=1
    AND rdq.origrec IN (
      SELECT
        rdq.origrec
      FROM rr_report_delivery_queue rdq
        LEFT OUTER JOIN rr_rdq_history rdh ON (1=1
          AND rdq.batch_id = rdh.batch_id
          AND rdq.queue_item_no = rdh.queue_item_no)
      WHERE 1=1
        AND rdq.dept = 'PHX-VIR'
        AND rdq.status = 'ERROR'
    );
*/    
---------- ----------


----------PROCESS_DirectFax SQL----------
  --This is the core Script for the Process_DirectFax SQL.
/*  
      SELECT DISTINCT      
        rdq.dept,
        rdq.folderno,
        rc.compname || '(' || rc.rasclientid || ')' AS client,
        rdq.testgroupname AS panel,
        rdq.queue_item_no,      
        rdh.sent_by AS appr_by,
        to_char(rdh.sent_date, 'YYYY.MM.DD')  || '  ' || rdh.sent_time AS approved_dt,
        to_char(fq.senddate, 'YYYY.MM.DD')  || '  ' || fq.sendtime AS faxed_dt,
        fq.tofax,      
        fq.crtmessage,
        rdq.stardoc_id,
        fq.receipt,
        fq.origrec AS fq_origrec,
        rdh.origrec AS rdh_origrec,
        rdq.origrec AS rdq_origrec,
        '~' AS eol
      FROM rr_report_delivery_queue rdq
        LEFT OUTER JOIN rr_rdq_history rdh ON (1=1
          AND rdq.receipt_number = rdh.receipt_number
          AND rdq.queue_item_no = rdh.queue_item_no)
        INNER JOIN rasclients rc ON (rdq.rasclientid = rc.rasclientid)
        INNER JOIN folderscontactsext fcx ON (1=1
          AND rdq.rasclientid = fcx.rasclientid
          AND rdq.contactid = fcx.contactid)
        LEFT OUTER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
        INNER JOIN folders f ON (rdq.folderno = f.folderno)
        INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      WHERE 1=1
        AND rdq.rasclientid IN (&ClientList)
        AND (
            TRUNC(rdh.sent_date) BETWEEN 
              TO_DATE('&StartDate', 'DD-MON-YY') 
              AND TO_DATE('0&EndDate', 'DD-MON-YY')
             )
        AND fq.tofax IS NOT NULL
        AND rdq.status = 'PROCESSED'
        AND (
            upper(fq.crtmessage) LIKE '%ERROR%' OR
            fq.senddate IS NULL
            )
      ORDER BY
        rdq.dept ASC,
        client ASC,
        rdq.folderno ASC,
        approved_dt ASC;
*/     
---------- ----------
