/*-----Rhapsody File Paths Reivew-------------------------------------*/
  -----DESCRIPTION-----
    --Run this set of scripts to identify the various paths in STARLiMS
    --for Rhapsody targeted directories.
  ----- -----
    
  -----HISTORY-----
    --2019.08.09 JTY: Create Script
  ----- -----
/*--------------------------------------------------------------------*/





/*--------------------------------------------------------------------*/
  -----LRN-B, MEDSIS-----
    SELECT
      rc.rasclientid,
      'HL7 Clients Manager' As application,
      mt.ior_xml_path,
      mt.origrec AS mt_origrec,
      '~' AS eol
    FROM rasclients rc
    INNER JOIN rasclientmessagetypes mt ON (rc.rasclientid = mt.rasclientid)
    WHERE 1=1
      AND mt.ior_xml_path IS NOT NULL
    ORDER BY
      rc.rasclientid ASC;
  -----PHLIP-----
    SELECT
      rc.rasclientid,
      'Ras Client' As application,
      rc.dev_outbound_results,
      rc.origrec AS rc_origrec,
      '~' AS eol
    FROM rasclients rc
    WHERE 1=1
      AND rc.dev_outbound_results IS NOT NULL
    ORDER BY
      rc.rasclientid ASC;  
  ----- -----
  ----- -----
/*--------------------------------------------------------------------*/


/*--------------------------------------------------------------------*/
  --Identify test associated with a reporting program

  WITH
    -----ActiveTests-----
      ActiveTests AS (
        SELECT DISTINCT
          t.testcatcode,        
          ctt.dept,
          (t.testno || ' (' || t.testcode || ')') AS test_name,
          t.testflag AS test_type,
          t.testcode,
          '~' AS eol
        FROM tests t
          INNER JOIN conditiontesttriggers ctt ON (t.testcode = ctt.testcode)
          INNER JOIN sp_tests sp ON (ctt.testcode = sp.testcode AND sp.active = 'A')
          
        WHERE 1=1
          AND t.testcatcode IN (
          'Bacteriology', 'BioTerrorism', 'Clinical',
          'Environmental', 'Food/Miscellaneous', 'Mycobacteriology',
          'Parasitology', 'Serology', 'Virology')
       ORDER BY
         t.testcatcode ASC,
         ctt.dept ASC,
         test_name ASC
      ),
    ----- -----
    
    -----PhlipFlu-----
      PhlipFlu AS (
        SELECT DISTINCT
          'PHLIP' AS program,
          act.testcatcode,        
          act.dept,
          act.test_name,
          act.test_type,
          act.testcode,
          act.eol
        FROM ActiveTests act
          INNER JOIN hl7_dist_loincs dl ON (act.testcode = dl.testcode)        
        WHERE 1=1
        ORDER BY
          act.testcode ASC
      ),
    ----- -----   
    
    -----LrnB-----
      LrnB AS (
        SELECT DISTINCT
          'LRN-B' AS program,
          act.testcatcode,        
          act.dept,
          act.test_name,
          act.test_type,
          act.testcode,
          act.eol
        FROM ActiveTests act
          INNER JOIN hl7_analytes ha ON (1=1
            AND act.testcode = ha.testcode
            AND ha.rasclientid = 'CDC')
        WHERE 1=1
        ORDER BY
          act.testcode ASC
      ),
    ----- -----
    
    -----MEDSIS-----
      Medsis AS (
        SELECT DISTINCT
          'MEDSIS' AS program,
          act.testcatcode,        
          act.dept,
          act.test_name,
          act.test_type,
          act.testcode,
          act.eol
        FROM ActiveTests act
          INNER JOIN hl7_analytes ha ON (1=1
            AND act.testcode = ha.testcode
            AND ha.rasclientid = 'MEDSIS')
        WHERE 1=1
        ORDER BY
          act.testcode ASC
      ),
    ----- -----
    -----MEDSIS-TEST-----
      MedsisTest AS (
        SELECT DISTINCT
          'MEDSIS-TEST' AS program,
          act.testcatcode,        
          act.dept,
          act.test_name,
          act.test_type,
          act.testcode,
          act.eol
        FROM ActiveTests act
          INNER JOIN hl7_analytes ha ON (1=1
            AND act.testcode = ha.testcode
            AND ha.rasclientid = 'MEDSIS')
        WHERE 1=1
        ORDER BY
          act.testcode ASC
      ),
    ----- -----
    -----NoProgram-----
      NoProgram AS (
        SELECT DISTINCT
          '-None-' AS program,
          act.testcatcode,        
          act.dept,
          act.test_name,
          act.test_type,
          act.testcode,
          act.eol
        FROM ActiveTests act
          LEFT OUTER JOIN PhlipFlu pf ON (act.testcode = pf.testcode)
          LEFT OUTER JOIN LrnB lb  ON (act.testcode = lb.testcode)
          LEFT OUTER JOIN Medsis md ON (act.testcode = md.testcode)
          LEFT OUTER JOIN MedsisTest mt ON (act.testcode = mt.testcode)          
        WHERE 1=1
          AND ( 1=1
          AND pf.testcode IS NULL 
          AND lb.testcode IS NULL
          AND md.testcode IS NULL
          AND mt.testcode IS NULL
          )
        ORDER BY
          act.testcode ASC
      ),
    ----- -----    

    -----UnionTables-----
      UnionTables AS (
        (SELECT * FROM PhlipFlu)
        UNION  (SELECT * FROM LrnB)
        UNION  (SELECT * FROM Medsis)
        UNION  (SELECT * FROM MedsisTest)
        UNION  (SELECT * FROM NoProgram)
      )
    ----- -----
    -----FinalQuery-----
      SELECT DISTINCT
        ut.program,
        ut.testcatcode,        
        ut.dept,
        ut.test_name,
        ut.test_type,
        ut.testcode,
        ut.eol
       FROM UnionTables ut
       WHERE 1=1
         AND ut.program <> '-None-'
       ORDER BY
        ut.program ASC,
        ut.testcatcode ASC,        
        ut.dept ASC,
        ut.test_name ASC,
        ut.test_type,
        ut.testcode,
        ut.eol
      ----- -----
/*--------------------------------------------------------------------*/
