/*-----Test Configuration Documentation--------------------------------------*/
/*---------------------------------------------------------------------------*/



/*-----01 Panel Information--------------------------------------------------*/
  --PANELS FOR CLINICAL LOGIN Application
  ---Referenced Tables---
/*  
    SELECT * FROM tests t;
    SELECT * FROM conditiontesttriggers ctt;
    SELECT * FROM testgroupnames tgn;
    SELECT * from sp_tests sp;
    SELECT * FROM sample_programs;    
*/
  --- ---
  
  -----Panel Properties-----   
    SELECT DISTINCT
      tgn.testgroupname AS panel_name,
      sp.progname AS "USAGE",
      tgn.status,
      tgn.default_usage AS "DEFAULT",
      tgn.generic,
      tgn.questionformid AS question_id,
      tgn.icd9_code,
      tgn.sample_category,
      '~' AS sp_1,
      tgn.lrn_program,
      tgn.a_c_runtogether,
      tgn.a_c_approvetogether,
      tgn.test_repeats,
      tgn.autorelease,
      tgn.metadatamethodcode,
      '~' AS eol
    FROM tests t
      INNER JOIN conditiontesttriggers ctt ON (t.testcode = ctt.testcode)
      INNER JOIN testgroupnames tgn ON (ctt.testgroupname = tgn.testgroupname)
      INNER JOIN sample_programs sp ON (tgn.sp_code = sp.sp_code)
    WHERE 1=1
      --AND tgn.testgroupname IN (&PanelList)
      AND t.testno IN (&TestNameList)
    ORDER BY
      tgn.testgroupname ASC;    
  ----- -----

  -----Panel Tests-----
  ----- -----
  
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/







      /*-----Reportable LOINC Codes datagrid-----*/
        SELECT
          ctt.testgroupname AS panel,
          hm.header_name AS mapping_name,
          rc.rasclientid,
          t.testno,
          hl.analyte,
          hl.loincnumber,
          hl.value_type,
          hl.reportable_condition,
          Coalesce(hl.reportsection, '') AS reportsection,
          '~' AS eol
        FROM tests t
          INNER JOIN conditiontesttriggers ctt ON (t.testcode = ctt.testcode)
          LEFT OUTER JOIN hl7_dist_messages hm ON (ctt.testgroupname = hm.testgroupname)
          LEFT OUTER JOIN hl7_dist_submitters hs ON (ctt.testgroupname = hs.testgroupname)
          INNER JOIN rasclients rc ON (hs.rasclientid = rc.rasclientid)
          LEFT OUTER JOIN hl7_dist_loincs hl ON (1=1
            AND ctt.testgroupname = hl.testgroupname
            AND t.testcode = hl.testcode
            AND hm.header_name = hl.header_name)
        WHERE 1=1
          AND t.testno IN (
  --          'Influenza PCR',
  --          'FilmArray Respiratory Panel 2',
  --          '2019 Novel Coronavirus rRT-PCR',
--            'TaqPath COVID-19 rRT-PCR',
            'Xpert Xpress SARS CoV 2',
  --          'BGI SARS-2019-nCoV RT-PCR',
            '')  
        ORDER BY
          ctt.testgroupname ASC,
          hm.header_name ASC,
          rc.rasclientid ASC,
          t.testno ASC,
          hl.analyte ASC;
      /*----- -----*/      
