
/*-----ClientReportDeliveryUpdate--------------------------------------------*/
  --This is a set of queries related to the DirectFax Project.  The following
  --queries have been developed:
    --20. Identify Active Samples for identified Client
    --31. Udate Delivery Method for Existing Samples
    --31. Report Delivery Queue Update
/*---------------------------------------------------------------------------*/





/*---Hard Delivery Method Update---------------------------------------------*/
  --Currently STARLiMS doesn't like updating delivery methods for many clients
  --These set of scripts will force the update through the database
  --Valid Submitter Methods | E-mail | Fax | Hard Copy | 
  /*-----1. Review current delivery option-----*/
/*  
    SELECT DISTINCT
      rc.compname,
      rc.rasclientid,
      --cr.external_id,      
      rcx.fullname,
      rcx.sendcoa,
      rcx.submit_method,
      rcx.fax,
      rcx.email,
      rc.url AS pdf_password,
      rc.origrec AS rc_origrec,
      rcx.origrec AS rcx_origrec,
      '~' AS eol
    FROM rasclients rc
      INNER JOIN rasclientcontactsext rcx ON (rc.rasclientid = rcx.rasclientid)
      LEFT OUTER JOIN centralreceiving cr ON (rc.rasclientid = cr.rasclientid)
    WHERE 1=1
      AND rc.status = 'Active'
      AND rcx.sendcoa = 'Y'
        AND rcx.fullname = 'Laboratory Results'
      ---Search Parameters---
        AND rc.rasclientid = 'AANG'
--        AND cr.external_id = 'AZ00101488'
--        AND rcx.submit_method IN ('E-mail','Fax','Hard Copy')
      ---
    ORDER BY
      rc.compname ASC
      ,rcx.fullname ASC
      --,cr.external_id DESC
      ;
*/      
  /*----- -----*/

  /*-----2. Force Update-----*/
/*  
    UPDATE rasclientcontactsext rcx
    SET rcx.submit_method = 'E-mail'
    WHERE rcx.origrec = '48056'
*/    
  /*----- -----*/
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*-----10. Check Client by Sample ID-----------------------------------------*/
/*
  SELECT DISTINCT
    rc.rasclientid,
    rc.compname  
  FROM sundata_prod.folders f
    INNER JOIN sundata_prod.rasclients  rc ON (f.rasclientid = rc.rasclientid)
  WHERE 1=1
    AND f.external_id = '&SampleID';
*/    
/*---------------------------------------------------------------------------*/

/*-----20. Identify Active Samples for identified Client----------------------*/
  --Identify active samples for identified client(s) if you want to switch them
  --to Fax delivery.

    SELECT DISTINCT
      rc.compname || '(' || rc.rasclientid || ')' AS client,
      f.folderno,
      f.dept,
      f.testgroupname AS panel,
      fcx.submit_method,
      rcx.email,
      rcx.fax,
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      INNER JOIN rasclients rc ON (cr.rasclientid = rc. rasclientid)
      INNER JOIN rasclientcontactsext rcx ON (rc.rasclientid = rcx.rasclientid)
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN folderscontactsext fcx ON (f.folderno = fcx.folderno)
    WHERE 1=1
      AND UPPER(f.testgroupname) NOT LIKE '%SENDOUT%'
      AND UPPER(f.testgroupname) NOT LIKE '%PFGE%'
      AND mr.field_varchar_80 IN ('LRN-B', 'Diagnostic')
      AND rc.rasclientid = '&RasClientID'  ---CLIENT(s) OF INTEREST HERE---
      AND (f.apprdate IS NULL OR fc.approveddate IS NULL)
    ORDER BY
      client ASC,
      f.dept ASC,
      f.folderno ASC          

/*---------------------------------------------------------------------------*/


/*-----30. Udate Delivery Method for Existing Samples-------------------------*/
  --Update delivery method for active samples in system to match the Exetrnal
  --Contact as defined in the Client List application.  This should be used when
  --a Client has just converted over to a new delivery method, and you want to sync
  --existing samples in the system with this new method.  
  --
/*
  MERGE INTO folderscontactsext t1
  USING (
    SELECT DISTINCT
      rc.compname || '(' || rc.rasclientid || ')' AS client,
      f.dept,
      fcx.folderno,
      f.testgroupname AS panel,
      fcx.contactid,
      fcx.submit_method,
      rcx.submit_method AS rcx_submit_method,
      rcx.fax AS rcx_fax,
      fcx.rasclientid,
      fcx.origrec AS fcx_origrec,
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN rasclients rc ON (cr.rasclientid = rc. rasclientid)
      INNER JOIN rasclientcontactsext rcx ON (rc.rasclientid = rcx.rasclientid)
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN folderscontactsext fcx ON (1=1
        AND fcx.folderno = f.folderno
        AND fcx.rasclientid = rcx.rasclientid
        AND fcx.contactid = rcx.contactid)
    WHERE 1=1
      AND (rcx.submit_method <> fcx.submit_method)
      AND rc.rasclientid = '&RasClientID'  ---CLIENT(s) OF INTEREST HERE---
      AND (f.apprdate IS NULL OR fc.approveddate IS NULL)
      AND UPPER(f.testgroupname) NOT LIKE '%SENDOUT%'
      AND UPPER(f.testgroupname) NOT LIKE '%PFGE%'
    ORDER BY
      client ASC,
      f.dept ASC,
      fcx.folderno ASC  
  ) t2
  ON (1=1
    AND t1.origrec = t2.fcx_origrec
    AND t1.folderno = t2.folderno 
    AND t1.rasclientid = t2.rasclientid
    AND t1.contactid = t2.contactid
  )    
  WHEN MATCHED THEN
    UPDATE SET
      t1.submit_method = rcx_submit_method;
*/
/*---------------------------------------------------------------------------*/





/*-----31. Report Delivery Queue Update--------------------------------------*/
  --Update RDQ to utlize Delivery method as defined by the ExternalContact
  --info in the Client List application for the identified Client.
  --This can also be used if the Fax number has changed, as defined for the
  --external client in the Client List application, and you want to 
  --sinc existing samples with the new number.
/*  
  MERGE INTO rr_report_delivery_queue t1
  USING (
    SELECT DISTINCT
      (rc.compname || ' (' || rc.rasclientid || ')') AS client,
      f.dept,
      rdq.folderno,
      rdq.status,
      rcx.fullname,
      rcx.contactid,
      rcx.submit_method AS rcx_method,
      rcx.fax AS rcx_address,
      rdq.delivery_method,
      rdq.delivery_address,
      rdq.origrec AS rdq_origrec,
      rc.rasclientid,
      '~' AS eol
    FROM rr_report_delivery_queue rdq
      INNER JOIN folders f ON (rdq.folderno = f.folderno)
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN rasclientcontactsext rcx ON (1=1
        AND rdq.rasclientid = rcx.rasclientid
        AND rdq.contactid = rcx.contactid)
    WHERE 1=1
      AND UPPER(f.testgroupname) NOT LIKE '%SENDOUT%'
      AND UPPER(f.testgroupname) NOT LIKE '%PFGE%'
      AND (
        (rdq.delivery_method <> rcx.submit_method )
        OR (rdq.delivery_address <> rcx.fax )
      )
      AND rdq.status = 'QUEUED'
      AND rdq.rasclientid = '&RasClientID'
    ORDER BY
      client ASC,
      f.dept ASC,
      rdq.folderno ASC
  ) t2
  ON (1=1
    AND t1.origrec = t2.rdq_origrec
    AND t1.rasclientid = t2.rasclientid
    AND t1.contactid = t2.contactid
    AND t1.folderno = t2.folderno
  )    
  WHEN MATCHED THEN
    UPDATE SET
      t1.delivery_method = t2.rcx_method,
      t1.delivery_address = t2.rcx_address;
*/      
/*---------------------------------------------------------------------------*/

