

/*-----Panel Responsible Update Scripts----------------------------*/
  /*----------Summary----------*/
    --Use this script to update an exising user to make them
    --responsible for the same test as another existing user.
    --
      --01. Add Responsible for Person
        --Scripts will take identified user as template and person 
        --to change, and will make sure new person to change is 
        --  responsible for the same panels as the identified user 
        --template. This is an Additive Script, it will never remove
        --responsiblilties.
      --02. Add ResponsiblePersons for Panel
        --Update indicated Panel to add provided list of persons
        --to be responsible. 
      --03. No Responsiblities
        --Remove all responsibilities for the identified user.
      --04. Dept Responsible/NotResponsible
        --Add/Remove responsibiltiy for all panels in identified dept.
  /*----------  ----------*/  
  
  /*----------Environments----------*/  
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/  
  
  /*----------Source Tables----------*/
/*  
    SELECT DISTINCT * FROM testgroup_users;
    SELECT DISTINCT * FROM users ORDER BY fullname ASC;
      SELECT DISTINCT
        u.fullname,
        u.usrnam,
        tgu.testgroupname,
        '~' AS eol      
      FROM testgroup_users tgu
        INNER JOIN users u ON (tgu.usrnam = u.usrnam)
      ORDER BY
        u.fullname ASC,
        u.usrnam ASC,
        tgu.testgroupname ASC;
*/        
    --    
  /*----------  ----------*/  

  /*----------History----------*/
    --2013.06.18 JTY: Being development
    --2013.06.19 JTY: Completed Add Responsible scripts component
  /*----------  ----------*/  
/*-----------------------------------------------------------------*/









/*-----01. Add Responsible for Person------------------------------*/
  /*----------  ----------*/
    --This script will add responsible test based on the provided
    --user you would like to use as a template to ADD responsible
    --to the user.  This is an additive script, and will never remove
    --responsiblities.
  /*----------  ----------*/  
  
  
  /*----------  ----------*/ 
/*  
    ---Before Summary---
      --Show list of panels UserTemplate is responsible for 
      --but UserNewResp is not before new records are added.
      SELECT DISTINCT
        tgu1.usrnam,
        tgu1.testgroupname
      FROM testgroup_users tgu1
        LEFT OUTER JOIN testgroup_users tgu2 ON (
            tgu1.testgroupname = tgu2.testgroupname
            AND UPPER(tgu1.usrnam) = UPPER('&UserTemplate')
            AND UPPER(tgu2.usrnam) = UPPER('&UserNewResp')
            )
      WHERE 1=1
        AND tgu2.testgroupname IS NULL
        AND tgu1.usrnam = UPPER('&UserTemplate');
        
      ---If you want to review list of panels responsibe...
        --SELECT DISTINCT * FROM testgroup_users WHERE usrnam = '&UserTemplate';
        --SELECT DISTINCT * FROM testgroup_users WHERE usrnam = '&UserNewResp';
    ---

    ---Merge---
      --This will identify panels the UserTemplate is responsible for
      --but the UserNewResp is not, and make UserNewResp responsible for
      --the identified panels
      MERGE INTO testgroup_users tgu
      USING(
        SELECT DISTINCT
          tgu1.testgroupname,
          tgu1.usrnam
        FROM testgroup_users tgu1
        WHERE 1=1
          AND tgu1.usrnam = '&UserTemplate'
      ) ut
      ON (tgu.usrnam = '&UserNewResp' AND tgu.testgroupname = ut.testgroupname)
      WHEN NOT MATCHED THEN
        INSERT (tgu.origsts, tgu.testgroupname,
            tgu.usrnam, tgu.appr_level,
            tgu.appr_required)
        VALUES('N', ut.testgroupname,
            UPPER('&UserNewResp'), '1',
            'N');
    ---

    ---After Summary---
      --Show list of panels UserTemplate is responsible for 
      --but UserNewResp is not.  (should be none at this point)
      SELECT DISTINCT
        tgu1.usrnam,
        tgu1.testgroupname
      FROM testgroup_users tgu1
        LEFT OUTER JOIN testgroup_users tgu2 ON (
            tgu1.testgroupname = tgu2.testgroupname
            AND UPPER(tgu1.usrnam) = UPPER('&UserTemplate')
            AND UPPER(tgu2.usrnam) = UPPER('&UserNewResp')
            )
      WHERE 1=1
        AND tgu2.testgroupname IS NULL
        AND tgu1.usrnam = UPPER('&UserTemplate');
    ---    
*/
  /*----------  ----------*/      
  
/*-----------------------------------------------------------------*/










/*-----02. Add ResponsiblePersons for Panel------------------------*/

  /*----------Canidate List----------*/  
    --Query retrieves a list of persons in the lab of 
    --interest who should be considered for Panel
    --approval for the indicated panel.
    --It is based on the logic:
      --User is Active
      --User has attempteed to log in within the last month
      --LDAP is utilized for authentication
      --User is Scientist2 or SectionSuper
      --User is associated with the Dept specified.
/*      
    SELECT DISTINCT
      '&SchemaName' AS Environment,
      sa.dept,
      sa.servgrp,
      sa.usrnam,
      r.role,
      u.fullname,
      TRUNC(u.last_login_attempt_date) AS last_login,
      u.deptlist
    FROM &SchemaName.servganalyst sa
      INNER JOIN &SchemaName.users u ON (sa.usrnam = u.usrnam)
      INNER JOIN &SchemaName.userroles ur ON (u.usrnam = ur.usrnam)
      INNER JOIN &SchemaName.roles r ON (ur.treeauth = r.treeauth)
    WHERE 1=1
      AND sa.dept = '&Department'
      AND u.status = 'Active'
      AND u.securityaction = 'GLOBALSECURITYACTION'
      --AND u.ldap_server = 'HSPHXMDC03'
--      AND MONTHS_BETWEEN((TRUNC(sysdate)), TRUNC(u.last_login_attempt_date))<1 
      AND r.role IN ('PHScientist2','SectionSuper')
  --    AND sa.testgroupname = '&Panel'
    ORDER BY 
      sa.dept ASC,
      sa.servgrp ASC,
      u.fullname ASC;
*/      
  /*----------  ----------*/    
  
  /*----------Update Query----------*/  
    --Using the information from the previous query
    --we will add Responsible persons to the identified
    --panel.
/*    
    MERGE INTO &SchemaName.testgroup_users t1
    USING (
      SELECT DISTINCT
        'N' AS origsts,
        '&PanelName' AS testgroupname,
        u.usrnam,
        '1' AS appr_level,
        'N' AS appr_required
      FROM &SchemaName.users u
      WHERE 1=1
        AND u.fullname IN (&ResponsibleList)
      ) t2
    ON (1=1
      AND t1.testgroupname = t2.testgroupname
      AND t1.usrnam = t2.usrnam
      AND t1.appr_level = t2.appr_level
      AND t1.appr_required = t2.appr_required
      )
    WHEN NOT MATCHED THEN
      INSERT (
        origsts,
        testgroupname,
        usrnam,
        appr_level,
        appr_required
      )
      VALUES (
        t2.origsts,
        t2.testgroupname,
        t2.usrnam,
        t2.appr_level,
        t2.appr_required      
      )
*/      
  /*----------  ----------*/        

/*-----------------------------------------------------------------*/











/*-----03. No Responsiblities---------------------------------------*/


  /*----------Review panels----------*/
    --Review panels this person is currently responible for
/*    
      SELECT *
      FROM testgroup_users 
      WHERE usrnam = '&DenyUser'
      ORDER BY testgroupname ASC;
*/      
  /*----------  ----------*/

  /*----------Deny Responsibility-----------*/
    --This script will remove any responsible relations to panels
    --the user may have, so that they are NOT responsible for any
    --panels.
/*
      DELETE 
      FROM testgroup_users 
      WHERE usrnam = '&DenyUser';
*/      
  /*----------  ----------*/
/*-----------------------------------------------------------------*/




/*-----04. Lab Responsible Scripts---------------------------------*/

--  SELECT DISTINCT u.usrnam, u.fullname FROM SUNDATA_PROD.users u ORDER BY u.fullname ASC;

  /*----------Make Responsible for Dept Panels----------*/
    --Utilize this script to make the identified person responsible
    --for all current panels within a lab.
/*    
   MERGE INTO testgroup_users t1
    USING (
      SELECT DISTINCT
          ctt.dept,
          tgn.testgroupname AS Panel,
          tgn.status,
          'N' AS origsts,
          '1' AS appr_level,
          'N' AS appr_required,
          '&UserID' AS usrnam,
        '~' AS eol
      FROM testgroupnames tgn    
        INNER JOIN conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
        INNER JOIN Testgroup_Users tgu ON (tgn.testgroupname = tgu.testgroupname) 
      WHERE 1=1
        AND ctt.dept = '&Dept'
      ORDER BY 
          ctt.dept ASC,
          tgn.testgroupname ASC
     ) t2
     ON (1=1
         AND t1.testgroupname = t2.Panel
         AND t1.usrnam = t2.usrnam)
     WHEN NOT MATCHED THEN
       INSERT(
           t1.origsts, t1.testgroupname, 
           t1.usrnam, t1.appr_level, 
           t1.appr_required)
       VALUES(
           t2.origsts, t2.panel,
           '&UserID', t2.appr_level,
           t2.appr_required)
*/     
  /*----------  ----------*/



  /*----------Not Responsible for Dept Panels----------*/
    --Utilize this script to make sure the identified person
    --is NOT responsible for all current panels within a lab.
/*  


    MERGE INTO testgroup_users t1
    USING (
      SELECT DISTINCT
          ctt.dept,
          tgn.testgroupname AS Panel,
          tgn.status,
--          t.testno,
--          ctt.testcode,
          tgu.usrnam,
          'N' AS origsts,
          '1' AS appr_level,
          'N' AS appr_required,
        '~' AS eol
      FROM testgroupnames tgn    
        INNER JOIN conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
        INNER JOIN tests t ON (ctt.testcode = t.testcode)
        INNER JOIN Testgroup_Users tgu ON (tgn.testgroupname = tgu.testgroupname) 
      WHERE 1=1
        AND ctt.dept = '&Dept'
        AND tgu.usrnam IN ('&UserID')
      ORDER BY 
          ctt.dept ASC,
          tgn.testgroupname ASC,
--          t.testno ASC,
          tgu.usrnam ASC
     ) t2
     ON (1=1
         AND t1.testgroupname = t2.Panel
         AND t1.usrnam = '&UserID')
     WHEN MATCHED THEN
       UPDATE SET t1.appr_required = t1.appr_required
       DELETE WHERE ( 1=1
         AND t1.testgroupname = t2.panel 
         AND t1.usrnam = t2.usrnam)
*/         
  /*----------  ----------*/


  
/*-----------------------------------------------------------------*/



