/*-----Test_DuplicateForNewTest----------------------------------------------*/
/*---------------------------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Scripts here will help you build a new test based on an existing test 
    --(ReferenceTest).  I have created these script to create 
    --[BioFire Respiratory Panel 2.1] test based on the [Film Array Panel 2]
    -- test.
    --Assumptions:  You have already created the new basic test but need to 
    --add various componets simular to an existing test. Including:
      --01. Analytes
      --02. Possible Results
      --03. LOINC Codes
      --04. Specifications
  /*----- -----*/

  /*-----HISTORY-----*/
    --2020.08.01 JTY: Created Script
  /*----- -----*/
/*---------------------------------------------------------------------------*/


/*-----01. Add Additional Analytes-------------------------------------------*/
  /*---Review Current Analytes---*/
/*
    SELECT
     a.testcode,
     a.analyte,
     a.sorter
    FROM analytes a
    WHERE 1=1
      AND a.testcode = '546'
    ORDER BY
      a.sorter ASC;
*/
  /*--- ---*/

  /*---Add New Analytes---*/
  /*--- ---*/
    --this will only add an analytes if it isn't already associaed with the test.
/*
    MERGE INTO analytes t1
    USING (
      SELECT DISTINCT
        '&NewTestName' AS NewTestNo,
        t2.testcode AS newTestCode,
        '&RefernceTestName' AS OldTestNo,
        a.testcode AS oldTestCode,
        a.analyte,
        a.sinonym,
        a.sorter,
        a.analprint,
        a.analtype,
        a.norep,
        a.overwritecalcul,
        a.schemaname, 
        a.useflag,
        a.origsts
      FROM analytes a
        INNER JOIN tests t1 ON (a.testcode = t1.testcode)
        INNER JOIN tests t2 ON (t2.testno = '&NewTestName')
      WHERE 1=1
        AND t1.testno = '&RefernceTestName'
      ORDER BY a.sorter ASC
    ) t2
    ON (t1.testcode = t2.newTestCode AND t1.analyte = t2.analyte)
    WHEN NOT MATCHED THEN
      INSERT (
        t1.testcode,
        t1.analyte,
        t1.sinonym, 
        t1.sorter,
        t1.analprint,
        t1.analtype,
        t1.norep,
        t1.overwritecalcul,
        t1.schemaname,
        t1.useflag,
        t1.origsts
      )
      VALUES (
        t2.newTestCode,
        t2.analyte,
        t2.sinonym, 
        t2.sorter, 
        t2.analprint,
        t2.analtype,
        t2.norep,
        t2.overwritecalcul,
        t2.schemaname,
        t2.useflag,
        t2.origsts
      )
*/      
/*---------------------------------------------------------------------------*/




/*-----02 Add Possible Results-----------------------------------------------*/
  --Add Possible Results to an analyte if they don't already exists. based on idicated test.

/*
    MERGE INTO possibleresults t1
    USING (
      SELECT DISTINCT
        '&NewTestName' AS NewTestNo,
        t2.testcode AS newTestCode,
        '&RefernceTestName' AS OldTestNo,
        pr.testcode AS oldTestCode,
        pr.analyte,
        pr.conclusion_report,
        pr.localnumber,
        pr.origsts,
        pr.result,
        pr.result_status,
        pr.snomedcode,
        pr.snomedconceptid,
        pr.snomeddescriptionid,
        pr.code_system_oid,
        pr.cdc_reportable,
        '~' AS eol
      FROM possibleresults pr
        INNER JOIN tests t1 ON (pr.testcode = t1.testcode)
        INNER JOIN tests t2 ON (t2.testno = '&NewTestName')
      WHERE 1=1
        AND t1.testno = '&RefernceTestName'
      ORDER BY pr.analyte ASC
    ) t2
    ON (t1.testcode = t2.newTestCode AND t1.analyte = t2.analyte)
    WHEN NOT MATCHED THEN
      INSERT (
        t1.testcode,
        t1.analyte,
        t1.conclusion_report,
        t1.localnumber,
        t1.origsts,
        t1.result,
        t1.result_status,
        t1.snomedcode,
        t1.snomedconceptid,
        t1.snomeddescriptionid,
        t1.code_system_oid,
        t1.cdc_reportable
      )
      VALUES (
        t2.newTestCode,
        t2.analyte,
        t2.conclusion_report,
        t2.localnumber,
        t2.origsts,
        t2.result,
        t2.result_status,
        t2.snomedcode,
        t2.snomedconceptid,
        t2.snomeddescriptionid,
        t2.code_system_oid,
        t2.cdc_reportable
      )
*/
/*---------------------------------------------------------------------------*/




/*-----03. Add Test Loinc Codes----------------------------------------------*/
  --Add Test LOINC Codes to analytes if they don't already exists based on indicated test.
/*
    MERGE INTO testloinccodes t1
    USING (
      SELECT DISTINCT
        '&NewTestName' AS NewTestNo,
        t2.testcode AS newTestCode,
        '&RefernceTestName' AS OldTestNo,
        tlc.testcode AS oldTestCode,
        tlc.analyte,
        tlc.loinccomponenet,
        tlc.loincdefault,
        tlc.loincmethod,
        tlc.loincnumber,
        tlc.loincproperty,
        tlc.loincscale,
        tlc.loincsystems,
        tlc.loinctime,
        tlc.origsts,
        tlc.version,
        tlc.hl7_reportable,
        tlc.code_system_oid,
        '~' AS eol
      FROM testloinccodes tlc
        INNER JOIN tests t1 ON (tlc.testcode = t1.testcode)
        INNER JOIN tests t2 ON (t2.testno = '&NewTestName')
      WHERE 1=1
        AND t1.testno = '&RefernceTestName'
      ORDER BY
        tlc.analyte ASC
    ) t2
    ON (1=1
      AND t1.testcode = t2.newTestCode 
      AND t1.analyte = t2.analyte
      AND t1.loinccomponenet = t2.loinccomponenet
    )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.testcode,
        t1.analyte,
        t1.loinccomponenet,
        t1.loincdefault,
        t1.loincmethod,
        t1.loincnumber,
        t1.loincproperty,
        t1.loincscale,
        t1.loincsystems,
        t1.loinctime,
        t1.origsts,
        t1.version,
        t1.hl7_reportable,
        t1.code_system_oid
      )
      VALUES (
        t2.newTestCode,
        t2.analyte,
        t2.loinccomponenet,
        t2.loincdefault,
        t2.loincmethod,
        t2.loincnumber,
        t2.loincproperty,
        t2.loincscale,
        t2.loincsystems,
        t2.loinctime,
        t2.origsts,
        t2.version,
        t2.hl7_reportable,
        t2.code_system_oid
      )
*/
/*---------------------------------------------------------------------------*/



/*-----04. Specifications----------------------------------------------------*/
  --This script will mirror the specifications form the reference test to the new test.
  --NOTE: THIS MAY NOT WORK.....  
  
/*
    MERGE INTO spec_analytes t1
    USING (
      SELECT
        '&NewTestName' AS NewTestNo,
        t2.testcode AS newTestCode,
        '&RefernceTestName' AS OldTestNo,
        sa.testcode AS oldTestCode,
        sa.analyte,
        sa.synonim,
        sa.specno,
      ss.qctype,
        sa.pass_text,
        sa.qc_expected_result,
        sa.specsorter,
        sa.analtype,
        sa.schemaname,
        sa.printflag,
        sa.origsts,
        sa.sptestsorter,
        '~' AS eol
       FROM spec_analytes sa
        INNER JOIN spec_sets ss ON (sa.specno = ss.specno)
        INNER JOIN tests t1 ON (sa.testcode = t1.testcode)
        INNER JOIN tests t2 ON (t2.testno = '&NewTestName')
      WHERE 1=1
        AND t1.testno = '&RefernceTestName'
        AND sa.pass_text IS NOT NULL
      ORDER BY
         ss.qctype ASC,
         sa.specno ASC,
         sa.testcode ASC,
         sa.analyte ASC,
         ss.qctype ASC
    ) t2
    ON (1=1
      AND t1.testcode = t2.newTestCode 
      AND t1.analyte = t2.analyte
      AND t1.specno = t2.specno
      --AND t1.pass_text = t2.pass_text
    )
    WHEN MATCHED THEN
      UPDATE SET
        t1.synonim = t2.synonim,
        t1.pass_text = t2.pass_text,
        t1.qc_expected_result = t2.qc_expected_result,
        t1.specsorter = t2.specsorter,
        t1.analtype = t2.analtype,
        t1.schemaname = t2.schemaname,
        t1.printflag = t2.printflag,
        t1.origsts = t2.origsts,
        t1.sptestsorter = t2.sptestsorter
    WHEN NOT MATCHED THEN
      INSERT(
        t1.testcode,
        t1.analyte,
        t1.synonim,
        t1.specno,
        t1.pass_text,
        t1.qc_expected_result,
        t1.specsorter,
        t1.analtype,
        t1.schemaname,
        t1.printflag,
        t1.origsts,
        t1.sptestsorter
      )
      VALUES (
        t2.newTestCode,
        t2.analyte,
        t2.synonim,
        t2.specno,
        t2.pass_text,
        t2.qc_expected_result,
        t2.specsorter,
        t2.analtype,
        t2.schemaname,
        t2.printflag,
        t2.origsts,
        t2.sptestsorter
      )
*/
/*---------------------------------------------------------------------------*/



/*-----05. Panel HL7 Reporting-----------------------------------------------*/
  --Here we will flag analytes for reporting to the PHLIP program based on
  --the 
/*  
    MERGE INTO Hl7_Analytes t1
    USING (
      SELECT DISTINCT
        '&NewTestName' AS NewTestNo,
        t2.testcode AS newTestCode,
        '&RefernceTestName' AS OldTestNo,
        ha.testcode AS oldTestCode,
        ha.analyte,
        ha.rasclientid,
        ha.reportable,
        ha.result_fld,
        ha.value_type,
        ha.origsts,
        ha.lrn_param,
        ha.interface_id,
        '~' AS eol
      FROM Hl7_Analytes ha
        INNER JOIN tests t1 ON (ha.testcode = t1.testcode)
        INNER JOIN tests t2 ON (t2.testno = '&NewTestName')
      WHERE 1=1
        AND t1.testno = '&RefernceTestName'
      ORDER BY
        ha.analyte ASC
    ) t2
    ON (1=1
      AND t1.testcode = t2.newTestCode 
      AND t1.analyte = t2.analyte
    )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.testcode,
        t1.analyte,
        t1.rasclientid,
        t1.reportable,
        t1.result_fld,
        t1.value_type,
        t1.origsts,
        t1.lrn_param,
        t1.interface_id
      )
      VALUES (
        t2.newTestCode,
        t2.analyte,
        t2.rasclientid,
        t2.reportable,
        t2.result_fld,
        t2.value_type,
        t2.origsts,
        t2.lrn_param,
        t2.interface_id
      )
*/  
/*---------------------------------------------------------------------------*/


/*-----06. Panel HL7 Reporting2-----------------------------------------------*/
  --Here we will flag analytes for reporting to the PHLIP program based on
  --the 

    MERGE INTO Hl7_Analytes t1
    USING (
      SELECT DISTINCT
        '&NewTestName' AS NewTestNo,
        t2.testcode AS newTestCode,
        '&RefernceTestName' AS OldTestNo,
        hl.origsts,
        hl.header_name,
        hl.testgroupname,
        hl.rasclientid,
        hl.analyte,
        hl.loincnumber,
        hl.testcode,
        hl.reportable_condition,
        hl.reportsection,
        hl.value_type,
        '~' AS eol
      FROM hl7_dist_loincs hl
        INNER JOIN tests t1 ON (hl.testcode = t1.testcode)
        INNER JOIN tests t2 ON (t2.testno = '&NewTestName')
      WHERE 1=1
        AND t1.testno = '&RefernceTestName'
      ORDER BY
        hl.analyte ASC
    ) t2
    ON (1=1
      AND t1.testcode = t2.newTestCode 
      AND t1.analyte = t2.analyte
    )
    WHEN NOT MATCHED THEN
      INSERT (
        t1.testcode,
        t1.analyte,
        t1.rasclientid,
        t1.reportable,
        t1.result_fld,
        t1.value_type,
        t1.origsts,
        t1.lrn_param,
        t1.interface_id
      )
      VALUES (
        t2.newTestCode,
        t2.analyte,
        t2.rasclientid,
        t2.reportable,
        t2.result_fld,
        t2.value_type,
        t2.origsts,
        t2.lrn_param,
        t2.interface_id
      )
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
--OTHER STUFF
/*
select * from equipment_batches eb WHERE eb.eqid = 'Torch';
select * from equip_tests et WHERE et.batch_id IN ('306', '562');

    MERGE INTO equip_tests t1
    USING ( 
      SELECT DISTINCT
        et.testcode AS oldtestcode,
        et.batch_id AS oldbatchid,
        '546' AS newtestcode,
        '562' AS newbatchid,
        et.calexpdate,
        et.calfrequency,
        et.eqid,
        et.origsts,
        et.method,
        et.override_flag
      FROM equip_tests et
      WHERE 1=1
        AND   et.batch_id = '306'
    ) t2
    ON (t1.testcode = t2.newTestCode AND t1.batch_id = t2.newbatchid)
    WHEN MATCHED THEN
      UPDATE SET
        t1.calexpdate = t2.calexpdate,
        t1.calfrequency = t2.calfrequency,
        t1.eqid = t2.eqid,
        t1.origsts = t2.origsts,
        t1.method = t2.method,
        t1.override_flag = t2.override_flag
*/
SELECT * FROM HL7_DIST_LOINCS hl WHERE hl.testcode IN ('511', '559')
