

/*-----SL10: InventoryHistory--------------------------------*/
  /*----------Summary----------*/
    --This query will display the inventory history for the
    --parameters provided.
  /*---------- ----------*/  

  /*----------History----------*/
    --2013.07.25 JTY: Created Query
  /*---------- ----------*/  
  
  /*----------SL10 Environments----------*/
    --DEV:  sunrise_data
    --TEST: sundata_sat
    --PROD: sundata_prod
  /*----------  ----------*/
/*-----------------------------------------------------------*/




/*-----------------------------------------------------------*/
/*-----Primary Query-----------------------------------------*/
  /*---------- ----------*/  
    SELECT DISTINCT    
      --Material Details--
      '~Mat:' AS Sep1,
      i.matcode,
      m.matname,
      i.unit_code,
      i.suppcode,
      --
      --Inventory Info--
      'Inv:' AS Sep2,   
      i.lotno,
      i.status,
      (loc1.locationcode || ': ' || loc1.location) AS location,
      i.item_counter,
      Trunc(i.receive_date) AS receive_date,
      Trunc(i.expire_date) AS expire_date,
      --
      --History--
      'His:' AS Sep3,
      u.fullname AS h_changedby,
      (loc2.locationcode || ': ' || loc2.location) AS h_location,      
      ic.balance AS h_balance,
      Trunc(ic.datechange) AS h_datechange,
      ic.amountchange AS h_amountchange,
      --ic.itemsremoved AS h_itemsremoved,
      --
      '~' AS eol
    FROM inventory i
      INNER JOIN materials m ON (i.matcode = m.matcode)
      INNER JOIN inventorychange ic ON (ic.inventoryid = i.inventoryiD)
      INNER JOIN locations loc1 ON (ic.locationcode = loc1.locationcode)
      INNER JOIN locations loc2 ON (ic.locationcode = loc2.locationcode)
      INNER JOIN users u ON (ic.changedby = u.usrnam)
    WHERE 1=1
---Selection Criteria---
      AND i.lotno = '1928rbs/mw'
      AND i.matcode = '.1% Agar Fixative'
      --AND m.matname = ''
      --AND ic.locationcode = ''
      --AND i.item_counter <> '0'
---    
    ORDER BY
      i.matcode ASC,
      i.lotno ASC,
      --i.inventoryid ASC,
      Trunc(ic.datechange) ASC  
  /*---------- ----------*/    

  /*---------- ----------*/  
  /*---------- ----------*/    
  
/*-----------------------------------------------------------*/





/*-----WorkSpace---------------------------------------------*/
  /*---------- ----------*/  
  /*---------- ----------*/ 
/*-----------------------------------------------------------*/

