

/*
---------------------------------------------------------------------------
-----TestLibrary-----------------------------------------------------------
  -----DESCRIPTION-----
    List of Active Dept, Panels, and Tests
  ----- -----
  
  -----HISTORY-----
    2021.06.07 JTY: Created Script
  ----- -----


---------------------------------------------------------------------------

*/


  SELECT DISTINCT
    tc.testcatcode AS test_library,
    ctt.dept,
    ctt.testgroupname AS panel,
    (t.testno || ' (' || t.testcode || ')') AS test_name,
    t.testflag,
    ctt.defaultselect,
    '~' AS eol
  FROM tests t
    INNER JOIN testcategory tc ON (t.testcatcode = tc.testcatcode)
    INNER JOIN conditiontesttriggers ctt ON (t.testcode = ctt.testcode)
    INNER JOIN testgroupnames tgn ON (ctt.testgroupname = tgn.testgroupname)
    LEFT OUTER JOIN methodsrelatedtotests mrt ON (t.testcode = mrt.testcode)
    LEFT OUTER JOIN analytes a ON (t.testcode = a.testcode)
    LEFT OUTER JOIN testreagents tr ON (t.testcode = tr.testcode)

  WHERE 1=1
    AND t.origrec > 0
    AND tgn.status <> 'Retired'
    AND tc.testcatcode <> 'Retired'
  ORDER BY
    tc.testcatcode ASC,
    ctt.dept ASC,
    ctt.testgroupname ASC,
    test_name ASC

