/*
-----EPI CRE_CRPA Daily Job Extract---------------------------------
  -----DESCRIPTION-----
    This query can be used to extract data from the adhs_epi_cre view.
    The view is used as the data sourced for the EPI_CRE_Extract
    Exteral Interfaces interface.  This should execute daily for the
    EPI group.
  ----- -----

  ----- -----
  ----- -----

  -----HISTORY-----
  ----- -----

--------------------------------------------------------------------
*/

--------------------------------------------------------------------


  SELECT DISTINCT
    cre.birth_date,
    cre.date_collected,
    cre.date_received,
    cre.Reporting_month,
    cre.ethnicity,
    cre.sample_no,
    cre.first_name,
    cre.last_name,
    cre.middle_initial,
    cre.onset_date,
    cre.race,
    cre.sl_patient_id,
    cre.submitter_pid,
    cre.submitter_code,
    cre.ARLN_Specimen_ID,
    cre.specimen_desc,
    cre.sex,
    cre.sample_type,
    cre.date_approved,
    cre.panel_name,
    cre.exposure_date,
    cre.Patient_age,
    cre.physician, 
    cre.symptoms,
    cre.provider,
    cre.facility_name,
    cre.provider_address,
    cre.provider_city,
    cre.provider_state,
    cre.provider_zip,
    cre.provider_phone,
    cre.activity_type,
    cre.submitter_facility_city,
    cre.Submitter_facility_name,
    cre.submitter_facility_county,
    cre.Submitter_facility_zipcode,
    cre.Phenotypic_test_result,
    cre.Phenotypic_method_used,
    cre.Confirmed_carbapenem_resistant,
    cre.AST_method_used,
    cre.PCR_method_used,
    cre.Organism_tested,
    cre.IMP_gene,
    cre.KPC_gene,
    cre.mcr_gene,
    cre.NDM_gene,
    cre.OXA_48_like_gene,
    cre.VIM_gene,
    cre.Other_gene_name,
    cre.Other_gene_result,
    cre.Aztreonam_result,
    cre.Aztreonam_AST_MIC,
    cre.Aztreonam_AST_zone_diameter,
    cre.Cefepime_result,
    cre.Cefepime_AST_MIC,
    cre.Cefepime_AST_zone_diameter,
    cre.Ceftazidime_result,
    cre.Ceftazidime_AST_MIC,
    cre.Ceftazidime_AST_zone_diameter,
    cre.Ceftriaxone_result, 
    cre.Ceftriaxone_AST_MIC,
    cre.Ceftriaxone_AST_zone_diameter,
    cre.Colistin_result,
    cre.Colistin_AST_MIC,
    cre.Doripenem_result,
    cre.Doripenem_AST_MIC,
    cre.Doripenem_AST_zone_diameter,
    cre.Ertapenem_result,
    cre.Ertapenem_AST_MIC,
    cre.Ertapenem_AST_zone_diameter,
    cre.Imipenem_result,
    cre.Imipenem_AST_MIC,
    cre.Imipenem_AST_zone_diameter,
    cre.Meropenem_result,
    cre.Meropenem_AST_MIC,
    cre.Meropenem_AST_zone_diameter,
    cre.O3g_cep_name,
    cre.O3g_cep_AST_MIC,
    cre.O3g_cep_AST_zone_diameter,
    cre.Isolate_forwarded_to_RegLab,
    cre.Date_forwarded_to_RegLab,
    cre.RegLab_comment,
    cre.carb_resist_completed,
    cre.sendout_completed,
    cre.inactivation_completed,
    cre.carb_pcr_completed,
    cre.antibiotic_completed,
    cre.folderno,
    cre.ordno,
    cre.is_cre,
    cre.is_crpa,
    cre.resist_cre,
    cre.resist_crpa,
    cre.Pt_AST_MIC,
    cre.Pt_AST_zone_diameter,
    cre.days_elapsed,
    '~' AS eol
  FROM adhs_epi_cre cre  
  WHERE 1=1
    AND cre.days_elapsed < &DaysElaped
  ORDER BY
      cre.days_elapsed ASC,
      cre.folderno DESC
--------------------------------------------------------------------
