

--Identify samples for Salmonella Cuture and Serotyping

SELECT DISTINCT
  cr.rasclientid,
  f.external_id,
  f.apprdate,
  f.apprtime,
  mr.field_varchar_80,
  f.testgroupname,  
  ot.testno,
  r.final,
  pr.snomedcode,
  '~' AS eol
FROM folders f
  INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
  INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
  INNER JOIN metadata_repository mr ON (1=1
    AND mr.tablereference = 'CENTRALRECEIVING'
    AND mr.original_origrec = cr.origrec)
  INNER JOIN results r ON (1=1
    AND ot.ordno = r.ordno
    AND ot.testcode = r.testcode)
  INNER JOIN possibleresults pr ON (1=1
    AND r.testcode = pr.testcode
    AND r.final = pr.result)
WHERE 1=1
  AND ot.testcode IN ('515', '368')
  AND f.apprdate IS NOT NULL
  AND f.external_id IS NOT NULL
  AND mr.field_varchar_80 = 'Diagnostic'
  AND f.apprdate > to_date('16-DEC-2019', 'DD-MON-YY')
  
ORDER BY
  f.apprdate DESC,
  f.external_id DESC
  
  
