/*------AmmendedReportsCount-------------------------------------------------
  -----DESCRIPTION-----
    This script is use to get the monthly number of Ammended Reports.  This in
    in response to a request from Stacy
  ----- -----


  ----- -----
  ----- -----
  -----HISTORY-----
    2020.03.25 JTY Created script
  ----- -----

---------------------------------------------------------------------------*/
---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
  /*----- -----*/
    WITH
      ---CoreData---
      CoreData AS(
        SELECT
          rdq.folderno,
          rdq.origrec AS rdq_origrec,          
          mr.field_varchar_80 AS activity_type,
          rdq.reporttype,
          rdq.stardoc_id,          
          rdq.status,
          rdq.apprsts,
          TO_CHAR( rdh.sent_date, 'YYYY-MM' ) AS year_month,
          rdh.sent_date,
          rdh.sent_time,
          (TO_CHAR( rdh.sent_date, 'YYYY-MM-DD') || ' ' || rdh.sent_time) AS sent_timestamp,
          rdh.delivery_method,
          '~' AS eol
        FROM  rr_report_delivery_queue rdq
          INNER JOIN rr_rdq_history rdh ON ( 1=1
            AND rdq.queue_item_no = rdh.queue_item_no
            AND rdq.stardoc_id = rdh.stardoc_id
          )
          LEFT OUTER JOIN centralreceiving cr ON (rdq.external_id = cr.external_id)
          LEFT OUTER JOIN metadata_repository mr ON (1=1
            AND mr.tablereference = 'CENTRALRECEIVING'
            AND mr.original_origrec = cr.origrec
--            AND mr.field_varchar_80 = 'Diagnostic'
          )
            
        WHERE 1=1
--          AND rdq.reporttype = 'Amended'
          AND rdq.reporttype NOT IN ('Preliminary', 'Final')
          AND rdh.sent_date > to_date('&StartDate', 'DD-MON-YYYY')
          AND rdq.folderno NOT IN ('AZ00049294-01')
        ORDER BY
        rdh.stardoc_id ASC
--          rdh.sent_date ASC,
--          rdq.folderno ASC
      ),
      --- ---
      --NoDuplicates--
        NoDuplicates AS (
          SELECT
            cd.stardoc_id,
            MAX(cd.rdq_origrec) AS max_origrec,
            MAX(sent_timestamp) AS max_delivery
          FROM CoreData cd
--WHERE folderno = 'AZ00056777-01'
          GROUP BY
            cd.stardoc_id
        ),
      --- ---
      --RecordsOfInterest--
        RecordsOfInterest AS (
          SELECT
            cd.*
          FROM NoDuplicates nd
            INNER JOIN CoreData cd ON (1=1
              AND nd.max_origrec = cd.rdq_origrec
              AND nd.max_delivery = cd.sent_timestamp)
        )
      --- ---
      ---Monthly---
        SELECT
        ri.year_month,
        COUNT(DISTINCT ri.stardoc_id) AS report_count     
        FROM RecordsOfInterest ri
        WHERE 1=1
        GROUP BY
          ri.year_month
        ORDER BY
          ri.year_month ASC;
      --- ---


    
  /*----- -----

  
  /*----- -----
  /*----- -----
  
/*---------------------------------------------------------------------------*/
/*
SELECT 
  rdq.external_id,
  cr.external_id,
  rdh.reporttype,
  rdh.sent_date,
  rdh.receipt_number,
  rdh.stardoc_id,
  '~' AS eol
 FROM rr_rdq_history rdh
   INNER JOIN rr_report_delivery_queue rdq ON (1=1
     AND rdh.stardoc_id = rdq.stardoc_id
     AND rdq.queue_item_no = rdh.queue_item_no      
   )
   LEFT OUTER JOIN centralreceiving CR ON (rdq.external_id = cr.external_id)
 WHERE 1=1
   AND rdh.reporttype NOT IN ('Final', 'Preliminary')
   AND rdh.sent_date > to_date('&StartDate', 'DD-MON-YYYY')
 ORDER BY
   rdh.sent_date DESC;
*/   
