
/*-----Drew_CRE_Query_2020-10-06---------------------------------------------*/
/*---------------------------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --This is a query created for Drew for the [Carbapenem Resistance Testing]
    --Panel.  Intent of the use of the data is known.
  /*----- -----*/


  /*-----HISTORY-----*/
    --2020.10.06 JTY: Created Query
  /*----- -----*/ 
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/

    SELECT DISTINCT
      cr.external_id,
      cr.date_collected,      
      cr.date_received,
      ot.testno,
      r.analyte,
      r.final,
      r.dateenter,
    f.apprdate AS panel_appr,
    ot.apprdate AS test_appr,      
      cr.birth_date,            
      cr.first_name,
      cr.last_name,
      (rc.compname || ' (' || cr.rasclientid || ')') AS submitting_org,
      cr.spec_source,      
      f.testgroupname AS panel_name,      
      mr.field_varchar_80 AS activity_type,
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN ordtask OT on (f.folderno = ot.folderno)
      INNER JOIN results r ON (1=1
        AND ot.ordno = r.ordno
        AND ot.testcode = r.testcode)
    WHERE 1=1
      --Selection Criteria--
      AND f.testgroupname IN (&PanelList)
      AND f.apprdate BETWEEN to_date('&StartDate', 'DD-MON-YYYY') AND to_date('&EndDate', 'DD-MON-YYYY')
      -- --      
--      AND mr.field_varchar_80 IN ('Diagnostic')
--      AND cr.rasclientid NOT IN ('ADHS', 'ASL-P')
    ORDER BY
      cr.external_id ASC;
