/*-----Canned Comments---------------------------------------*/

  /*----------Summary----------*/
    --This query will display the canned comments for the parameters
    --specified.
    --This is the script the QA/QC dept will regularly request to be 
    --run.
  /*---------- ----------*/

  /*----------History----------*/
    --2020.07.08 JTY: Updated for database
    --2013.07.25 JTY: Created script
  /*---------- ----------*/

/*-----------------------------------------------------------------*/



/*----------Canned Comments----------------------------------------*/
  --This query will display canned comments in the specified
  --environment

  /*----------Show Canned Comments----------*/
  WITH
    ---MyRef---
      --All panels in environment and associated test,
      --and analytes.
      MyRef AS (
        SELECT DISTINCT
          ctt.dept,
          tc.testcatcode,
          ctt.servgrp,
          ctt.testgroupname AS panel,
          ctt.testcode,
          t.testno,
          a.analtype,
          a.analyte,
          '~' AS eol
        FROM conditiontesttriggers ctt
          INNER JOIN tests t ON (ctt.testcode = t.testcode)
          INNER JOIN testcategory tc ON (t.testcatcode = tc.testcatcode)
          INNER JOIN analytes a ON (t.testcode = a.testcode)
        WHERE 1=1
        ORDER BY
          ctt.dept ASC,
          tc.testcatcode ASC,
          ctt.servgrp ASC,
          ctt.testgroupname  ASC,
          ctt.testcode ASC,
          t.testno ASC,
          a.analtype ASC,
          a.analyte ASC
      ),
    ---
    ---MyCannedComments---
      MyCannedComments AS (
        SELECT DISTINCT
          CASE
            WHEN ('sundata_prod' = 'sunrise_data') THEN 'DEV'
            WHEN ('sundata_prod' = 'sundata_sat') THEN 'TEST'
            WHEN ('sundata_prod' = 'sundata_prod') THEN 'PROD'
          END AS env,
          (Coalesce(mr1.dept, mr2.dept, mr3.dept, 'All')) AS MyDept,
          CASE
            WHEN (mr3.analyte IS NOT NULL) THEN '04_Result'
            WHEN (mr2.testno IS NOT NULL) THEN '03_Test'
            WHEN (mr1.panel IS NOT NULL) THEN '02_Panel'
            ELSE '01_Folder'
          END AS CC_Level,
          mr1.panel,
          mr2.testno AS test_name,
          mr2.testcode,
          mr3.analyte,
          (cc.conditionfield || ' ' || cc.qualifier || ' '  || cc.conditionvalue ) AS cc_trigger,
          cc.start_date,
          cc.canned_comment,
          '~' AS eol
        FROM canned_comments cc
          LEFT OUTER JOIN MyRef mr1 ON (cc.testgroupname = mr1.panel)
          LEFT OUTER JOIN MyRef mr2 ON (cc.testcode = mr2.testcode)
          LEFT OUTER JOIN MyRef mr3 ON (cc.analyte = mr3.analyte)
        WHERE 1=1
          --AND Coalesce(mr1.dept, mr2.dept, mr3.dept) IN ('PHX-TB')
          AND cc.status = 'Released'
        ORDER BY
          cc_level ASC,
          --Coalesce(mr1.dept, mr2.dept, mr3.dept) DESC,
          mr1.panel ASC,
          mr2.testno ASC,
          mr3.analyte ASC,
          cc.canned_comment ASC),
    ---
    ---MySummary---
      MySummary AS (
        SELECT DISTINCT
          mcc.env,
          mcc.MyDept AS dept,
          mcc.cc_level,
          mcc.panel,
          mcc.test_name,
          mcc.testcode,
          mcc.analyte,
          mcc.start_date,
          mcc.cc_trigger,
          mcc.canned_comment,
          mcc.eol
        FROM MyCannedComments mcc
        WHERE 1=1
        ORDER BY
          mcc.MyDept ASC,
          mcc.cc_level ASC,
          mcc.panel ASC,
          mcc.test_name ASC,
          mcc.analyte ASC,
          mcc.canned_comment ASC)
    ---
    ---Final Query---
      SELECT DISTINCT
          ms.env,
          ms.dept,
          ms.start_date,
          ms.cc_level,
          ms.panel,
          ms.test_name,
          ms.testcode,
          ms.analyte,
          ms.cc_trigger,
          ms.canned_comment,
          ms.eol
      FROM MySummary ms
      WHERE 1=1
---Filter parameters---
--        AND (ms.dept IS NULL or ms.dept IN ('All' ,'PHX-BAC'))  --PHX-BAC, PHX-BT, PHX-EM, PHX-SER, PHX-TB, PHX-VIR
---
        AND ms.start_date > TO_DATE('01-OCT-2019','DD-MON-YYYY')
      ORDER BY
        ms.Dept ASC,
        ms.start_date DESC,
        ms.cc_level ASC,
        ms.panel ASC,
        ms.test_name ASC,
        ms.analyte ASC,
        ms.canned_comment ASC
        
        
        
