
--SELECT DISTINCT mr.field_varchar_80  FROM metadata_repository mr

SELECT DISTINCT
  (rc.compname || ' (' || rc.rasclientid || ')') AS client_name,
  Count (cr.external_id) AS total,
  Count(CASE WHEN (bl.external_id IS NOT NULL) THEN 1 ELSE NULL END) AS barcode,
  Count(CASE WHEN (bl.external_id IS NULL) THEN 1 ELSE NULL END) AS "STANDARD",
  '~' AS eol  
FROM centralreceiving cr
  LEFT OUTER JOIN barcode_log bl ON (cr.external_id = bl.external_id)
  INNER JOIN RASCLIENTS rc ON (CR.Rasclientid = rc.rasclientid)
  INNER JOIN folders f ON (cr.external_id = f.external_id)
  INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
  INNER JOIN results r ON (1=1
    AND ot.ordno = r.ordno
    AND ot.testcode = r.testcode)
  INNER JOIN metadata_repository mr ON (1=1
    AND mr.tablereference = 'CENTRALRECEIVING'
    AND mr.original_origrec = cr.origrec
    AND mr.field_varchar_80 IN ('Diagnostic', 'LRN-B'))
WHERE 1=1
--  AND f.apprdate IS NOT NULL
  AND rc.rasclientid NOT IN ('ADHS')
  AND to_date('23-APR-2020', 'DD-MON-YYYY')< to_date(cr.date_received, 'DD-MON-YY')
--  AND to_date('23-APR-2020', 'DD-MON-YYYY')< to_date(f.apprdate, 'DD-MON-YY')
GROUP BY
  (rc.compname || ' (' || rc.rasclientid || ')')
ORDER BY 
  total DESC,
  UPPER(rc.compname || ' (' || rc.rasclientid || ')') ASC
