/*---------------------------------------------------------------------------*/
/*----Victor Totals----------------------------------------------------------*/
  /*-----DESCRIPTION-----*/
/*  
    Number of Users
    Number of Samples per year
    Number of tests configured per year
    Number of reports per year
*/    
    --ASSUMPTIONS:
      --1. Sample Activity Type = Diagnostic
      --2. Sample was not canceled
      --3. Test was not canceled
      --4. Sample Approval date is NOT NULL
      --5. Client is not ADHS, ASL-P, ADHS-T      
      --6. Sample is in identified test list (this can be easily updated).
  /*----- -----*/
  
  /*-----HISTORY-----*/
    --2020.09.19 JTY: Created query
  /*----- -----*/
/*---------------------------------------------------------------------------*/





/*-----Number of Users-------------------------------------------------------*/
--A number of users have multiple roles, we will assume a over count of about
--five users per role.
  SELECT
    COUNT (
      CASE WHEN (u.deptlist = 'External') THEN 1
      ELSE NULL
      END
    ) AS my_lims,
    COUNT (
      CASE WHEN (ur.treeauth IN ('H')) THEN 1
      ELSE NULL
      END
    ) AS epis,
    COUNT (
      CASE WHEN (ur.treeauth IN ('Z')) THEN 1
      ELSE NULL
      END
    ) AS my_lims,
    COUNT (
      CASE WHEN (ur.treeauth IN ('X')) THEN 1
      ELSE NULL
      END
    ) AS my_county,
    COUNT (
      CASE WHEN (ur.treeauth IN ('C')) THEN 1
      ELSE NULL
      END
    ) AS labfolks,
        COUNT (
      CASE WHEN (ur.treeauth IN ('F')) THEN 1
      ELSE NULL
      END
    ) AS receiving,
        COUNT (
      CASE WHEN (ur.treeauth IN ('L', 'G')) THEN 1
      ELSE NULL
      END
    ) AS administrators,
    '~' AS eol
   FROM users u
     INNER JOIN userroles ur ON (u.usrnam = ur.usrnam)
  WHERE 1=1
    AND u.status = 'Active'

  
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*-----Number of Samples per year--------------------------------------------*/
/*
    SELECT DISTINCT
      COUNT (DISTINCT cr.external_id) AS total_samples,
      '~' as EOL
    FROM centralreceiving cr
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN foldercondition fc ON (f.folderno = fc.folderno)      
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        and mr.original_origrec = cr.origrec)
      INNER JOIN tests t ON (ot.testcode = t.testcode)
    WHERE 1=1
      AND f.apprdate BETWEEN (TO_DATE('&StartDate', 'DD-MON-YYYY')) AND (TO_DATE('&EndDate', 'DD-MON-YYYY'))
      AND mr.field_varchar_80 = 'Diagnostic'
      AND fc.status NOT IN ('Cancel')
      AND ot.dispsts NOT IN ('Cancel')
      AND f.apprdate IS NOT NULL
      AND cr.rasclientid NOT IN ('ADHS', 'ASL-P', 'ADHS-T')
    ORDER BY
      f.apprdate DESC,
      cr.external_id ASC;
*/      
/*---------------------------------------------------------------------------*/


