
/*-----myLIMS_Users----------------------------------------------------------
  ---------------------------------------------------------------------------
  -----DESCRIPTION-----
    Various queries associated with the myLIMS website
  ----- -----
  
  -----HISTORY-----
    2020.03.16 Updated for with Who Has Access Query
    2020.03.05 JTY: Created Query
  ----- -----
---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*-----Who Has Access?-------------------------------------------------------*/
  --This query was created in response to request for user that have access
  --to Maricopa invormation (Role=myCounty, County='Maricopa'
  SELECT
    rc.county,
    (rc.compname || ' (' || rc.rasclientid || ')') AS client,
    (u.fullname || ' (' || u.usrnam || ')') AS mylims_user,
    r.role,
    u.status,
    u.email,
    '~' AS eol
  FROM rasclientcontacts rcc
    INNER JOIN rasclients rc ON (rcc.rasclientid = rc.rasclientid)
    INNER JOIN users u ON (rcc.usrnam = u.usrnam)
    INNER JOIN userroles ur ON (u.usrnam = ur.usrnam)
    INNER JOIN roles r ON (ur.treeauth = r.treeauth)
  WHERE 1=1
    AND u.status = 'Active'
    AND rc.county = '&County'
    AND r.role = '&Role'  --myCounty, MyLims
    AND rc.rasclientid NOT IN ('ADHS')
    --AND rc.rasclientid IN (&RasClientList)
    --AND u.email NOT LIKE ('%maricopa.gov')
  ORDER BY
    client ASC,
    mylims_user ASC;
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*-----myLIMS users?---------------------------------------------------------*/
  --    Query to identify the clients who have active myLIMS accounts associated
  --    with them.
  SELECT DISTINCT 
    rc.compname,
    rcc.rasclientid,
--    rcc.usrnam,
--    u.role,
--    u.last_login_attempt_date,
--    u.*,
    '~' AS eol
  FROM rasclientcontacts rcc
    INNER JOIN rasclients rc ON (rcc.rasclientid = rc.rasclientid)
    INNER JOIN users u ON (rcc.usrnam = u.usrnam)
  WHERE 1=1
    AND u.status = 'Active'
    AND u.deptlist = 'External'
    AND u.last_login_attempt_date IS NOT NULL
  ORDER BY
    rc.compname ASC;
/*---------------------------------------------------------------------------*/



