/*-----Cancel Failed Faxes------------------------------------------------*/
  -----DESCRIPTION-----
    --Use these scripts to update the ReportDeliveryQueue and FaxQueue so that
    --you stop getting notification of failed faxes

  ----- -----  

  -----HISTORY-----
    --2020.08.27 JTY Created Scripts
  ----- -----    
/*------------------------------------------------------------------------*/



/*------------------------------------------------------------------------*/
  -----01. Review ReportDeliveryQueue & FaxQueue tables-----
/*  
    SELECT DISTINCT
      f.apprdate,
      f.external_id,
      rdq.status AS rdq_status,
      fq.status AS fq_status,
      fq.crtmessage,
      rc.rasclientid,
      rc.compname,
      rdq.apprsts,     
      f.testgroupname,
      rdq.queue_item_no,
      rdq.origrec AS rdq_origrec,
      fq.origrec AS fq_origrec,
      fq.statusname,
      fq.errorname,
      fq.errorcode,
      fq.usercomments,
      '~' AS eol
    FROM rr_report_delivery_queue rdq
      INNER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
      INNER JOIN folders f ON (rdq.folderno = f.folderno)
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
    WHERE 1=1
      --AND rdq.queue_item_no IN (&RDQItemNoList)
      -- SELECTION CRITERIA FOR Process_DirectFax.ReFax_Reports---
      AND (
           upper(fq.crtmessage) LIKE '%ERROR%' OR
           fq.senddate IS NULL)
      ---           
    ORDER BY
      f.apprdate ASC,
      rc.rasclientid ASC,
      f.external_id ASC;
*/      
  ----- -----

  -----02 Update ReportDeliveryQueue-----
/*
    MERGE INTO rr_report_delivery_queue t1
    USING (
    SELECT DISTINCT
      f.apprdate,
      f.external_id,
      rdq.status AS rdq_status,
      fq.status AS fq_status,
      fq.crtmessage,
      rc.rasclientid,
      rc.compname,
      rdq.apprsts,
      rdq.origrec AS rdq_origrec,
      f.testgroupname,
      rdq.queue_item_no,
      fq.origrec AS fq_origrec,
      fq.statusname,
      fq.errorname,
      fq.errorcode,
      fq.usercomments,
      '~' AS eol
    FROM rr_report_delivery_queue rdq
      INNER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
      INNER JOIN folders f ON (rdq.folderno = f.folderno)
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
    WHERE 1=1
      --AND rdq.queue_item_no IN (&RDQItemNoList)
      -- SELECTION CRITERIA FOR Process_DirectFax.ReFax_Reports---
      AND (
           upper(fq.crtmessage) LIKE '%ERROR%' OR
           fq.senddate IS NULL)
      ---           
    ORDER BY
      f.apprdate ASC,
      rc.rasclientid ASC,
      f.external_id ASC
    ) t2
    ON (t1.origrec = t2.rdq_origrec)
    WHEN MATCHED THEN 
    UPDATE SET
      t1.status = 'PROCESSED';
*/      
  ----- -----


  -----03. Update FaxQueue-----
/*
    MERGE INTO faxqueue t1
    USING (
      SELECT DISTINCT
        f.apprdate,
        f.external_id,
        rdq.status AS rdq_status,
        fq.status AS fq_status,
        fq.crtmessage,
        rc.rasclientid,
        rc.compname,
        rdq.apprsts,     
        f.testgroupname,
        rdq.queue_item_no,
        fq.origrec AS fq_origrec,
        fq.statusname,
        fq.errorname,
        fq.errorcode,
        fq.usercomments,
        '~' AS eol
      FROM rr_report_delivery_queue rdq
        INNER JOIN faxqueue fq ON (rdq.receipt_number = fq.receipt)
        INNER JOIN folders f ON (rdq.folderno = f.folderno)
        INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
        INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      WHERE 1=1
        --AND rdq.queue_item_no IN (&RDQItemNoList)
        -- SELECTION CRITERIA FOR Process_DirectFax.ReFax_Reports---
        AND (
             upper(fq.crtmessage) LIKE '%ERROR%' OR
             fq.senddate IS NULL)
        ---           
      ORDER BY
        f.apprdate ASC,
        rc.rasclientid ASC,
        f.external_id ASC
    ) t2
    ON (t1.origrec = t2.fq_origrec)
    WHEN MATCHED THEN 
    UPDATE SET
      t1.crtmessage = '&UpdateMessage',
      t1.statusname = 'fsDoneOK',
      t1.errorname = '',
      t1.senddate = sysdate;
*/      
  ----- -----





  
/*------------------------------------------------------------------------*/

