/*-----RightFax Phonebook Export---------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Utilize this query to generate a list of clients with Fax numbers that can
    --be imported into the RightFax phonebook for bulk notifications.
  /*----- -----*/  
  
  /*-----HISTORY-----*/
    --2020-09-10 JTY: Created Document
  /*----- -----*/  
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
  /*-----01 Run Query-----*/
    SELECT DISTINCT
      rc.rasclientid AS "ID",
       rc.category AS "Name",
      rc.compname AS "Company",
      rc.adress AS "Address",
      (rc.state || ' | ' || rc.city) AS "CityState",
      TRANSLATE(REPLACE(LOWER(rcx.fax),'(0) -',' '),'abcdefghijklmnopqrstuvwxyz()- +/,.#',' ') AS "Fax1",
      rc.primaryphone AS "Voice1",
      rc.defaultcontact AS "BillCode1",
      '' AS "BillCode2",
      'Source: STARLiMS Extract 2020-09-10' AS "Notes"
    FROM rasclients rc
      INNER JOIN rasclientcontactsext rcx ON (rc.rasclientid = rcx.rasclientid)
    WHERE 1=1
      AND rc.status = 'Active'
      AND rcx.sendcoa = 'Y'
      AND rcx.fax IS NOT NULL
    ORDER BY
     "Name" ASC,
     "Company" ASC,
     "Fax1" ASC;
  /*----- -----*/
  
  /*-----02. Export Data-----*/
    --Export query results to Excel Spreadsheet.
  /*----- -----*/

  /*-----03. Modify Spreadsheet-----*/
    --Remove index column (column showin row number)
  /*----- -----*/
  
  /*-----04. Save as Tab text file-----*/
    --Save Excel spreadsheet as Tab deliminated text file.
  /*----- -----*/

  /*-----05. Import Phonebook-----*/
    --In RightFax Util application, use the |Tools | Phonebook Import | tool to import 
    --the enteries.
  /*----- -----*/
  
  /*-----07. DONE-----*/
  /*----- -----*/

  
  
  
 
