PL/SQL Developer Test script 3.0
131

/*-----FindColumnValue---------------------------------------*/
  -----DESCRIPTION-----
    --This test script will take the passed parameters and
    --identify all tables and columns that contain the value
    --we are looking for.
  ----- 
  
  -----ASSUMPTIONS-----
    --User is logged into the appropriate database schema.
    --User has read rights to the user_tab_columns table.
    
    --Analytes
      --FieldDataType: VARCHAR2
      --FieldDataLength: 50
  -----

  -----TEST VARIABLES-----
    --FieldDataType    :  DataType for column containing data.
    --sFieldDataLength :  DataLength for column containing data.
    --FieldSeachValue  :  Value to search Schema for.
  -----

  -----HISTORY-----
    --2013.12.02 JTY: Begin creating script
  -----


/*-----------------------------------------------------------*/


--FROM: from Luminex Molecular Salmonella Serotyping
--TO: Molecular Salmonella Serotyping


/*-----------------------------------------------------------*/


  /*----------VARIABLES SECTION----------*/
  DECLARE

    --Input Parameters--
      sFieldDataType user_tab_columns.DATA_TYPE%Type;
      sFieldDataLength user_tab_columns.DATA_LENGTH%Type;
      sFieldSeachValue VarChar2(50);
    --
    --LocalPrimatives--
      iCounter pls_integer;
      iColumnsChecked pls_integer;      
      iOccuranceCount pls_integer;
      sSQL VarChar2(2000);
      sCurrentTable VarChar2(200);
      sCurrentColumn VarChar2(200);
    --
    ---Cursors---
    CURSOR cur_Prospects(
        pFieldDataType user_tab_columns.DATA_TYPE%Type,
        pFieldDataLength user_tab_columns.DATA_LENGTH%Type) IS
      SELECT DISTINCT
        utc.TABLE_NAME,
        utc.COLUMN_NAME,
        '%' AS eol
      FROM user_tab_columns utc
      WHERE 1=1
        AND upper(utc.DATA_TYPE) = UPPER(pFieldDataType)
        AND upper(utc.DATA_LENGTH) = UPPER(pFieldDataLength)   
---We may want to by-pass some rouge columns if they generate errors--         
        AND utc.COLUMN_NAME NOT IN ('testfield')    
      ORDER BY
        utc.TABLE_NAME ASC,
        utc.COLUMN_NAME ASC;        
      
    ---
  /*----------  ----------*/


  /*----------CODE SECTION----------*/
    BEGIN
      ---Set Variable Defaults---
        sFieldDataType   := :FieldDataType;
        sFieldDataLength := :FieldDataLength;
        sFieldSeachValue := :FieldSeachValue;            
        iCounter := 0;
        iColumnsChecked := 0;
      ---
      ---Loop through prospects---
        FOR rec_Prospects IN cur_Prospects(
            sFieldDataType, sFieldDataLength) LOOP
          --Update variables--
            iColumnsChecked := iColumnsChecked +1;
            sCurrentTable:= rec_Prospects.Table_Name;
            sCurrentColumn:= rec_Prospects.Column_Name;
            sSQL:=
              q'[ SELECT ]' ||
              q'[ COUNT(DISTINCT "]' || sCurrentColumn || q'[" ) AS Occurances  ]' ||
              q'[ FROM ]' || sCurrentTable || 
              q'[ WHERE 1=1 ]' ||
              q'[ AND UPPER("]' || sCurrentColumn || q'[") = UPPER(']' || sFieldSeachValue || q'[') ]';
          --
          --Check identified column for value matches--
            EXECUTE IMMEDIATE (sSQL) INTO iOccuranceCount;
            IF (iOccuranceCount>0) THEN
              iCounter := iCounter +1;          
              dbms_output.put_line(    
                  to_char(icounter,'000') || ': ' ||
                  '[' || sCurrentTable || '].' || sCurrentColumn);
            END IF;        
          --
        END LOOP;     
      ---
      ---Summarize Search---
        dbms_output.put_line('~~DONE~~');
        dbms_output.put_line('Searched columns: ' || to_char(iColumnsChecked,'000'));
        dbms_output.put_line('Matched  columns: ' || to_char(iCounter,'000'));
      ---
    ---Error Handling---
      EXCEPTION
        WHEN OTHERS THEN
          dbms_output.put_line('-->ERROR: ' || '[' || sCurrentTable || '].' || sCurrentColumn);          
          dbms_output.put_line(sSQL);                    
    ---      
    END;
  /*---------- ----------*/

/*----------  ----------*/
/*----------  ----------*/




-----
3
FieldDataType
1
VARCHAR2
5
FieldDataLength
1
50
3
FieldSeachValue
1
L. pneumophila PCR
5
0
