
--Influenza PCR: 1
--FilmArray Respiratory Panel 2: 511

SELECT * FROM hl7_dist_loincs

SELECT DISTINCT
  t.testcatcode,
  t.testcode,
  t.testno,
  tl.loincnumber AS t_loinc,

  '~' AS eol
FROM tests t
  INNER JOIN hl7_dist_loincs tl ON (t.testcode = dl.testcode)
WHERE 1=1
  AND t.testcode IN ('1', '525')
ORDER BY
  t.testcatcode ASC,
  t.testno ASC;




SELECT
--TESTS.TESTCATCODE, 
--TESTS.TESTCODE, 
--TESTS.TESTNO, 
TESTLOINCCODES_1.LOINCNUMBER AS T_LOINC, 
LOINCCODES_1.LOINCSHORTNAME AS T_Short,
TESTLOINCCODES_1.VERSION AS T_Ver, 
ANALYTES.ANALYTE, 
TESTLOINCCODES.LOINCNUMBER AS A_LOINC, 
LOINCCODES.LOINCSHORTNAME AS A_Short,
TESTLOINCCODES.CODE_SYSTEM_OID AS A_OID, 
TESTLOINCCODES.VERSION AS A_Ver, 
ANALYTES.SINONYM AS A_Sinonym, 
ANALYTES.ANALTYPE, 
SPEC_ANALYTES.PRINTFLAG,
ANALYTES_RNDEFAULTVALUES.RN3, 
ANALYTES.SCHEMANAME, 
ANALYTES.UNITS, 
HL7_DIST_LOINCS.LOINCNUMBER, 
HL7_DIST_LOINCS.VALUE_TYPE,
HL7_DIST_LOINCS.REPORTABLE_CONDITION
FROM HL7_DIST_LOINCS 
  RIGHT OUTER JOIN ANALYTES 
    INNER JOIN  TESTS ON ANALYTES.TESTCODE = TESTS.TESTCODE 
  ON HL7_DIST_LOINCS.ANALYTE = ANALYTES.ANALYTE 
      AND HL7_DIST_LOINCS.TESTCODE = ANALYTES.TESTCODE 
  LEFT OUTER JOIN LOINCCODES 
  RIGHT OUTER JOIN TESTLOINCCODES ON LOINCCODES.VERSION = TESTLOINCCODES.VERSION 
      AND LOINCCODES.LOINCNUMBER = TESTLOINCCODES.LOINCNUMBER 
    ON ANALYTES.ANALYTE = TESTLOINCCODES.ANALYTE 
        AND ANALYTES.TESTCODE = TESTLOINCCODES.TESTCODE 
  LEFT OUTER JOIN TESTLOINCCODES AS TESTLOINCCODES_1 
    ON TESTS.TESTCODE = TESTLOINCCODES_1.TESTCODE 
  LEFT OUTER JOIN ANALYTES_RNDEFAULTVALUES ON ANALYTES.TESTCODE = ANALYTES_RNDEFAULTVALUES.TESTCODE
    AND ANALYTES.ANALYTE = ANALYTES_RNDEFAULTVALUES.ANALYTE 
  LEFT OUTER JOIN  SPEC_ANALYTES ON ANALYTES.TESTCODE = SPEC_ANALYTES.TESTCODE 
    AND ANALYTES.ANALYTE = SPEC_ANALYTES.ANALYTE 
  LEFT OUTER JOIN LOINCCODES AS LOINCCODES_1 ON TESTLOINCCODES_1.VERSION = LOINCCODES_1.VERSION 
    AND TESTLOINCCODES_1.LOINCNUMBER = LOINCCODES_1.LOINCNUMBER
WHERE 1=1
  AND (TESTS.TESTCATCODE in ('Virology') 
  AND SPEC_ANALYTES.SPECNO = 1 
  AND SPEC_ANALYTES.SPECNO = 1 
  AND TESTS.TESTFLAG <> 'Micro') 
  AND (TESTLOINCCODES_1.ANALYTE = 'TESTLOINC' OR TESTLOINCCODES_1.ANALYTE IS NULL)
ORDER BY TESTS.TESTCATCODE, TESTS.TESTNO, ANALYTES.ANALYTE;

 

 
-- Complete list of possible results with associated SNOMED codes in selected units

SELECT   TESTS.TESTCATCODE, TESTS.TESTCODE, TESTS.TESTNO, ANALYTES.ANALYTE, ANALYTES.ANALTYPE, SPEC_ANALYTES.PRINTFLAG, 

                         ANALYTES_RNDEFAULTVALUES.RN3, ANALYTES.SCHEMANAME, ANALYTES.SINONYM, ANALYTES.UNITS, POSSIBLERESULTS.RESULT, POSSIBLERESULTS.SNOMEDCODE, 

                         POSSIBLERESULTS.SNOMEDDESCRIPTIONID, SNOMEDCODES.SNOMEDELEMENT, POSSIBLERESULTS.CODE_SYSTEM_OID, SPEC_ANALYTES.SPECNO

FROM            SNOMEDCODES RIGHT OUTER JOIN

                         POSSIBLERESULTS ON SNOMEDCODES.SNOMEDCODE = POSSIBLERESULTS.SNOMEDCODE AND 

                         SNOMEDCODES.SNOMEDDESCRIPTIONID = POSSIBLERESULTS.SNOMEDDESCRIPTIONID RIGHT OUTER JOIN

                         SPEC_ANALYTES LEFT OUTER JOIN

                         ANALYTES INNER JOIN

                         TESTS ON ANALYTES.TESTCODE = TESTS.TESTCODE ON SPEC_ANALYTES.TESTCODE = ANALYTES.TESTCODE AND 

                         SPEC_ANALYTES.ANALYTE = ANALYTES.ANALYTE LEFT OUTER JOIN

                         ANALYTES_RNDEFAULTVALUES ON ANALYTES.TESTCODE = ANALYTES_RNDEFAULTVALUES.TESTCODE AND ANALYTES.ANALYTE = ANALYTES_RNDEFAULTVALUES.ANALYTE ON 

                         POSSIBLERESULTS.TESTCODE = ANALYTES.TESTCODE AND POSSIBLERESULTS.ANALYTE = ANALYTES.ANALYTE

WHERE        (ANALYTES.ANALTYPE = 'C' AND TESTS.TESTFLAG <> 'Micro' AND EXISTS

                             (SELECT        1 AS exp1

                               FROM            POSSIBLERESULTS AS POSSIBLERESULTS_1

                               WHERE        (ANALYTES.ANALYTE = ANALYTE AND ANALYTES.TESTCODE = TESTCODE AND SPEC_ANALYTES.SPECNO = 1 AND

                                                   TESTS.TESTCATCODE IN ('Unit 13', 'Unit 72', 'MPIR'))))

ORDER BY TESTS.TESTCATCODE, TESTS.TESTNO, ANALYTES.ANALYTE, POSSIBLERESULTS.RESULT

 

