/*-----Client Sentinel Providers List Update--------------------------------*/
  --Use these script to review and update the Sentinel Providers for the 
  --Clients.  This will update the [HL7 ID] field in the [HL7 Config] tab
  --for the client.  The Provider ID is used in the PHLIP messaging.
  --This will be used in PLT 284 & PLT249 in the HL7 message (whatever that is).
/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
  --Identify Clients that have the Sentinel Provider id associated with them.
    SELECT
      rc.rasclientid,
      rc.compname,
      rc.hl7_id,
      '~' AS eol
    FROM rasclients rc
    WHERE 1=1
      AND rc.hl7_id IS NOT NULL
    ORDER BY
      rc.rasclientid ASC,
      rc.compname ASC;

/*---------------------------------------------------------------------------*/




/*-----Update Client List with Sentinel Provider ID's------------------------*/
  /*----- -----*/
  --Use these SQL statements to update the Clients with ProviderID's if they
  --are in the Sentinel Provider list. 
    UPDATE rasclients rc SET rc.hl7_id = '4147' WHERE rc.rasclientid = 'AH-P';
    UPDATE rasclients rc SET rc.hl7_id = '4005' WHERE rc.rasclientid = 'ASU-T';
    UPDATE rasclients rc SET rc.hl7_id = '4137' WHERE rc.rasclientid = 'BH';
    UPDATE rasclients rc SET rc.hl7_id = '4119' WHERE rc.rasclientid = 'BIMC';
    UPDATE rasclients rc SET rc.hl7_id = '4142' WHERE rc.rasclientid = 'CGRMC';
    UPDATE rasclients rc SET rc.hl7_id = '4006' WHERE rc.rasclientid = 'CHS';
    UPDATE rasclients rc SET rc.hl7_id = '4154' WHERE rc.rasclientid = 'CQCH';
    UPDATE rasclients rc SET rc.hl7_id = '4140' WHERE rc.rasclientid = 'CVCH';
    UPDATE rasclients rc SET rc.hl7_id = '4076' WHERE rc.rasclientid = 'ERHC-EPC';
    UPDATE rasclients rc SET rc.hl7_id = '4160' WHERE rc.rasclientid = 'FHAA';
    UPDATE rasclients rc SET rc.hl7_id = '4136' WHERE rc.rasclientid = 'GHR';
    UPDATE rasclients rc SET rc.hl7_id = '4093' WHERE rc.rasclientid = 'KRH';
    UPDATE rasclients rc SET rc.hl7_id = '4074' WHERE rc.rasclientid = 'LPRH';
    UPDATE rasclients rc SET rc.hl7_id = '4082' WHERE rc.rasclientid = 'MCHC';
    UPDATE rasclients rc SET rc.hl7_id = '4073' WHERE rc.rasclientid = 'MGRMC';
    UPDATE rasclients rc SET rc.hl7_id = '4155' WHERE rc.rasclientid = 'NCCH';
    UPDATE rasclients rc SET rc.hl7_id = '4117' WHERE rc.rasclientid = 'PH';
    UPDATE rasclients rc SET rc.hl7_id = '4139' WHERE rc.rasclientid = 'PRMC';
    UPDATE rasclients rc SET rc.hl7_id = '4138' WHERE rc.rasclientid = 'SLFHC-CG';
    UPDATE rasclients rc SET rc.hl7_id = '4156' WHERE rc.rasclientid = 'SVRHC';
    UPDATE rasclients rc SET rc.hl7_id = '4101' WHERE rc.rasclientid = 'VALVMC';
    UPDATE rasclients rc SET rc.hl7_id = '4095' WHERE rc.rasclientid = 'WARMC';
    UPDATE rasclients rc SET rc.hl7_id = '4001' WHERE rc.rasclientid = 'YRMC-Y';
  /*----- -----*/

/*---------------------------------------------------------------------------*/  
