
/*---------Generate Samples for Validation-----------------------------------*/
  --These sets of scripts should help you determine what data would be valid
  --for test samples (ie Submitter, Specimen Type, etc).
/*---------------------------------------------------------------------------*/


/*---01. Sample Information--------------------------------------------------*/
    SELECT DISTINCT
      f.testgroupname,
      cr.spec_source,
      cr.sampdesc,
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        AND mr.field_varchar_80 = 'Diagnostic')
      INNER JOIN ordtask OT ON (f.folderno = ot.folderno)
    WHERE 1=1
      AND ot.testno IN ('TaqPath COVID-19 rRT-PCR', '2019 Novel Coronavirus rRT-PCR')
    --  AND f.testgroupname IN (
    --    'Measles PCR', 'Clinical Virology', 'Influenza',
    --    'Coronavirus Morbidity', 'Coronavirus', 'Influenza',
    --    'Norovirus PCR'
    --  )
    --  AND ot.testno IN (
    --    'BGI SARS-2019-nCoV RT-PCR', '2019 Novel Coronavirus rRT-PCR', 'TaqPath COVID-19 rRT-PCR',
    --    'Xpert Xpress SARS CoV 2', 'Influenza PCR', 'Measles PCR',
    --    'FilmArray Respiratory Panel 2', 'Xpert Norovirus'
    --   )
    --  AND f.testgroupname = 'Clinical Virology'
      ORDER BY
        f.testgroupname ASC;
/*---------------------------------------------------------------------------*/





/*---------------------------------------------------------------------------*/
/*-----Identify Sentinel Proivders-------------------------------------------*/
  SELECT 
    rc.rasclientid,
    rc.compname,
    rc.hl7_id,
    '~' AS eol
  FROM rasclients rc
  WHERE 1=1
    AND rc.hl7_id IS NOT NULL
  ORDER BY
    rc.rasclientid ASC;    
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
    
