

SELECT DISTINCT
  f.folderno,
  f.dept,
  UPPER(cr.last_name || ', ' || cr.first_name ) AS patient_name,
  f.testgroupname,
  f.apprdate,
  ha.rasclientid,
  cr.rasclientid,
--  ot.testno,
  f.apprdate,
  '~' AS eol
FROM hl7_analytes ha
 INNER JOIN tests t ON (ha.testcode = ha.testcode)
 INNER JOIN ordtask ot ON (t.testcode = ot.testcode)
 INNER JOIN folders f ON (ot.folderno = ot.folderno)
 INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
  INNER JOIN metadata_repository mr ON (1=1
    AND mr.tablereference = 'CENTRALRECEIVING'
    AND mr.original_origrec = cr.origrec)
WHERE 1=1
  AND ha.rasclientid IN ('MEDSIS', 'MEDSIS-TEST')
  AND f.external_id IN (
  'AZ20000162', 'AZ20000163', 'AZ20000164',
  'AZ20000165', 'AZ20000166', 'AZ20000169',
  'AZ20000170', 'AZ20000171', 'AZ20000172',
  'AZ20000173'
  )
--  AND f.external_id IN (
--  'AZ20000034', 'AZ20000035', 'AZ20000036',
--  'AZ20000077', 'AZ20000078', 'AZ20000079',
--  'AZ20000080', 'AZ20000107'
--  )



--  AND to_date(f.apprdate, 'DD-MON-YY') BETWEEN to_date('02-OCT-2019', 'DD-MON-YYYY') AND to_date('07-OCT-2019', 'DD-MON-YYYY')
ORDER BY
  f.testgroupname ASC,
  f.folderno ASC
