

/*-----PHLIP_Validation_SampleID---------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --The purpose of these scripts are to identify real world samples that
    --should be good for performing PHLIP validation on.
  /*----- -----*/
  
  
  /*-----HISTORY-----*/
    --2020.05.02 JTY: Create Script
  /*----- -----*/
/*---------------------------------------------------------------------------*/


/*-----01. Identify Potential Samples for validation-------------------------*/

  -----Influenza PCR---
/*  
    SELECT DISTINCT
      cr.rasclientid,
      cr.owner_county,
      f.external_id,
      (cr.first_name || ' ' || cr.last_name) AS patient_name,    
      f.dept,
      f.testgroupname,
      t.testno,
      r.runno,
      r.final,
      f.apprdate,
      '~' AS eol
    FROM folders f
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN tests t ON (ot.testcode = t.testcode)    
      INNER JOIN results r ON (1=1
        AND ot.ordno = r.ordno
        AND ot.testcode = r.testcode)
    WHERE 1=1
        AND f.external_id LIKE ('AZ00%')
        AND f.apprdate IS NOT NULL      
        AND t.testno IN (
          'Influenza PCR'
  --        'FilmArray Respiratory Panel 2'
  --        '2019 Novel Coronavirus rRT-PCR',
  --        'TaqPath COVID-19 rRT-PCR',
  --        'Xpert Xpress SARS CoV 2',
  --        'BGI SARS-2019-nCoV RT-PCR',     
        )
        
  --AND r.final IN (
  --'Inconclusive',
  --'Inconclusive, no RP',
  --'Influenza A 2009 H1N1'
  --'Influenza A(H3)',
  --'Influenza B Victoria',
  --'Influenza B Yamagata', 
  --'Influenza not detected', 
  --'Not Tested', 
  --'Not detected', 
  --'Retest',
  --'Sample Not Tested'
  --'')
  --AND f.external_id = 'AZ00091550'      
      AND mr.field_varchar_80 = 'Diagnostic'
      AND EXTRACT(YEAR FROM  f.apprdate)  = 2019
      AND f.apprdate IS NOT NULL
      AND f.external_id IS NOT NULL
      AND cr.last_name <> 'Yoder'
  --AND f.external_id IN (
  --'AZ00078903', 'AZ00080995', 'AZ00091473',
  --'AZ00091474', 'AZ00092908', 'AZ00092987',
  --'AZ00093129', 'AZ00093539', 'AZ00093550'
  --)    
    ORDER BY
      f.external_id DESC,
      cr.rasclientid ASC,
      cr.owner_county ASC,
      f.testgroupname ASC,
      r.final ASC
      ;
*/      
  ----- ---

  -----Influenza PCR---
/*
    SELECT DISTINCT
      cr.rasclientid,
r.analyte,
      cr.owner_county,
      f.external_id,
      (cr.first_name || ' ' || cr.last_name) AS patient_name,    
      f.dept,
      f.testgroupname,
      t.testno,
      r.runno,
      r.final,
      f.apprdate,
      '~' AS eol
    FROM folders f
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN tests t ON (ot.testcode = t.testcode)    
      INNER JOIN results r ON (1=1
        AND ot.ordno = r.ordno
        AND ot.testcode = r.testcode)
    WHERE 1=1
        AND f.external_id LIKE ('AZ00%')
        AND f.apprdate IS NOT NULL
        AND r.final = 'Detected'
        AND t.testno IN (
  --        'Influenza PCR'
            'FilmArray Respiratory Panel 2'
  --        '2019 Novel Coronavirus rRT-PCR',
  --        'TaqPath COVID-19 rRT-PCR',
  --        'Xpert Xpress SARS CoV 2',
  --        'BGI SARS-2019-nCoV RT-PCR',     
        )
       AND r.analyte IN (
         'Parainfluenza Virus 1', 
         'Mycoplasma pneumoniae',
         'Influenza B',
         'Human Rhinovirus/Enterovirus'
       )        
  --AND r.final IN (
  --'Inconclusive',
  --'Inconclusive, no RP',
  --'Influenza A 2009 H1N1'
  --'Influenza A(H3)',
  --'Influenza B Victoria',
  --'Influenza B Yamagata', 
  --'Influenza not detected', 
  --'Not Tested', 
  --'Not detected', 
  --'Retest',
  --'Sample Not Tested'
  --'')
AND f.external_id = 'AZ00093487'      
      AND mr.field_varchar_80 = 'Diagnostic'
--      AND EXTRACT(YEAR FROM  f.apprdate)  = 2019
      AND f.apprdate IS NOT NULL
      AND f.external_id IS NOT NULL
      AND cr.last_name <> 'Yoder'
    ORDER BY
      f.external_id DESC,
      cr.rasclientid ASC,
      cr.owner_county ASC,
      f.testgroupname ASC,
      r.final ASC
      ;
*/      
  ----- ---
  
  -----Xpert Norovirus---
    SELECT DISTINCT
      cr.rasclientid,
      cr.owner_county,
      f.external_id,
      (cr.first_name || ' ' || cr.last_name) AS patient_name,    
      f.dept,
      f.testgroupname,
      t.testno,
      r.runno,
      r.final,
      f.apprdate,
      '~' AS eol
    FROM folders f
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN tests t ON (ot.testcode = t.testcode)    
      INNER JOIN results r ON (1=1
        AND ot.ordno = r.ordno
        AND ot.testcode = r.testcode)
    WHERE 1=1
        AND f.external_id LIKE ('AZ00%')
        AND f.apprdate IS NOT NULL      
        AND t.testno IN (
            'Xpert Norovirus'
  --        'Influenza PCR'
  --        'FilmArray Respiratory Panel 2'
  --        '2019 Novel Coronavirus rRT-PCR',
  --        'TaqPath COVID-19 rRT-PCR',
  --        'Xpert Xpress SARS CoV 2',
  --        'BGI SARS-2019-nCoV RT-PCR',     
        )
        
  AND r.final IN (
  'GII Positive',
--  'Negative',
--  'Not Tested',
  '')
  AND f.external_id = 'AZ00083684'      
      AND mr.field_varchar_80 = 'Diagnostic'
      AND EXTRACT(YEAR FROM  f.apprdate)  = 2019
      AND f.apprdate IS NOT NULL
      AND f.external_id IS NOT NULL
      AND cr.last_name <> 'Yoder'
  --AND f.external_id IN (
  --'AZ00078903', 'AZ00080995', 'AZ00091473',
  --'AZ00091474', 'AZ00092908', 'AZ00092987',
  --'AZ00093129', 'AZ00093539', 'AZ00093550'
  --)    
    ORDER BY
--      f.external_id DESC,
--      cr.rasclientid ASC,
--      cr.owner_county ASC,
      f.testgroupname ASC,
      r.final ASC
      ;
  ----- ---
  
  
/*---------------------------------------------------------------------------*/


/*-----02. Update First/Last Name for Validation-----------------------------*/
/*
SELECT cr.first_name,cr.last_name FROM centralreceiving cr WHERE cr.external_id = '&ExternalID'


  UPDATE centralreceiving cr
  SET 
    cr.first_name = 'Scenario-&ScenarioNumber',
    cr.last_name = 'PhlipVal'
  WHERE 1=1
    AND cr.external_id = '&ExternalID'
*/    
/*---------------------------------------------------------------------------*/



/*-----TimeStamp Isssues-----------------------------------------------------*/
--Samples having issues with APM-18, OBX-19 Where analyzed time apppears to be before collection time.
/*
SELECT DISTINCT
  cr.external_id,
  cr.date_received,
  cr.time_received,
  ot.testno,
  r.dateenter,
  ot.analyzedenddate,
  ot.analyzedtime,
  
  '~' AS eol
FROM centralreceiving cr
  INNER JOIN folders f ON (cr.external_id = f.external_id)
  INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
  INNER JOIN results r ON (1=1
    AND ot.runno = r.runno
    AND ot.ordno = r.ordno
    AND ot.testcode = r.testcode)
WHERE 1=1
  AND cr.external_id IN ('AZ10000112')
  
UPDATE centralreceiving cr SET
cr.time_received = '05:20'
WHERE 1=1
  AND cr.external_id IN ('AZ10000106')
*/  
/*---------------------------------------------------------------------------*/
