
/*-----01 Rabies Sample HL7---------------------------------------------------*/
  --Query to retrieve information associated with specified sample
    SELECT DISTINCT
      cr.external_id,
      f.testgroupname,
      (ot.testno || ' (' || ot.testcode || ')') AS test_name,
      r.final,
      ot.apprdate,
      '~' AS sp1,
       ---Submitter Info---
         '~SUB~' AS SUB,
         cr.pid AS bite_no,
         cr.date_received,
         cr.time_received,
         mr.field_varchar_80 AS activity_type,
         (rc.compname || ' (' || cr.rasclientid || ')') AS submitter,        
       --- ---
       ---Animal Info---
         '~ANM~' AS ANM,
         cr.patientrace AS category,
         (species.display_name || ' (' || mr.field_varchar_05 || ')') AS species,
         (gender.display_name || ' (' || cr.sex || ')')  AS gender,
         (agecat.display_name || ' (' || cr.category_other || ')') AS age_category,
         mr.field_integer_02 AS age,
         (spectype.display_name || ' (' || cr.spec_source || ')')  AS specimen_type,
         (vacstat.display_name || ' (' || mr.field_varchar_51 || ')')  AS vax_stat,
         mr.field_date_02 AS vax_date,
         cr.onset_date,
       --- ---
       ---Sample Collection Info---
        '~COL~' AS col,
         cr.date_collected AS collect_date,
         cr.owner_state AS state,
         cr.owner_county AS county,
         cr.owner_city AS city,
         cr.owner_zip AS zip_code,
         cr.latitude AS latitude,
         cr.longitude AS longitude,
       --- ---
       ---Victim Info---
         '~VIC~' AS vic,
         mr.field_date_01 AS vic_exp_date,
         mr.field_varchar_01 AS vic_name,
       --- ---
       ---EPI Questions---
        '~EPI~' AS epi,
         (domesticexp.display_name || ' (' || mr.field_varchar_52 || ')')  AS domestic_exp,
         mr.field_integer_03  AS domestic_cnt,
         (domesticspe.display_name || ' (' || mr.field_varchar_54 || ')')  AS domestic_species,
         (humanexp.display_name || ' (' || mr.field_varchar_55 || ')')  AS human_exp,        
         mr.field_integer_05  AS human_cnt,
         (exptype.display_name || ' (' || mr.field_varchar_56 || ')')  AS exp_type,
         (surveillance.display_name || ' (' || mr.field_varchar_02 || ')')  AS surveillance_mthd,
         (ownership.display_name || ' (' || mr.field_varchar_57 || ')')  AS ownership,
         (deathtype.display_name || ' (' || mr.field_varchar_58 || ')')  AS death_type,        
         (signs.display_name || ' (' || mr.field_varchar_59 || ')')  AS signs,
         (held.display_name || ' (' || mr.field_varchar_60 || ')')  AS held,
         mr.field_integer_04 AS days_held,
         (send_cdc.display_name || ' (' || send_cdc.concept_code || ')')  AS cdc_sendout,
       --- ---
       ---Test Info---
         '~TST~' AS TST,
         (t.testno || ' (' || t.testcode || ')') AS test_name,
         t.phvs_concept_code AS loinc_code,
         t.phvs_concept_name,
         t.phvs_code_system_oid AS code_sys,
       --- ---
       ---Results Info---
         '~RST~' AS RST,
         sc.snomedcode,
         sc.snomedelement,
         pr.code_system_oid,
         pr.localnumber,
       --- ---
      '~' AS eol
     
   ---->FROM<---      
    FROM centralreceiving cr
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
      ---Test Info ---
        LEFT OUTER JOIN ordtask ot ON (f.folderno = ot.folderno)
        LEFT OUTER JOIN tests t ON ot.testcode = t.testcode
      --- ---
      ---Results Info---
        LEFT OUTER JOIN results r ON (1=1
          AND ot.ordno = r.ordno
          AND ot.testcode = r.testcode)
        LEFT OUTER JOIN possibleresults pr ON (1=1
          AND r.testcode = pr.testcode
          AND r.analyte = pr.analyte
          AND r.final = pr.result)
        LEFT OUTER JOIN snomedcodes sc ON (1=1
          AND pr.snomedcode = sc.snomedcode
          AND pr.snomedconceptid = pr.snomedcode) ---hmmm pr.snomedcode or pr.snomedconceptid?
      --- ---
      ---HL7 Lookups: Submitter Info---
        INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)      
      --- ---
      ---HL7 Lookups: Animal Info---
        LEFT OUTER JOIN phvs_value_sets_details species ON ( 1=1
          AND species.value_set_code = 'PHVS_Rabies_AnimalSpecies'
          AND species.concept_code = mr.field_varchar_05)
        LEFT OUTER JOIN phvs_value_sets_details gender ON ( 1=1
          AND gender.value_set_code = 'PHVS_Rabies_AnimalGender'
          AND gender.concept_code = cr.sex)
        LEFT OUTER JOIN phvs_value_sets_details agecat ON ( 1=1
          AND agecat.value_set_code = 'PHVS_Rabies_AgeCategory'
          AND agecat.concept_code = cr.category_other)
        LEFT OUTER JOIN phvs_value_sets_details spectype ON ( 1=1
          AND spectype.value_set_code = 'PHVS_Rabies_SpecimenSource'
          AND spectype.concept_code = cr.spec_source)
        LEFT OUTER JOIN phvs_value_sets_details vacstat ON ( 1=1
          AND vacstat.value_set_code = 'PHVS_Rabies_VaccinatedStatus'
          AND vacstat.concept_code = mr.field_varchar_51)
      --- ---
      ---HL7 Lookups: EPI Questions---
        LEFT OUTER JOIN phvs_value_sets_details domesticexp ON ( 1=1
          AND domesticexp.value_set_code = 'PHVS_Rabies_YNU'
          AND domesticexp.concept_code = mr.field_varchar_52)
        LEFT OUTER JOIN phvs_value_sets_details domesticspe ON ( 1=1
          AND domesticspe.value_set_code = 'PHVS_Rabies_ExposedSpecies'
          AND domesticspe.concept_code = mr.field_varchar_54)
        LEFT OUTER JOIN phvs_value_sets_details humanexp ON ( 1=1
          AND humanexp.value_set_code = 'PHVS_Rabies_YNU'
          AND humanexp.concept_code = mr.field_varchar_55)
        LEFT OUTER JOIN phvs_value_sets_details exptype ON ( 1=1
          AND exptype.value_set_code = 'PHVS_Rabies_ExposureType'
          AND exptype.concept_code = mr.field_varchar_56)
        LEFT OUTER JOIN phvs_value_sets_details surveillance ON ( 1=1
          AND surveillance.value_set_code = 'PHVS_Rabies_Surveillance'
          AND surveillance.concept_code = mr.field_varchar_02)
        LEFT OUTER JOIN phvs_value_sets_details ownership ON ( 1=1
          AND ownership.value_set_code = 'PHVS_Rabies_Ownership'
          AND ownership.concept_code = mr.field_varchar_57)
        LEFT OUTER JOIN phvs_value_sets_details deathtype ON ( 1=1
          AND deathtype.value_set_code = 'PHVS_Rabies_DeathType'
          AND deathtype.concept_code = mr.field_varchar_58)
        LEFT OUTER JOIN phvs_value_sets_details signs ON ( 1=1
          AND signs.value_set_code = 'PHVS_Rabies_YNU'
          AND signs.concept_code = mr.field_varchar_59)
        LEFT OUTER JOIN phvs_value_sets_details held ON ( 1=1
          AND held.value_set_code = 'PHVS_Rabies_YNU'
          AND held.concept_code = mr.field_varchar_60)
        --Sent to CDC--  
          LEFT OUTER JOIN ordtask ot2 ON ( 1=1
            AND f.folderno = ot2.folderno
            AND ot2.testno = 'Send out Virology')
          LEFT OUTER JOIN phvs_value_sets_details send_cdc ON ( 1=1
            AND send_cdc.value_set_code = 'PHVS_Rabies_YNU'
            AND send_cdc.concept_code = 
              CASE 
                WHEN (ot2.origrec IS NULL) THEN 'N'
                ELSE 'Y' 
              END
          )
         -- --
      --- ---
      ---HL7 Lookups: Test Information---
        LEFT OUTER JOIN loinccodes lc ON (1=1
          AND lc.classcode = 'MICRO'
          AND lc.version = '2.24'
          AND lc.loincnumber = t.phvs_concept_code)
      --- ---
    WHERE 1=1
      AND cr.external_id = '&SampleID'
    ORDER BY
      cr.external_id ASC,
--      test_name ASC,
      r.final ASC;

/*---------------------------------------------------------------------------*/
