


-----Update delivery method for all external contacts to PDF Only-----
  UPDATE rasclientcontactsext rcx
  SET rcx.submit_method = 'PDF Only'
  WHERE 1=1
    AND rcx.submit_method IS NOT NULL    
----- -----


-----Update all active samples delivery Methods to match new default-----
  MERGE INTO folderscontactsext t1
  USING (
    SELECT DISTINCT
      rc.compname || '(' || rc.rasclientid || ')' AS client,
      f.dept,
      fcx.folderno,
      f.testgroupname AS panel,
      fcx.contactid,
      fcx.submit_method,
      rcx.submit_method AS rcx_submit_method,
      rcx.fax AS rcx_fax,
      fcx.rasclientid,
      fcx.origrec AS fcx_origrec,
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN rasclients rc ON (cr.rasclientid = rc. rasclientid)
      INNER JOIN rasclientcontactsext rcx ON (rc.rasclientid = rcx.rasclientid)
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN foldercondition fc ON (f.folderno = fc.folderno)
      INNER JOIN folderscontactsext fcx ON (1=1
        AND fcx.folderno = f.folderno
        AND fcx.rasclientid = rcx.rasclientid
        AND fcx.contactid = rcx.contactid)
    WHERE 1=1
      AND (rcx.submit_method <> fcx.submit_method)
--      AND rc.rasclientid = '&RasClientID'  ---CLIENT(s) OF INTEREST HERE---
      AND (f.apprdate IS NULL OR fc.approveddate IS NULL)
      AND UPPER(f.testgroupname) NOT LIKE '%SENDOUT%'
      AND UPPER(f.testgroupname) NOT LIKE '%PFGE%'
    ORDER BY
      client ASC,
      f.dept ASC,
      fcx.folderno ASC  
  ) t2
  ON (1=1
    AND t1.origrec = t2.fcx_origrec
    AND t1.folderno = t2.folderno 
    AND t1.rasclientid = t2.rasclientid
    AND t1.contactid = t2.contactid
  )    
  WHEN MATCHED THEN
    UPDATE SET
      t1.submit_method = rcx_submit_method;
----- -----

-----Update all RDQ samples delivery Methods to match new default-----
--Since this is for PDF only, we will wipe out the DistributionMethodID and
--the DeliveryAddress.
  MERGE INTO rr_report_delivery_queue t1
  USING (
    SELECT DISTINCT
      (rc.compname || ' (' || rc.rasclientid || ')') AS client,
      f.dept,
      rdq.folderno,
      rdq.status,
      rcx.fullname,
      rcx.contactid,
      rcx.submit_method AS rcx_method,
      rcx.fax AS rcx_address,
      --rdq.itemid,
      '' AS itemid,
      rdq.delivery_method,
      --rdq.delivery_address,
      '' AS delivery_address,
      rdq.origrec AS rdq_origrec,
      rc.rasclientid,
      '~' AS eol
    FROM rr_report_delivery_queue rdq
      INNER JOIN folders f ON (rdq.folderno = f.folderno)
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN rasclientcontactsext rcx ON (1=1
        AND rdq.rasclientid = rcx.rasclientid
        AND rdq.contactid = rcx.contactid)
    WHERE 1=1
      AND UPPER(f.testgroupname) NOT LIKE '%SENDOUT%'
      AND UPPER(f.testgroupname) NOT LIKE '%PFGE%'
      AND (
        (rdq.delivery_method <> rcx.submit_method )
        OR (rdq.delivery_address <> rcx.fax )
      )
      AND rdq.status = 'QUEUED'
--      AND rdq.rasclientid = '&RasClientID'
    ORDER BY
      client ASC,
      f.dept ASC,
      rdq.folderno ASC
  ) t2
  ON (1=1
    AND t1.origrec = t2.rdq_origrec
    AND t1.rasclientid = t2.rasclientid
    AND t1.contactid = t2.contactid
    AND t1.folderno = t2.folderno
  )    
  WHEN MATCHED THEN
    UPDATE SET
      t1.delivery_method = t2.rcx_method,
      t1.delivery_address = t2.rcx_address,
      t1.itemid = t2.itemid;
----- -----
