SELECT 
  H1.Header_Name AS "Program Name",
  H1.HL7_SEGMENT AS "HL7 Segment", 
  H1.HL7_FIELD_NAME AS "HL7 Segment Field", 
  '' AS "HL7 Field Name Description",
  H1.COMPOSITE AS "Value Type",
  H1.DEFAULT_VALUE AS "Default Value", 
  H1.CALCNAME AS "Calculation",
  H1.MANDATORY AS "Required",
--  H1.STARLIMS_TABLE, 
--  H1.STARLIMS_COLUMN,
--  H1.HL7_VERSION, 
--  H2.DESCRIPTION,
--  H1.METADATA_REFTBL,
  '~' AS eol
FROM HL7_FIELDMAP H1
  INNER JOIN HL7_FIELDNAMES H2 ON (1=1
    AND H1.HL7_VERSION = H2.VERSION 
    AND H1.HL7_FIELD_NAME = H2.FIELDNAME 
    AND H1.HL7_SEGMENT = H2.HL7_SEGMENT)
WHERE 1=1
  AND HEADER_NAME = '&HeaderName'
ORDER BY 
  "Program Name" ASC,
  "HL7 Segment" ASC,
  "HL7 Segment Field" ASC
