
/*
  SELECT
    lc1.*
  FROM loinccodes lc1
    INNER JOIN loinccodes lc2 ON (1=1
      AND lc1.classcode = lc2.classcode
      AND lc1.codestatus = lc2.codestatus
      AND lc1.loinccomponenet = lc2.loinccomponenet
      AND lc1.loincmethod = lc2.loincmethod
      AND lc1.loincnumber = lc2.loincnumber
      AND lc1.loincproperty = lc2.loincproperty
      AND lc1.loincscale = lc2.loincscale
      AND lc1.loincshortname = lc2.loincshortname
      AND lc1.loincsystems = lc2.loincsystems
      AND lc1.loinctime = lc2.loinctime
      AND lc1.mapto = lc2.mapto
      AND lc1.origsts = lc2.origsts
      AND lc1.version = lc2.version
      AND lc1.origrec <> lc2.origrec
    )
  WHERE 1=1
  ORDER BY lc1.loincnumber ASC;
*/

/*---------------------------------------------------------------------------*/
/*-----SNOMED CODES Cleanup--------------------------------------------------*/

  /*-----1. Remove Exact Duplicates-----*/
    --Everything the same except for the Origric number
/*
    MERGE INTO snomedcodes t1
    USING () t2
    ON (
    
    )
    WHEN MATCHED THEN
      UPDATE SET t1.origrec = t1.origrec)
      DELETE WHERE (t1.origrec = )
*/

--Try to identify records to remove...
    SELECT 
      my_rownum,
      sc1_origrec,
      snomedcode,
      '~' AS eol
    FROM (
    SELECT DISTINCT
      rownum AS my_rownum,  
      sc1.snomedcode,
      sc1.snomedelement,
      sc1.origrec AS sc1_origrec,
  --    sc2.origrec AS sc2_origrec,
      '~' AS eol
    FROM snomedcodes sc1
      INNER JOIN snomedcodes sc2 ON (1=1
        AND sc1.snomedcode = sc2.snomedcode
        AND COALESCE(sc1.loinccondname, '.') = COALESCE(sc2.loinccondname, '.')
        AND COALESCE(sc1.origsts, '.') = COALESCE(sc2.origsts, '.')
        AND COALESCE(sc1.snomedelement, '.') = COALESCE(sc2.snomedelement, '.')
        AND COALESCE(sc1.snomedconceptid, '.') = COALESCE(sc2.snomedconceptid, '.')
        AND COALESCE(sc1.snomeddescriptionid, '.') = COALESCE(sc2.snomeddescriptionid, '.')
        AND COALESCE(sc1.snomed_group, '.') = COALESCE(sc2.snomed_group, '.')
        AND sc1.origrec <> sc2.origrec
      )
    WHERE 1=1
     AND sc1.snomedcode = '260373001'  --421
    ORDER BY
      sc1.snomedcode ASC,
      sc1.origrec ASC
    ) toss_me
    WHERE 1=1
      AND my_rownum > 1
    ORDER BY rownum ASC
  /*----- -----*/
/*---------------------------------------------------------------------------*/
  
