


/*-----CRE EPI Check---------------------------------------------------------*/
  --This query will compare the results from the ADHS_CRE_EXTRACT view and the
  --ADHS_EPI_CRE extract and make sure the check out.
/*---------------------------------------------------------------------------*/


SELECT 
  ec.sample_no,
  cx.ARLN_Specimen_ID AS cx_ARLN_Specimen_ID,
  ec.Phenotypic_test_result,
  cx.Phenotypic_test_result AS cx_Phenotypic_test_result,  
  ec.Confirmed_carbapenem_resistant,
  cx.confirmed_carbapenem_resistant AS cx_con_carbapenem_resistant,
  ec.is_cre,
  cx.is_cre AS cx_is_cre,
  ec.is_crpa,
  cx.is_crpa AS cx_is_crpa,
  ec.IMP_gene,
  cx.IMP_gene AS cx_IMP_gene,
  ec.KPC_gene,
  cx.KPC_gene AS cx_KPC_gene,
  ec.mcr_gene,
  cx.mcr_gene AS cx_mcr_gene,
  ec.NDM_gene,
  cx.NDM_gene AS cx_NDM_gene,
  ec.OXA_48_like_gene,
  cx.OXA_48_like_gene AS cx_OXA_48_like_gene,
  ec.VIM_gene,
  cx.VIM_gene AS cx_VIM_gene,
  ec.Other_gene_name,
  cx.Other_gene_name AS cx_Other_gene_name,
  ec.Other_gene_result,
  cx.Other_gene_result AS cx_Other_gene_result,
  ec.Aztreonam_result,
  '~' AS cx_Aztreonam_result,
  ec.Aztreonam_AST_MIC,
  cx.Aztreonam_AST_MIC AS cx_Aztreonam_AST_MIC,  
  ec.Aztreonam_AST_zone_diameter,
  cx.Aztreonam_AST_zone_diameter AS cx_Aztreonam_AST_zone_diameter,  
  ec.Cefepime_result,
  '~' AS cx_Cefepime_result,
  ec.Cefepime_AST_MIC,
  cx.Cefepime_AST_MIC AS cx_Cefepime_AST_MIC,
  ec.Cefepime_AST_zone_diameter,
  cx.Cefepime_AST_zone_diameter AS cx_Cefepime_AST_zone_diameter,
  ec.Ceftazidime_result,
  '~' AS cx_Ceftazidime_result,
  ec.Ceftazidime_AST_MIC,
  cx.Ceftazidime_AST_MIC AS cx_Ceftazidime_AST_MIC,
  ec.Ceftazidime_AST_zone_diameter,
  cx.Ceftazidime_AST_zone_diameter AS cx_Ceftazidime_AST_zone_diam,
  ec.Ceftriaxone_result,
  '~' AS cx_Ceftriaxone_result,
  ec.Ceftriaxone_AST_MIC,
  cx.Ceftriaxone_AST_MIC AS cx_Ceftriaxone_AST_MIC,
  ec.Ceftriaxone_AST_zone_diameter,
  cx.Ceftriaxone_AST_zone_diameter AS cx_Ceftriaxone_AST_zone_diam,
  ec.Colistin_result,
  '~' AS cx_Colistin_result,
  ec.Colistin_AST_MIC,
  cx.Colistin_AST_MIC AS cx_Colistin_AST_MIC,
  ec.Doripenem_result,
  '~' AS cx_Doripenem_result,
  ec.Doripenem_AST_MIC,
  cx.Doripenem_AST_MIC AS cx_Doripenem_AST_MIC,
  ec.Doripenem_AST_zone_diameter,
  cx.Doripenem_AST_zone_diameter AS cx_Doripenem_AST_zone_diam,
  ec.Ertapenem_result,
  '~' AS cx_Ertapenem_result,
  ec.Ertapenem_AST_MIC,
  cx.Ertapenem_AST_MIC AS cx_Ertapenem_AST_MIC,
  ec.Ertapenem_AST_zone_diameter,
  cx.Ertapenem_AST_zone_diameter AS cx_Ertapenem_AST_zone_diam,
  ec.Imipenem_result,
  '~' AS cx_Imipenem_result,
  ec.Imipenem_AST_MIC,
  cx.Imipenem_AST_MIC AS cx_Imipenem_AST_MIC,
  ec.Imipenem_AST_zone_diameter,
  cx.Imipenem_AST_zone_diameter AS cx_Imipenem_AST_zone_diam,
  ec.Meropenem_result,
  '~' AS cx_Meropenem_result,
  ec.Meropenem_AST_MIC,
  cx.Meropenem_AST_MIC AS cx_Meropenem_AST_MIC,
  ec.Meropenem_AST_zone_diameter,
  cx.Meropenem_AST_zone_diameter AS cx_Meropenem_AST_zone_diam,
  ec.O3g_cep_name,
  cx.O3g_cep_name AS cx_O3g_cep_name,
  ec.O3g_cep_AST_MIC,
  cx.O3g_cep_AST_MIC AS cx_O3g_cep_AST_MIC,
  ec.O3g_cep_AST_zone_diameter,
  cx.O3g_cep_AST_zone_diameter AS cx_O3g_cep_AST_zone_diam,
  ec.Pt_AST_MIC,
  cx.Pt_AST_MIC AS cx_Pt_AST_MIC,
  ec.Pt_AST_zone_diameter,
  cx.Pt_AST_zone_diameter AS cx_Pt_AST_zone_diameter,
  ec.days_elapsed,
  cx.days_elapsed AS cx_days_elapsed,
  '~' AS eol
FROM adhs_epi_cre ec
  LEFT OUTER JOIN adhs_cre_extract cx ON (ec.sample_no = cx.ARLN_Specimen_ID)
WHERE 1=1

  AND ec.sample_no IN (  
'AZ00097771',
'AZ00098329',
'AZ00098333',
'AZ00098391',
'AZ00098323',
'AZ00098118',
'AZ00098336',
'AZ00098219',
'AZ00098220',
'AZ00098137',
'AZ00098326',
'AZ00098331',
'AZ00098213',
'AZ00098120',
'AZ00097768',
'AZ00098324',
'AZ00098218',
'AZ00098409',
'AZ00098327',
'AZ00098325',
'AZ00098215',
'AZ00098330',
'AZ00097460',
'AZ00098119'
  )
  
ORDER BY
  ec.sample_no DESC;  
