/*-----ETOR_StaticList-------------------------------------------------------*/
  --Set of queries to provide requested information to ETOR team.
  
/*---------------------------------------------------------------------------*/





/*-----01. Specimen_Type-----------------------------------------------------*/

  SELECT 
    TRIM(ss.specimen_source) AS Specimen_Type
  FROM specimen_sources ss
  ORDER BY
    ss.specimen_source ASC;
/*---------------------------------------------------------------------------*/


/*-----02. Sample Description------------------------------------------------*/
  SELECT
    TRIM (bsd.bs_name) AS sample_description
  FROM base_static_data bsd
    INNER JOIN metadata_repository mr ON (1=1
      AND bsd.origrec = mr.original_origrec
      AND mr.tablereference = 'BASE_STATIC_DATA'
    )
  WHERE 1=1
    AND bsd.bs_type = 'Sample Descriptions'
    AND bsd.bs_status = 'Active'
    AND mr.field_varchar_01 = 'Clinical'
  ORDER BY
    sample_description ASC;
/*---------------------------------------------------------------------------*/


/*-----03. Sex---------------------------------------------------------------*/
    SELECT 
      bsd.bs_name AS sex,
      bsd.bs_name AS value
    FROM base_static_data bsd
    WHERE 1=1
      AND bsd.bs_type = 'Sex Codes'
      AND bsd.bs_status= 'Active'
    ORDER BY
      bsd.bs_name ASC;
/*---------------------------------------------------------------------------*/


/*-----04. Race--------------------------------------------------------------*/
    SELECT 
      TRIM(dbms_lob.substr(bsd.bs_description, 200)) AS race,
      bsd.bs_name AS value
    FROM base_static_data bsd
    WHERE 1=1
      AND bsd.bs_type = 'DCLS_RACE_CODES'
      AND bsd.bs_status= 'Active'
    ORDER BY
      bsd.bs_name;
/*---------------------------------------------------------------------------*/


/*-----05. Ethnicity---------------------------------------------------------*/
    SELECT 
      TRIM(dbms_lob.substr(bsd.bs_description, 200)) AS Ethnicity,
      bsd.bs_name AS value
    FROM base_static_data bsd
    WHERE 1=1
      AND bsd.bs_type = 'DCLS_ETHNIC_GROUP_CODES'
      AND bsd.bs_status= 'Active'
    ORDER BY
      bsd.bs_name;
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/

