

/*---------------------------------------------------------------------------*/
/*-----01. Update Barcode Descriptions---------------------------------------*/
/*
    MERGE INTO barcode_mappings t1
    USING (
      SELECT DISTINCT
        bm.barcode_number_id,
        bm.mapping_number,
        bm.mapping_description,
        bm.calculation_script
      FROM barcode_mappings bm
      WHERE 1=1
        AND bm.barcode_number_id = '&SrceBarcodeVersionID'
      ORDER BY
        bm.barcode_number_id ASC,
        bm.mapping_number ASC
    ) t2
    ON (1=1
      AND t1.barcode_number_id = '&TrgBarcodeVersionID'
      AND t1.mapping_number = t2.mapping_number
    --  AND t1.mapping_description <> t2.mapping_description
      )
    WHEN MATCHED THEN
      UPDATE SET t1.mapping_description = t2.mapping_description;
*/
/*---------------------------------------------------------------------------*/

--SELECT * FROM barcode_versions bv
--update barcode_versions bv SET bv.status = 'Draft' WHERE bv.origrec = '503'
--update barcode_versions bv SET bv.status = 'Approve' WHERE bv.origrec = '402'
--DELETE FROM barcode_mappings bm WHERE 1=1 AND bm.barcode_number_id = 14 AND bm.mapping_number > 30

/*-----Copy Mapping Info-----------------------------------------------------*/
  --Copy barcode mapping from SourceBarcodeVersion to TargetBarcodeVersion
  --for designated row range.
/*  
MERGE INTO barcode_mappings t1
USING (
  SELECT DISTINCT
    bm.barcode_number_id AS src_barcode_number,
    &TrgBarcodeNumber AS trg_barcode_number,
    bm.mapping_number,
    bm.mapping_table,
    bm.mapping_field,
    bm.calculation_script,
    bm.mapping_description
  FROM barcode_mappings bm
  WHERE 1=1
    AND bm.barcode_number_id = &SrcBarcodeNumber
    AND bm.mapping_number <= &TopMappingNumber
  ORDER BY
    bm.barcode_number_id ASC,
    bm.mapping_number ASC    
) t2 ON ( 1=1
          AND t1.barcode_number_id = t2.trg_barcode_number
          AND t1.mapping_number = t2.mapping_number        
        )
WHEN NOT MATCHED THEN
  INSERT (
          t1.barcode_number_id,
          t1.mapping_number,
          t1.mapping_table,
          t1.mapping_field,
          --t1.calculation_script,
          t1.mapping_description
  )
  VALUES (
          t2.trg_barcode_number,
          t2.mapping_number,
          t2.mapping_table,
          t2.mapping_field,
          --t2.calculation_script,
          t2.mapping_description
  )
  */      
/*---------------------------------------------------------------------------*/

/*-----03. Barcode Check-----------------------------------------------------*/
/*
  --Use this script to check on values of barcode scan for sample.
    SELECT DISTINCT
      cr.last_name AS "005_PI-LastName",
      cr.first_name,
      cr.middle_initial,
      cr.sex,
      cr.birth_date,
      mr.field_integer_01 AS "010_PI-Age",
      cr.patientrace,
      cr.ethnicity,
      cr.date_collected,
      cr.time_collected,      cr.date_sent AS "015_-DateOrdered",
      cr.onset_date,
      cr.date_received,
      cr.time_received,
      mr.field_varchar_02,
      mr.field_varchar_05 AS "020_PI-Reason",
      cr.owner_address AS "021_PI-Address",
      cr.patient_phone,
      cr.owner_country AS "023_NULL",
      cr.owner_state,
      cr.owner_county AS "025_PI-County",
      cr.owner_city,
      cr.owner_zip,
      mr.field_varchar_80 AS "028_HardCodeActivity",
      cr.spec_source AS "029_SpecType",
      cr.sampdesc AS "030_SS-Description",
      mr.field_varchar_03 AS "031_NULL",
      mr.field_date_01,
      cr.rasclientid AS "033_ClientID",
      mr.field_varchar_30 AS "034_ClientName",
      mr.field_varchar_230 AS "035_Client_Address",
      mr.field_varchar_231 AS "Client_City",
      mr.field_varchar_232 AS "Client_State",
      mr.field_varchar_233 AS "Client_Zip",
      mr.field_varchar_234 AS "Client_County",
      mr.field_varchar_235 AS "040_Client_Category",
      mr.field_varchar_236 AS "Client_Contact",
      mr.field_varchar_237 AS "Client_Phone",
      mr.field_varchar_01 AS "Physician",
      cr.pid AS "044_SS-SubmiterPID",
      mr.field_varchar_220 AS "045-SS-Findings",
      mr.field_varchar_20 AS "PRO-Name",
      mr.field_varchar_28 AS "PRO-NPI",
      mr.field_varchar_21 AS "PRO-Facility",
      mr.field_varchar_27 AS "PRO-Phone",
      mr.field_varchar_22 AS "050_PRO-Address",
      mr.field_varchar_24 AS "PRO-State",
      mr.field_varchar_26 AS "PRO-County",
      mr.field_varchar_23 AS "PRO-City",
      mr.field_varchar_25 AS "PRO-Zip",
      mr.field_varchar_14 AS "055_RT-Test",
      mr.field_varchar_225 AS "Other",
      mr.field_varchar_201 AS "EQ-01",
      mr.field_varchar_202 AS "EQ-02",
      mr.field_varchar_203 AS "EQ-03",
      mr.field_varchar_204 AS "060_EQ-04_Admitted",
      mr.field_varchar_205 AS "EQ-05",
      mr.field_varchar_206 AS "EQ-06",
      mr.field_varchar_207 AS "EQ-07",
      mr.field_varchar_210 AS "EQ-08",
      mr.field_varchar_211 AS "065_EQ-09_child",
      mr.field_varchar_212 AS "EQ-10",
      mr.field_varchar_213 AS "EQ-11",
      mr.field_varchar_214 AS "EQ-12",
      mr.field_varchar_215 AS "069_EQ-13_details",
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec)
    WHERE 1=1
      AND cr.external_id = '&SampleID'
      */
/*---------------------------------------------------------------------------*/  



/*-----Barcode Field Description Migration-----------------------------------*/  
  --The Barcode Export/Inport tool doesn't migrate the Description/Comment
  --field.  Use this set of scripts to perform the update from one environment
  --to the next.
/*
  -----00. Reference Tables-----
    select * from barcode_numbers;
    select * from barcode_versions;
    select * from barcode_mappings;    
  ----- -----

  -----01. Source Envirnment-----
   --Log into the Source Environment
  ----- -----
  
  -----02. Extract info from Source Environment-----
    SELECT DISTINCT
      bv.barcode_type,
      bv.version_name,
      bv.barcode_version_id,
      bv.status,
      '~' AS sp1,
      bm.origrec,
      bm.mapping_number,
      bm.mapping_table,
      bm.mapping_field,
      bm.mapping_description
    FROM barcode_versions bv
      INNER JOIN barcode_mappings bm ON (bv.barcode_version_id = bm.barcode_number_id)
    WHERE 1=1
      AND bv.status = 'Approve'
      AND bv.version_name = '&SrcBarcode'
      AND bv.barcode_version_id = '&BarcodeVersion'
    ORDER BY
      bv.barcode_type ASC,
      bv.version_name ASC,
      bv.barcode_version_id ASC,
      bm.mapping_number ASC;
  ----- -----
  
  -----03. Export Results to file-----
    --ACTION REQUIRED: Use Export function to export results to CSV file: BarcodeExport_ENV_YYYY-MM-DD.csv  
  ----- -----
  
  -----04. Connect to Target Environment-----
   --Time to log into the Target Environment to complete the remaining steps.
  ----- -----
  
  -----05. Drop [adhs_temp] Table-----
    --If table exists already we want to drop it, who knows what's in it.
      DROP TABLE adhs_temp;
  ----- -----

  -----06. Create [adhs_temp] table-----
    --Create temp table to hold info from soucre environment
    CREATE TABLE adhs_temp(
      barcode_type        VARCHAR2(30 CHAR),
      version_name        VARCHAR2(30 CHAR),
      barcode_version_id  NUMBER(22),
      status              VARCHAR2(15 CHAR),
      sp1                 VARCHAR2(1 CHAR),            
      origrec             NUMBER(22),
      mapping_number      NUMBER(22),
      mapping_table       VARCHAR2(255 CHAR),
      mapping_field       VARCHAR2(255 CHAR),
      mapping_description VARCHAR2(255 CHAR)  
    )
    TABLESPACE DRAGONFLY
      pctfree 10
      initrans 1
      maxtrans 255
      storage(
        initial 64K
        next 1M
        minextents 1
        maxextents unlimited
      );
  ----- -----
  
  -----07. Date Import into ADHS_TEMP -----
    --ACTION REQUIRED: Use the TextImport tool to import the CSV file into ADHS_TEMP table.
  ----- -----

  -----08. Merge/Upate Barcode Field Descriptions-----
    --Here we are going to update the Barcode Field Descriptions.  You can
    --Select the Using SQL part to preview the data comming in before
    --executing the Merge.
    MERGE INTO barcode_mappings t1
    USING (
      SELECT DISTINCT
        temp.barcode_type,
        temp.version_name,
        temp.barcode_version_id AS src_version_id,
        temp.status,
        temp.sp1,
        temp.origrec AS src_bm_origrec,
        bm.barcode_number_id As trg_version_id,
        temp.mapping_number,
        temp.mapping_table,
        temp.mapping_field,
        temp.mapping_description
      FROM adhs_temp temp
        INNER JOIN barcode_versions bv ON (1=1
          AND temp.barcode_type = bv.barcode_type
          AND temp.version_name = bv.version_name
          AND temp.status = bv.status)
        INNER JOIN barcode_mappings bm ON (bv.barcode_version_id = bm.barcode_number_id)
      WHERE 1=1
        AND bv.barcode_version_id = (
          SELECT
          MAX(bv.barcode_version_id)
          FROM barcode_versions bv2   
          WHERE 1=1
            AND bv.barcode_type = bv2.barcode_type
            AND bv.version_name = bv2.version_name
        )
      ORDER BY
        temp.barcode_type ASC,
        temp.version_name ASC,
        bm.barcode_number_id ASC,
        temp.mapping_number ASC
    ) t2
    ON (1=1
        AND t1.barcode_number_id = t2.trg_version_id
        AND t1.mapping_number = t2.mapping_number
        )
    WHEN MATCHED THEN
      UPDATE SET 
        t1.mapping_description = t2.mapping_description
  ----- -----
  
  -----09. Done-----
    --Done with Syncing the LOINC Codes
  ----- -----
    select * from barcode_mappings bm WHERE bm.barcode_number_id = '5' ORDER BY bm.mapping_number ASC
  
*/  

/*---------------------------------------------------------------------------*/  
