/*-----Bulk Update Cities and Counties---------------------------------------*/
  --Use scripts here to sync city and County Codes with PROD codes for
  --cities and Countie.
  
 
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*-----01. Extract Cities Info from PROD-------------------------------------*/
/*
      SELECT DISTINCT
        c.region,
        c.country_code,
        c.state_code,
        c.city_code,
        c.city,
        c.origsts
      FROM city c
      WHERE 1=1
      ORDER BY 
        c.region ASC,
        c.country_code ASC,
        c.state_code ASC,
        c.city_code ASC
*/        
/*---------------------------------------------------------------------------*/


/*-----02. Create Temp Table [ADHS_Temp]-------------------------------------*/
/*
  -----Drop [adhs_temp] Table-----
    --If table exists already we want to drop it, who knows what's in it.
      DROP TABLE adhs_temp;
  ----- -----

  -----Create [adhs_temp] table-----
    CREATE TABLE adhs_temp(
      region       VARCHAR2(50 CHAR),
      country_code VARCHAR2(3 CHAR),
      state_code   VARCHAR2(3 CHAR),
      city_code    NUMBER(22),      
      city         VARCHAR2(50 CHAR),
      origsts      CHAR(1 CHAR) 
    )
    TABLESPACE DRAGONFLY
      pctfree 10
      initrans 1
      maxtrans 255
      storage(
        initial 64K
        next 1M
        minextents 1
        maxextents unlimited
      );
  ----- -----
*/
/*---------------------------------------------------------------------------*/

--  ====>IMPORT CITIES FROM PROD TO ADHS_TEMP TABLE  <====

/*-----03. Update and Sync City Codes----------------------------------------*/
--delete from zip_codes
--delete from city c
--select * from city c order by c.city_code ASC

/*
    MERGE INTO city t1
    USING (
        SELECT DISTINCT
          tmp.region,
          tmp.country_code,
          tmp.state_code,
          tmp.city,
          tmp.city_code,
          tmp.origsts
        FROM adhs_temp tmp
        WHERE 1=1     
          AND tmp.city IS NOT NULL
        ORDER BY tmp.city ASC
    ) t2
    ON (1=1
--      AND UPPER(COALESCE(t1.region, '')) = UPPER(COALESCE(t2.region, ''))
      AND UPPER(COALESCE(t1.country_code, '')) = UPPER(COALESCE(t2.country_code, ''))
      AND UPPER(COALESCE(t1.state_code, '')) = UPPER(COALESCE(t2.state_code, ''))
      AND UPPER(COALESCE(t1.city, '')) = UPPER(COALESCE(t2.city, ''))
    )
    WHEN MATCHED THEN
      UPDATE SET t1.city_code = t2.city_code
    WHEN NOT MATCHED THEN
      INSERT (
               t1.region,
               t1.country_code,
               t1.state_code,
               t1.city_code,
               t1.city,
               t1.origsts
      )
      VALUES (
               t2.region,
               t2.country_code,
               t2.state_code,
               t2.city_code,
               t2.city,
               t2.origsts
      )
*/
/*---------------------------------------------------------------------------*/





/*-----03. Update and Sync Zip Codes----------------------------------------*/
/*
  -----Extract PROD ZIPS-----  
    SELECT DISTINCT
      zc.country_code,
      zc.state_code,
      zc.city_code,
      zc.zip,
      zc.origsts
    FROM zip_codes zc
    ORDER BY
      zc.country_code ASC,
      zc.state_code ASC,
      zc.city_code ASC,
      zc.zip ASC      
  ----- -----

  -----Drop [adhs_temp] Table-----
    --If table exists already we want to drop it, who knows what's in it.
      DROP TABLE adhs_temp;
  ----- -----

  -----Create [adhs_temp] table-----
    CREATE TABLE adhs_temp(
      origsts      CHAR(1 CHAR),
      state_code   VARCHAR2(3 CHAR),
      country_code VARCHAR2(3 CHAR),
      city_code    NUMBER(22),
      zip          VARCHAR2(15 CHAR)
    )
    TABLESPACE DRAGONFLY
      pctfree 10
      initrans 1
      maxtrans 255
      storage(
        initial 64K
        next 1M
        minextents 1
        maxextents unlimited
      );
  ----- -----
--  ====>IMPORT ZIP CODES FROM PROD TO ADHS_TEMP TABLE  <====
  ----- -----
--SELECT * FROM ADHS_TEMP  
    MERGE INTO zip_codes t1
    USING (
      SELECT DISTINCT
        tmp.country_code,
        tmp.state_code,
        tmp.city_code,
        tmp.zip,
        tmp.origsts
      FROM adhs_temp tmp
      ORDER BY
        tmp.country_code ASC,
        tmp.state_code ASC,
        tmp.city_code ASC,
        tmp.zip ASC
    ) t2
    ON (1=1
    AND UPPER(t1.country_code) = UPPER(t2.country_code)
    AND UPPER(t1.state_code) = UPPER(t2.state_code)
    AND UPPER(t1.city_code) = UPPER(t2.city_code)
    AND UPPER(t1.zip) = UPPER(t2.zip)
    )
--    WHEN MATCHED THEN
--      UPDATE SET t1.city_code = t2.city_code
    WHEN NOT MATCHED THEN
      INSERT (
              t1.country_code,
              t1.state_code,
              t1.city_code,
              t1.zip,
              t1.origsts
      )
      VALUES (
              t2.country_code,
              t2.state_code,
              t2.city_code,
              t2.zip,
              t2.origsts
      )
  ----- -----
*/
/*---------------------------------------------------------------------------*/








/*-----03. Update and Sync County Codes----------------------------------------*/
/*
--UPDATE counties c SET c.county_code = 0 WHERE c.county = 'UNKNOWN'
  -----Extract PROD County Codes-----  
    SELECT DISTINCT
      c.country_code,
      c.state_code,
      c.county,
      c.county_code,
      c.district,
      c.origsts
    FROM counties c
    ORDER BY
      c.country_code ASC,
      c.state_code ASC,
      c.county_code ASC   
  ----- -----

  -----Drop [adhs_temp] Table-----
    --If table exists already we want to drop it, who knows what's in it.
      DROP TABLE adhs_temp;
  ----- -----

  -----Create [adhs_temp] table-----
    CREATE TABLE adhs_temp(
      origsts      CHAR(1 CHAR),
      county       VARCHAR2(50 CHAR),
      district     VARCHAR2(50 CHAR),
      state_code   VARCHAR2(3 CHAR),
      country_code VARCHAR2(3 CHAR),
      county_code  NUMBER(22)
    )
    TABLESPACE DRAGONFLY
      pctfree 10
      initrans 1
      maxtrans 255
      storage(
        initial 64K
        next 1M
        minextents 1
        maxextents unlimited
      );
  ----- -----
--delete counties  
--select * from counties
  ----- -----
    MERGE INTO counties t1
    USING (
            SELECT DISTINCT
              c.country_code,
              c.state_code,
              c.county,
              c.county_code,
              c.district,
              c.origsts
            FROM ADHS_Temp c
            ORDER BY
              c.country_code ASC,
              c.state_code ASC,
              c.county_code ASC   
    ) t2
    ON (1=1
    AND UPPER(t1.country_code) = UPPER(t2.country_code)
    AND UPPER(t1.state_code) = UPPER(t2.state_code)
    AND UPPER(t1.county) = UPPER(t2.county)
    )
    WHEN MATCHED THEN
      UPDATE SET t1.county_code = t2.county_code
    WHEN NOT MATCHED THEN
      INSERT (
              t1.country_code,
              t1.state_code,
              t1.county,
              t1.county_code,
              t1.district,
              t1.origsts
      )
      VALUES (
              t2.country_code,
              t2.state_code,
              t2.county,
              t2.county_code,
              t2.district,
              t2.origsts
      )
  ----- -----
*/
/*---------------------------------------------------------------------------*/
