

/*-----BulkImport NPI-------------------------------------------------------*/
  --Use this script to import National Provider Identifier for 
  --the clients.
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/

/*-----01. Create Temp Table [ADHS_Temp]-------------------------------------*/
/*
  -----Drop [adhs_temp] Table-----
    --If table exists already we want to drop it, who knows what's in it.
      DROP TABLE adhs_temp;
  ----- -----
  -----Create [adhs_temp] table-----
    CREATE TABLE adhs_temp(
      rasclientid      VARCHAR2(15 CHAR),
      organizational_oid    VARCHAR2(100 CHAR)
    )
    TABLESPACE DRAGONFLY
      pctfree 10
      initrans 1
      maxtrans 255
      storage(
        initial 64K
        next 1M
        minextents 1
        maxextents unlimited
      );
  ----- -----
*/
/*---------------------------------------------------------------------------*/

/*-----02. Import [adhs_temp] table contents---------------------------------*/

  -----DESCRIPTION-----
   --Make a csv file with ZipCodes to be imported into the temp table.
   --import into the [adhs_temp] table.
   --Import is acheived utilizing the "Text Importer" tool located in the "Tools"
   --menu.
   --Optionally you can perform a series of instert stattments to populate the
   --table.  I have provided an example insert statement below.
  ----- -----

  -----Usefull Queries-----
--    SELECT * FROM adhs_temp;
--    SELECT rc.rasclientid, rc.organizational_oid FROM rasclients rc ORDER BY rc.rasclientid ASC;
  ----- -----

  -----Sample Insert Statement-----  

  ----- -----

/*---------------------------------------------------------------------------*/


/*-----Update RasClient List with NPI----------------------------------------*/
  --We will compare the temp table NPI values with the existing client NPI
  --values and update them if they do not match.  NPI values should be 10
  --digits.
/*
    MERGE INTO rasclients t1
    USING (
        SELECT DISTINCT
          tmp.rasclientid,
          tmp.organizational_oid
        FROM adhs_temp tmp
        WHERE 1=1
          AND LENGTH(tmp.organizational_oid) = 10
        ORDER BY tmp.rasclientid ASC
     ) t2
    ON ( 1=1
          AND UPPER(t1.rasclientid) = UPPER(t2.rasclientid)
        )
    WHEN MATCHED THEN
      UPDATE SET t1.organizational_oid = t2.organizational_oid
      */
/*---------------------------------------------------------------------------*/
