
/*-----RetoreMetaDataTemplateReference---------------------------------------*/
  --Use this script to restore MetaData Templates to their appropriate
  --panels on the event that this associateion is lost due to the promote
  --process of a MetadataTemplate from one environment to another.
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/


/*-----01. Extract the data from Environment---------------------------------*/
  --Run This SQL and export the result to an excel spreadsheet we will use
  --this extract to import into the adhs_temp table.
/*  
    SELECT
      tgn.testgroupname,
      '~' AS sp,
      mr.*
    FROM testgroupnames tgn
      INNER JOIN metadata_references mr ON (1=1
        AND mr.tablereference = 'TESTGROUPNAMES'
        AND mr.original_origrec = tgn.origrec)
    WHERE 1=1
    ORDER BY
      tgn.testgroupname ASC
*/      
/*---------------------------------------------------------------------------*/

/*-----02. Create Temp Table [ADHS_Temp]-------------------------------------*/
  --We will create the temp table to hold the MetaData Template data we just
  --saved to the CSV file.

  -----Create [adhs_temp] table-----
/*  
    DROP TABLE adhs_temp;
    CREATE TABLE adhs_temp(
      testgroupname       VARCHAR2(50 CHAR) not null,
      spacer            VARCHAR2(1 CHAR),
      origrec            NUMBER(22) not null,
      origsts            CHAR(1 CHAR) default 'N' not null,
      metadatamethodcode VARCHAR2(200 CHAR),
      original_origrec   NUMBER(22) not null,
      tablereference     VARCHAR2(30 CHAR) not null,
      metadata_type_id   NUMBER(22) not null     
    )
    TABLESPACE DRAGONFLY
      pctfree 10
      initrans 1
      maxtrans 255
      storage(
        initial 64K
        next 1M
        minextents 1
        maxextents unlimited
      );
*/
  ----- -----

/*---------------------------------------------------------------------------*/

/*-----03. Import [adhs_temp] table contents---------------------------------*/

  -----DESCRIPTION-----
   --Taking the CSV file from the export in step 1 and importing it into the
   --adhs_temp table.
  ----- -----

  -----Usefull Queries-----
--    SELECT * FROM adhs_temp;
  ----- -----


    --Use the DataImport tool to accomplish the data import.
      -- |Tools | Text Importer |

/*---------------------------------------------------------------------------*/


/*-----04 Resture MetaData Templates-----------------------------------------*/
  --Now we will repair the metadata_references table with any templates that
  --were lost from the promotion.

SELECT
  tgn.testgroupname, 
  mr.* 
FROM metadata_references mr 
  INNER JOIN testgroupnames tgn ON (1=1
    AND mr.tablereference = 'TESTGROUPNAMES'
    AND mr.original_origrec = tgn.origrec)
WHERE 1=1
--  AND mr.metadata_type_id = '279'
  AND mr.metadatamethodcode LIKE 'Clinical Human_V%'
ORDER BY
  tgn.testgroupname ASC,
  mr.metadata_type_id ASC;

---THIS SQL IS STILL TO BE DETERMINED---
/*
    MERGE INTO metadata_references t1
    USING (
        SELECT DISTINCT      
          testgroupname,
          spacer,
          origrec,
          origsts,
          metadatamethodcode,
          original_origrec,
          tablereference,
          metadata_type_id
        FROM adhs_temp tmp
        WHERE 1=1
        ORDER BY 
          tmp.testgroupname ASC,
          tmp.metadata_type_id ASC
        ) t2
    ON ( 1=1
      AND t1.testgroupname = t2.testgroupname
      AND t1.metadatamethodcode = t2.metadatamethodcode
      AND 
      
    )
    WHEN NOT MATCHED THEN
      INSERT (t1.country_code, t1.state_code, t1.city, t1.city_code)
      VALUES (t2.country_code, t2.state_code, t2.city, "CITY_seq".nextVal)
      */
/*---------------------------------------------------------------------------*/


