
/*-----MetaDataTemplate Scripts----------------------------------------------*/
  -----DESCRIPTION-----
    --Use these script to manipulate the MetaDataTemplates.
      --01. Manipulate Versions
  ----- -----
  
  -----HISTORY-----
    --2020.08.27 JTY Created Script
  ----- -----
/*---------------------------------------------------------------------------*/


/*-----Important Tables------------------------------------------------------*/
/*
  SELECT * FROM metadata_template_types;
  SELECT * FROM metadatafields;
  SELECT * FROM metadatafieldproperties;
  SELECT * FROM metadatafieldformat;
  SELECT * FROM metadata_users_default;
  SELECT * FROM metadatarelations;
  SELECT * FROM metadata
*/  
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
  -----MetaData Templates-----
    SELECT DISTINCT
      mtt.usage,
      mtt.tablereference,
      mtt.entity_description,
      mfp.metadatamethodcode,
      mfp.metadatamethodname,
      mfp.version,
      mfp.status,          --Draft/Released
      mfp.isdefault,
      mfp.issystem,
      mfp.parent_template,  --Nothing when Released.
      mtt.metadata_type_id,
      '~' AS eol
    FROM metadata_template_types mtt
      INNER JOIN metadatafieldproperties mfp ON (1=1
        AND mtt.metadata_type_id= mfp.metadata_type_id
       )
    WHERE 1=1
      AND mfp.metadatamethodcode = '&MetaDataCode';
  ----- -----
  -----MetaDataTemplate Fields-----
    SELECT DISTINCT
      mfp.metadatamethodcode,
      mf.taborder,
      mf.fieldcaption,
      mf.tablename,
      mf.fieldname,
      '~' AS sp1,
      mf.*,      
      '~' AS eol
    FROM metadatafieldproperties mfp
      INNER JOIN metadatafields mf ON (mfp.metadatamethodcode = mf.metadatamethodcode)
    WHERE 1=1
      AND mfp.metadatamethodcode = '&MetaDataCode'
    ORDER BY
      mfp.metadatamethodcode ASC,
      mf.taborder ASC
  ----- -----
  
/*---------------------------------------------------------------------------*/


/*-----01. Manipulate Versions-----------------------------------------------*/
  -----DESCRIPTION-----
    --Use these scripts when you need to make a minor change to a template, and
    --don't want to have to keep updating the template version.
  ----- -----

  ----- -----
  ----- -----
  
/*---------------------------------------------------------------------------*/


