
/*=================================================================*/  
/*-----QBE User Acces Copy-----------------------------------------*/  
  ---DESCRIPTION---
    --This set of scripts can be used to update a Target QBE template
    --to match permissions of the identified Source QBE template
    --Generally this may need to be execueted when migrating QBE
    --templates between enviornments.    
  ---

  ---HISTORY---
    --2014.02.11 JTY: Created Script
  ---
/*-----------------------------------------------------------------*/  
/*=================================================================*/  


  /*-----Grant Read Permissions to key tables-----*/
    --GRANT SELECT ON uac_resources TO &TargetSchema;
    --GRANT SELECT ON uac_rights TO &TargetSchema;  
  /*----- -----*/


/*=================================================================*/  
/*-----------------------------------------------------------------*/  

  /*-----Resources Review-----*/ 
    --Need to make sure an entry exists in the uac_resources table. 
/*    
    SELECT DISTINCT
      * 
    FROM uac_resources ure
    WHERE 1=1
      AND resource_type = 'QBE_TEMPLATE' 
    ORDER BY resource_name ASC;   
*/    
  /*----- -----*/
/*  
  INSERT INTO uac_resources ure
   (origsts, resource_type, resource_name,resource_description)
      VALUES ('N', 'QBE_TEMPLATE', 'AdhsMLog','ADHS Master Log');
*/  
  /*-----Add Resource if does not exits -----*/
/*
    MERGE INTO &TargetEnvironment.uac_resources t1
    USING (
        SELECT DISTINCT
          ure.origsts,
          ure.resource_type,
          ure.resource_name,
          ure.resource_description
        FROM &SourceEnvironment.uac_resources ure
        WHERE 1=1
          AND ure.resource_type = 'QBE_TEMPLATE'
          AND ure.resource_name = '&SourceTemplate') t2
    ON ( 1=1
        AND t1.origsts = t2.origsts
        AND t1.resource_type = t2.resource_type
        AND t1.resource_name = '&TargetTemplate'
        AND t1.resource_description = '&TargetName') 
    WHEN NOT MATCHED THEN
      INSERT (t1.origsts, t1.resource_type, 
          t1.resource_name,
          t1.resource_description)
      VALUES (t2.origsts, t2.resource_type, 
          '&TargetTemplate',
          '&TargetName');
*/          
  /*----- -----*/





  /*-----UAC Rights Review-----*/
    --Review what UAC rights exists in the table.
/*    
    SELECT DISTINCT
      uac.origsts, 
          resource_type, 
          resource_name,
          permission, 
          access_type, 
          entity_type,
          entity_id
    FROM uac_rights uac
    WHERE 1=1
      AND uac.resource_type = 'QBE_TEMPLATE' 
      AND resource_name = '&SourceTemplate'
    ORDER BY 
      uac.resource_name ASC;
*/      
  /*----- -----*/
/*
INSERT INTO uac_rights(
          origsts, 
          resource_type, 
          resource_name,
          permission, 
          access_type, 
          entity_type,
          entity_id)
      VALUES (
          'N',
          'QBE_TEMPLATE',
          'AdhsMLog',
          'CAN_CHANGE',
          'GRANT',
          'USER',
          'YODERJ'
          )
*/


  /*----- -----*/
/*  
    MERGE INTO uac_rights t1
    USING (  
        SELECT DISTINCT
          uac.origsts,
          uac.resource_type,
--          '&TargetTemplate' AS resource_name,
uac2.resource_name,
          uac.permission,
          uac.access_type,
          uac.entity_type,
          uac.entity_id
        FROM uac_rights uac
          LEFT OUTER JOIN uac_rights uac2 ON (uac2.resource_name IN (&UpdateList))
        WHERE 1=1
          AND uac.resource_type = 'QBE_TEMPLATE'
          AND uac.resource_name = '&SourceTemplate'
        ORDER BY 
          uac2.resource_name ASC,
          uac.entity_type ASC,
          uac.entity_id ASC
        
    ) t2
    ON (
        1=1
        AND t1.resource_type = t2.resource_type
        AND t1.resource_name = t2.resource_name 
        AND t1.permission = t2.permission 
        AND t1.access_type = t2.access_type         
        AND t1.entity_type = t2.entity_type         
        AND t1.entity_id = t2.entity_id
    )
    WHEN NOT MATCHED THEN
      INSERT (
          t1.origsts, t1.resource_type, 
          t1.resource_name,
          t1.permission, t1.access_type, t1.entity_type,
          t1.entity_id)
      VALUES (
          t2.origsts, t2.resource_type, 
          t2.resource_name,
          t2.permission, t2.access_type, t2.entity_type,
          t2.entity_id);
*/          
  /*----- -----*/
/*-----------------------------------------------------------------*/  
/*=================================================================*/  







      


