
/*-----UpdateRhapsodyTargetDicrectories-------------------------------*/
  -----DESCRIPTION-----
    --This set of script to be used for DEV/TEST environment in V12
    --migration to re-direct XML files generated by STARLiMS to the 
    --path: \\Groups\lab\Groups\LAB\LIMS\Rhapsody\01_Clinical\01_Input\06_CLONE  
    --The following scripts are contained in this file:
      --01 HL7 Clients Manager - Update the HL7 Clients Manager application
      --02 RASCLient - Update the Client List application (PHLIP)
  ----- -----
    
  -----HISTORY-----
    --2019.08.09 JTY: Create Script
  ----- -----
/*--------------------------------------------------------------------*/




/*-----01 HL7 Clients Manager-----------------------------------------*/
  ---Review potential changes---
    SELECT
      (rc.compname || ' (' || rc.rasclientid || ')') AS ras_client,
      mt.ior_xml_path,
      mt.origrec AS mt_origrec,
      '~' AS eol
    FROM rasclients rc
    INNER JOIN rasclientmessagetypes mt ON (rc.rasclientid = mt.rasclientid)
    WHERE 1=1
      AND mt.ior_xml_path IS NOT NULL
      AND mt.ior_xml_path <> '\\Groups\lab\Groups\LAB\LIMS\Rhapsody\01_Clinical\01_Input\01_DevTest'
    ORDER BY
      ras_client ASC;
  --- ---
  ---Make Changes---
/*
    MERGE INTO rasclientmessagetypes t1
    USING (
      SELECT
        (rc.compname || ' (' || rc.rasclientid || ')') AS ras_client,
        mt.ior_xml_path,
        mt.origrec AS mt_origrec,
        '~' AS eol
      FROM rasclients rc
      INNER JOIN rasclientmessagetypes mt ON (rc.rasclientid = mt.rasclientid)
      WHERE 1=1
        AND mt.ior_xml_path IS NOT NULL
        AND mt.ior_xml_path <> '\\Groups\lab\Groups\LAB\LIMS\Rhapsody\01_Clinical\01_Input\01_DevTest'
      ORDER BY
        ras_client ASC
    ) t2
    ON (t1.origrec = t2.mt_origrec)
    WHEN MATCHED THEN
      UPDATE SET t1.ior_xml_path = '\\Groups\lab\Groups\LAB\LIMS\Rhapsody\01_Clinical\01_Input\01_DevTest';
*/      
  --- ---
/*--------------------------------------------------------------------*/


/*-----02 RASCLient-----------------------------------------*/
  --RasClients associated with PHLIP program have the XML file target
  --set in the ClientList application
  ---Review potential changes---
    SELECT
      (rc.compname || ' (' || rc.rasclientid || ')') AS ras_client,
      rc.dev_outbound_results,
      rc.origrec AS rc_origrec,
      '~' AS eol
    FROM rasclients rc
    WHERE 1=1
      AND rc.dev_outbound_results IS NOT NULL
      AND rc.dev_outbound_results <> '\\Groups\lab\Groups\LAB\LIMS\Rhapsody\01_Clinical\01_Input01_DevTest'
    ORDER BY
      ras_client ASC;
  --- ---
  ---Make Changes---
/*
    MERGE INTO rasclients t1
    USING (
      SELECT
        (rc.compname || ' (' || rc.rasclientid || ')') AS ras_client,
        rc.dev_outbound_results,
        rc.origrec AS rc_origrec,
        '~' AS eol
      FROM rasclients rc
      WHERE 1=1
        AND rc.dev_outbound_results IS NOT NULL
        AND rc.dev_outbound_results <> '\\Groups\lab\Groups\LAB\LIMS\Rhapsody\01_Clinical\01_Input01_DevTest'
      ORDER BY
        ras_client ASC
    ) t2
    ON (t1.origrec = t2.rc_origrec)
    WHEN MATCHED THEN
      UPDATE SET t1.dev_outbound_results = '\\Groups\lab\Groups\LAB\LIMS\Rhapsody\01_Clinical\01_Input01_DevTest';
*/      
  --- ---
/*--------------------------------------------------------------------*/
