/*------BatchJobsCheckScripts------------------------------------------------
    -----DESCRIPTION-----
      V12 TEST Database Info:  ClinicalPH12TEST_DATA/St44l1msv12@start.world
       
      Use these set sets of qeries to identify and validat batch jobs.  The
      following scripts are included:
    ----- -----
    
    -----HISTORY-----
      2019.08.05 JTY - Created Script      
    ----- -----    
          
  ---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*----01. AFB_Preliminary----------------------------------------------------*/
  --Locate and modify samples for AFB_Preliminary script

  --Locate Prospective Samples for validation
    SELECT
      f.dept,
      f.rasclientid,
      f.external_id,
      f.testgroupname,
      ot1.testno,
      ot1.apprdate,
      (trunc(trunc(sysdate) - ot1.apprdate) ) AS days,
      ot2.testno,
      ot2.apprdate,
      '~' AS eol
    FROM folders f
      INNER JOIN ordtask ot1 ON (1=1
        AND ot1.testno = 'AFB Smear'
        AND f.folderno = ot1.folderno)
      INNER JOIN ordtask ot2 ON (1=1 
        AND ot2.testno = 'AFB Culture'
        AND f.folderno = ot2.folderno) 
    WHERE 1=1
      AND f.dept = 'PHX-TB'
      AND f.testgroupname = 'AFB Clinical'  
      AND f.apprdate IS NULL
      AND ot1.apprdate IS NOT NULL
      AND ot2.apprdate IS NULL
      AND (trunc(trunc(sysdate) - ot1.apprdate)) > 28
    ORDER BY
      days ASC,      
      f.external_id DESC;
/*---------------------------------------------------------------------------*/    
  
