
/*-----ReportsPanelsAndTest--------------------------------------------------*/
  -----DESCRIPTION-----
    --The purpose of these scripts is to identify the reports that are currently
    --being used in STARLiMS for migration to the new STARLiMS installation.
    --the following class of reports are scripted below:
    --  01. Sample Preliminary/Final Reports
    --  02. Reports assoicated with the QBE module
    --  
  ----- -----


  -----HISTORY-----
    --2019.05.31 JTY: Begin Query Creation
  ----- -----

/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*-----01. Sample Preliminary/Final Reports----------------------------------*/
  --Application Location: Reporting Rules | Outputs | Reports
  SELECT DISTINCT
  -- rr.rulename,
   rrr.reportname AS report_template_name,
   --LTRIM(rrl.caption,'Panel(s):') AS panel,
   --t.testno AS test_name,
    '~' AS EOL
  FROM rr_reportingrules rr
    INNER JOIN rr_reportingrulereports rrr ON (1=1
      AND rr.entitytypeid = rrr.entitytypeid
      AND rr.ruleid = rrr.ruleid)
    INNER JOIN rr_reportingruleslevels rrl ON (1=1
      AND rr.ruleid = rrl.ruleid
      AND rrr.ruleselectionid = rrl.ruleselectionid)
    INNER JOIN testgroupnames tgn ON (
      LTRIM(rrl.caption,'Panel(s):') = tgn.testgroupname)
    INNER JOIN conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
    INNER JOIN tests t ON (ctt.testcode = t.testcode)
  WHERE 1=1
    AND rr.rulename IN ('Clinical Default', 'Env Default')
    AND tgn.status <> 'Retired'

  ORDER BY
    rrr.reportname ASC;
/*---------------------------------------------------------------------------*/
--SELECT * FROM sundict_prod.LIMSREPORTS

/*---------------------------------------------------------------------------*/
/*-----02. Reports assoicated with the QBE module----------------------------*/
  --Application Location: QBE Manager|Reports
    SELECT DISTINCT
      --qtp.name AS template_name,
      --qtp.qbetemplateid,
      --qtp.description AS template_desc,      
      qrp.description AS report_desc,
      qrp.reportid,
      '' AS eol
    FROM qbetemplates qtp
      INNER JOIN qbereports qrp ON (qtp.qbetemplateid = qrp.qbetemplateid)
    WHERE 1=1
      --AND qtp.qbetemplateid = '&TemplateID'
    ORDER BY
      report_desc ASC;
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
--TEST Worksheets
  --Application Location: TestManager|Worksheets 
    SELECT DISTINCT
      tws.report_name
    FROM tests_worksheets tws
    WHERE 1=1
    ORDER BY
      tws.report_name ASC;


/*---------------------------------------------------------------------------*/
