/*-----V12 DocketScripts-----------------------------------------------------
  -----DESCRIPTION-----
    This set of queries will be used to generate information for the V12
    conversion document
  ----- -----

  -----HISTORY-----
    2019.02.15 JTY: Created script
  ----- -----
-----------------------------------------------------------------------------*/




/*-----01. Test List---------------------------------------------------------*/
  --List of active test for labs.
/*  
  SELECT DISTINCT
    t.testcatcode,
    (t.testno || ' (' || t.testcode || ')') AS test_name_code,    
    t.testflag,
    '~' AS eol
  FROM tests t
   
  WHERE 1=1
    AND t.testcatcode IN (
    'Bacteriology', 'BioTerrorism', 'Environmental',
    'Mycobacteriology', 'Serology', 'Virology'
    )
  ORDER BY
    t.testcatcode ASC,
    test_name_code ASC;
*/    
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/

  SELECT DISTINCT
    ctt.dept,
--    tgn.testgroupname AS panel,
     (t.testno || ' (' || t.testcode || ')') AS test_name,
     t.testflag AS test_type,
--     ctt.defaultselect AS auto_add,
    '~' AS eol
  FROM testgroupnames tgn
    INNER JOIN conditiontesttriggers ctt ON (tgn.testgroupname = ctt.testgroupname)
    INNER JOIN tests t ON (ctt.testcode = t.testcode)
    INNER JOIN sp_tests spt ON (t.testcode = spt.testcode)
  WHERE 1=1 
    AND tgn.status = 'Active'
    AND spt.active = 'A'
--AND ctt.dept NOT IN ('PHX-BAC', 'PHX-BT', 'PHX-EM', 'PHX-SER', 'PHX-TB')    
  ORDER BY
    ctt.dept ASC,
--    panel ASC,
    test_name ASC;
/*---------------------------------------------------------------------------*/
