
/*---------------------------------------------------------------------------*/
/*-----V12_ProdExamples------------------------------------------------------
  -----DESCRIPTION-----
    Review results of samples that have been provided from V10 that are good 
    test samples for V12
    
    V12 Login Info:  ClinicalPH12TEST_DATA/St44l1msv12@start.world
  ----- -----

  -----HISTORY-----
  ----- -----

  
---------------------------------------------------------------------------*/






/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*-----01. BAC Samples-------------------------------------------------------*/

    SELECT
      f.rasclientid,
      f.dept,
      f.testgroupname,
      f.folderno,
      f.apprdate,
      ot.testno,
      ot.runno,
      re.analyte,
      ot.apprdate,
      ot.ordno,  
      re.final,
      '~' AS eol
    FROM folders f
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN tests t ON (ot.testcode = t.testcode)
      INNER JOIN results re ON (1=1
        AND ot.ordno = re.ordno
        AND ot.testcode = re.testcode)
    WHERE 1=1
      AND f.external_id IN (
        'AZ00086791', 'AZ00085193', 'AZ00086362', 'AZ00084511' )
    ORDER By
      f.dept ASC,
      f.testgroupname ASC,
      f.folderno ASC,
      ot.runno ASC,
      ot.ordno ASC,
      re.analyte ASC,
      re.final ASC;
/*---------------------------------------------------------------------------*/  
