/*
----------V12_ViewsCheck---------------------------------------------------
  -----DESECRIPTION-----
    Execute these sets of queries to make sure views in new database are
    working
  ----- -----

  -----HISTORY-----
    2019.06.10 JTY: Begin scirpt creation
  ----- -----  
---------------------------------------------------------------------------
---------------------------------------------------------------------------
*/



---------------------------------------------------------------------------
-----01 ADHS_BARCODE_SAMPLES view check-----
/*
---Not exact match due to Samples accessioned from 2019 - forward. 
---causing first_bc_id, first_bc_received, and first_bc_month difference.
---This is not an issue, so we are GOOD TO GO.
  SELECT * FROM adhs_barcode_samples a 
    WHERE 1=1
      AND a.date_received BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
and a.external_id = 'AZ00064066'      
  ORDER BY 
    a.external_id ASC,
    a.date_received ASC,
    a.panel ASC;
*/      
----- -----    

-----02 ADHS_CRE_Extract view check-----
---Exact Match!  GOOD TO GO
/*
  SELECT * FROM adhs_cre_extract a 
    WHERE 1=1
      AND a.date_approved BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
  ORDER BY 
    a.date_approved ASC,
    a.ordno ASC;
*/      
----- -----    

-----03 adhs_epi_cre view check-----
---Exact Match!  GOOD TO GO
/*  
  SELECT * FROM adhs_epi_cre a 
    WHERE 1=1
      AND to_date(a.date_received, 'YYYYMMDD') BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
  ORDER BY 
    to_date(a.date_received, 'YYYYMMDD') ASC,
    a.ordno ASC
    ;
*/  
----- -----    

-----04 adhs_epi_suspectruns view check-----
 --No Records to validate
--  SELECT * FROM adhs_epi_suspectruns a;
----- -----    

-----05 adhs_epi_tb view check-----
---Exact Match!  GOOD TO GO
/*
  SELECT * FROM adhs_epi_tb a 
    WHERE 1=1
      AND a.date_approved  BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
  ORDER BY 
    a.date_approved ASC,
    a.folderno ASC,
    a.ordno ASC,
    a.stardoc_id ASC;
*/
----- -----    

-----06 adhs_report_footnotes view check-----
---All match except for AZ00077593:  GOOD TO GO
/*
  SELECT * FROM adhs_report_footnotes a 
    WHERE 1=1
AND a.external_id <> 'AZ00077593'    
      AND a.fn_date  BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
  ORDER BY 
    a.folderno ASC,
    a.fn_date ASC,
    a.fn_time ASC,
    a.footnote ASC;
*/
----- -----   

-----07 adhs_requiredfields view check-----
---Exact Match!  GOOD TO GO
/*
  SELECT * FROM adhs_requiredfields a 
    WHERE 1=1
      AND a.DATE_RECEIVED  BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
  ORDER BY 
    a.DATE_RECEIVED ASC,
    a.external_id ASC;
*/
----- -----   


-----08 adhs_tbgrant_2d view check-----
---Exact Match!  GOOD TO GO
/*
  SELECT * FROM adhs_tbgrant_2d a 
    WHERE 1=1
      AND a.date_approved  BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
  ORDER BY 
    a.date_approved ASC,
    a.folderno ASC,
    a.ot_orderno ASC;
*/
----- -----   

-----09 adhs_history_card view check-----
---Exact Match!  GOOD TO GO
/*
  SELECT * FROM adhs_tb_history_card a 
    WHERE 1=1
      AND a.date_received  BETWEEN to_date('01-JAN-2018','DD-MON-YYYY') AND to_date('01-JAN-2019','DD-MON-YYYY')
  ORDER BY 
    a.date_received ASC,
    a.folderno ASC,
    a.naa ASC;
*/
----- -----   

-----10 mdf_reportdata view check-----
  --NOT property of ADHS
--  SELECT * FROM mdf_reportdata
----- -----   


-----11 ordtask_audit view check-----
  --NOT property of ADHS 
--  SELECT * FROM ordtask_audit
----- -----   


---------------------------------------------------------------------------
