--We are looking for XML files that should have been generated
--when approved in the specified date range and include the following
--test (MEDSIS):
  --SLE IgM MAC-ELISA (327)
  --WNV IgM MAC-ELISA (326)
  --Measles PCR (25)
  --Mumps PCR (26)
  
  --Some samples didn't generate the XLM Files we expected to be generated:
    --AZ00090526: SLE IgM MAC-ELISA
    --AZ00090821: Mumps PCR
    --AZ00090898: Measles PCR

SELECT DISTINCT
  f.external_id,
  mr.field_varchar_80,
  f.dept,
  f.apprdate,
  ot.testno,
  ot.runno,
  ot.apprdate,
  '~' AS eol  
FROM folders f
  INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
  INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
  INNER JOIN metadata_repository mr ON (1=1
    AND mr.tablereference = 'CENTRALRECEIVING'
    AND mr.original_origrec = cr.origrec)
WHERE 1=1
  AND mr.field_varchar_80 = 'Diagnostic'
  AND ot.apprdate IS NOT NULL
  AND f.external_id IS NOT NULL
  AND f.apprdate IS NOT NULL
--  AND ot.testcode IN ('327', '326', '26', '25')
AND ot.testcode IN ('1', '511')
--AND f.apprdate = to_date('&CheckDate', 'DD-MON-YYYY')
ORDER BY
  f.apprdate DESC,
  f.external_id ASC,
  ot.testno ASC
