
-----LRN-B samples for review----------------------------------------------

SELECT DISTINCT
  mr.field_varchar_80,
  (rc.compname || ' (' || rc.rasclientid || ')') AS rasclient,
  f.external_id,
  f.apprdate,
  ot.testno,
  t.testflag,
  
  r.final,
  '~' AS eol
FROM centralreceiving cr
  INNER JOIN metadata_repository mr ON (1=1
    AND mr.tablereference = 'CENTRALRECEIVING'
    AND mr.original_origrec = cr.origrec)    
  INNER JOIN folders f ON (cr.external_id = f.external_id)
  INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
  INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
  INNER JOIN tests t ON (ot.testcode = t.testcode)
  INNER JOIN results r ON (1=1
    AND ot.ordno = r.ordno
    AND ot.testcode = r.testcode)
WHERE 1=1
  AND f.apprdate IS NOT NULL
  AND f.external_id IS NOT NULL
  AND mr.field_varchar_80 = 'LRN-B'
  AND rc.rasclientid NOT IN ('ASL-P')
AND t.testflag = 'Micro'
ORDER BY  
  f.external_id DESC,
  ot.testno ASC

---------------------------------------------------------------------------
/*
SELECT DISTINCT
  mr.field_varchar_80,
  (rc.compname || ' (' || rc.rasclientid || ')') AS rasclient,
  f.external_id,
  --Test: Real-Time PCR for Burkholderia--
  ot.testno,
  r.final,
  --Test: Burkholderia Culture Identification--
  ot2.testno,
  r2.final,
  '~' AS eol
FROM centralreceiving cr
  INNER JOIN metadata_repository mr ON (1=1
    AND mr.tablereference = 'CENTRALRECEIVING'
    AND mr.original_origrec = cr.origrec)    
  INNER JOIN folders f ON (cr.external_id = f.external_id)
  INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
  --Test: Real-Time PCR for Burkholderia--
  INNER JOIN ordtask ot ON (1=1
    AND f.folderno = ot.folderno 
    AND ot.testno = 'Real-Time PCR for Burkholderia')
  INNER JOIN results r ON (1=1
    AND ot.ordno = r.ordno
    AND ot.testcode = r.testcode)

  --Test: Burkholderia Culture Identification--
  INNER JOIN ordtask ot2 ON (1=1
    AND f.folderno = ot2.folderno 
    AND ot2.testno = 'Burkholderia Culture Identification')
  INNER JOIN results r2 ON (1=1
    AND ot2.ordno = r2.ordno
    AND ot2.testcode = r2.testcode)

    
WHERE 1=1
  AND f.apprdate IS NOT NULL
  AND f.external_id IS NOT NULL
  AND mr.field_varchar_80 = 'LRN-B'

  AND rc.rasclientid NOT IN ('ASL-P')
--AND r.final = 'Burkholderia pseudomallei DNA detected'  
ORDER BY  
  f.external_id DESC,
  ot.testno ASC
*/
---------------------------------------------------------------------------
---------------------------------------------------------------------------
