/*-----SNOMED Cleanup--------------------------------------------------------*/

  -----DESCRIPTION-----
    --Use these sets of SQL queries for review and cleanup of SNOMED CODES
  ----- -----
  
  -----HISTORY-----
    --2020-09-08 JTY: Created Script
  ----- -----
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
    -----01. Identify Duplicate SNOMED CODES-----
      --This query till take the provided tests list and identify any 
      --SNOMED codes that are duplicated.
/*      
      SELECT DISTINCT
        sc.snomedcode,
        sc.origrec AS sc_origrec,
        sc.snomed_group,
        sc.loinccondname,
        sc.snomedconceptid,
        sc.snomeddescriptionid,
        sc.snomedelement,
        '~' AS eol
      FROM tests t
        INNER JOIN possibleresults pr ON (t.testcode = pr.testcode)
        INNER JOIN snomedcodes sc ON (pr.snomedcode = sc.snomedcode)
        INNER JOIN snomedcodes sc2 ON (pr.snomedcode = sc2.snomedcode)
      WHERE 1=1
        AND t.testno IN (&TestNameList)
        AND sc.snomedcode = sc2.snomedcode AND sc.origrec <> sc2.Origrec
      ORDER BY
        sc.snomedcode ASC,
        sc.snomed_group ASC;
*/
    ----- -----

    -----02. Review SNOMED Codes-----
      --Reivew the Possible Results SNOMED Info compared to the
      --cooresponding SNOMED codes in the table and detrmine what 
      --records need to be eliminated (use the sc Origrec for this)
/*
      SELECT DISTINCT
        sc.origrec AS sc_origrec,
        pr.snomedcode,
        pr.snomedconceptid AS pr_snomedconceptid,
        sc.snomedconceptid AS sc_snomedconceptid,
        pr.snomeddescriptionid AS pr_snomeddescriptionid,
        sc.snomeddescriptionid AS sc_snomeddescriptionid,
        '~' AS eol
      FROM tests t
        INNER JOIN possibleresults pr ON (t.testcode = pr.testcode)
        INNER JOIN snomedcodes sc ON (pr.snomedcode = sc.snomedcode)
      WHERE 1=1
        AND t.testno IN (&TestNameList)
        AND sc.snomedcode IN (&SnomedCodeList)
      ORDER BY
        pr.snomedcode ASC,
        pr.snomedconceptid ASC,
        pr.snomeddescriptionid ASC;
*/
    ----- -----
    
    -----03. Delete the unwanted duplicate SNOMED CODES-----
      --DELETE FROM snomedcodes sc WHERE sc.origrec IN (&KillSnomedList);
    ----- -----

  
/*---------------------------------------------------------------------------*/
