      WITH
        FolderList AS (
          SELECT DISTINCT
            cr.external_id,
            (rc.rasclientid  || ': ' || rc.compname) AS client_name,
            gp.validationset,
            f.folderno,
            f.testgroupname AS panel,
            gp.interface_id,
            gp.workflowstep,
            f.apprsts,
            fc.dispsts,      
            TO_CHAR(f.apprdate, 'YYYY-MM-DD') || '   ' || fc.approvedtime AS approved,
            gp.comments,
            (gp.usrnam || ': ' || u.fullname) AS username,
            gp.last_updated,
            '~' AS eol
          FROM centralreceiving cr
            INNER JOIN folders f ON (cr.external_id = f.external_id)
            INNER JOIN foldercondition fc ON (f.folderno = fc.folderno)
            INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
            INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
            INNER JOIN hl7_generator_pool gp ON (f.folderno = gp.folderno)
            INNER JOIN users u ON (gp.usrnam = u.usrnam)
          WHERE 1=1
          
          
          ORDER BY
            cr.external_id DESC,
            f.folderno DESC,
            gp.interface_id DESC
        ),
        TestList AS (
          SELECT
            fl.folderno,
            ListAgg(ot.testno, ' | ') WITHIN GROUP (ORDER BY ot.testno) AS test_list,
            '~' AS eol
          FROM FolderList fl
            INNER JOIN ordtask ot ON (fl.folderno =  ot.folderno)            
          WHERE 1=1
          GROUP BY
            fl.folderno
        ),
        AnalyteResults AS (
          SELECT
            fl.folderno,
            ot.testno,
            r.testcode,
            (r.analyte || ' = ' || ListAgg(r.final, ' | ') WITHIN GROUP (ORDER BY r.final)) AS analyte_results,
            '~' AS eol
          FROM FolderList fl
            INNER JOIN ordtask ot ON (fl.folderno =  ot.folderno)
            INNER JOIN results r ON (1=1
              AND ot.ordno = r.ordno
              AND ot.testcode = r.testcode)
          WHERE 1=1
          GROUP BY
            fl.folderno,
            ot.testno,
            r.testcode,
            r.analyte
        ),
       TestResults AS (
          SELECT
            ar.folderno,
            ar.testno,
            ar.testcode,
            ListAgg(analyte_results, chr(13)) WITHIN GROUP (ORDER BY ar.analyte_results) AS test_results,
            '~' AS eol
          FROM AnalyteResults ar              
          WHERE 1=1
          GROUP BY
            ar.folderno,
            ar.testno,
            ar.testcode
        ),
       FolderResults AS (
          SELECT
            tr.folderno,
            ListAgg(tr.test_results, chr(13)) WITHIN GROUP (ORDER BY tr.test_results) AS folder_results,
            '~' AS eol
          FROM TestResults tr
          WHERE 1=1
          GROUP BY
            tr.folderno
        )
        
select * from FolderResults        
        
        
        
        
        
/*        SELECT DISTINCT
          fl.external_id,
          fl.client_name,
          fl.validationset,
          fl.folderno,
          fl.panel,
          fl.interface_id,
          fl.workflowstep,
          fl.apprsts,
          fl.dispsts,
          fl.approved,
          tl.test_list,
          fr.folder_results,
          fl.comments,
          fl.username,
          fl.last_updated,
          tl.eol
        FROM FolderList fl
          LEFT OUTER JOIN TestList tl ON (fl.folderno = tl.folderno)
          LEFT OUTER JOIN FolderResults fr ON (fl.folderno = fr.folderno)
        WHERE 1=1
        ORDER BY
          fl.panel ASC,
          fl.external_id DESC,
          fl.folderno ASC,
          fl.interface_id ASC
*/
