/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
  /*-----ADHS non-Negative Results-----*/
    --Query built for Lisa Villarroel and lab to identify ADHS Positive 
    --COVID-19 samples
    SELECT 
      cr.rasclientid,
      cr.external_id,
      (cr.last_name || ', ' || cr.first_name) AS patient_name,
      ot.testno,
      r.final,
      to_date(cr.date_received, 'DD-MON-YY') AS date_received,
      f.apprdate,
      '~' AS eol  
    FROM centralreceiving cr
      INNER JOIN folders f ON (f.external_id = cr.external_id)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN results r ON (1=1
        AND ot.ordno = r.ordno
        AND ot.testcode = r.testcode)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        AND mr.field_varchar_80 = 'Diagnostic'
      )
    WHERE 1=1
      AND cr.rasclientid = 'ADHS'
      AND ot.testno IN (
        'TaqPath COVID-19 rRT-PCR', 
        '2019 Novel Coronavirus rRT-PCR',
        'Xpert Xpress SARS CoV 2')
      AND f.apprdate IS NOT NULL
      AND r.numres IN (
      'Detected', 'Inconclusive', 'Invalid',      --2019 Novel Coronavirus rRT-PCR
      'Positive', 'PresumtivePositive'  --Xpert Xpress SARS CoV 2
      )
--     AND to_date(cr.date_received, 'DD-MON-YY') BETWEEN to_date('&FromDate', 'DD-MON-YYYY') AND to_date('&ToDate', 'DD-MON-YYYY')
   /*----- -----*/
/*---------------------------------------------------------------------------*/
