/*-----National Guard Samples------------------------------------------------*/
  /*-----DESCRIPTION-----*/
    --Query created to identify samples for the National Guard.
  /*----- -----*/
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
  /*----- -----*/
    SELECT DISTINCT
      rc.compname,
      rc.rasclientid,
      cr.external_id,
      cr.date_received,
      f.apprdate,
      r.final,
      (CASE r.final
        WHEN 'Positive' THEN '2'
        WHEN 'Detected' THEN '3'
        WHEN 'Not Tested' THEN '4'
        WHEN 'Retest' THEN '5'
        ELSE '99'
      END) AS sorter,  
      '~' AS eol
    FROM centralreceiving cr
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        AND mr.field_varchar_80 = 'Diagnostic')
      INNER JOIN rasclients rc ON (cr.rasclientid = rc.rasclientid)
      INNER JOIN folders f ON (cr.external_id = f.external_id)
      INNER JOIN ordtask ot ON (f.folderno = ot.folderno)
      INNER JOIN results r ON (1=1
        AND r.ordno = ot.ordno
        AND r.testcode = ot.testcode)
    WHERE 1=1
      AND f.apprdate IS NOT NULL
      AND cr.rasclientid IN ('AANG-3200', 'AANG-WAATS', 'AANG', 'ANG-T')
      AND f.testgroupname IN ('Coronavirus')
      AND r.final NOT IN ('Negative', 'Not Detected')
    --  AND r.final NOT IN ('Negative', 'Not Detected', 'Retest', 'Not Tested')
    ORDER BY
      sorter ASC,
      r.final ASC,
      rc.compname ASC,
      cr.date_received ASC,
      cr.external_id ASC
      ;
  /*----- -----*/
/*---------------------------------------------------------------------------*/


