
/*-----Update External Contact-----------------------------------------------*/
  -----DESCRIPTION-----
    --Use this scrpit to update the External contact for all active samples
    --that meet these critera:
      --Active Sample (folder has not been approved)
      --Activity='Diagnostic'
      --Panel = 'Coronavirus'
      --External Contact = 'Laboratory Results'
      
    --We will be replacing the external contact with the 'COVID-19 Reporting'
    --external contact so that the report delivery is updated to Email
  ----- -----

  -----HISTORY-----
    --2020.05.16 JTY: Created Query
  ----- -----
  
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
  --We will use the Merge statement to identify and update the records we are
  --targeting.
  --NOTE: Not sure if this is working as hopped, sometimes I get a primary 
  --      key violation when this is run need to review this closer.  Also 
  --      this script may actaully ADD a new external contact instead of
  --      updating the exitsing one. Not sure, first time I ran it it added,
  --      second time I ran it it updated..... !!
  ----- -----
    MERGE INTO folderscontactsext t1
    USING (
    SELECT DISTINCT
      fcx.folderno,
      fcx.origrec,
      rcx.contactid AS orig_contactid,
      rcx.submit_method AS orig_submit_method,
--      '5013' AS contactid,
--      'E-mail' AS submit_method,
      rcx2.contactid,
      rcx2.submit_method,
      '~' AS eol
    FROM folderscontactsext fcx
      INNER JOIN rasclientcontactsext rcx ON (1=1
        AND fcx.rasclientid = rcx.rasclientid    
        AND fcx.contactid = rcx.contactid
        AND rcx.fullname = 'Laboratory Results'
        AND rcx.submit_method = 'Hard Copy')
      INNER JOIN folders f ON (fcx.folderno = f.folderno)
      INNER JOIN rasclientcontactsext rcx2 ON (1=1
        AND fcx.rasclientid = rcx2.rasclientid
        AND rcx2.fullname = 'COVID-19 Reporting'
      )
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        AND mr.field_varchar_80 = 'Diagnostic')
    WHERE 1=1
      AND fcx.rasclientid = 'ADHS'
      AND fcx.sendcoa = 'Y'
      AND f.testgroupname = 'Coronavirus'
      AND f.apprdate IS NULL
--AND rownum < 101
    --AND f.external_id = 'AZ00104168'
    ORDER BY
      fcx.folderno ASC,
      fcx.origrec ASC
    ) t2
    ON (t1.origrec = t2.origrec)
--    ON (t1.folderno = t2.folderno AND t1.contactid = t2.orig_contactid)
    WHEN MATCHED THEN
      UPDATE SET 
      t1.contactid = t2.contactid,
      t1.submit_method = t2.submit_method;
  ----- -----
--SELECT fx.folderno, fx.contactid, fx.submit_method FROM folderscontactsext fx WHERE fx.folderno = 'AZ00104033-01';
  -----Check for samples with multiple external contacts.-----
/*  
    SELECT
      fcx1.folderno,
      fcx1.contactid,
      fcx1.submit_method
    FROM folderscontactsext fcx1
      INNER JOIN folderscontactsext fcx2 ON (fcx1.folderno = fcx2.folderno AND fcx1.contactid <> fcx2.contactid)
    WHERE 1=1
      AND fcx1.rasclientid = 'ADHS'
    ORDER BY 
    fcx1.folderno ASC,
    fcx1.submit_method ASC;
*/    
  ----- -----

  -----Review Changes-----
/*  
    SELECT DISTINCT
      fcx.folderno,
      fcx.origrec,
      rcx.fullname,
      fcx.submit_method,
      '~' AS eol
    FROM folderscontactsext fcx
      INNER JOIN rasclientcontactsext rcx ON (1=1
        AND fcx.rasclientid = rcx.rasclientid    
        AND fcx.contactid = rcx.contactid
        AND rcx.fullname = 'Laboratory Results'
        AND rcx.submit_method = 'Hard Copy')
      INNER JOIN folders f ON (fcx.folderno = f.folderno)
      INNER JOIN rasclientcontactsext rcx2 ON (1=1
        AND fcx.rasclientid = rcx2.rasclientid
        AND rcx2.fullname = 'COVID-19 Reporting'
      )
      INNER JOIN centralreceiving cr ON (f.external_id = cr.external_id)
      INNER JOIN metadata_repository mr ON (1=1
        AND mr.tablereference = 'CENTRALRECEIVING'
        AND mr.original_origrec = cr.origrec
        AND mr.field_varchar_80 = 'Diagnostic')
    WHERE 1=1
      AND fcx.rasclientid = 'ADHS'
      AND fcx.sendcoa = 'Y'
      AND f.testgroupname = 'Coronavirus'
      AND f.apprdate IS NULL
    --AND f.external_id = 'AZ00104168'
    ORDER BY
      fcx.folderno ASC,
      fcx.origrec ASC
  ----- -----
*/  
  
/*---------------------------------------------------------------------------*/
